var require = meteorInstall({"imports":{"server":{"accounts":{"ldap.js":["babel-runtime/helpers/typeof","ldapjs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/ldap.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({LDAP:function(){return LDAP}});var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var ldapjs;module.import("ldapjs",{"default":function(v){ldapjs=v}});
var Future = Npm.require("fibers/future");                                                                             // 1
                                                                                                                       // 2
                                                                                                                       //
// At a minimum, set up LDAP_DEFAULTS.url and .dn according to                                                         //
// your needs. url should appear as 'ldap://your.url.here'                                                             //
// dn should appear in normal ldap format of comma separated attribute=value                                           //
// e.g. 'uid=someuser,cn=users,dc=somevalue'                                                                           //
LDAP_DEFAULTS = {                                                                                                      // 8
  url: false,                                                                                                          // 9
  port: "389",                                                                                                         // 10
  dn: false,                                                                                                           // 11
  searchDN: false,                                                                                                     // 12
  searchCredentials: false,                                                                                            // 13
  createNewUser: true,                                                                                                 // 14
  defaultDomain: false,                                                                                                // 15
  searchResultsProfileMap: false,                                                                                      // 16
  base: null,                                                                                                          // 17
  search: "(objectclass=*)",                                                                                           // 18
  ldapsCertificate: false                                                                                              // 19
};                                                                                                                     // 8
                                                                                                                       //
/**                                                                                                                    //
 @class LDAP                                                                                                           //
 @constructor                                                                                                          //
 */                                                                                                                    //
function LDAP() {                                                                                                      // 26
  // Set options                                                                                                       //
  this.options = _.clone(LDAP_DEFAULTS);                                                                               // 28
};                                                                                                                     // 29
                                                                                                                       //
/**                                                                                                                    //
 * Attempt to bind (authenticate) ldap                                                                                 //
 * and perform a dn search if specified                                                                                //
 *                                                                                                                     //
 * @method ldapCheck                                                                                                   //
 *                                                                                                                     //
 * @param {Object} options  Object with username, ldapPass and overrides for LDAP_DEFAULTS object.                     //
 * Additionally the searchBeforeBind parameter can be specified, which is used to search for the DN                    //
 * if not provided.                                                                                                    //
 */                                                                                                                    //
LDAP.prototype.ldapCheck = function (db, options) {                                                                    // 41
                                                                                                                       //
  var _this = this;                                                                                                    // 43
                                                                                                                       //
  options = options || {};                                                                                             // 45
                                                                                                                       //
  if (options.hasOwnProperty("username") && options.hasOwnProperty("ldapPass") || options.hasOwnProperty("searchUsername")) {
    var _ret = function () {                                                                                           // 48
      _this.options.base = db.getLdapBase();                                                                           // 49
      _this.options.url = db.getLdapUrl();                                                                             // 50
      _this.options.searchBeforeBind = {};                                                                             // 51
      _this.options.searchBeforeBind[db.getLdapSearchUsername()] = options.searchUsername || options.username;         // 52
      _this.options.filter = db.getLdapFilter() || "(objectclass=*)";                                                  // 54
      _this.options.searchBindDn = db.getLdapSearchBindDn();                                                           // 55
      _this.options.searchBindPassword = db.getLdapSearchBindPassword();                                               // 56
                                                                                                                       //
      var resolved = false;                                                                                            // 58
      var ldapAsyncFut = new Future();                                                                                 // 59
                                                                                                                       //
      // Create ldap client                                                                                            //
      var fullUrl = db.getLdapUrl();                                                                                   // 62
      var client = null;                                                                                               // 63
                                                                                                                       //
      var errorFunc = function errorFunc(err) {                                                                        // 65
        if (err) {                                                                                                     // 66
          if (resolved) return;                                                                                        // 67
          resolved = true;                                                                                             // 68
          ldapAsyncFut["return"]({                                                                                     // 69
            error: err                                                                                                 // 70
          });                                                                                                          // 69
        }                                                                                                              // 72
      };                                                                                                               // 73
                                                                                                                       //
      if (fullUrl.indexOf("ldaps://") === 0) {                                                                         // 75
        var tlsOptions = {};                                                                                           // 76
        var cert = db.getLdapCaCert();                                                                                 // 77
        if (cert) {                                                                                                    // 78
          tlsOptions.ca = cert;                                                                                        // 79
        }                                                                                                              // 80
                                                                                                                       //
        client = ldapjs.createClient({                                                                                 // 82
          url: fullUrl,                                                                                                // 83
          tlsOptions: tlsOptions                                                                                       // 84
        }, errorFunc);                                                                                                 // 82
      } else {                                                                                                         // 86
        client = ldapjs.createClient({                                                                                 // 87
          url: fullUrl                                                                                                 // 88
        }, errorFunc);                                                                                                 // 87
      }                                                                                                                // 90
                                                                                                                       //
      client.on("error", errorFunc);                                                                                   // 92
                                                                                                                       //
      var username = options.username;                                                                                 // 94
      var domain = _this.options.defaultDomain;                                                                        // 95
                                                                                                                       //
      if (!options.hasOwnProperty("searchUsername")) {                                                                 // 97
        // Slide @xyz.whatever from username if it was passed in                                                       //
        // and replace it with the domain specified in defaults                                                        //
        var emailSliceIndex = options.username.indexOf("@");                                                           // 100
                                                                                                                       //
        // If user appended email domain, strip it out                                                                 //
        // And use the defaults.defaultDomain if set                                                                   //
        if (emailSliceIndex !== -1) {                                                                                  // 104
          username = options.username.substring(0, emailSliceIndex);                                                   // 105
          domain = domain || options.username.substring(emailSliceIndex + 1, options.username.length);                 // 106
        } else {                                                                                                       // 107
          username = options.username;                                                                                 // 108
        }                                                                                                              // 109
      }                                                                                                                // 110
                                                                                                                       //
      if (_this.options.searchBindDn) {                                                                                // 112
        var _ret2 = function () {                                                                                      // 112
          var ldapBindFut = new Future();                                                                              // 113
          client.bind(_this.options.searchBindDn, _this.options.searchBindPassword, function (err) {                   // 114
            if (err) {                                                                                                 // 116
              ldapBindFut["throw"](err);                                                                               // 117
            } else {                                                                                                   // 118
              ldapBindFut["return"]();                                                                                 // 119
            }                                                                                                          // 120
          });                                                                                                          // 121
                                                                                                                       //
          try {                                                                                                        // 124
            ldapBindFut.wait();                                                                                        // 125
          } catch (err) {                                                                                              // 126
            return {                                                                                                   // 127
              v: {                                                                                                     // 127
                v: { error: err }                                                                                      // 127
              }                                                                                                        // 127
            };                                                                                                         // 127
          }                                                                                                            // 128
        }();                                                                                                           // 112
                                                                                                                       //
        if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                // 112
      }                                                                                                                // 129
      // initialize result                                                                                             //
      var retObject = {                                                                                                // 131
        username: username,                                                                                            // 132
        email: domain ? username + "@" + domain : false,                                                               // 133
        emptySearch: true,                                                                                             // 134
        searchResults: {}                                                                                              // 135
      };                                                                                                               // 131
                                                                                                                       //
      var filter = _this.options.filter;                                                                               // 138
      Object.keys(_this.options.searchBeforeBind).forEach(function (searchKey) {                                       // 139
        filter = "&" + filter + "(" + searchKey + "=" + _this.options.searchBeforeBind[searchKey] + ")";               // 140
      });                                                                                                              // 141
                                                                                                                       //
      var searchOptions = {                                                                                            // 143
        scope: "sub",                                                                                                  // 144
        sizeLimit: 1,                                                                                                  // 145
        filter: filter                                                                                                 // 146
      };                                                                                                               // 143
                                                                                                                       //
      // perform LDAP search to determine DN                                                                           //
      client.search(_this.options.base, searchOptions, function (err, res) {                                           // 150
        if (err) {                                                                                                     // 151
          if (resolved) return;                                                                                        // 152
          resolved = true;                                                                                             // 153
          ldapAsyncFut["return"]({                                                                                     // 154
            error: err                                                                                                 // 155
          });                                                                                                          // 154
          return;                                                                                                      // 157
        }                                                                                                              // 158
                                                                                                                       //
        retObject.emptySearch = true;                                                                                  // 160
        res.on("searchEntry", function (entry) {                                                                       // 161
          retObject.dn = entry.objectName;                                                                             // 162
          retObject.username = retObject.dn;                                                                           // 163
          retObject.emptySearch = false;                                                                               // 164
                                                                                                                       //
          retObject.searchResults = _.omit(entry.object, "userPassword");                                              // 166
                                                                                                                       //
          if (options.hasOwnProperty("searchUsername")) {                                                              // 168
            // This was only a search, return immediately                                                              //
            resolved = true;                                                                                           // 170
            ldapAsyncFut["return"](retObject);                                                                         // 171
            return;                                                                                                    // 172
          }                                                                                                            // 173
                                                                                                                       //
          // use the determined DN to bind                                                                             //
          client.bind(entry.objectName, options.ldapPass, function (err) {                                             // 176
            try {                                                                                                      // 177
              if (err) {                                                                                               // 178
                throw new Meteor.Error(err.code, err.message);                                                         // 179
              } else {                                                                                                 // 180
                resolved = true;                                                                                       // 181
                ldapAsyncFut["return"](retObject);                                                                     // 182
              }                                                                                                        // 183
            } catch (e) {                                                                                              // 184
              if (resolved) return;                                                                                    // 186
              resolved = true;                                                                                         // 187
              ldapAsyncFut["return"]({                                                                                 // 188
                error: e                                                                                               // 189
              });                                                                                                      // 188
            }                                                                                                          // 191
          });                                                                                                          // 192
        });                                                                                                            // 193
                                                                                                                       //
        res.on("error", errorFunc);                                                                                    // 195
                                                                                                                       //
        // If no dn is found, return as is.                                                                            //
        res.on("end", function (result) {                                                                              // 198
          if (retObject.dn === undefined) {                                                                            // 199
            resolved = true;                                                                                           // 200
            ldapAsyncFut["return"](retObject);                                                                         // 201
          }                                                                                                            // 202
        });                                                                                                            // 203
      });                                                                                                              // 204
                                                                                                                       //
      return {                                                                                                         // 206
        v: ldapAsyncFut.wait()                                                                                         // 206
      };                                                                                                               // 206
    }();                                                                                                               // 48
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 48
  } else {                                                                                                             // 208
    throw new Meteor.Error(403, "Missing LDAP Auth Parameter");                                                        // 209
  }                                                                                                                    // 210
};                                                                                                                     // 212
                                                                                                                       //
LDAP.prototype.updateUserQuota = function (db, user) {                                                                 // 214
  var fallback = {                                                                                                     // 215
    storage: user.cachedStorageQuota || 0,                                                                             // 216
    grains: Infinity,                                                                                                  // 217
    compute: Infinity                                                                                                  // 218
  };                                                                                                                   // 215
                                                                                                                       //
  var setting = db.collections.settings.findOne({ _id: "quotaLdapAttribute" });                                        // 221
  if (!setting) return fallback;                                                                                       // 222
                                                                                                                       //
  // TODO(someday): don't just assume the first login identity is the primary identity?                                //
  var email = db.getPrimaryEmail(user._id, user.loginIdentities[0].id);                                                // 225
  if (!email) return fallback;                                                                                         // 226
                                                                                                                       //
  var ldapUser = void 0;                                                                                               // 228
  try {                                                                                                                // 229
    ldapUser = this.ldapCheck(db, { searchUsername: email });                                                          // 230
  } catch (err) {                                                                                                      // 231
    console.error("Error looking up quota from LDAP");                                                                 // 232
    return fallback;                                                                                                   // 233
  }                                                                                                                    // 234
                                                                                                                       //
  if (!ldapUser || !ldapUser.searchResults) return fallback;                                                           // 236
                                                                                                                       //
  var newStorageQuota = +ldapUser.searchResults[setting.value];                                                        // 238
  if (newStorageQuota !== user.cachedStorageQuota) {                                                                   // 239
    Meteor.users.update({ _id: user._id }, { $set: { cachedStorageQuota: newStorageQuota } });                         // 240
  }                                                                                                                    // 241
                                                                                                                       //
  // TODO(someday): cache timestamp as well and only check/update if greater than 60s ago                              //
  return {                                                                                                             // 244
    storage: newStorageQuota,                                                                                          // 245
    grains: Infinity,                                                                                                  // 246
    compute: Infinity                                                                                                  // 247
  };                                                                                                                   // 244
};                                                                                                                     // 249
                                                                                                                       //
                                                                                                                       // 251
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"picture.js":["meteor/http",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/picture.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({userPictureUrl:function(){return userPictureUrl},fetchPicture:function(){return fetchPicture}});var HTTP;module.import("meteor/http",{"HTTP":function(v){HTTP=v}});
                                                                                                                       //
var userPictureUrl = function userPictureUrl(user) {                                                                   // 3
  if (user.services && !(user.profile && user.profile.picture)) {                                                      // 4
    // Try to determine user's avatar URL from login service.                                                          //
                                                                                                                       //
    var google = user.services.google;                                                                                 // 7
    if (google && google.picture) {                                                                                    // 8
      return google.picture;                                                                                           // 9
    }                                                                                                                  // 10
                                                                                                                       //
    var github = user.services.github;                                                                                 // 12
    if (github && github.id) {                                                                                         // 13
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                   // 14
    }                                                                                                                  // 15
                                                                                                                       //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                      //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                          //
    // Github are different because they are actually the identity providers, so they already know                     //
    // the user logged in.                                                                                             //
  }                                                                                                                    // 21
};                                                                                                                     // 22
                                                                                                                       //
var fetchPicture = function fetchPicture(db, url) {                                                                    // 24
  try {                                                                                                                // 25
    var result = HTTP.get(url, {                                                                                       // 26
      npmRequestOptions: { encoding: null },                                                                           // 27
      timeout: 5000                                                                                                    // 28
    });                                                                                                                // 26
                                                                                                                       //
    var metadata = {};                                                                                                 // 31
                                                                                                                       //
    metadata.mimeType = result.headers["content-type"];                                                                // 33
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                  // 36
    }                                                                                                                  // 37
                                                                                                                       //
    var enc = result.headers["content-encoding"];                                                                      // 39
    if (enc && enc !== "identity") {                                                                                   // 40
      metadata.encoding = enc;                                                                                         // 41
    }                                                                                                                  // 42
                                                                                                                       //
    return db.addStaticAsset(metadata, result.content);                                                                // 44
  } catch (err) {                                                                                                      // 45
    console.error("failed to fetch user profile picture:", url, err.stack);                                            // 46
  }                                                                                                                    // 47
};                                                                                                                     // 48
                                                                                                                       //
                                                                                                                       // 50
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"saml-utils.js":["crypto","querystring","url","xml2js","xmlbuilder","xml-crypto","xmldom","zlib",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/saml-utils.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SAML:function(){return SAML}});var crypto;module.import("crypto",{"default":function(v){crypto=v}});var querystring;module.import("querystring",{"default":function(v){querystring=v}});var Url;module.import("url",{"default":function(v){Url=v}});var xml2js;module.import("xml2js",{"default":function(v){xml2js=v}});var xmlbuilder;module.import("xmlbuilder",{"default":function(v){xmlbuilder=v}});var xmlCrypto;module.import("xml-crypto",{"default":function(v){xmlCrypto=v}});var xmldom;module.import("xmldom",{"default":function(v){xmldom=v}});var zlib;module.import("zlib",{"default":function(v){zlib=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 10
                                                                                                                       //
var SAML = function SAML(options) {                                                                                    // 12
  this.options = this.initialize(options);                                                                             // 13
};                                                                                                                     // 14
                                                                                                                       //
SAML.prototype.initialize = function (options) {                                                                       // 16
  if (!options) {                                                                                                      // 17
    options = {};                                                                                                      // 18
  }                                                                                                                    // 19
                                                                                                                       //
  if (!options.protocol) {                                                                                             // 21
    options.protocol = "https://";                                                                                     // 22
  }                                                                                                                    // 23
                                                                                                                       //
  if (!options.path) {                                                                                                 // 25
    options.path = "/saml/consume";                                                                                    // 26
  }                                                                                                                    // 27
                                                                                                                       //
  if (!options.issuer) {                                                                                               // 29
    options.issuer = "onelogin_saml";                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (options.identifierFormat === undefined) {                                                                        // 33
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  return options;                                                                                                      // 37
};                                                                                                                     // 38
                                                                                                                       //
SAML.prototype.generateUniqueID = function () {                                                                        // 40
  var chars = "abcdef0123456789";                                                                                      // 41
  var uniqueID = "";                                                                                                   // 42
  for (var i = 0; i < 20; i++) {                                                                                       // 43
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                       // 44
  }                                                                                                                    // 45
                                                                                                                       //
  return uniqueID;                                                                                                     // 47
};                                                                                                                     // 48
                                                                                                                       //
SAML.prototype.generateInstant = function () {                                                                         // 50
  var date = new Date();                                                                                               // 51
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                     // 53
                                                                                                                       //
SAML.prototype.signRequest = function (xml) {                                                                          // 55
  var signer = crypto.createSign("RSA-SHA1");                                                                          // 56
  signer.update(xml);                                                                                                  // 57
  return signer.sign(this.options.privateCert, "base64");                                                              // 58
};                                                                                                                     // 59
                                                                                                                       //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                             // 61
  var id = "_" + this.generateUniqueID();                                                                              // 62
  var instant = this.generateInstant();                                                                                // 63
                                                                                                                       //
  var callbackUrl = void 0;                                                                                            // 65
  // Post-auth destination                                                                                             //
  if (this.options.callbackUrl) {                                                                                      // 67
    callbackUrl = this.options.callbackUrl;                                                                            // 68
  } else {                                                                                                             // 69
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                        // 70
  }                                                                                                                    // 71
                                                                                                                       //
  if (this.options.id) id = this.options.id;                                                                           // 73
                                                                                                                       //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                       //
  if (this.options.identifierFormat) {                                                                                 // 82
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                    // 85
                                                                                                                       //
  request += "<samlp:RequestedAuthnContext xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Comparison=\"exact\">" + "<saml:AuthnContextClassRef xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" + "</saml:AuthnContextClassRef>" + "</samlp:RequestedAuthnContext>\n" + "</samlp:AuthnRequest>";
                                                                                                                       //
  return request;                                                                                                      // 95
};                                                                                                                     // 96
                                                                                                                       //
SAML.prototype.generateLogoutRequest = function (req) {                                                                // 98
  var id = "_" + this.generateUniqueID();                                                                              // 99
  var instant = this.generateInstant();                                                                                // 100
                                                                                                                       //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                   //
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                        //
                                                                                                                       //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                      // 114
};                                                                                                                     // 115
                                                                                                                       //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                                // 117
  var _this = this;                                                                                                    // 118
  zlib.deflateRaw(request, function (err, buffer) {                                                                    // 119
    if (err) {                                                                                                         // 120
      return callback(err);                                                                                            // 121
    }                                                                                                                  // 122
                                                                                                                       //
    var base64 = buffer.toString("base64");                                                                            // 124
    var target = _this.options.entryPoint;                                                                             // 125
                                                                                                                       //
    if (operation === "logout") {                                                                                      // 127
      if (_this.options.logoutUrl) {                                                                                   // 128
        target = _this.options.logoutUrl;                                                                              // 129
      }                                                                                                                // 130
    }                                                                                                                  // 131
                                                                                                                       //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                     // 133
                                                                                                                       //
    var samlRequest = {                                                                                                // 138
      SAMLRequest: base64                                                                                              // 139
    };                                                                                                                 // 138
                                                                                                                       //
    if (_this.options.privateCert) {                                                                                   // 142
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                               // 143
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                   // 144
    }                                                                                                                  // 145
                                                                                                                       //
    target += querystring.stringify(samlRequest);                                                                      // 147
                                                                                                                       //
    callback(null, target);                                                                                            // 149
  });                                                                                                                  // 150
};                                                                                                                     // 151
                                                                                                                       //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                            // 153
  var request = this.generateAuthorizeRequest(req);                                                                    // 154
                                                                                                                       //
  this.requestToUrl(request, "authorize", callback);                                                                   // 156
};                                                                                                                     // 157
                                                                                                                       //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                               // 159
  var request = this.generateLogoutRequest(req);                                                                       // 160
                                                                                                                       //
  this.requestToUrl(request, "logout", callback);                                                                      // 162
};                                                                                                                     // 163
                                                                                                                       //
SAML.prototype.certToPEM = function (cert) {                                                                           // 165
  cert = cert.match(/.{1,64}/g).join("\n");                                                                            // 166
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                       // 167
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                       // 168
  return cert;                                                                                                         // 169
};                                                                                                                     // 170
                                                                                                                       //
SAML.prototype.validateSignature = function (xml, cert) {                                                              // 172
  var _this = this;                                                                                                    // 173
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                               // 174
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                                 // 176
  sig.keyInfoProvider = {                                                                                              // 177
    getKeyInfo: function getKeyInfo(key) {                                                                             // 178
      return "<X509Data></X509Data>";                                                                                  // 179
    },                                                                                                                 // 180
                                                                                                                       //
    getKey: function getKey(keyInfo) {                                                                                 // 182
      return _this.certToPEM(cert);                                                                                    // 183
    }                                                                                                                  // 184
  };                                                                                                                   // 177
  sig.loadSignature(signature.toString());                                                                             // 186
  return sig.checkSignature(xml);                                                                                      // 187
};                                                                                                                     // 188
                                                                                                                       //
SAML.prototype.getElement = function (parentElement, elementName) {                                                    // 190
  if (parentElement["saml:" + elementName]) {                                                                          // 191
    return parentElement["saml:" + elementName];                                                                       // 192
  } else if (parentElement["samlp:" + elementName]) {                                                                  // 193
    return parentElement["samlp:" + elementName];                                                                      // 194
  } else if (parentElement["saml2p:" + elementName]) {                                                                 // 195
    return parentElement["saml2p:" + elementName];                                                                     // 196
  } else if (parentElement["saml2:" + elementName]) {                                                                  // 197
    return parentElement["saml2:" + elementName];                                                                      // 198
  }                                                                                                                    // 199
                                                                                                                       //
  return parentElement[elementName];                                                                                   // 201
};                                                                                                                     // 202
                                                                                                                       //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                                  // 204
  var _this = this;                                                                                                    // 205
  var xml = new Buffer(samlResponse, "base64").toString("utf8");                                                       // 206
  var parser = new xml2js.Parser({ explicitRoot: true });                                                              // 207
  parser.parseString(xml, function (err, doc) {                                                                        // 208
    // Verify signature                                                                                                //
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                     // 210
      return callback(new Error("Invalid signature"), null, false, xml);                                               // 211
    }                                                                                                                  // 212
                                                                                                                       //
    var response = _this.getElement(doc, "Response");                                                                  // 214
    if (response) {                                                                                                    // 215
      var assertion = _this.getElement(response, "Assertion");                                                         // 216
      if (!assertion) {                                                                                                // 217
        return callback(new Error("Missing SAML assertion"), null, false, xml);                                        // 218
      }                                                                                                                // 219
                                                                                                                       //
      profile = {};                                                                                                    // 221
                                                                                                                       //
      if (response.$ && response.$.InResponseTo) {                                                                     // 223
        profile.inResponseToId = response.$.InResponseTo;                                                              // 224
      }                                                                                                                // 225
                                                                                                                       //
      if (response.$ && response.$.Destination) {                                                                      // 227
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                                // 228
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination), null, false, xml);
        }                                                                                                              // 231
      }                                                                                                                // 232
                                                                                                                       //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                           // 234
      if (issuer) {                                                                                                    // 235
        profile.issuer = issuer[0];                                                                                    // 236
      }                                                                                                                // 237
                                                                                                                       //
      var subject = _this.getElement(assertion[0], "Subject");                                                         // 239
      if (subject) {                                                                                                   // 240
        var nameID = _this.getElement(subject[0], "NameID");                                                           // 241
        if (nameID) {                                                                                                  // 242
          profile.nameID = nameID[0]._;                                                                                // 243
                                                                                                                       //
          if (nameID[0].$.Format) {                                                                                    // 245
            profile.nameIDFormat = nameID[0].$.Format;                                                                 // 246
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                      // 247
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."), null, false, xml);
            }                                                                                                          // 251
          }                                                                                                            // 252
        }                                                                                                              // 253
                                                                                                                       //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                                 // 255
        if (subjectConfirmation) {                                                                                     // 256
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];        // 257
          if (subjectConfirmationData) {                                                                               // 259
            var recipient = subjectConfirmationData.$.Recipient;                                                       // 260
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                            // 261
              return callback(new Error("SAML sent to wrong recipient"), null, false, xml);                            // 262
            }                                                                                                          // 263
                                                                                                                       //
            var nowMs = Date.now();                                                                                    // 265
            var notBefore = subjectConfirmationData.$.NotBefore;                                                       // 266
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                          // 267
              return callback(new Error("SAML assertion was signed for the future."), null, false, xml);               // 268
            }                                                                                                          // 269
                                                                                                                       //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                                 // 271
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                   // 272
              return callback(new Error("SAML assertion was signed for the past."), null, false, xml);                 // 273
            }                                                                                                          // 274
          }                                                                                                            // 275
        }                                                                                                              // 276
      }                                                                                                                // 277
                                                                                                                       //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                                // 279
      if (conditions) {                                                                                                // 280
        for (var key in conditions) {                                                                                  // 281
          if (conditions.hasOwnProperty(key)) {                                                                        // 282
            var value = conditions[key];                                                                               // 283
            if (key === "$") {                                                                                         // 284
              var _nowMs = Date.now();                                                                                 // 285
              var _notBefore = value.NotBefore;                                                                        // 286
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                     // 287
                return callback(new Error("SAML condition NotBefore is in the future."), null, false, xml);            // 288
              }                                                                                                        // 290
                                                                                                                       //
              var _notOnOrAfter = value.NotOnOrAfter;                                                                  // 292
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                              // 293
                return callback(new Error("SAML condition notOnOrAfter is in the past."), null, false, xml);           // 294
              }                                                                                                        // 296
            } else if (key.endsWith("AudienceRestriction") || key.endsWith("OneTimeUse") || key.endsWith("ProxyRestriction")) {
              continue;                                                                                                // 300
              // Do nothing.                                                                                           //
              // We already check both Destination and SubjectConfirmation.Recipient, so                               //
              // the Audience constraint isn't as important, and is tricky to handle                                   //
              // correctly.                                                                                            //
              // OneTimeUse is actually very tricky to get right, and requires a cache of                              //
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                           //
              // we would probably need to stuff it in Mongo to make it robust across multiple                         //
              // front-ends. It is a very rarely used constraint anyways.                                              //
              // ProxyRestriction constraints only govern the future use of the assertion by the                       //
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                         //
              // spec, it is always considered valid.                                                                  //
            } else {                                                                                                   // 312
                return callback(new Error("Unrecognized SAML constraint: " + key), null, false, xml);                  // 313
              }                                                                                                        // 314
          }                                                                                                            // 315
        }                                                                                                              // 316
      }                                                                                                                // 317
                                                                                                                       //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                   // 319
      if (attributeStatement) {                                                                                        // 320
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                         // 321
                                                                                                                       //
        if (attributes) {                                                                                              // 323
          attributes.forEach(function (attribute) {                                                                    // 324
            var value = _this.getElement(attribute, "AttributeValue");                                                 // 325
            if (typeof value[0] === "string") {                                                                        // 326
              profile[attribute.$.Name] = value[0];                                                                    // 327
            } else {                                                                                                   // 328
              profile[attribute.$.Name] = value[0]._;                                                                  // 329
            }                                                                                                          // 330
          });                                                                                                          // 331
        }                                                                                                              // 332
                                                                                                                       //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                           // 334
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs              //
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                                 // 336
        }                                                                                                              // 337
                                                                                                                       //
        if (!profile.email && profile.mail) {                                                                          // 339
          profile.email = profile.mail;                                                                                // 340
        }                                                                                                              // 341
                                                                                                                       //
        var microsoftEmail = profile["http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress"];            // 343
        if (!profile.email && microsoftEmail) {                                                                        // 344
          profile.email = microsoftEmail;                                                                              // 345
        }                                                                                                              // 346
                                                                                                                       //
        var microsoftDisplayName = profile["http://schemas.microsoft.com/identity/claims/displayname"];                // 348
        if (!profile.displayName && microsoftDisplayName) {                                                            // 349
          profile.displayName = microsoftDisplayName;                                                                  // 350
        }                                                                                                              // 351
      }                                                                                                                // 352
                                                                                                                       //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                                // 355
      }                                                                                                                // 356
                                                                                                                       //
      callback(null, profile, false, xml);                                                                             // 358
    } else {                                                                                                           // 359
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                    // 360
                                                                                                                       //
      if (logoutResponse) {                                                                                            // 362
        callback(null, null, true, xml);                                                                               // 363
      } else {                                                                                                         // 364
        return callback(new Error("Unknown SAML response message"), null, false, xml);                                 // 365
      }                                                                                                                // 366
    }                                                                                                                  // 368
  });                                                                                                                  // 370
};                                                                                                                     // 371
                                                                                                                       //
SAML.prototype.generateServiceProviderMetadata = function () {                                                         // 373
  var entityId = this.options.issuer;                                                                                  // 374
  var metadata = {                                                                                                     // 375
    "EntityDescriptor": {                                                                                              // 376
      "@xmlns": "urn:oasis:names:tc:SAML:2.0:metadata",                                                                // 377
      "@xmlns:ds": "http://www.w3.org/2000/09/xmldsig#",                                                               // 378
      "@entityID": entityId,                                                                                           // 379
      "@ID": entityId.replace(/\W/g, "_"),                                                                             // 380
      "SPSSODescriptor": {                                                                                             // 381
        "@protocolSupportEnumeration": "urn:oasis:names:tc:SAML:2.0:protocol"                                          // 382
      }                                                                                                                // 381
    }                                                                                                                  // 376
  };                                                                                                                   // 375
                                                                                                                       //
  var decryptionCert = this.options.localCertPublic; // TODO(someday); support local certs                             // 387
  if (decryptionCert) {                                                                                                // 388
    decryptionCert = decryptionCert.replace(/-+BEGIN CERTIFICATE-+\r?\n?/, "");                                        // 389
    decryptionCert = decryptionCert.replace(/-+END CERTIFICATE-+\r?\n?/, "");                                          // 390
    decryptionCert = decryptionCert.replace(/\r\n/g, "\n");                                                            // 391
                                                                                                                       //
    metadata.EntityDescriptor.SPSSODescriptor.KeyDescriptor = {                                                        // 393
      "ds:KeyInfo": {                                                                                                  // 394
        "ds:X509Data": {                                                                                               // 395
          "ds:X509Certificate": {                                                                                      // 396
            "#text": decryptionCert                                                                                    // 397
          }                                                                                                            // 396
        }                                                                                                              // 395
      },                                                                                                               // 394
      "EncryptionMethod": [                                                                                            // 401
      // this should be the set that the xmlenc library supports                                                       //
      { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes256-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes128-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#tripledes-cbc" }]
    };                                                                                                                 // 393
  }                                                                                                                    // 408
                                                                                                                       //
  if (this.options.logoutCallbackUrl) {                                                                                // 410
    metadata.EntityDescriptor.SPSSODescriptor.SingleLogoutService = {                                                  // 411
      "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                    // 412
      "@Location": this.options.logoutCallbackUrl                                                                      // 413
    };                                                                                                                 // 411
  }                                                                                                                    // 415
                                                                                                                       //
  metadata.EntityDescriptor.SPSSODescriptor.NameIDFormat = this.options.identifierFormat;                              // 417
  metadata.EntityDescriptor.SPSSODescriptor.AssertionConsumerService = {                                               // 418
    "@index": "1",                                                                                                     // 419
    "@isDefault": "true",                                                                                              // 420
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                      // 421
    "@Location": Meteor.absoluteUrl("_saml/validate/default")                                                          // 422
  };                                                                                                                   // 418
                                                                                                                       //
  return xmlbuilder.create(metadata).end({ pretty: true, indent: "  ", newline: "\n" });                               // 425
};                                                                                                                     // 426
                                                                                                                       //
                                                                                                                       // 428
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"async-helpers.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/async-helpers.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({inMeteor:function(){return inMeteor},promiseToFuture:function(){return promiseToFuture},waitPromise:function(){return waitPromise},onInMeteor:function(){return onInMeteor}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 3
                                                                                                                       //
var inMeteorListener = undefined;                                                                                      // 5
var onInMeteor = function onInMeteor(callback) {                                                                       // 6
  inMeteorListener = callback;                                                                                         // 7
};                                                                                                                     // 8
                                                                                                                       //
// Meteor context <-> Async Node.js context adapters                                                                   //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 11
  callback();                                                                                                          // 12
});                                                                                                                    // 13
                                                                                                                       //
var inMeteor = function inMeteor(callback) {                                                                           // 15
  if (inMeteorListener) {                                                                                              // 16
    inMeteorListener();                                                                                                // 17
  }                                                                                                                    // 18
                                                                                                                       //
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 21
    inMeteorInternal(function () {                                                                                     // 22
      try {                                                                                                            // 23
        resolve(callback());                                                                                           // 24
      } catch (err) {                                                                                                  // 25
        reject(err);                                                                                                   // 26
      }                                                                                                                // 27
    });                                                                                                                // 28
  });                                                                                                                  // 29
};                                                                                                                     // 30
                                                                                                                       //
var promiseToFuture = function promiseToFuture(promise) {                                                              // 32
  var result = new Future();                                                                                           // 33
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 34
  return result;                                                                                                       // 35
};                                                                                                                     // 36
                                                                                                                       //
var waitPromise = function waitPromise(promise) {                                                                      // 38
  return promiseToFuture(promise).wait();                                                                              // 39
};                                                                                                                     // 40
                                                                                                                       //
                                                                                                                       // 42
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"auth.js":["meteor/meteor","meteor/check","crypto","fs","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var SANDSTORM_VARDIR;module.import("/imports/server/constants.js",{"SANDSTORM_VARDIR":function(v){SANDSTORM_VARDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 8
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 9
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 11
  if (tokenIsSetupSession(token)) {                                                                                    // 12
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 13
    globalDb.collections.setupSession.remove({                                                                         // 14
      _id: "current-session",                                                                                          // 15
      hashedSessionId: hash                                                                                            // 16
    });                                                                                                                // 14
  }                                                                                                                    // 18
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 20
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 21
    console.log("Admin token deleted.");                                                                               // 22
  }                                                                                                                    // 23
}                                                                                                                      // 24
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 26
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 27
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 28
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 29
    if (stats.mtime < expireTime) {                                                                                    // 30
      return false;                                                                                                    // 31
    } else {                                                                                                           // 32
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 33
    }                                                                                                                  // 34
  } else {                                                                                                             // 35
    return false;                                                                                                      // 36
  }                                                                                                                    // 37
}                                                                                                                      // 38
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 40
  if (token) {                                                                                                         // 41
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 42
    if (setupSession) {                                                                                                // 43
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 44
      var now = new Date();                                                                                            // 45
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 46
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 47
        return true;                                                                                                   // 48
      }                                                                                                                // 49
    }                                                                                                                  // 50
  }                                                                                                                    // 51
                                                                                                                       //
  return false;                                                                                                        // 53
}                                                                                                                      // 54
                                                                                                                       //
function checkAuth(token) {                                                                                            // 56
  check(token, Match.OneOf(undefined, null, String));                                                                  // 57
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 58
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 59
  }                                                                                                                    // 60
}                                                                                                                      // 61
                                                                                                                       //
                                                                                                                       // 63
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backend.js":["babel-runtime/helpers/classCallCheck","/imports/server/constants.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/backend.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SandstormBackend:function(){return SandstormBackend},shouldRestartGrain:function(){return shouldRestartGrain}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});var inMeteor,promiseToFuture,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"promiseToFuture":function(v){promiseToFuture=v},"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 20
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 21
var Crypto = Npm.require("crypto");                                                                                    // 22
                                                                                                                       //
var storageUsageUnimplemented = false;                                                                                 // 24
                                                                                                                       //
function generateSessionId(grainId, userId, packageSalt, clientSalt) {                                                 // 26
  var sessionParts = [grainId, clientSalt];                                                                            // 27
  if (userId) {                                                                                                        // 28
    sessionParts.push(userId);                                                                                         // 29
  }                                                                                                                    // 30
                                                                                                                       //
  if (packageSalt) {                                                                                                   // 32
    sessionParts.push(packageSalt);                                                                                    // 33
  }                                                                                                                    // 34
                                                                                                                       //
  var sessionInput = sessionParts.join(":");                                                                           // 36
  return Crypto.createHash("sha256").update(sessionInput).digest("hex");                                               // 37
}                                                                                                                      // 38
                                                                                                                       //
var shouldRestartGrain = function shouldRestartGrain(error, retryCount) {                                              // 40
  // Given an error thrown by an RPC call to a grain, return whether or not it makes sense to try                      //
  // to restart the grain and retry. `retryCount` is the number of times that the request has                          //
  // already gone through this cycle (should be zero for the first call).                                              //
  return error.kjType === "disconnected" && retryCount < 1;                                                            // 44
};                                                                                                                     // 45
                                                                                                                       //
var SandstormBackend = function () {                                                                                   //
  function SandstormBackend(db, backendCap) {                                                                          // 48
    _classCallCheck(this, SandstormBackend);                                                                           // 48
                                                                                                                       //
    this._db = db;                                                                                                     // 49
    this._backendCap = backendCap;                                                                                     // 50
  }                                                                                                                    // 51
                                                                                                                       //
  SandstormBackend.prototype.cap = function cap() {                                                                    //
    return this._backendCap;                                                                                           // 54
  };                                                                                                                   // 55
                                                                                                                       //
  SandstormBackend.prototype.deleteUser = function deleteUser(userId) {                                                //
    return waitPromise(this._backendCap.deleteUser(userId));                                                           // 58
  };                                                                                                                   // 59
                                                                                                                       //
  SandstormBackend.prototype.shutdownGrain = function shutdownGrain(grainId, ownerId, keepSessions) {                  //
    if (!keepSessions) {                                                                                               // 62
      Sessions.remove({ grainId: grainId });                                                                           // 63
    }                                                                                                                  // 64
                                                                                                                       //
    var grain = this._backendCap.getGrain(ownerId, grainId).supervisor;                                                // 66
    return grain.shutdown().then(function () {                                                                         // 67
      grain.close();                                                                                                   // 68
      throw new Error("expected shutdown() to throw disconnected");                                                    // 69
    }, function (err) {                                                                                                // 70
                                                                                                                       //
      grain.close();                                                                                                   // 72
      if (err.kjType !== "disconnected") {                                                                             // 73
        throw err;                                                                                                     // 74
      }                                                                                                                // 75
    });                                                                                                                // 76
  };                                                                                                                   // 77
                                                                                                                       //
  SandstormBackend.prototype.deleteGrain = function deleteGrain(grainId, ownerId) {                                    //
    // We leave it up to the caller if they want to actually wait, but some don't so we report                         //
    // exceptions.                                                                                                     //
    return this._backendCap.deleteGrain(ownerId, grainId)["catch"](function (err) {                                    // 82
      console.error("problem deleting grain " + grainId + ":", err.message);                                           // 83
      throw err;                                                                                                       // 84
    });                                                                                                                // 85
  };                                                                                                                   // 86
                                                                                                                       //
  SandstormBackend.prototype.maybeRetryUseGrain = function maybeRetryUseGrain(grainId, cb, retryCount, err) {          //
    var _this = this;                                                                                                  // 88
                                                                                                                       //
    if (shouldRestartGrain(err, retryCount)) {                                                                         // 89
      return inMeteor(function () {                                                                                    // 90
        return cb(_this.continueGrain(grainId).supervisor)["catch"](_this.maybeRetryUseGrain.bind(_this, grainId, cb, retryCount + 1));
      });                                                                                                              // 93
    } else {                                                                                                           // 94
      throw err;                                                                                                       // 95
    }                                                                                                                  // 96
  };                                                                                                                   // 97
                                                                                                                       //
  SandstormBackend.prototype.useGrain = function useGrain(grainId, cb) {                                               //
    var _this2 = this;                                                                                                 // 99
                                                                                                                       //
    // This will open a grain for you, handling restarts if needed, and call the passed function with                  //
    // the supervisor capability as the only parameter. The callback must return a promise that used                   //
    // the supervisor, so that we can check if a disconnect error occurred, and retry if possible.                     //
    // This function returns the same promise that your callback returns.                                              //
    //                                                                                                                 //
    // This function is NOT expected to be run in a meteor context.                                                    //
    return inMeteor(function () {                                                                                      // 106
      return cb(_this2.continueGrain(grainId).supervisor)["catch"](_this2.maybeRetryUseGrain.bind(_this2, grainId, cb, 0));
    });                                                                                                                // 109
  };                                                                                                                   // 110
                                                                                                                       //
  SandstormBackend.prototype.continueGrain = function continueGrain(grainId) {                                         //
    var grain = Grains.findOne(grainId);                                                                               // 113
    if (!grain) {                                                                                                      // 114
      throw new Meteor.Error(404, "Grain Not Found", "Grain ID: " + grainId);                                          // 115
    }                                                                                                                  // 116
                                                                                                                       //
    // If a DevPackage with the same app ID is currently active, we let it override the installed                      //
    // package, so that the grain runs using the dev app.                                                              //
    var devPackage = DevPackages.findOne({ appId: grain.appId });                                                      // 120
    var isDev = void 0;                                                                                                // 121
    var mountProc = void 0;                                                                                            // 122
    var pkg = void 0;                                                                                                  // 123
    if (devPackage) {                                                                                                  // 124
      isDev = true;                                                                                                    // 125
      pkg = devPackage;                                                                                                // 126
      mountProc = pkg.mountProc;                                                                                       // 127
    } else {                                                                                                           // 128
      pkg = Packages.findOne(grain.packageId);                                                                         // 129
      if (!pkg) {                                                                                                      // 130
        throw new Meteor.Error(500, "Grain's package not installed", "Package ID: " + grain.packageId);                // 131
      }                                                                                                                // 133
    }                                                                                                                  // 134
                                                                                                                       //
    var manifest = pkg.manifest;                                                                                       // 136
    var packageId = pkg._id;                                                                                           // 137
                                                                                                                       //
    if (!("continueCommand" in manifest)) {                                                                            // 139
      throw new Meteor.Error(500, "Package manifest defines no continueCommand.", "Package ID: " + packageId);         // 140
    }                                                                                                                  // 142
                                                                                                                       //
    var result = this.startGrainInternal(packageId, grainId, grain.userId, manifest.continueCommand, false, isDev, mountProc);
    result.packageSalt = isDev ? pkg._id : grain.packageSalt;                                                          // 146
    return result;                                                                                                     // 147
  };                                                                                                                   // 148
                                                                                                                       //
  SandstormBackend.prototype.startGrainInternal = function startGrainInternal(packageId, grainId, ownerId, command, isNew, isDev, mountProc) {
    // Starts the grain supervisor.  Must be executed in a Meteor context.  Blocks until grain is                      //
    // started. Returns a promise for an object containing two fields: `owner` (the ID of the owning                   //
    // user) and `supervisor` (the supervisor capability).                                                             //
                                                                                                                       //
    if (isUserExcessivelyOverQuota(Meteor.users.findOne(ownerId))) {                                                   // 155
      throw new Meteor.Error(402, "Cannot start grain because owner's storage is exhausted.\n" + "Please ask them to upgrade.");
    }                                                                                                                  // 159
                                                                                                                       //
    // Ugly: Stay backwards-compatible with old manifests that had "executablePath" and "args" rather                  //
    //   than just "argv".                                                                                             //
    if ("args" in command) {                                                                                           // 163
      if (!("argv" in command)) {                                                                                      // 164
        command.argv = command.args;                                                                                   // 165
      }                                                                                                                // 166
                                                                                                                       //
      delete command.args;                                                                                             // 168
    }                                                                                                                  // 169
                                                                                                                       //
    if ("executablePath" in command) {                                                                                 // 171
      if (!("deprecatedExecutablePath" in command)) {                                                                  // 172
        command.deprecatedExecutablePath = command.executablePath;                                                     // 173
      }                                                                                                                // 174
                                                                                                                       //
      delete command.executablePath;                                                                                   // 176
    }                                                                                                                  // 177
                                                                                                                       //
    return this._backendCap.startGrain(ownerId, grainId, packageId, command, isNew, isDev, mountProc);                 // 179
  };                                                                                                                   // 180
                                                                                                                       //
  SandstormBackend.prototype.updateLastActive = function updateLastActive(grainId, userId, identityId) {               //
    // Update the lastActive date on the grain, any relevant API tokens, and the user,                                 //
    // and also update the user's storage usage.                                                                       //
                                                                                                                       //
    var storagePromise = undefined;                                                                                    // 186
    var ownerId = undefined;                                                                                           // 187
    if (this._db.isQuotaEnabled() && !storageUsageUnimplemented) {                                                     // 188
      ownerId = Grains.findOne(grainId).userId;                                                                        // 189
      storagePromise = this._backendCap.getUserStorageUsage(ownerId);                                                  // 190
    }                                                                                                                  // 191
                                                                                                                       //
    var now = new Date();                                                                                              // 193
    if (Grains.update(grainId, { $set: { lastUsed: now } }) === 0) {                                                   // 194
      // Grain must have been deleted. Ignore.                                                                         //
      return;                                                                                                          // 196
    }                                                                                                                  // 197
                                                                                                                       //
    if (userId) {                                                                                                      // 199
      Meteor.users.update(userId, { $set: { lastActive: now } });                                                      // 200
    }                                                                                                                  // 201
                                                                                                                       //
    if (identityId) {                                                                                                  // 203
      Meteor.users.update({ _id: identityId }, { $set: { lastActive: now } });                                         // 204
      // Update any API tokens that match this user/grain pairing as well                                              //
      ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: { lastUsed: now } }, { multi: true });
    }                                                                                                                  // 209
                                                                                                                       //
    if (storagePromise) {                                                                                              // 211
      try {                                                                                                            // 212
        var size = parseInt(waitPromise(storagePromise).size);                                                         // 213
        Meteor.users.update(ownerId, { $set: { storageUsage: size } });                                                // 214
        // TODO(security): Consider actively killing grains if the user is excessively over quota?                     //
        //   Otherwise a constantly-active grain could consume arbitrary space without being stopped.                  //
      } catch (err) {                                                                                                  // 217
        if (err.kjType === "unimplemented") {                                                                          // 218
          storageUsageUnimplemented = true;                                                                            // 219
        } else {                                                                                                       // 220
          console.error("error getting user storage usage:", err.stack);                                               // 221
        }                                                                                                              // 222
      }                                                                                                                // 223
    }                                                                                                                  // 224
  };                                                                                                                   // 225
                                                                                                                       //
  SandstormBackend.prototype.openSessionInternal = function openSessionInternal(grainId, userId, identityId, title, apiToken, cachedSalt) {
    // Start the grain if it is not running. This is an optimization: if we didn't start it here,                      //
    // it would start on the first request to the session host, but we'd like to get started before                    //
    // the round trip.                                                                                                 //
                                                                                                                       //
    var _continueGrain = this.continueGrain(grainId);                                                                  // 227
                                                                                                                       //
    var supervisor = _continueGrain.supervisor;                                                                        // 227
    var packageSalt = _continueGrain.packageSalt;                                                                      // 227
                                                                                                                       //
                                                                                                                       //
    this.updateLastActive(grainId, userId, identityId);                                                                // 233
                                                                                                                       //
    cachedSalt = cachedSalt || Random.id(22);                                                                          // 235
    var sessionId = generateSessionId(grainId, userId, packageSalt, cachedSalt);                                       // 236
    var session = Sessions.findOne({ _id: sessionId });                                                                // 237
    if (session) {                                                                                                     // 238
      // TODO(someday): also do some more checks for anonymous sessions (sessions without a userId).                   //
      if (session.identityId && session.identityId !== identityId || session.grainId !== grainId) {                    // 240
        var e = new Meteor.Error(500, "Duplicate SessionId");                                                          // 242
        console.error(e);                                                                                              // 243
        throw e;                                                                                                       // 244
      } else {                                                                                                         // 245
        return {                                                                                                       // 246
          supervisor: supervisor,                                                                                      // 247
          methodResult: {                                                                                              // 248
            sessionId: session._id,                                                                                    // 249
            title: title,                                                                                              // 250
            grainId: grainId,                                                                                          // 251
            hostId: session.hostId,                                                                                    // 252
            tabId: session.tabId,                                                                                      // 253
            salt: cachedSalt                                                                                           // 254
          }                                                                                                            // 248
        };                                                                                                             // 246
      }                                                                                                                // 257
    }                                                                                                                  // 258
                                                                                                                       //
    // TODO(someday): Allow caller to specify the parent session from which to inherit the tab ID, or                  //
    //   something.                                                                                                    //
                                                                                                                       //
    session = {                                                                                                        // 263
      _id: sessionId,                                                                                                  // 264
      grainId: grainId,                                                                                                // 265
      hostId: Crypto.createHash("sha256").update(sessionId).digest("hex").slice(0, 32),                                // 266
      tabId: Crypto.createHash("sha256").update("tab:").update(sessionId).digest("hex").slice(0, 32),                  // 267
      timestamp: new Date().getTime(),                                                                                 // 268
      hasLoaded: false                                                                                                 // 269
    };                                                                                                                 // 263
                                                                                                                       //
    if (userId) {                                                                                                      // 272
      session.userId = userId;                                                                                         // 273
    }                                                                                                                  // 274
                                                                                                                       //
    if (identityId) {                                                                                                  // 276
      session.identityId = identityId;                                                                                 // 277
    }                                                                                                                  // 278
                                                                                                                       //
    if (apiToken) {                                                                                                    // 280
      session.hashedToken = apiToken._id;                                                                              // 281
    }                                                                                                                  // 282
                                                                                                                       //
    Sessions.insert(session);                                                                                          // 284
                                                                                                                       //
    return {                                                                                                           // 286
      supervisor: supervisor,                                                                                          // 287
      methodResult: {                                                                                                  // 288
        sessionId: session._id,                                                                                        // 289
        title: title,                                                                                                  // 290
        grainId: grainId,                                                                                              // 291
        hostId: session.hostId,                                                                                        // 292
        tabId: session.tabId,                                                                                          // 293
        salt: cachedSalt                                                                                               // 294
      }                                                                                                                // 288
    };                                                                                                                 // 286
  };                                                                                                                   // 297
                                                                                                                       //
  return SandstormBackend;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 298
                                                                                                                       //
                                                                                                                       // 300
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"constants.js":["meteor/meteor","url",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/constants.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SANDSTORM_ALTHOME:function(){return SANDSTORM_ALTHOME},SANDSTORM_LOGDIR:function(){return SANDSTORM_LOGDIR},SANDSTORM_VARDIR:function(){return SANDSTORM_VARDIR},staticAssetHost:function(){return staticAssetHost}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Url;module.import("url",{"default":function(v){Url=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
                                                                                                                       //
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       //
var SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                       // 22
var SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                         // 23
var SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                   // 24
                                                                                                                       //
// TODO: dedupe this and the equivalent copy in sandstorm-db                                                           //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 27
                                                                                                                       //
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + wildcardHost[0] + "static" + wildcardHost[1];  // 29
                                                                                                                       //
                                                                                                                       // 31
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications.js":["meteor/check",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/desktop-notifications.js                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({createAppActivityDesktopNotification:function(){return createAppActivityDesktopNotification}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var createAppActivityDesktopNotification = function createAppActivityDesktopNotification(options) {                    // 19
  check(options, {                                                                                                     // 20
    userId: String,                                                                                                    // 21
    notificationId: String,                                                                                            // 22
    appActivity: {                                                                                                     // 23
      user: Match.OneOf(undefined, {                                                                                   // 24
        identityId: String,                                                                                            // 27
        name: String,                                                                                                  // 28
        avatarUrl: String                                                                                              // 29
      }, { anonymous: true }),                                                                                         // 26
      grainId: String,                                                                                                 // 33
      path: String,                                                                                                    // 34
      body: Match.ObjectIncluding({                                                                                    // 35
        defaultText: String                                                                                            // 36
      }),                                                                                                              // 35
      actionText: Match.ObjectIncluding({                                                                              // 38
        defaultText: String                                                                                            // 39
      })                                                                                                               // 38
    }                                                                                                                  // 23
  });                                                                                                                  // 20
                                                                                                                       //
  globalDb.collections.desktopNotifications.insert({                                                                   // 44
    userId: options.userId,                                                                                            // 45
    notificationId: options.notificationId,                                                                            // 46
    creationDate: new Date(),                                                                                          // 47
    appActivity: options.appActivity                                                                                   // 48
  });                                                                                                                  // 44
};                                                                                                                     // 50
                                                                                                                       //
                                                                                                                       // 52
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"email.js":["meteor/meteor","nodemailer","nodemailer-smtp-pool",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/email.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({send:function(){return send},rawSend:function(){return rawSend}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var nodemailer;module.import("nodemailer",{"default":function(v){nodemailer=v}});var smtpPool;module.import("nodemailer-smtp-pool",{"default":function(v){smtpPool=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 5
                                                                                                                       //
var getSmtpConfig = function getSmtpConfig() {                                                                         // 7
  var config = Settings.findOne({ _id: "smtpConfig" });                                                                // 8
  return config && config.value;                                                                                       // 9
};                                                                                                                     // 10
                                                                                                                       //
var makePool = function makePool(mailConfig) {                                                                         // 12
  if (!mailConfig.hostname) {                                                                                          // 13
    throw new Error("This Sandstorm server has not been configured to send email.");                                   // 14
  }                                                                                                                    // 15
                                                                                                                       //
  var auth = false;                                                                                                    // 17
  if (mailConfig.auth && (mailConfig.auth.user || mailConfig.auth.pass)) {                                             // 18
    auth = mailConfig.auth;                                                                                            // 19
  }                                                                                                                    // 20
                                                                                                                       //
  var secure = mailConfig.port === 465;                                                                                // 22
  var tlsOptions = {                                                                                                   // 23
    // Previously, node 0.10 did not attempt to validate certificates received when connecting                         //
    // with STARTTLS, so to avoid regressing we need to preserve that behavior here for now.                           //
    rejectUnauthorized: false                                                                                          // 26
  };                                                                                                                   // 23
                                                                                                                       //
  var pool = nodemailer.createTransport(smtpPool({                                                                     // 29
    host: mailConfig.hostname,                                                                                         // 30
    port: mailConfig.port,                                                                                             // 31
    secure: secure,                                                                                                    // 32
    tls: tlsOptions,                                                                                                   // 33
    auth: auth                                                                                                         // 34
  }));                                                                                                                 // 29
                                                                                                                       //
  // TODO(someday): allow maxConnections to be configured?                                                             //
  pool._futureWrappedSendMail = _.bind(Future.wrap(pool.sendMail), pool);                                              // 38
  return pool;                                                                                                         // 39
};                                                                                                                     // 40
                                                                                                                       //
// We construct the SMTP pool at the first call to Email.send, so that                                                 //
// other code like migrations can modify the SMTP configuration.                                                       //
var pool = void 0;                                                                                                     // 44
var configured = false;                                                                                                // 45
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 47
  Settings.find({ _id: "smtpConfig" }).observeChanges({                                                                // 48
    removed: function removed() {                                                                                      // 49
      configured = false;                                                                                              // 50
    },                                                                                                                 // 51
                                                                                                                       //
    changed: function changed() {                                                                                      // 53
      configured = false;                                                                                              // 54
    },                                                                                                                 // 55
                                                                                                                       //
    added: function added() {                                                                                          // 57
      configured = false;                                                                                              // 58
    }                                                                                                                  // 59
  });                                                                                                                  // 48
});                                                                                                                    // 61
                                                                                                                       //
var getPool = function getPool(smtpConfig) {                                                                           // 63
  if (smtpConfig) {                                                                                                    // 64
    return makePool(smtpConfig);                                                                                       // 65
  } else if (!configured) {                                                                                            // 66
    configured = true;                                                                                                 // 67
    var config = getSmtpConfig();                                                                                      // 68
    if (config) {                                                                                                      // 69
      pool = makePool(config);                                                                                         // 70
    }                                                                                                                  // 71
  }                                                                                                                    // 72
                                                                                                                       //
  return pool;                                                                                                         // 74
};                                                                                                                     // 75
                                                                                                                       //
var smtpSend = function smtpSend(pool, mailOptions) {                                                                  // 77
  pool._futureWrappedSendMail(mailOptions).wait();                                                                     // 78
};                                                                                                                     // 79
                                                                                                                       //
var rawSend = function rawSend(mailOptions, smtpConfig) {                                                              // 81
  // Sends an email mailOptions object structured as described in                                                      //
  // https://github.com/nodemailer/mailcomposer#e-mail-message-fields                                                  //
  // across the transport described by smtpConfig.                                                                     //
  var pool = getPool(smtpConfig);                                                                                      // 85
  if (pool) {                                                                                                          // 86
    smtpSend(pool, mailOptions);                                                                                       // 87
  } else {                                                                                                             // 88
    throw new Error("SMTP pool is misconfigured.");                                                                    // 89
  }                                                                                                                    // 90
};                                                                                                                     // 91
                                                                                                                       //
// Old comment below                                                                                                   //
/**                                                                                                                    //
 * Send an email.                                                                                                      //
 *                                                                                                                     //
 * Connects to the mail server configured via the MAIL_URL environment                                                 //
 * variable. If unset, prints formatted message to stdout. The "from" option                                           //
 * is required, and at least one of "to", "cc", and "bcc" must be provided;                                            //
 * all other options are optional.                                                                                     //
 *                                                                                                                     //
 * @param options                                                                                                      //
 * @param options.from {String} RFC5322 "From:" address                                                                //
 * @param options.to {String|String[]} RFC5322 "To:" address[es]                                                       //
 * @param options.cc {String|String[]} RFC5322 "Cc:" address[es]                                                       //
 * @param options.bcc {String|String[]} RFC5322 "Bcc:" address[es]                                                     //
 * @param options.replyTo {String|String[]} RFC5322 "Reply-To:" address[es]                                            //
 * @param options.subject {String} RFC5322 "Subject:" line                                                             //
 * @param options.text {String} RFC5322 mail body (plain text)                                                         //
 * @param options.html {String} RFC5322 mail body (HTML)                                                               //
 * @param options.headers {Object} custom RFC5322 headers (dictionary)                                                 //
 */                                                                                                                    //
                                                                                                                       //
// New API doc comment below                                                                                           //
/**                                                                                                                    //
 * @summary Send an email. Throws an `Error` on failure to contact mail server                                         //
 * or if mail server returns an error. All fields should match                                                         //
 * [RFC5322](http://tools.ietf.org/html/rfc5322) specification.                                                        //
 * @locus Server                                                                                                       //
 * @param {Object} options                                                                                             //
 * @param {String} options.from "From:" address (required)                                                             //
 * @param {String|String[]} options.to,cc,bcc,replyTo                                                                  //
 *   "To:", "Cc:", "Bcc:", and "Reply-To:" addresses                                                                   //
 * @param {String} [options.subject]  "Subject:" line                                                                  //
 * @param {String} [options.text|html] Mail body (in plain text or HTML)                                               //
 * @param {Object} [options.headers] Dictionary of custom headers                                                      //
 * @param {Object} [options.smtpConfig] SMTP server to use. Otherwise defaults to configured one.                      //
 * @param {String} [options.smtpConfig.hostname] SMTP server hostname.                                                 //
 * @param {Number} [options.smtpConfig.port] SMTP server port.                                                         //
 * @param {Object} [options.smtpConfig.auth] SMTP server authentication tokens.  Optional.                             //
 * @param {String} [options.smtpConfig.auth.user] Username of user to log in to SMTP server as.  Optional.             //
 * @param {String} [options.smtpConfig.auth.pass] Password of user to log in to SMTP server as.  Optional.             //
 * @param {Object} [options.attachments] Attachments. See:                                                             //
 *   https://github.com/nodemailer/mailcomposer/tree/v0.1.15#add-attachments                                           //
 * @param {String} [options.envelopeFrom] Envelope sender.                                                             //
 */                                                                                                                    //
var send = function send(options) {                                                                                    // 137
  // Unpack options                                                                                                    //
  var from = options.from;                                                                                             // 137
  var to = options.to;                                                                                                 // 137
  var cc = options.cc;                                                                                                 // 137
  var bcc = options.bcc;                                                                                               // 137
  var replyTo = options.replyTo;                                                                                       // 137
  var subject = options.subject;                                                                                       // 137
  var text = options.text;                                                                                             // 137
  var html = options.html;                                                                                             // 137
  var envelopeFrom = options.envelopeFrom;                                                                             // 137
  var headers = options.headers;                                                                                       // 137
  var attachments = options.attachments;                                                                               // 137
  var smtpConfig = options.smtpConfig;                                                                                 // 137
                                                                                                                       //
                                                                                                                       //
  var opts = {                                                                                                         // 154
    from: from,                                                                                                        // 155
    to: to,                                                                                                            // 156
    cc: cc,                                                                                                            // 157
    bcc: bcc,                                                                                                          // 158
    replyTo: replyTo,                                                                                                  // 159
    subject: subject,                                                                                                  // 160
    text: text,                                                                                                        // 161
    html: html,                                                                                                        // 162
    headers: headers,                                                                                                  // 163
    attachments: attachments                                                                                           // 164
  };                                                                                                                   // 154
                                                                                                                       //
  if (envelopeFrom) {                                                                                                  // 167
    opts.envelope = {                                                                                                  // 168
      from: envelopeFrom,                                                                                              // 169
      to: to,                                                                                                          // 170
      cc: cc,                                                                                                          // 171
      bcc: bcc                                                                                                         // 172
    };                                                                                                                 // 168
  }                                                                                                                    // 174
                                                                                                                       //
  rawSend(opts, smtpConfig);                                                                                           // 176
};                                                                                                                     // 177
                                                                                                                       //
                                                                                                                       // 179
                                                                                                                       //
// TODO(cleanup): Remove this once BlackrockPayments code finds a better way to import it.                             //
global.SandstormEmail = { send: send };                                                                                // 182
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"frontend-ref.js":["babel-runtime/helpers/classCallCheck","./persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/frontend-ref.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({FrontendRefRegistry:function(){return FrontendRefRegistry}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var checkRequirements;module.import("./persistent.js",{"checkRequirements":function(v){checkRequirements=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var FrontendRefRegistry = function () {                                                                                //
  function FrontendRefRegistry() {                                                                                     // 20
    _classCallCheck(this, FrontendRefRegistry);                                                                        // 20
                                                                                                                       //
    this._frontendRefHandlers = {};                                                                                    // 21
    this._typeIdHandlers = {};                                                                                         // 22
  }                                                                                                                    // 23
                                                                                                                       //
  FrontendRefRegistry.prototype.create = function create(db, frontendRef, requirements) {                              //
    // Construct a fresh capability based on a `frontendRef` value.                                                    //
                                                                                                                       //
    checkRequirements(requirements);                                                                                   // 28
                                                                                                                       //
    var saveTemplate = { frontendRef: frontendRef };                                                                   // 30
    if (requirements) {                                                                                                // 31
      saveTemplate.requirements = requirements;                                                                        // 32
    }                                                                                                                  // 33
                                                                                                                       //
    return this.restore(db, saveTemplate, frontendRef);                                                                // 35
  };                                                                                                                   // 36
                                                                                                                       //
  FrontendRefRegistry.prototype.restore = function restore(db, saveTemplate, frontendRef) {                            //
    // Restores a frontendRef capability using the appropriate registered handler.                                     //
                                                                                                                       //
    var keys = Object.keys(frontendRef);                                                                               // 41
    if (keys.length != 1) {                                                                                            // 42
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var key = keys[0];                                                                                                 // 46
    var handler = this._frontendRefHandlers[key];                                                                      // 47
    if (!handler) {                                                                                                    // 48
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return handler.restore(db, saveTemplate, frontendRef[key]);                                                        // 52
  };                                                                                                                   // 53
                                                                                                                       //
  FrontendRefRegistry.prototype.query = function query(db, userAccountId, tag) {                                       //
    // Performs a powerbox query using the appropriate registered handler.                                             //
                                                                                                                       //
    var handler = this._typeIdHandlers[tag.id];                                                                        // 58
    if (handler) {                                                                                                     // 59
      return handler.query(db, userAccountId, tag.value);                                                              // 60
    } else {                                                                                                           // 61
      return []; // no matches                                                                                         // 62
    }                                                                                                                  // 63
  };                                                                                                                   // 64
                                                                                                                       //
  FrontendRefRegistry.prototype.validate = function validate(db, session, frontendRefRequest) {                        //
    // Validates a powerbox request on the given `session` (a record from the Sessions table)                          //
    // requesting the creation of the given frontendRef type. `frontendRefRequest` is expected to                      //
    // come directly from the client; calling validate() verifies that it is well-formed and                           //
    // carries out any type-specific server-side work needed to construct the desired frontendRef.                     //
    // `validate()` also returns an array of MembraneRequirements that shall apply to the                              //
    // capability. These requirements will not yet have been checked, so the caller should check                       //
    // them before proceeding.                                                                                         //
                                                                                                                       //
    var keys = Object.keys(frontendRefRequest);                                                                        // 75
    if (keys.length != 1) {                                                                                            // 76
      throw new Error("invalid frontendRefRequest: " + JSON.stringify(frontendRefRequest));                            // 77
    }                                                                                                                  // 78
                                                                                                                       //
    var key = keys[0];                                                                                                 // 80
    var handler = this._frontendRefHandlers[key];                                                                      // 81
    if (!handler) {                                                                                                    // 82
      throw new Error("invalid frontendRefRequest: " + JSON.stringify(frontendRefRequest));                            // 83
    }                                                                                                                  // 84
                                                                                                                       //
    if (!handler.validate) {                                                                                           // 86
      throw new Error("frontendRef type cannot be created via powerbox: " + JSON.stringify(frontendRefRequest));       // 87
    }                                                                                                                  // 89
                                                                                                                       //
    var _handler$validate = handler.validate(db, session, frontendRefRequest[key]);                                    // 66
                                                                                                                       //
    var descriptor = _handler$validate.descriptor;                                                                     // 66
    var requirements = _handler$validate.requirements;                                                                 // 66
    var frontendRef = _handler$validate.frontendRef;                                                                   // 66
                                                                                                                       //
                                                                                                                       //
    var result = { descriptor: descriptor, requirements: requirements, frontendRef: {} };                              // 94
    result.frontendRef[key] = frontendRef;                                                                             // 95
    return result;                                                                                                     // 96
  };                                                                                                                   // 97
                                                                                                                       //
  FrontendRefRegistry.prototype.register = function register(object) {                                                 //
    // Register callbacks related to a particular frontendRef type. The object has the fields:                         //
    //   `frontendRefField`: Name of the field of `ApiTokens.frontendRef` that is filled in for                        //
    //       this type. Only needed if `create` and/or `validate` handlers are defined.                                //
    //   `typeId`: Type ID of powerbox tags handled by the `query` callback. Stringified decimal                       //
    //       64-bit integer. Only needed if `query` is defined.                                                        //
    //   `restore`: Callback to construct a capability of this type when restoring a saved                             //
    //       capability. Has signature `(db, saveTemplate, value) -> capability`, where:                               //
    //     `value`: The value of the single field of `ApiTokens.frontendRef` for this capability.                      //
    //     `saveTemplate`: The token template to pass to the PersistentImpl constructor.                               //
    //     `capability` (returned): A Cap'n Proto capability implementing SystemPersistent along                       //
    //         with whatever other interfaces are appropriate for the ref type.                                        //
    //   `validate`: Callback to validate a powerbox request for a new capability of this type.                        //
    //       Has signature `(db, session, request) -> {descriptor, requirements, frontendRef}`,                        //
    //       where:                                                                                                    //
    //     `request` is type-specific information describing the requested capability. The                             //
    //         callback *must* type-check this value, and should throw an exception if it is                           //
    //         not valid.                                                                                              //
    //     `session` is the record from the Sessions table of the UI session where the powerbox                        //
    //         request occurred.                                                                                       //
    //     `descriptor` (returned) is the JSON-encoded PowerboxDescriptor for the capability. Note                     //
    //         that if the descriptor contains any `tag.value`s, they of course need to be                             //
    //         presented as capnp-encoded Buffers.                                                                     //
    //     `requirements` (returned) is an array of MembraneRequirements which should apply to the                     //
    //         new capability. Note that these requirements will be checked immediately and the                        //
    //         powerbox request will fail if they aren't met.                                                          //
    //     `frontendRef` (returned) is the value that will be written for the key specified                            //
    //         by `frontendRefField` in the single-key object `ApiTokens.frontendRef`.                                 //
    //    `query`: Callback to populate options for a powerbox request for this type ID. Has                           //
    //        signature `(db, userAccountId, tagValue) -> options`, where:                                             //
    //      `tagValue`: A Buffer of the Cap'n-Proto-encoded `PowerboxDescriptor.Tag.value`.                            //
    //      `options` (returned): An array of objects representing the options that should be                          //
    //          offered to the user for this query. See the `powerboxOptions` Meteor publish in                        //
    //          powerbox-server.js for a full description of the fields of each option.                                //
                                                                                                                       //
    if (object.frontendRefField) {                                                                                     // 134
      if (object.frontendRefField in this._frontendRefHandlers) {                                                      // 135
        throw new Error("frontendRef handler already registered: " + object.frontendRefField);                         // 136
      }                                                                                                                // 137
                                                                                                                       //
      this._frontendRefHandlers[object.frontendRefField] = object;                                                     // 139
    }                                                                                                                  // 140
                                                                                                                       //
    if (object.typeId) {                                                                                               // 142
      if (object.typeId in this._typeIdHandlers) {                                                                     // 143
        throw new Error("typeId handler already registered: " + object.typeId);                                        // 144
      }                                                                                                                // 145
                                                                                                                       //
      this._typeIdHandlers[object.typeId] = object;                                                                    // 147
    }                                                                                                                  // 148
  };                                                                                                                   // 149
                                                                                                                       //
  return FrontendRefRegistry;                                                                                          //
}();                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 152
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"migrations.js":["meteor/meteor","meteor/underscore","meteor/check","/imports/server/accounts/picture.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/migrations.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({migrateToLatest:function(){return migrateToLatest}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var _;module.import("meteor/underscore",{"_":function(v){_=v}});var Match;module.import("meteor/check",{"Match":function(v){Match=v}});var userPictureUrl,fetchPicture;module.import("/imports/server/accounts/picture.js",{"userPictureUrl":function(v){userPictureUrl=v},"fetchPicture":function(v){fetchPicture=v}});var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});// Minimal tooling for doing run-at-least-once, ordered migrations.
//                                                                                                                     //
// Because migrations can experience partial failure and likely have                                                   //
// side-effects, we should be careful to make sure all migrations are                                                  //
// idempotent and safe to accidentally run multiple times.                                                             //
                                                                                                                       //
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       // 9
                                                                                                                       // 10
                                                                                                                       // 11
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 13
var Url = Npm.require("url");                                                                                          // 14
var Crypto = Npm.require("crypto");                                                                                    // 15
                                                                                                                       //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect(db, backend) {                                    // 17
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 18
  ["google", "github"].forEach(function (serviceName) {                                                                // 19
    var config = configurations.findOne({ service: serviceName });                                                     // 20
    if (config && config.loginStyle !== "redirect") {                                                                  // 21
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                           // 22
    }                                                                                                                  // 23
  });                                                                                                                  // 24
};                                                                                                                     // 25
                                                                                                                       //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings(db, backend) {      // 27
  // In the before time, Google and Github login were enabled by default.                                              //
  //                                                                                                                   //
  // This actually didn't make much sense, required the first user to configure                                        //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                          //
  // secure.                                                                                                           //
  //                                                                                                                   //
  // Now, we have admin-token, so we wish to disable all logins by default                                             //
  // (since they need to be configured anyway) but since users may have never                                          //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                          //
  // we can't just use the value in the Settings collection, since it might                                            //
  // never have been set.                                                                                              //
  //                                                                                                                   //
  // Thus, if the service is configured but absent from Settings, we should                                            //
  // explicitly enable it in Settings, and then the rest of the logic can just                                         //
  // depend on what value is in Settings and default to false without breaking                                         //
  // user installations.                                                                                               //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 44
  ["google", "github"].forEach(function (serviceName) {                                                                // 45
    var config = configurations.findOne({ service: serviceName });                                                     // 46
    var serviceConfig = db.collections.settings.findOne({ _id: serviceName });                                         // 47
    if (config && !serviceConfig) {                                                                                    // 48
      // Only explicitly enable the login service if:                                                                  //
      // 1) the service is already configured                                                                          //
      // 2) there is no sandstorm configuration already present (the user was                                          //
      //    using the previous default behavior).                                                                      //
      db.collections.settings.insert({ _id: serviceName, value: true });                                               // 53
    }                                                                                                                  // 54
  });                                                                                                                  // 55
};                                                                                                                     // 56
                                                                                                                       //
var denormalizeInviteInfo = function denormalizeInviteInfo(db, backend) {                                              // 58
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                        //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                    //
  // which has more information about the key, namely a freeform note entered by the admin when                        //
  // they created the key. In the case that the email invite form was used, the note has the form                      //
  // "E-mail invite to <address>".                                                                                     //
  //                                                                                                                   //
  // Later, we decided it was useful to indicate in the users table visible to the admin                               //
  // information about the invite terms. Namely, for email invites we want to show the address                         //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                          //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                        //
  // from the SignupKeys table.                                                                                        //
                                                                                                                       //
  db.collections.users.find().forEach(function (user) {                                                                // 71
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                          // 72
      var signupInfo = db.collections.signupKeys.findOne(user.signupKey);                                              // 73
      if (signupInfo && signupInfo.note) {                                                                             // 74
        var newFields = { signupNote: signupInfo.note };                                                               // 75
                                                                                                                       //
        var prefix = "E-mail invite to ";                                                                              // 77
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                               // 78
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                                // 79
        }                                                                                                              // 80
                                                                                                                       //
        db.collections.users.update(user._id, { $set: newFields });                                                    // 82
      }                                                                                                                // 83
    }                                                                                                                  // 84
  });                                                                                                                  // 85
};                                                                                                                     // 86
                                                                                                                       //
var mergeRoleAssignmentsIntoApiTokens = function mergeRoleAssignmentsIntoApiTokens(db, backend) {                      // 88
  db.collections.roleAssignments.find().forEach(function (roleAssignment) {                                            // 89
    db.collections.apiTokens.insert({                                                                                  // 90
      grainId: roleAssignment.grainId,                                                                                 // 91
      userId: roleAssignment.sharer,                                                                                   // 92
      roleAssignment: roleAssignment.roleAssignment,                                                                   // 93
      petname: roleAssignment.petname,                                                                                 // 94
      created: roleAssignment.created,                                                                                 // 95
      owner: {                                                                                                         // 96
        user: {                                                                                                        // 97
          userId: roleAssignment.recipient,                                                                            // 98
          title: roleAssignment.title                                                                                  // 99
        }                                                                                                              // 97
      }                                                                                                                // 96
    });                                                                                                                // 90
  });                                                                                                                  // 103
};                                                                                                                     // 104
                                                                                                                       //
var fixOasisStorageUsageStats = function fixOasisStorageUsageStats(db, backend) {};                                    // 106
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                     //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                      //
// with a no-op.                                                                                                       //
                                                                                                                       //
var fetchProfilePictures = function fetchProfilePictures(db, backend) {                                                // 111
  db.collections.users.find({}).forEach(function (user) {                                                              // 112
    var url = userPictureUrl(user);                                                                                    // 113
    if (url) {                                                                                                         // 114
      console.log("Fetching user picture:", url);                                                                      // 115
      var assetId = fetchPicture(db, url);                                                                             // 116
      if (assetId) {                                                                                                   // 117
        db.collections.users.update(user._id, { $set: { "profile.picture": assetId } });                               // 118
      }                                                                                                                // 119
    }                                                                                                                  // 120
  });                                                                                                                  // 121
};                                                                                                                     // 122
                                                                                                                       //
var assignPlans = function assignPlans(db, backend) {                                                                  // 124
  // This was a one-time migration intended to be applied on Oasis to existing users.                                  //
  // It has run, so we only need this stub function here.                                                              //
};                                                                                                                     // 127
                                                                                                                       //
var removeKeyrings = function removeKeyrings(db, backend) {                                                            // 129
  // These blobs full of public keys were not intended to find their way into mongo and while                          //
  // harmless they slow things down because they're huge. Remove them.                                                 //
  db.collections.packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
};                                                                                                                     // 135
                                                                                                                       //
var useLocalizedTextInUserActions = function useLocalizedTextInUserActions(db, backend) {                              // 137
  function toLocalizedText(newObj, oldObj, field) {                                                                    // 138
    if (field in oldObj) {                                                                                             // 139
      if (typeof oldObj[field] === "string") {                                                                         // 140
        newObj[field] = { defaultText: oldObj[field] };                                                                // 141
      } else {                                                                                                         // 142
        newObj[field] = oldObj[field];                                                                                 // 143
      }                                                                                                                // 144
    }                                                                                                                  // 145
  }                                                                                                                    // 146
                                                                                                                       //
  db.collections.userActions.find({}).forEach(function (userAction) {                                                  // 148
    var fields = {};                                                                                                   // 149
    toLocalizedText(fields, userAction, "appTitle");                                                                   // 150
    toLocalizedText(fields, userAction, "title");                                                                      // 151
    toLocalizedText(fields, userAction, "nounPhrase");                                                                 // 152
    db.collections.userActions.update(userAction._id, { $set: fields });                                               // 153
  });                                                                                                                  // 154
};                                                                                                                     // 155
                                                                                                                       //
var verifyAllPgpSignatures = function verifyAllPgpSignatures(db, backend) {                                            // 157
  db.collections.packages.find({}).forEach(function (pkg) {                                                            // 158
    try {                                                                                                              // 159
      console.log("checking PGP signature for package:", pkg._id);                                                     // 160
      var info = waitPromise(backend.cap().tryGetPackage(pkg._id));                                                    // 161
      if (info.authorPgpKeyFingerprint) {                                                                              // 162
        console.log("  " + info.authorPgpKeyFingerprint);                                                              // 163
        db.collections.packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });  // 164
      } else {                                                                                                         // 166
        console.log("  no signature");                                                                                 // 167
      }                                                                                                                // 168
    } catch (err) {                                                                                                    // 169
      console.error(err.stack);                                                                                        // 170
    }                                                                                                                  // 171
  });                                                                                                                  // 172
};                                                                                                                     // 173
                                                                                                                       //
var splitUserIdsIntoAccountIdsAndIdentityIds = function splitUserIdsIntoAccountIdsAndIdentityIds(db, backend) {        // 175
  db.collections.users.find().forEach(function (user) {                                                                // 176
    var identity = {};                                                                                                 // 177
    var serviceUserId = void 0;                                                                                        // 178
    if ("devName" in user) {                                                                                           // 179
      identity.service = "dev";                                                                                        // 180
      serviceUserId = user.devName;                                                                                    // 181
    } else if ("expires" in user) {                                                                                    // 182
      identity.service = "demo";                                                                                       // 183
      serviceUserId = user._id;                                                                                        // 184
    } else if (user.services && "google" in user.services) {                                                           // 185
      identity.service = "google";                                                                                     // 186
      if (user.services.google.email && user.services.google.verified_email) {                                         // 187
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                          //
        identity.verifiedEmail = user.services.google.email;                                                           // 188
      }                                                                                                                // 189
                                                                                                                       //
      serviceUserId = user.services.google.id;                                                                         // 191
    } else if (user.services && "github" in user.services) {                                                           // 192
      identity.service = "github";                                                                                     // 193
      identity.unverifiedEmail = user.services.github.email;                                                           // 194
      serviceUserId = user.services.github.id;                                                                         // 195
    } else if (user.services && "emailToken" in user.services) {                                                       // 196
      identity.service = "emailToken";                                                                                 // 197
      identity.verifiedEmail = user.services.emailToken.email;                                                         // 198
      serviceUserId = user.services.emailToken.email;                                                                  // 199
    }                                                                                                                  // 200
                                                                                                                       //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");            // 202
                                                                                                                       //
    if (user.profile) {                                                                                                // 205
      if (user.profile.name) {                                                                                         // 206
        identity.name = user.profile.name;                                                                             // 207
      }                                                                                                                // 208
                                                                                                                       //
      if (user.profile.handle) {                                                                                       // 210
        identity.handle = user.profile.handle;                                                                         // 211
      }                                                                                                                // 212
                                                                                                                       //
      if (user.profile.picture) {                                                                                      // 214
        identity.picture = user.profile.picture;                                                                       // 215
      }                                                                                                                // 216
                                                                                                                       //
      if (user.profile.pronoun) {                                                                                      // 218
        identity.pronoun = user.profile.pronoun;                                                                       // 219
      }                                                                                                                // 220
                                                                                                                       //
      if (user.profile.email) {                                                                                        // 222
        identity.unverifiedEmail = user.profile.email;                                                                 // 223
      }                                                                                                                // 224
    }                                                                                                                  // 225
                                                                                                                       //
    identity.main = true;                                                                                              // 227
                                                                                                                       //
    db.collections.users.update(user._id, { $set: { identities: [identity] } });                                       // 229
                                                                                                                       //
    db.collections.grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });        // 231
    db.collections.sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });      // 232
    db.collections.apiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });     // 233
    db.collections.apiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({                                                                           // 243
      "requirements.permissionsHeld.userId": user._id                                                                  // 244
    }, {                                                                                                               // 243
      $set: { "requirements.$.permissionsHeld.identityId": identity.id },                                              // 246
      $unset: { "requirements.$.permissionsHeld.userId": 1 }                                                           // 247
    }, {                                                                                                               // 245
      multi: true                                                                                                      // 249
    }) > 0) {}                                                                                                         // 248
    // The `$` operator modifies the first element in the array that matches the query. Since                          //
    // there may be many matches, we need to repeat until no documents are modified.                                   //
  });                                                                                                                  // 254
                                                                                                                       //
  db.collections.apiTokens.remove({ userInfo: { $exists: true } });                                                    // 256
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                              //
  // that this field could show up in the database was in this deprecated, no-longer-functional                        //
  // form of API token.                                                                                                //
};                                                                                                                     // 260
                                                                                                                       //
var appUpdateSettings = function appUpdateSettings(db, backend) {                                                      // 262
  db.collections.settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                         // 263
  db.collections.settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                     // 264
  db.collections.settings.insert({ _id: "appUpdatesEnabled", value: true });                                           // 265
};                                                                                                                     // 266
                                                                                                                       //
var moveDevAndEmailLoginDataIntoIdentities = function moveDevAndEmailLoginDataIntoIdentities(db, backend) {            // 268
  db.collections.users.find().forEach(function (user) {                                                                // 269
    if (user.identities.length !== 1) {                                                                                // 270
      throw new Error("User does not have exactly one identity: ", user);                                              // 271
    }                                                                                                                  // 272
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 274
    if (Match.test(identity.service, Object)) {                                                                        // 275
      return;                                                                                                          // 275
    } // Already migrated.                                                                                             // 275
                                                                                                                       //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                   // 277
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                    // 278
                                                                                                                       //
    var serviceObject = {};                                                                                            // 280
    var fieldsToUnset = {};                                                                                            // 281
                                                                                                                       //
    if (identity.service === "dev") {                                                                                  // 283
      serviceObject.name = user.devName;                                                                               // 284
      fieldsToUnset.devName = 1;                                                                                       // 285
    } else if (identity.service === "emailToken") {                                                                    // 286
      serviceObject.tokens = user.services.emailToken.tokens;                                                          // 287
      serviceObject.email = user.services.emailToken.email;                                                            // 288
      fieldsToUnset["services.emailToken"] = 1;                                                                        // 289
    }                                                                                                                  // 290
                                                                                                                       //
    newIdentity.service = {};                                                                                          // 292
    newIdentity.service[identity.service] = serviceObject;                                                             // 293
                                                                                                                       //
    var modifier = { $set: { identities: [newIdentity] } };                                                            // 295
    if (Object.keys(fieldsToUnset).length > 0) {                                                                       // 296
      modifier.$unset = fieldsToUnset;                                                                                 // 297
    }                                                                                                                  // 298
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, modifier);                                                          // 300
  });                                                                                                                  // 301
};                                                                                                                     // 302
                                                                                                                       //
var repairEmailIdentityIds = function repairEmailIdentityIds(db, backend) {                                            // 304
  db.collections.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {             // 305
    if (user.identities.length !== 1) {                                                                                // 306
      throw new Error("User does not have exactly one identity: ", user);                                              // 307
    }                                                                                                                  // 308
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 310
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");               // 311
    newIdentity.service = { email: identity.service.emailToken };                                                      // 313
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");   // 314
                                                                                                                       //
    db.collections.grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                           // 333
  });                                                                                                                  // 334
};                                                                                                                     // 335
                                                                                                                       //
var splitAccountUsersAndIdentityUsers = function splitAccountUsersAndIdentityUsers(db, backend) {                      // 337
  db.collections.users.find({ identities: { $exists: true } }).forEach(function (user) {                               // 338
    if (user.identities.length !== 1) {                                                                                // 339
      throw new Error("User does not have exactly one identity: ", user);                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 343
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                             // 344
    identityUser._id = identity.id;                                                                                    // 345
    identityUser.profile = identity.profile;                                                                           // 346
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                       // 347
    identityUser.profile.service = Object.keys(identity.service)[0];                                                   // 348
                                                                                                                       //
    // Updating this user needs to be a two step process because the `services` field typically                        //
    // contains subfields that are constrained to be unique by Mongo indices.                                          //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                     // 352
    if (identity.service.dev) {                                                                                        // 353
      identityUser.stagedServices.dev = identity.service.dev;                                                          // 354
    } else if (identity.service.email) {                                                                               // 355
      identityUser.stagedServices.email = identity.service.email;                                                      // 356
    }                                                                                                                  // 357
                                                                                                                       //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                            // 363
    accountUser.nonloginIdentities = [];                                                                               // 364
    if (user.services && user.services.resume) {                                                                       // 365
      accountUser.services = { resume: user.services.resume };                                                         // 366
    }                                                                                                                  // 367
                                                                                                                       //
    accountUser.stashedOldUser = user;                                                                                 // 369
                                                                                                                       //
    db.collections.apiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });
                                                                                                                       //
    db.collections.users.upsert({ _id: identityUser._id }, identityUser);                                              // 376
    db.collections.users.update({ _id: user._id }, accountUser);                                                       // 377
  });                                                                                                                  // 378
                                                                                                                       //
  db.collections.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                       // 380
    db.collections.users.update({ _id: identity._id }, {                                                               // 381
      $unset: { stagedServices: 1 },                                                                                   // 382
      $set: { services: identity.stagedServices }                                                                      // 383
    });                                                                                                                // 381
  });                                                                                                                  // 385
};                                                                                                                     // 386
                                                                                                                       //
var populateContactsFromApiTokens = function populateContactsFromApiTokens(db, backend) {                              // 388
  db.collections.apiTokens.find({                                                                                      // 389
    "owner.user.identityId": { $exists: 1 },                                                                           // 390
    accountId: { $exists: 1 }                                                                                          // 391
  }).forEach(function (token) {                                                                                        // 389
    var identityId = token.owner.user.identityId;                                                                      // 393
    var identity = db.getIdentity(identityId);                                                                         // 394
    if (identity) {                                                                                                    // 395
      var profile = identity.profile;                                                                                  // 396
      db.collections.contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                           // 397
        ownerId: token.accountId,                                                                                      // 398
        petname: profile && profile.name,                                                                              // 399
        created: new Date(),                                                                                           // 400
        identityId: identityId,                                                                                        // 401
        profile: profile                                                                                               // 402
      });                                                                                                              // 397
    }                                                                                                                  // 404
  });                                                                                                                  // 405
};                                                                                                                     // 406
                                                                                                                       //
var cleanUpApiTokens = function cleanUpApiTokens(db, backend) {                                                        // 408
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                       //
  // where the user still existed in the database.                                                                     //
  db.collections.apiTokens.remove({                                                                                    // 411
    userId: { $exists: true },                                                                                         // 412
    identityId: { $exists: false }                                                                                     // 413
  });                                                                                                                  // 411
  db.collections.apiTokens.remove({                                                                                    // 415
    "owner.user.userId": { $exists: true },                                                                            // 416
    "owner.user.identityId": { $exists: false }                                                                        // 417
  });                                                                                                                  // 415
                                                                                                                       //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                             //
  db.collections.apiTokens.find({                                                                                      // 421
    "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true }                                                  // 422
  }).forEach(function (apiToken) {                                                                                     // 421
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                  // 424
    db.collections.apiTokens.update({ _id: apiToken._id }, {                                                           // 425
      $set: { "owner.user.denormalizedGrainMetadata.icon": icon },                                                     // 426
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true }                                                 // 427
    });                                                                                                                // 425
  });                                                                                                                  // 429
                                                                                                                       //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                    //
  function repairChain(parentToken) {                                                                                  // 432
    db.collections.apiTokens.find({                                                                                    // 433
      parentToken: parentToken._id,                                                                                    // 434
      grainId: { $exists: true },                                                                                      // 435
      identityId: { $exists: false }                                                                                   // 436
    }).forEach(function (childToken) {                                                                                 // 433
      db.collections.apiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });      // 438
      repairChain(childToken);                                                                                         // 439
    });                                                                                                                // 440
  }                                                                                                                    // 441
                                                                                                                       //
  db.collections.apiTokens.find({                                                                                      // 443
    grainId: { $exists: true },                                                                                        // 444
    identityId: { $exists: true },                                                                                     // 445
    parentToken: { $exists: false }                                                                                    // 446
  }).forEach(repairChain);                                                                                             // 443
};                                                                                                                     // 448
                                                                                                                       //
var initServerTitleAndReturnAddress = function initServerTitleAndReturnAddress(db, backend) {                          // 450
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                             // 451
  db.collections.settings.insert({ _id: "serverTitle", value: hostname });                                             // 452
  db.collections.settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                             // 453
};                                                                                                                     // 454
                                                                                                                       //
var sendReferralNotifications = function sendReferralNotifications(db, backend) {                                      // 456
  if (db.isReferralEnabled()) {                                                                                        // 457
    db.collections.users.find({                                                                                        // 458
      loginIdentities: { $exists: true },                                                                              // 459
      expires: { $exists: false }                                                                                      // 460
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                               // 458
      db.sendReferralProgramNotification(user._id);                                                                    // 462
    });                                                                                                                // 463
  }                                                                                                                    // 464
};                                                                                                                     // 465
                                                                                                                       //
var assignBonuses = function assignBonuses(db, backend) {                                                              // 467
  // This was a one-time migration intended to be applied on Oasis to existing users.                                  //
  // It has run, so we only need this stub function here.                                                              //
};                                                                                                                     // 470
                                                                                                                       //
var splitSmtpUrl = function splitSmtpUrl(db, backend) {                                                                // 472
  var smtpUrlSetting = db.collections.settings.findOne({ _id: "smtpUrl" });                                            // 473
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                          // 474
  var returnAddress = db.collections.settings.findOne({ _id: "returnAddress" });                                       // 475
                                                                                                                       //
  // Default values.                                                                                                   //
  var smtpConfig = {                                                                                                   // 478
    hostname: "localhost",                                                                                             // 479
    port: "25",                                                                                                        // 480
    auth: undefined,                                                                                                   // 481
    returnAddress: returnAddress.value                                                                                 // 482
  };                                                                                                                   // 478
                                                                                                                       //
  var parsed = void 0;                                                                                                 // 485
  try {                                                                                                                // 486
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                            // 487
  } catch (e) {}                                                                                                       // 488
                                                                                                                       //
  if (parsed) {                                                                                                        // 490
    // If there was a SMTP URL previously defined, import its data.                                                    //
    var auth = undefined;                                                                                              // 492
    if (parsed.auth) {                                                                                                 // 493
      var colonIndex = parsed.auth.indexOf(":");                                                                       // 494
      var user = undefined;                                                                                            // 495
      var pass = undefined;                                                                                            // 496
      if (colonIndex !== -1) {                                                                                         // 497
        user = parsed.auth.slice(0, colonIndex);                                                                       // 498
        pass = parsed.auth.slice(colonIndex + 1);                                                                      // 499
      }                                                                                                                // 500
                                                                                                                       //
      auth = {                                                                                                         // 502
        user: user,                                                                                                    // 503
        pass: pass                                                                                                     // 504
      };                                                                                                               // 502
    }                                                                                                                  // 506
                                                                                                                       //
    // Override defaults with previous config's values.                                                                //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                              // 509
    smtpConfig.port = parsed.port || "25";                                                                             // 510
    smtpConfig.auth = auth;                                                                                            // 511
  }                                                                                                                    // 512
                                                                                                                       //
  db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                        // 514
  db.collections.settings.remove({ _id: "returnAddress" });                                                            // 515
  db.collections.settings.remove({ _id: "smtpUrl" });                                                                  // 516
};                                                                                                                     // 517
                                                                                                                       //
var smtpPortShouldBeNumber = function smtpPortShouldBeNumber(db, backend) {                                            // 519
  var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                  // 520
  if (entry) {                                                                                                         // 521
    var setting = entry.value;                                                                                         // 522
    if (setting.port) {                                                                                                // 523
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                 // 524
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: setting });                                       // 525
    }                                                                                                                  // 526
  }                                                                                                                    // 527
};                                                                                                                     // 528
                                                                                                                       //
var consolidateOrgSettings = function consolidateOrgSettings(db, backend) {                                            // 530
  var settings = db.collections.settings;                                                                              // 531
  var orgGoogleDomain = settings.findOne({ _id: "organizationGoogle" });                                               // 532
  var orgEmailDomain = settings.findOne({ _id: "organizationEmail" });                                                 // 533
  var orgLdap = settings.findOne({ _id: "organizationLdap" });                                                         // 534
  var orgSaml = settings.findOne({ _id: "organizationSaml" });                                                         // 535
                                                                                                                       //
  var orgMembership = {                                                                                                // 537
    google: {                                                                                                          // 538
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                      // 539
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                             // 540
    },                                                                                                                 // 538
    email: {                                                                                                           // 542
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                        // 543
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                               // 544
    },                                                                                                                 // 542
    ldap: {                                                                                                            // 546
      enabled: orgLdap ? orgLdap.value : false                                                                         // 547
    },                                                                                                                 // 546
    saml: {                                                                                                            // 549
      enabled: orgSaml ? orgSaml.value : false                                                                         // 550
    }                                                                                                                  // 549
  };                                                                                                                   // 537
                                                                                                                       //
  settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                        // 554
  settings.remove({ _id: "organizationGoogle" });                                                                      // 555
  settings.remove({ _id: "organizationEmail" });                                                                       // 556
  settings.remove({ _id: "organizationLdap" });                                                                        // 557
  settings.remove({ _id: "organizationSaml" });                                                                        // 558
};                                                                                                                     // 559
                                                                                                                       //
var unsetSmtpDefaultHostnameIfNoUsersExist = function unsetSmtpDefaultHostnameIfNoUsersExist(db, backend) {            // 561
  // We don't actually want to have the default hostname "localhost" set.                                              //
  // If the user has already finished configuring their server, then this migration should do                          //
  // nothing (since we might break their deployment), but for new installs (which will have no users                   //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                     //
  // default value.                                                                                                    //
  var hasUsers = db.collections.users.findOne();                                                                       // 567
  if (!hasUsers) {                                                                                                     // 568
    var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                // 569
    var smtpConfig = entry.value;                                                                                      // 570
    if (smtpConfig.hostname === "localhost") {                                                                         // 571
      smtpConfig.hostname = "";                                                                                        // 572
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                    // 573
    }                                                                                                                  // 574
  }                                                                                                                    // 575
};                                                                                                                     // 576
                                                                                                                       //
var extractLastUsedFromApiTokenOwner = function extractLastUsedFromApiTokenOwner(db, backend) {                        // 578
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                     //
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                     //
  // itself.                                                                                                           //
  db.collections.apiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                        // 582
    var lastUsed = token.owner.user.lastUsed;                                                                          // 583
    db.collections.apiTokens.update({ _id: token._id }, {                                                              // 584
      $set: { lastUsed: lastUsed },                                                                                    // 585
      $unset: { "owner.user.lastUsed": true }                                                                          // 586
    });                                                                                                                // 584
  });                                                                                                                  // 588
};                                                                                                                     // 589
                                                                                                                       //
var setUpstreamTitles = function setUpstreamTitles(db, backend) {                                                      // 591
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                    //
                                                                                                                       //
  var apiTokensRaw = db.collections.apiTokens.rawCollection();                                                         // 594
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                     // 595
                                                                                                                       //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                            //
  // for each of these, so we'd like to skip those which have nothing to update.                                       //
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                  // 602
  });                                                                                                                  // 602
                                                                                                                       //
  var count = 0;                                                                                                       // 604
  db.collections.grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {          // 605
    if (count % 100 == 0) {                                                                                            // 606
      console.log(count + " / " + grainIds.length);                                                                    // 607
    }                                                                                                                  // 608
                                                                                                                       //
    ++count;                                                                                                           // 610
                                                                                                                       //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                              //
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                         //
    // original name, so we don't know whether it was the owner or the receiver who renamed their                      //
    // copy post-sharaing. We assume it was the owner, because:                                                        //
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                    //
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                        //
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                         //
    //    was the user who had renamed their copy. They can rename it again if they like. On the                       //
    //    other hand, if we guessed wrongly in the other direction, the user would see                                 //
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                      //
    //    owner who renamed post-sharing.                                                                              //
    db.collections.apiTokens.update({                                                                                  // 623
      grainId: grain._id,                                                                                              // 624
      "owner.user.title": { $exists: true, $ne: grain.title }                                                          // 625
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                        // 623
  });                                                                                                                  // 627
};                                                                                                                     // 628
                                                                                                                       //
var markAllRead = function markAllRead(db, backend) {                                                                  // 630
  // Mark as "read" all grains and tokens that predate the creation of read/unread status.                             //
  // Otherwise it's pretty annoying to see all your old grains look like they have activity.                           //
                                                                                                                       //
  db.collections.grains.update({}, { $set: { ownerSeenAllActivity: true } }, { multi: true });                         // 634
  db.collections.apiTokens.update({ "owner.user": { $exists: true } }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
};                                                                                                                     // 638
                                                                                                                       //
var clearAppIndex = function clearAppIndex(db, backend) {                                                              // 640
  // Due to a bug in the app update code, some app update notifications that the user accepted                         //
  // around July 9-16, 2016 may not have applied. We have no way of knowing exactly which updates                      //
  // the user accepted but didn't receive. Instead, to recover, we are clearing the local cache of                     //
  // the app index one time. This way, the next time the app index is re-fetched, the server will                      //
  // interpret all of the apps in the index as updated and will re-deliver notifications to                            //
  // everyone. This may mean users get notifications that they previously dismissed, but they can                      //
  // click "dismiss" again easily enough.                                                                              //
                                                                                                                       //
  db.collections.appIndex.remove({});                                                                                  // 649
};                                                                                                                     // 650
                                                                                                                       //
var assignEmailVerifierIds = function assignEmailVerifierIds(db, backend) {                                            // 652
  // Originally, the ID of an EmailVerifier was actually the _id of the root token from which it                       //
  // was restored. This was broken, though: Conceptually, it meant that you couldn't have a working                    //
  // EmailVerifier that had not been restore()d from disk. In practice, that wasn't a problem due                      //
  // to the fact that powerbox selections always involve a restore(), but a different problem                          //
  // existed: the capability returned by claimRequest() would return one ID, but after save()ing                       //
  // and restore()ing that capability, the ID would be different, because the new capability would                     //
  // be a copy -- not a child -- of the original. Additionally, the whole thing made various code                      //
  // ugly because it was puncturing layers of abstraction. So, we switched to doing the right                          //
  // thing: assigning an ID to the EmailVerifier on first creation and storing it separately.                          //
                                                                                                                       //
  db.collections.apiTokens.find({ "frontendRef.emailVerifier": { $exists: true } }).forEach(function (token) {         // 663
    db.collections.apiTokens.update(token._id, { $set: { "frontendRef.emailVerifier.id": token._id } });               // 664
  });                                                                                                                  // 665
};                                                                                                                     // 666
                                                                                                                       //
var startPreinstallingApps = function startPreinstallingApps(db, backend) {                                            // 668
  // This isn't really a normal migration. It will run only on brand new servers, and it has to                        //
  // run after the `clearAppIndex` migration because it relies on populating AppIndex.                                 //
                                                                                                                       //
  var startPreinstallingAppsHelper = function startPreinstallingAppsHelper() {                                         // 672
    db.updateAppIndex();                                                                                               // 673
                                                                                                                       //
    var preinstalledApps = db.collections.appIndex.find({ _id: {                                                       // 675
        $in: db.getProductivitySuiteAppIds().concat(db.getSystemSuiteAppIds()) }                                       // 676
    }).fetch();                                                                                                        // 675
    var appAndPackageIds = _.map(preinstalledApps, function (app) {                                                    // 679
      return {                                                                                                         // 680
        appId: app.appId,                                                                                              // 681
        packageId: app.packageId                                                                                       // 682
      };                                                                                                               // 680
    });                                                                                                                // 684
                                                                                                                       //
    db.setPreinstalledApps(appAndPackageIds);                                                                          // 686
  };                                                                                                                   // 687
                                                                                                                       //
  if (!Meteor.settings["public"].isTesting && !db.allowDevAccounts()) {                                                // 689
    // We want preinstalling apps to run async and not block startup.                                                  //
    Meteor.setTimeout(startPreinstallingAppsHelper, 0);                                                                // 691
  }                                                                                                                    // 692
};                                                                                                                     // 693
                                                                                                                       //
var setNewServer = function setNewServer(db, backend) {                                                                // 695
  // This migration only applies to "old" servers. New servers will set                                                //
  // new_server_migrations_applied to false before any migrations run.                                                 //
  if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" })) {                                  // 698
    db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: true });                           // 699
  }                                                                                                                    // 700
};                                                                                                                     // 701
                                                                                                                       //
var addMembraneRequirementsToIdentities = function addMembraneRequirementsToIdentities(db, backend) {                  // 703
  var query = {                                                                                                        // 704
    "frontendRef.identity": { $exists: true },                                                                         // 705
    "owner.grain.grainId": { $exists: true },                                                                          // 706
    "requirements.0": { $exists: false }                                                                               // 707
  };                                                                                                                   // 704
                                                                                                                       //
  db.collections.apiTokens.find(query).map(function (apiToken) {                                                       // 710
    db.collections.apiTokens.update({ _id: apiToken._id }, {                                                           // 711
      $push: {                                                                                                         // 714
        requirements: {                                                                                                // 715
          permissionsHeld: {                                                                                           // 716
            grainId: apiToken.owner.grain.grainId,                                                                     // 717
            identityId: apiToken.frontendRef.identity,                                                                 // 718
            permissions: []                                                                                            // 719
          }                                                                                                            // 716
        }                                                                                                              // 715
      }                                                                                                                // 714
    });                                                                                                                // 713
  });                                                                                                                  // 725
};                                                                                                                     // 726
                                                                                                                       //
function backgroundFillInGrainSizes(db, backend) {                                                                     // 728
  // Fill in sizes for all grains that don't have them. Since computing a grain size requires a                        //
  // directory walk, we don't want to do them all at once. Instead, we compute one a second until                      //
  // all grains have sizes.                                                                                            //
                                                                                                                       //
  try {                                                                                                                // 733
    var grain = db.collections.grains.findOne({ size: { $exists: false } }, { fields: { _id: 1, userId: 1 } });        // 734
                                                                                                                       //
    if (grain) {                                                                                                       // 736
      // Compute size!                                                                                                 //
      try {                                                                                                            // 738
        var result = waitPromise(backend.cap().getGrainStorageUsage(grain.userId, grain._id));                         // 739
        db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: parseInt(result.size) } });
      } catch (err) {                                                                                                  // 743
        if (err.kjType === "failed") {                                                                                 // 744
          // Backend had a problem. Maybe the grain doesn't actually exist on disk and the database                    //
          // is messed up. We'll set the size to zero and move on.                                                     //
          console.error("Error while backfilling grain size for", grain._id, ":", err.stack);                          // 747
          db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: 0 } });           // 748
        } else {                                                                                                       // 749
          // Rethrow on disconnected / overloaded / unimplemented.                                                     //
          throw err;                                                                                                   // 751
        }                                                                                                              // 752
      }                                                                                                                // 753
                                                                                                                       //
      // Do another one in a second.                                                                                   //
      Meteor.setTimeout(backgroundFillInGrainSizes.bind(this, db, backend), 1000);                                     // 756
    }                                                                                                                  // 757
  } catch (err) {                                                                                                      // 758
    // We'll just stop for now, to avoid spamming logs if this error persists. Next time the server                    //
    // restarts, the migration will continue.                                                                          //
    console.error("Error while backfilling grain sizes:", err.stack);                                                  // 761
  }                                                                                                                    // 762
}                                                                                                                      // 763
                                                                                                                       //
// This must come after all the functions named within are defined.                                                    //
// Only append to this list!  Do not modify or remove list entries;                                                    //
// doing so is likely change the meaning and semantics of user databases.                                              //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles, markAllRead, clearAppIndex, assignEmailVerifierIds, setNewServer, addMembraneRequirementsToIdentities];
                                                                                                                       //
var NEW_SERVER_STARTUP = [startPreinstallingApps];                                                                     // 802
                                                                                                                       //
var migrateToLatest = function migrateToLatest(db, backend) {                                                          // 806
  if (Meteor.settings.replicaNumber) {                                                                                 // 807
    (function () {                                                                                                     // 807
      // This is a replica. Wait for the first replica to perform migrations.                                          //
                                                                                                                       //
      console.log("Waiting for migrations on replica zero...");                                                        // 810
                                                                                                                       //
      var done = new Future();                                                                                         // 812
      var change = function change(doc) {                                                                              // 813
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                           // 814
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                          // 815
      };                                                                                                               // 816
                                                                                                                       //
      var observer = db.collections.migrations.find({ _id: "migrations_applied" }).observe({                           // 818
        added: change,                                                                                                 // 819
        changed: change                                                                                                // 820
      });                                                                                                              // 818
                                                                                                                       //
      var newServerDone = new Future();                                                                                // 823
      var newServerChange = function newServerChange(doc) {                                                            // 824
        if (doc.value) {                                                                                               // 825
          console.log("New server migrations applied elsewhere");                                                      // 826
          newServerDone["return"]();                                                                                   // 827
        }                                                                                                              // 828
      };                                                                                                               // 829
                                                                                                                       //
      var newServerObserver = db.collections.migrations.find({ _id: "new_server_migrations_applied" }).observe({       // 831
        added: newServerChange,                                                                                        // 832
        changed: newServerChange                                                                                       // 833
      });                                                                                                              // 831
                                                                                                                       //
      done.wait();                                                                                                     // 836
      observer.stop();                                                                                                 // 837
      newServerDone.wait();                                                                                            // 838
      newServerObserver.stop();                                                                                        // 839
      console.log("Migrations have completed on replica zero.");                                                       // 840
    })();                                                                                                              // 807
  } else {                                                                                                             // 841
    var applied = db.collections.migrations.findOne({ _id: "migrations_applied" });                                    // 842
    var start = void 0;                                                                                                // 843
    if (!applied) {                                                                                                    // 844
      // Migrations table is not yet seeded with a value.  This means it has                                           //
      // applied 0 migrations.  Persist this.                                                                          //
      db.collections.migrations.insert({ _id: "migrations_applied", value: 0 });                                       // 847
      start = 0;                                                                                                       // 848
                                                                                                                       //
      // This also means this is a brand new server                                                                    //
      db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: false });                        // 851
    } else {                                                                                                           // 852
      start = applied.value;                                                                                           // 853
    }                                                                                                                  // 854
                                                                                                                       //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                     // 856
                                                                                                                       //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                  // 858
      // Apply migration i, then record that migration i was successfully run.                                         //
      console.log("Applying migration " + (i + 1));                                                                    // 860
      MIGRATIONS[i](db, backend);                                                                                      // 861
      db.collections.migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                     // 862
      console.log("Applied migration " + (i + 1));                                                                     // 863
    }                                                                                                                  // 864
                                                                                                                       //
    if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" }).value) {                          // 866
      // new_server_migrations_applied is guaranteed to exist since we have a migration that                           //
      // ensures it.                                                                                                   //
      for (var _i = 0; _i < NEW_SERVER_STARTUP.length; _i++) {                                                         // 869
        console.log("Running new server startup function " + (_i + 1));                                                // 870
        NEW_SERVER_STARTUP[_i](db, backend);                                                                           // 871
        console.log("Running new server startup function " + (_i + 1));                                                // 872
      }                                                                                                                // 873
                                                                                                                       //
      db.collections.migrations.update({ _id: "new_server_migrations_applied" }, { $set: { value: true } });           // 875
    }                                                                                                                  // 876
                                                                                                                       //
    // Start background migrations.                                                                                    //
    backgroundFillInGrainSizes(db, backend);                                                                           // 879
  }                                                                                                                    // 880
};                                                                                                                     // 881
                                                                                                                       //
                                                                                                                       // 883
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"observe-helpers.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/observe-helpers.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({fillUndefinedForChangedDoc:function(){return fillUndefinedForChangedDoc}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
function fillUndefinedForChangedDoc(newDoc, oldDoc) {                                                                  // 17
  // In publishes, setting a field to `undefined` specifies that it is no longer present.                              //
  // Annoyingly, in the changed callback of observing a collection, it does not do this for you.                       //
  Object.keys(oldDoc).forEach(function (key) {                                                                         // 20
    if (!(key in newDoc)) {                                                                                            // 21
      newDoc[key] = undefined;                                                                                         // 22
    }                                                                                                                  // 23
  });                                                                                                                  // 24
}                                                                                                                      // 25
                                                                                                                       //
                                                                                                                       // 27
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"persistent.js":["babel-runtime/helpers/classCallCheck","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/persistent.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({PersistentImpl:function(){return PersistentImpl},hashSturdyRef:function(){return hashSturdyRef},generateSturdyRef:function(){return generateSturdyRef},checkRequirements:function(){return checkRequirements}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 19
                                                                                                                       //
var privateDb = Symbol("PersistentImpl.db");                                                                           // 21
var privateTemplate = Symbol("PersistentImpl.template");                                                               // 22
var privateIsSaved = Symbol("PersistentImpl.isSaved");                                                                 // 23
                                                                                                                       //
var PersistentImpl = function () {                                                                                     //
  function PersistentImpl(db, saveTemplate) {                                                                          // 26
    _classCallCheck(this, PersistentImpl);                                                                             // 26
                                                                                                                       //
    this[privateDb] = db;                                                                                              // 27
    this[privateTemplate] = saveTemplate;                                                                              // 28
                                                                                                                       //
    // TODO(someday): This may or may not be quite right in cases where we're saving a root token                      //
    //   by copy. Is the copy the "same" capability or not? Today, isSaved() is only used by                           //
    //   wakelock notification handles which are not issued through the powerbox, therefore do not                     //
    //   go through claimRequest(), therefore are not saved by copy, so the point is moot.                             //
    this[privateIsSaved] = !!saveTemplate.parentToken;                                                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  PersistentImpl.prototype.isSaved = function isSaved() {                                                              //
    // Can be called by subclasses to ask whether or not a record currently exists in the ApiTokens                    //
    // table representing this capability.                                                                             //
                                                                                                                       //
    return this[privateIsSaved];                                                                                       // 41
  };                                                                                                                   // 42
                                                                                                                       //
  PersistentImpl.prototype.save = function save(params) {                                                              //
    var _this = this;                                                                                                  // 44
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 45
      if (!params.sealFor) {                                                                                           // 46
        throw new Error("must specify 'sealFor'");                                                                     // 47
      }                                                                                                                // 48
                                                                                                                       //
      var db = _this[privateDb];                                                                                       // 50
                                                                                                                       //
      var newToken = _.clone(_this[privateTemplate]);                                                                  // 52
      newToken.owner = params.sealFor;                                                                                 // 53
      if (newToken.owner.user) {                                                                                       // 54
        if (!newToken.identityId) {                                                                                    // 55
          throw new Error("can't save non-UiView with user as owner");                                                 // 56
        }                                                                                                              // 57
                                                                                                                       //
        // Only "identityId" and "title" are allowed to be passed to save().                                           //
        var userOwner = _.pick(newToken.owner.user, "identityId", "title");                                            // 60
                                                                                                                       //
        // Fill in denormalizedGrainMetadata and upstreamTitle ourselves.                                              //
        userOwner.denormalizedGrainMetadata = db.getDenormalizedGrainInfo(newToken.grainId);                           // 63
                                                                                                                       //
        var grain = db.getGrain(newToken.grainId);                                                                     // 65
        if (grain && grain.title !== userOwner.title) {                                                                // 66
          userOwner.upstreamTitle = grain.title;                                                                       // 67
        }                                                                                                              // 68
                                                                                                                       //
        newToken.owner.user = userOwner;                                                                               // 70
      }                                                                                                                // 71
                                                                                                                       //
      var sturdyRef = generateSturdyRef();                                                                             // 73
      newToken._id = hashSturdyRef(sturdyRef);                                                                         // 74
                                                                                                                       //
      newToken.created = new Date();                                                                                   // 76
                                                                                                                       //
      db.collections.apiTokens.insert(newToken);                                                                       // 78
      _this[privateIsSaved] = true;                                                                                    // 79
      return { sturdyRef: new Buffer(sturdyRef) };                                                                     // 80
    });                                                                                                                // 81
  };                                                                                                                   // 82
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
                                                                                                                       //
                                                                                                                       //
  return PersistentImpl;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
function hashSturdyRef(sturdyRef) {                                                                                    // 87
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 88
};                                                                                                                     // 89
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 91
  return Random.secret();                                                                                              // 92
}                                                                                                                      // 93
                                                                                                                       //
function checkRequirements(db, requirements) {                                                                         // 95
  // Checks if the given list of MembraneRequirements are all satisfied, returning true if so and                      //
  // false otherwise.                                                                                                  //
                                                                                                                       //
  // TODO(cleanup): SandstormPermissions has a different way of checking the same requirements.                        //
  //   Reuse?                                                                                                          //
                                                                                                                       //
  // TODO(security): Eventually we want checkRequirements(), when it passes, to produce an observer                    //
  //   that can be used to receive a notification when the requirements may no longer be satisfied,                    //
  //   in order to revoke the live object. See RequirementObserver in supervisor.capnp.                                //
                                                                                                                       //
  if (!requirements) {                                                                                                 // 106
    return true;                                                                                                       // 107
  }                                                                                                                    // 108
                                                                                                                       //
  requirements.forEach(function (requirement) {                                                                        // 110
    if (requirement.tokenValid) {                                                                                      // 111
      var token = db.collections.apiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token) {                                                                                                    // 115
        throw new Meteor.Error(403, "Capability revoked because the link through which it was introduced has been " + "revoked or deleted.");
      }                                                                                                                // 119
                                                                                                                       //
      checkRequirements(db, token.requirements);                                                                       // 121
                                                                                                                       //
      if (token.parentToken) {                                                                                         // 123
        checkRequirements(db, [{ tokenValid: token.parentToken }]);                                                    // 124
      }                                                                                                                // 125
    } else if (requirement.permissionsHeld) {                                                                          // 126
      var p = requirement.permissionsHeld;                                                                             // 127
      var viewInfo = db.collections.grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;       // 128
      var vertex = void 0;                                                                                             // 130
      if (p.identityId) {                                                                                              // 131
        vertex = { grain: { _id: p.grainId, identityId: p.identityId } };                                              // 132
      } else {                                                                                                         // 133
        vertex = { token: { _id: p.tokenId, grainId: p.grainId } };                                                    // 134
      }                                                                                                                // 135
                                                                                                                       //
      var currentPermissions = SandstormPermissions.grainPermissions(db, vertex, viewInfo || {}).permissions;          // 137
      if (!currentPermissions) {                                                                                       // 139
        throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
      }                                                                                                                // 143
                                                                                                                       //
      var requiredPermissions = p.permissions || [];                                                                   // 145
      for (var ii = 0; ii < requiredPermissions.length; ++ii) {                                                        // 146
        if (requiredPermissions[ii] && !currentPermissions[ii]) {                                                      // 147
          throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
        }                                                                                                              // 151
      }                                                                                                                // 152
    } else if (requirement.userIsAdmin) {                                                                              // 153
      if (!db.isAdminById(requirement.userIsAdmin)) {                                                                  // 154
        throw new Meteor.Error(403, "Capability revoked because the user who created it has lost their admin " + "rights.");
      }                                                                                                                // 158
    } else {                                                                                                           // 159
      throw new Meteor.Error(403, "Unknown requirement type.");                                                        // 160
    }                                                                                                                  // 161
  });                                                                                                                  // 162
};                                                                                                                     // 163
                                                                                                                       //
                                                                                                                       // 165
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"static-asset.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/static-asset.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({StaticAssetImpl:function(){return StaticAssetImpl},IdenticonStaticAssetImpl:function(){return IdenticonStaticAssetImpl}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014-2016 Sandstorm Development Group, Inc. and contributors                                          //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var Url = Npm.require("url");                                                                                          // 18
var StaticAsset = Capnp.importSystem("sandstorm/grain.capnp").StaticAsset;                                             // 19
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 21
                                                                                                                       //
var StaticAssetImpl = function () {                                                                                    //
  function StaticAssetImpl(assetId) {                                                                                  // 24
    _classCallCheck(this, StaticAssetImpl);                                                                            // 24
                                                                                                                       //
    check(assetId, String);                                                                                            // 25
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 26
    this._hostPath = makeWildcardHost("static") + "/" + assetId;                                                       // 27
  }                                                                                                                    // 28
                                                                                                                       //
  StaticAssetImpl.prototype.getUrl = function getUrl() {                                                               //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 31
  };                                                                                                                   // 32
                                                                                                                       //
  return StaticAssetImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 33
                                                                                                                       //
var IdenticonStaticAssetImpl = function () {                                                                           //
  function IdenticonStaticAssetImpl(hash, size) {                                                                      // 36
    _classCallCheck(this, IdenticonStaticAssetImpl);                                                                   // 36
                                                                                                                       //
    check(hash, String);                                                                                               // 37
    check(size, Match.Integer);                                                                                        // 38
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 39
    this._hostPath = makeWildcardHost("static") + "/identicon/" + hash + "?s=" + size;                                 // 40
  }                                                                                                                    // 41
                                                                                                                       //
  IdenticonStaticAssetImpl.prototype.getUrl = function getUrl() {                                                      //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 44
  };                                                                                                                   // 45
                                                                                                                       //
  return IdenticonStaticAssetImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 46
                                                                                                                       //
                                                                                                                       // 48
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"constants.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/constants.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({ACCOUNT_DELETION_SUSPENSION_TIME:function(){return ACCOUNT_DELETION_SUSPENSION_TIME}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
module.runModuleSetters(ACCOUNT_DELETION_SUSPENSION_TIME = 7 * 60 * 60 * 24 * 1000); // 7 days in ms                   // 17
                                                                                                                       //
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"db-deprecated.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/db-deprecated.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
var quotaManager = void 0;                                                                                             // 26
if (Meteor.isServer) {var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});         // 27
                                                                                                                       // 28
  // Imports are usually not allowed to occur in a block. However, it is the only way to do                            //
  // this under Meteor. Using // jscs:disable doesn't work for what it considers syntax violations,                    //
  // and so we've added this file to .jscsrc's excludedFiles explicitly.                                               //
                                                                                                                       //
  quotaManager = new LDAP();                                                                                           // 33
} else {                                                                                                               // 34
  quotaManager = {                                                                                                     // 35
    updateUserQuota: function updateUserQuota(db, user) {                                                              // 36
      return {                                                                                                         // 37
        storage: user.cachedStorageQuota || 0,                                                                         // 38
        grains: Infinity,                                                                                              // 39
        compute: Infinity                                                                                              // 40
      };                                                                                                               // 37
    }                                                                                                                  // 42
  };                                                                                                                   // 35
}                                                                                                                      // 44
                                                                                                                       //
globalDb = new SandstormDb(quotaManager);                                                                              // 46
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 48
DevPackages = globalDb.collections.devPackages;                                                                        // 49
UserActions = globalDb.collections.userActions;                                                                        // 50
Grains = globalDb.collections.grains;                                                                                  // 51
Contacts = globalDb.collections.contacts;                                                                              // 52
Sessions = globalDb.collections.sessions;                                                                              // 53
SignupKeys = globalDb.collections.signupKeys;                                                                          // 54
ActivityStats = globalDb.collections.activityStats;                                                                    // 55
DeleteStats = globalDb.collections.deleteStats;                                                                        // 56
FileTokens = globalDb.collections.fileTokens;                                                                          // 57
ApiTokens = globalDb.collections.apiTokens;                                                                            // 58
Notifications = globalDb.collections.notifications;                                                                    // 59
StatsTokens = globalDb.collections.statsTokens;                                                                        // 60
Misc = globalDb.collections.misc;                                                                                      // 61
Settings = globalDb.collections.settings;                                                                              // 62
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 64
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 65
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 66
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 67
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 68
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 69
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 70
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 71
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 72
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 73
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 74
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 75
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 76
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/demo.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({allowDemo:function(){return allowDemo}});// Sandstorm - Personal Cloud Sandbox                          //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;           // 17
                                                                                                                       //
                                                                                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"server":{"accounts":{"email-token":{"token-server.js":["crypto","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/email-token/token-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var crypto;module.import("crypto",{"default":function(v){crypto=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
                                                                                                                       //
                                                                                                                       // 3
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 5
                                                                                                                       //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                      // 7
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                              // 8
var V1_HASHFUNC = "sha512";                                                                                            // 9
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token                    //
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                                 //
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                      //
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly                     //
// sufficient to reconstruct the output of pbkdf2().                                                                   //
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                          // 15
                                                                                                                       //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                              // 17
                                                                                                                       //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                           // 19
  Meteor.users.update({                                                                                                // 20
    "services.email.tokens.createdAt": {                                                                               // 21
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                                  // 22
    }                                                                                                                  // 21
  }, {                                                                                                                 // 20
    $pull: {                                                                                                           // 25
      "services.email.tokens": {                                                                                       // 26
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                                 // 27
      }                                                                                                                // 26
    }                                                                                                                  // 25
  }, {                                                                                                                 // 24
    multi: true                                                                                                        // 31
  });                                                                                                                  // 30
};                                                                                                                     // 33
                                                                                                                       //
Meteor.startup(cleanupExpiredTokens);                                                                                  // 35
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                              //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                                // 37
                                                                                                                       //
var hashToken = function hashToken(token) {                                                                            // 39
  return {                                                                                                             // 40
    digest: SHA256(token),                                                                                             // 41
    algorithm: "sha-256"                                                                                               // 42
  };                                                                                                                   // 40
};                                                                                                                     // 44
                                                                                                                       //
var checkToken = function checkToken(tokens, token) {                                                                  // 46
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.                   //
  // Returns the matching object, if one is found, or undefined if none match.                                         //
  var foundToken = undefined;                                                                                          // 49
  tokens.forEach(function (userToken) {                                                                                // 50
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                                // 51
      foundToken = userToken;                                                                                          // 53
    }                                                                                                                  // 54
  });                                                                                                                  // 55
                                                                                                                       //
  return foundToken;                                                                                                   // 57
};                                                                                                                     // 58
                                                                                                                       //
var consumeToken = function consumeToken(user, token) {                                                                // 60
  var hashedToken = hashToken(token);                                                                                  // 61
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                                // 62
                                                                                                                       //
  if (foundToken !== undefined) {                                                                                      // 64
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                       // 65
  }                                                                                                                    // 66
                                                                                                                       //
  return foundToken;                                                                                                   // 68
};                                                                                                                     // 69
                                                                                                                       //
var makeBox = function makeBox(token, plaintext) {                                                                     // 71
  // Encrypt plaintext symmetrically with a key derived from token.  Returns an object with                            //
  // ciphertext and associated data needed to decrypt later.                                                           //
                                                                                                                       //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                          //
  // be used as a key directly, so we need to use a KDF with a strong random salt.                                     //
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole                   //
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                      //
  // This would require lengthening the token, which would make the manual-code-entry workflow                         //
  // worse, so I'm punting on that for now.                                                                            //
  var salt = Random.secret(16);                                                                                        // 81
  var key = crypto.pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                                        // 82
  var iv = crypto.randomBytes(16);                                                                                     // 83
  var cipher = crypto.createCipheriv(V1_CIPHER, key, iv);                                                              // 84
  var ciphertext = cipher.update(new Buffer(plaintext, "binary"));                                                     // 85
  return {                                                                                                             // 86
    version: 1,                                                                                                        // 87
    salt: salt,                                                                                                        // 88
    iv: iv.toString("base64"),                                                                                         // 89
    boxedValue: ciphertext.toString("base64")                                                                          // 90
  };                                                                                                                   // 86
};                                                                                                                     // 92
                                                                                                                       //
var tryUnbox = function tryUnbox(box, secret) {                                                                        // 94
  if (box) {                                                                                                           // 95
    if (box.version === 1) {                                                                                           // 96
      var key = crypto.pbkdf2Sync(secret, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                               // 97
      var iv = new Buffer(box.iv, "base64");                                                                           // 98
      var cipher = crypto.createDecipheriv(V1_CIPHER, key, iv);                                                        // 99
      var cipherText = new Buffer(box.boxedValue, "base64");                                                           // 100
      var plaintext = cipher.update(cipherText);                                                                       // 101
      return plaintext.toString("binary");                                                                             // 102
    }                                                                                                                  // 103
  }                                                                                                                    // 104
                                                                                                                       //
  // If no box was provided, or it was of an unknown version, return no data.                                          //
  return;                                                                                                              // 107
};                                                                                                                     // 108
                                                                                                                       //
// Handler to login with a token.                                                                                      //
Accounts.registerLoginHandler("email", function (options) {                                                            // 111
  if (!options.email) {                                                                                                // 112
    return undefined; // don't handle                                                                                  // 113
  }                                                                                                                    // 114
                                                                                                                       //
  if (!Accounts.identityServices.email.isEnabled()) {                                                                  // 116
    throw new Meteor.Error(403, "Email identity service is disabled.");                                                // 117
  }                                                                                                                    // 118
                                                                                                                       //
  options = options.email;                                                                                             // 120
  check(options, {                                                                                                     // 121
    email: String,                                                                                                     // 122
    token: String                                                                                                      // 123
  });                                                                                                                  // 121
                                                                                                                       //
  var user = Meteor.users.findOne({                                                                                    // 126
    "services.email.email": options.email                                                                              // 127
  }, {                                                                                                                 // 126
    fields: {                                                                                                          // 129
      "services.email": 1                                                                                              // 130
    }                                                                                                                  // 129
  });                                                                                                                  // 128
                                                                                                                       //
  if (!user) {                                                                                                         // 134
    console.error("User not found:", options.email);                                                                   // 135
    return {                                                                                                           // 136
      error: new Meteor.Error(403, "User not found")                                                                   // 137
    };                                                                                                                 // 136
  }                                                                                                                    // 139
                                                                                                                       //
  if (!user.services.email.tokens) {                                                                                   // 141
    console.error("User has no token set:", options.email);                                                            // 142
    return {                                                                                                           // 143
      error: new Meteor.Error(403, "User has no token set")                                                            // 144
    };                                                                                                                 // 143
  }                                                                                                                    // 146
                                                                                                                       //
  var tokenString = options.token.trim();                                                                              // 148
  var maybeToken = consumeToken(user, tokenString);                                                                    // 149
  if (!maybeToken) {                                                                                                   // 150
    console.error("Token not found:", options.email);                                                                  // 151
    return {                                                                                                           // 152
      error: new Meteor.Error(403, "Invalid authentication code")                                                      // 153
    };                                                                                                                 // 152
  }                                                                                                                    // 155
                                                                                                                       //
  // Attempt to decrypt the resumePath, if provided.                                                                   //
  var resumePath = tryUnbox(maybeToken.secureBox, tokenString);                                                        // 158
                                                                                                                       //
  return {                                                                                                             // 160
    userId: user._id,                                                                                                  // 161
    options: {                                                                                                         // 162
      resumePath: resumePath                                                                                           // 163
    }                                                                                                                  // 162
  };                                                                                                                   // 160
});                                                                                                                    // 166
                                                                                                                       //
var makeTokenUrl = function makeTokenUrl(email, token, options) {                                                      // 168
  if (options.linking) {                                                                                               // 169
    return options.rootUrl + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId() + "?allowLogin=" + options.linking.allowLogin;
  } else {                                                                                                             // 173
    return options.rootUrl + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);            // 174
  }                                                                                                                    // 175
};                                                                                                                     // 176
                                                                                                                       //
///                                                                                                                    //
/// EMAIL VERIFICATION                                                                                                 //
///                                                                                                                    //
var sendTokenEmail = function sendTokenEmail(db, email, token, options) {                                              // 181
  var subject = void 0;                                                                                                // 182
  var text = void 0;                                                                                                   // 183
                                                                                                                       //
  var rootHostname = Url.parse(options.rootUrl).hostname;                                                              // 185
                                                                                                                       //
  if (!options.linking) {                                                                                              // 187
    subject = "Log in to " + rootHostname;                                                                             // 188
    text = "To confirm this email address on ";                                                                        // 189
  } else {                                                                                                             // 190
    subject = "Confirm this email address on " + rootHostname;                                                         // 191
    text = "To confirm this email address on ";                                                                        // 192
  }                                                                                                                    // 193
                                                                                                                       //
  text = text + rootHostname + ", click on the following link:\n\n" + makeTokenUrl(email, token, options) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                       //
  var sendOptions = {                                                                                                  // 200
    to: email,                                                                                                         // 201
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                                    // 202
    subject: subject,                                                                                                  // 203
    text: text                                                                                                         // 204
  };                                                                                                                   // 200
                                                                                                                       //
  sendEmail(sendOptions);                                                                                              // 207
};                                                                                                                     // 208
                                                                                                                       //
///                                                                                                                    //
/// CREATING USERS                                                                                                     //
///                                                                                                                    //
// returns the user id                                                                                                 //
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, options) {                           // 214
  check(email, String);                                                                                                // 215
  check(options, {                                                                                                     // 216
    resumePath: String,                                                                                                // 217
    linking: Match.Optional({ allowLogin: Boolean }),                                                                  // 218
    rootUrl: String                                                                                                    // 219
  });                                                                                                                  // 216
                                                                                                                       //
  if (options.rootUrl !== process.env.ROOT_URL) {                                                                      // 222
    var parsedUrl = Url.parse(options.rootUrl);                                                                        // 223
    if (!db.hostIsStandalone(parsedUrl.hostname)) {                                                                    // 224
      throw new Meteor.Error(400, "rootUrl is not valid");                                                             // 225
    }                                                                                                                  // 226
  }                                                                                                                    // 227
                                                                                                                       //
  var atIndex = email.indexOf("@");                                                                                    // 229
  if (atIndex === -1) {                                                                                                // 230
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                                // 231
  }                                                                                                                    // 232
                                                                                                                       //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });             // 234
  var userId = void 0;                                                                                                 // 236
                                                                                                                       //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                                 //
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                         //
  var token = Random.id(12);                                                                                           // 240
  var tokenObj = hashToken(token);                                                                                     // 241
  tokenObj.createdAt = new Date();                                                                                     // 242
  tokenObj.secureBox = makeBox(token, options.resumePath);                                                             // 243
                                                                                                                       //
  if (user) {                                                                                                          // 245
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                         // 246
      throw new Meteor.Error("alreadySentEmailToken", "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again.");
    }                                                                                                                  // 252
                                                                                                                       //
    userId = user._id;                                                                                                 // 254
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                          // 256
  } else {                                                                                                             // 257
    var _options = {};                                                                                                 // 258
    user = {                                                                                                           // 259
      services: {                                                                                                      // 260
        email: {                                                                                                       // 261
          tokens: [tokenObj],                                                                                          // 262
          email: email                                                                                                 // 263
        }                                                                                                              // 261
      }                                                                                                                // 260
    };                                                                                                                 // 259
                                                                                                                       //
    userId = Accounts.insertUserDoc(_options, user);                                                                   // 268
  }                                                                                                                    // 269
                                                                                                                       //
  sendTokenEmail(db, email, token, options);                                                                           // 271
                                                                                                                       //
  return userId;                                                                                                       // 273
};                                                                                                                     // 274
                                                                                                                       //
Meteor.methods({                                                                                                       // 276
  createAndEmailTokenForUser: function createAndEmailTokenForUser(email, options) {                                    // 277
    // method for create user. Requests come from the client.                                                          //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                         //
    // It will always send an email to the user                                                                        //
                                                                                                                       //
    check(email, String);                                                                                              // 282
    check(options, {                                                                                                   // 283
      resumePath: String,                                                                                              // 284
      linking: Match.Optional({ allowLogin: Boolean }),                                                                // 285
      rootUrl: String                                                                                                  // 286
    });                                                                                                                // 283
                                                                                                                       //
    if (!Accounts.identityServices.email.isEnabled()) {                                                                // 289
      throw new Meteor.Error(403, "Email identity service is disabled.");                                              // 290
    }                                                                                                                  // 291
    // Create user. result contains id and token.                                                                      //
    var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, options);                               // 293
  },                                                                                                                   // 294
                                                                                                                       //
  linkEmailIdentityToAccount: function linkEmailIdentityToAccount(email, token, allowLogin) {                          // 296
    // Links the email identity with address `email` and login token `token` to the current account.                   //
    check(email, String);                                                                                              // 298
    check(token, String);                                                                                              // 299
    check(allowLogin, Boolean);                                                                                        // 300
    var account = Meteor.user();                                                                                       // 301
    if (!account || !account.loginIdentities) {                                                                        // 302
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                       // 303
    }                                                                                                                  // 304
                                                                                                                       //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 306
    if (!identity) {                                                                                                   // 308
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 309
    }                                                                                                                  // 310
                                                                                                                       //
    var maybeToken = consumeToken(identity, token.trim());                                                             // 312
    if (!maybeToken) {                                                                                                 // 313
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 314
    }                                                                                                                  // 315
                                                                                                                       //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id, allowLogin);
                                                                                                                       //
    // Return the resume path, if we have one.                                                                         //
    var resumePath = tryUnbox(maybeToken.secureBox, token);                                                            // 321
    return resumePath;                                                                                                 // 322
  }                                                                                                                    // 323
});                                                                                                                    // 276
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"identity":{"identity-server.js":["/imports/server/backend.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/identity/identity-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var SandstormBackend;module.import("/imports/server/backend.js",{"SandstormBackend":function(v){SandstormBackend=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var linkIdentityToAccountInternal = function linkIdentityToAccountInternal(db, backend, identityId, accountId, allowLogin) {
  // Links the identity to the account. If `allowLogin` is true, grants the identity login access                      //
  // if possible. Makes the account durable if it is a demo account.                                                   //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 23
  check(backend, SandstormBackend);                                                                                    // 24
  check(identityId, String);                                                                                           // 25
  check(accountId, String);                                                                                            // 26
                                                                                                                       //
  var accountUser = Meteor.users.findOne({ _id: accountId });                                                          // 28
  if (!accountUser) {                                                                                                  // 29
    throw new Meteor.Error(404, "No account found with ID " + accountId);                                              // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (accountUser.profile) {                                                                                           // 33
    throw new Meteor.Error(400, "Cannot link an identity to another identity.");                                       // 34
  }                                                                                                                    // 35
                                                                                                                       //
  if (!!_.findWhere(accountUser.loginIdentities, { id: identityId }) || !!_.findWhere(accountUser.nonloginIdentities, { id: identityId })) {
    throw new Meteor.Error("alreadyLinked", "Cannot link an identity that's alread linked to this account.");          // 39
  }                                                                                                                    // 41
                                                                                                                       //
  var identityUser = Meteor.users.findOne({ _id: identityId });                                                        // 43
                                                                                                                       //
  if (!identityUser) {                                                                                                 // 45
    throw new Meteor.Error(404, "No identity found with ID " + identityId);                                            // 46
  }                                                                                                                    // 47
                                                                                                                       //
  if (!identityUser.profile) {                                                                                         // 49
    throw new Meteor.Error(400, "Cannot link an account to another account");                                          // 50
  }                                                                                                                    // 51
                                                                                                                       //
  db.deleteUnusedAccount(backend, identityUser._id);                                                                   // 53
  if (Meteor.users.findOne({ "loginIdentities.id": identityUser._id })) {                                              // 54
    throw new Meteor.Error(403, "Cannot link an identity that can already log into another account");                  // 55
  }                                                                                                                    // 57
                                                                                                                       //
  var alreadyLinked = !!Meteor.users.findOne({ "nonloginIdentities.id": identityUser._id });                           // 59
                                                                                                                       //
  var pushModifier = alreadyLinked || !allowLogin ? { nonloginIdentities: { id: identityUser._id } } : { loginIdentities: { id: identityUser._id } };
                                                                                                                       //
  var modifier = void 0;                                                                                               // 65
  if (accountUser.expires) {                                                                                           // 66
    if (alreadyLinked) {                                                                                               // 67
      throw new Meteor.Error(403, "Cannot create an account for an identity that's " + "already linked to another account.");
    }                                                                                                                  // 70
                                                                                                                       //
    modifier = {                                                                                                       // 72
      $push: pushModifier,                                                                                             // 73
      $unset: { expires: 1 },                                                                                          // 74
      $set: { upgradedFromDemo: Date.now() }                                                                           // 75
    };                                                                                                                 // 72
    if (db.isReferralEnabled()) {                                                                                      // 77
      // Demo users never got the referral notification. Send it now:                                                  //
      db.sendReferralProgramNotification(accountUser._id);                                                             // 79
    }                                                                                                                  // 80
  } else {                                                                                                             // 82
    modifier = { $push: pushModifier };                                                                                // 83
  }                                                                                                                    // 84
                                                                                                                       //
  // Make sure not to add the same identity twice.                                                                     //
  Meteor.users.update({ _id: accountUser._id,                                                                          // 87
    "nonloginIdentities.id": { $ne: identityUser._id },                                                                // 88
    "loginIdentities.id": { $ne: identityUser._id } }, modifier);                                                      // 89
                                                                                                                       //
  if (accountUser.expires) {                                                                                           // 92
    var demoIdentityId = SandstormDb.getUserIdentityIds(accountUser)[0];                                               // 93
    Meteor.users.update({ _id: demoIdentityId }, { $unset: { expires: 1 },                                             // 94
      $set: { upgradedFromDemo: Date.now() } });                                                                       // 96
                                                                                                                       //
    // Mark the demo identity as nonlogin. It'd be nicer if the identity started out as nonlogin,                      //
    // but to get that to work we would need to adjust the account creation and first login logic.                     //
    Meteor.users.update({ _id: accountUser._id,                                                                        // 100
      "loginIdentities.id": demoIdentityId,                                                                            // 101
      "nonloginIdentities.id": { $not: { $eq: demoIdentityId } } }, { $pull: { loginIdentities: { id: demoIdentityId } },
      $push: { nonloginIdentities: { id: demoIdentityId } } });                                                        // 104
  }                                                                                                                    // 106
};                                                                                                                     // 107
                                                                                                                       //
Meteor.methods({                                                                                                       // 109
  loginWithIdentity: function loginWithIdentity(accountUserId) {                                                       // 110
    // Logs into the account with ID `accountUserId`. Throws an exception if the current user is                       //
    // not an identity user listed in the account's `loginIdentities` field. This method is not                        //
    // intended to be called directly; client-side code should only invoke it through                                  //
    // `Meteor.loginWithIdentity()`, which additionally maintains the standard Meteor client-side                      //
    // login state.                                                                                                    //
                                                                                                                       //
    check(accountUserId, String);                                                                                      // 117
                                                                                                                       //
    var identityUser = Meteor.user();                                                                                  // 119
    if (!identityUser || !identityUser.profile) {                                                                      // 120
      throw new Meteor.Error(403, "Must be already logged in as an identity.");                                        // 121
    }                                                                                                                  // 122
                                                                                                                       //
    var accountUser = Meteor.users.findOne(accountUserId);                                                             // 124
    if (!accountUser) {                                                                                                // 125
      throw new Meteor.Error(404, "No such user found: " + accountUserId);                                             // 126
    }                                                                                                                  // 127
                                                                                                                       //
    var linkedIdentity = _.findWhere(accountUser.loginIdentities, { id: identityUser._id });                           // 129
                                                                                                                       //
    if (!linkedIdentity) {                                                                                             // 131
      throw new Meteor.Error(403, "Current identity is not a login identity for account " + accountUserId);            // 132
    }                                                                                                                  // 134
                                                                                                                       //
    return Accounts._loginMethod(this, "loginWithIdentity", [accountUserId], "identity", function () {                 // 136
      return { userId: accountUserId };                                                                                // 137
    });                                                                                                                // 137
  },                                                                                                                   // 138
                                                                                                                       //
  createAccountForIdentity: function createAccountForIdentity() {                                                      // 140
    // Creates a new account for the currently-logged-in identity.                                                     //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 143
    if (!(user && user.profile)) {                                                                                     // 144
      throw new Meteor.Error(403, "Must be logged in as an identity in order to create an account.");                  // 145
    }                                                                                                                  // 146
                                                                                                                       //
    if (Meteor.users.findOne({                                                                                         // 148
      $or: [{ "loginIdentities.id": user._id }, { "nonloginIdentities.id": user._id }]                                 // 149
    })) {                                                                                                              // 148
      throw new Meteor.Error(403, "Cannot create an account for an identity that's already " + "linked to another account.");
    }                                                                                                                  // 156
                                                                                                                       //
    var newUser = {                                                                                                    // 158
      loginIdentities: [{ id: user._id }],                                                                             // 159
      nonloginIdentities: []                                                                                           // 160
    };                                                                                                                 // 158
    if (user.services.dev) {                                                                                           // 162
      newUser.signupKey = "devAccounts";                                                                               // 163
      if (user.services.dev.isAdmin) {                                                                                 // 164
        newUser.isAdmin = true;                                                                                        // 165
      }                                                                                                                // 166
                                                                                                                       //
      if (user.services.dev.hasCompletedSignup) {                                                                      // 168
        newUser.hasCompletedSignup = true;                                                                             // 169
      }                                                                                                                // 170
    } else if (user.expires) {                                                                                         // 171
      // Demo user.                                                                                                    //
      newUser.expires = user.expires;                                                                                  // 173
      if (!!user.appDemoId) {                                                                                          // 174
        newUser.appDemoId = user.appDemoId;                                                                            // 175
      }                                                                                                                // 176
    }                                                                                                                  // 177
                                                                                                                       //
    var options = {};                                                                                                  // 179
                                                                                                                       //
    // This will throw an error if the identity has been added as a login identity to some                             //
    // other account while we were executing the body of this method.                                                  //
    return Accounts.insertUserDoc(options, newUser);                                                                   // 183
  },                                                                                                                   // 184
                                                                                                                       //
  linkIdentityToAccount: function linkIdentityToAccount(token) {                                                       // 186
    // Links the identity of the current user to the account that has `token` as a resume token.                       //
    // If the account is a demo account, makes the account durable and gives the identity login                        //
    // access to it.                                                                                                   //
                                                                                                                       //
    check(token, String);                                                                                              // 191
                                                                                                                       //
    if (!this.userId) {                                                                                                // 193
      throw new Meteor.Error(403, "Cannot link to account if not logged in.");                                         // 194
    }                                                                                                                  // 195
                                                                                                                       //
    var hashed = Accounts._hashLoginToken(token);                                                                      // 197
    var accountUser = Meteor.users.findOne({ "services.resume.loginTokens.hashedToken": hashed });                     // 198
                                                                                                                       //
    linkIdentityToAccountInternal(this.connection.sandstormDb, this.connection.sandstormBackend, this.userId, accountUser._id, true);
  },                                                                                                                   // 202
                                                                                                                       //
  unlinkIdentity: function unlinkIdentity(accountUserId, identityId) {                                                 // 204
    // Unlinks the identity with ID `identityId` from the account with ID `accountUserId`.                             //
                                                                                                                       //
    check(identityId, String);                                                                                         // 207
    check(accountUserId, String);                                                                                      // 208
                                                                                                                       //
    if (!this.userId) {                                                                                                // 210
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 211
    }                                                                                                                  // 212
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 214
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 215
    }                                                                                                                  // 216
                                                                                                                       //
    var identityUser = Meteor.users.findOne({ _id: identityId });                                                      // 218
    Meteor.users.update({                                                                                              // 219
      _id: accountUserId                                                                                               // 220
    }, {                                                                                                               // 219
      $pull: {                                                                                                         // 222
        nonloginIdentities: { id: identityId },                                                                        // 223
        loginIdentities: { id: identityId }                                                                            // 224
      }                                                                                                                // 222
    });                                                                                                                // 221
  },                                                                                                                   // 227
                                                                                                                       //
  setIdentityAllowsLogin: function setIdentityAllowsLogin(identityId, allowLogin) {                                    // 229
    // Sets whether the current account allows the identity with ID `identityId` to log in.                            //
                                                                                                                       //
    check(identityId, String);                                                                                         // 232
    check(allowLogin, Boolean);                                                                                        // 233
    if (!this.userId) {                                                                                                // 234
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 235
    }                                                                                                                  // 236
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 238
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 239
    }                                                                                                                  // 240
                                                                                                                       //
    if (allowLogin) {                                                                                                  // 242
      Meteor.users.update({ _id: this.userId,                                                                          // 243
        "nonloginIdentities.id": identityId,                                                                           // 244
        "loginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { nonloginIdentities: { id: identityId } },    // 245
        $push: { loginIdentities: { id: identityId } } });                                                             // 247
    } else {                                                                                                           // 248
      Meteor.users.update({ _id: this.userId,                                                                          // 249
        "loginIdentities.id": identityId,                                                                              // 250
        "nonloginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { loginIdentities: { id: identityId } },    // 251
        $push: { nonloginIdentities: { id: identityId } } });                                                          // 253
    }                                                                                                                  // 254
  },                                                                                                                   // 255
                                                                                                                       //
  logoutIdentitiesOfCurrentAccount: function logoutIdentitiesOfCurrentAccount() {                                      // 257
    // Logs out all identities that are allowed to log in to the current account.                                      //
    var user = Meteor.user();                                                                                          // 259
    if (user && user.loginIdentities) {                                                                                // 260
      user.loginIdentities.forEach(function (identity) {                                                               // 261
        Meteor.users.update({ _id: identity.id }, { $set: { "services.resume.loginTokens": [] } });                    // 262
      });                                                                                                              // 263
    }                                                                                                                  // 264
  }                                                                                                                    // 265
});                                                                                                                    // 109
                                                                                                                       //
Accounts.linkIdentityToAccount = function (db, backend, identityId, accountId, allowLogin) {                           // 268
  // Links the identity to the account. If the account is a demo account, makes it durable.                            //
  // If `allowLogin` is true, attempts to give the identity login access.                                              //
  check(db, SandstormDb);                                                                                              // 271
  check(backend, SandstormBackend);                                                                                    // 272
  check(identityId, String);                                                                                           // 273
  check(accountId, String);                                                                                            // 274
  check(allowLogin, Boolean);                                                                                          // 275
  linkIdentityToAccountInternal(db, backend, identityId, accountId, allowLogin);                                       // 276
};                                                                                                                     // 277
                                                                                                                       //
Meteor.publish("accountsOfIdentity", function (identityId) {                                                           // 279
  check(identityId, String);                                                                                           // 280
  if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                              // 281
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var loginIdentities = {};                                                                                            // 284
                                                                                                                       //
  var _this = this;                                                                                                    // 286
  function addIdentitiesOfAccount(account) {                                                                           // 287
    account.loginIdentities.forEach(function (identity) {                                                              // 288
      if (!(identity.id in loginIdentities)) {                                                                         // 289
        var user = Meteor.users.findOne({ _id: identity.id });                                                         // 290
        if (user) {                                                                                                    // 291
          SandstormDb.fillInProfileDefaults(user);                                                                     // 292
          SandstormDb.fillInIntrinsicName(user);                                                                       // 293
          SandstormDb.fillInLoginId(user);                                                                             // 294
          var filteredUser = _.pick(user, "_id", "profile", "loginId");                                                // 295
          filteredUser.loginAccountId = account._id;                                                                   // 296
          filteredUser.sourceIdentityId = identityId;                                                                  // 297
          _this.added("loginIdentitiesOfLinkedAccounts", user._id, filteredUser);                                      // 298
        }                                                                                                              // 299
                                                                                                                       //
        loginIdentities[identity.id] = Meteor.users.find({ _id: identity.id }, { fields: { profile: 1 } }).observeChanges({
          changed: function changed(id, fields) {                                                                      // 303
            _this.changed("loginIdentitiesOfLinkedAccounts", id, fields);                                              // 304
          }                                                                                                            // 305
        });                                                                                                            // 302
      }                                                                                                                // 307
    });                                                                                                                // 308
  }                                                                                                                    // 309
                                                                                                                       //
  var cursor = Meteor.users.find({                                                                                     // 311
    $or: [{ "loginIdentities.id": identityId }, { "nonloginIdentities.id": identityId }]                               // 312
  });                                                                                                                  // 311
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 318
    added: function added(account) {                                                                                   // 319
      addIdentitiesOfAccount(account);                                                                                 // 320
    },                                                                                                                 // 321
                                                                                                                       //
    changed: function changed(newAccount, oldAccount) {                                                                // 323
      addIdentitiesOfAccount(newAccount);                                                                              // 324
    },                                                                                                                 // 325
                                                                                                                       //
    removed: function removed(account) {                                                                               // 327
      account.loginIdentities.forEach(function (identity) {                                                            // 328
        if (identity.id in loginIdentities) {                                                                          // 329
          _this.removed("loginIdentitiesOfLinkedAccounts", identity.id);                                               // 330
          loginIdentities[identity.id].stop();                                                                         // 331
          delete loginIdentities[identity.id];                                                                         // 332
        }                                                                                                              // 333
      });                                                                                                              // 334
    }                                                                                                                  // 335
  });                                                                                                                  // 318
  this.ready();                                                                                                        // 337
                                                                                                                       //
  this.onStop(function () {                                                                                            // 339
    handle.stop();                                                                                                     // 340
    Object.keys(loginIdentities).forEach(function (identityId) {                                                       // 341
      loginIdentities[identityId].stop();                                                                              // 342
      delete loginIdentities[identityId];                                                                              // 343
    });                                                                                                                // 344
  });                                                                                                                  // 345
});                                                                                                                    // 346
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"ldap":{"ldap-server.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/ldap/ldap-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});                               // 1
                                                                                                                       //
// Register login handler with Meteor                                                                                  //
Accounts.registerLoginHandler("ldap", function (loginRequest) {                                                        // 4
  // If 'ldap' isn't set in loginRequest object,                                                                       //
  // then this isn't the proper handler (return undefined)                                                             //
  if (!loginRequest.ldap) {                                                                                            // 7
    return undefined;                                                                                                  // 8
  }                                                                                                                    // 9
                                                                                                                       //
  if (!Accounts.identityServices.ldap.isEnabled()) {                                                                   // 11
    throw new Meteor.Error(403, "LDAP service is disabled.");                                                          // 12
  }                                                                                                                    // 13
                                                                                                                       //
  check(loginRequest, {                                                                                                // 15
    ldap: true,                                                                                                        // 16
    username: String,                                                                                                  // 17
    ldapPass: String                                                                                                   // 18
  });                                                                                                                  // 15
                                                                                                                       //
  // Instantiate LDAP                                                                                                  //
  var ldapObj = new LDAP();                                                                                            // 22
                                                                                                                       //
  // Call ldapCheck and get response                                                                                   //
  var ldapResponse = ldapObj.ldapCheck(this.connection.sandstormDb, loginRequest);                                     // 25
                                                                                                                       //
  if (ldapResponse.error) {                                                                                            // 27
    return {                                                                                                           // 28
      userId: null,                                                                                                    // 29
      error: ldapResponse.error                                                                                        // 30
    };                                                                                                                 // 28
  } else if (ldapResponse.emptySearch) {                                                                               // 32
    return {                                                                                                           // 33
      userId: null,                                                                                                    // 34
      error: new Meteor.Error(403, "User not found in LDAP")                                                           // 35
    };                                                                                                                 // 33
  } else {                                                                                                             // 37
    // Set initial userId and token vals                                                                               //
    return Accounts.updateOrCreateUserFromExternalService("ldap", { id: ldapResponse.dn, username: loginRequest.username,
      rawAttrs: ldapResponse.searchResults }, {});                                                                     // 41
  }                                                                                                                    // 42
});                                                                                                                    // 44
                                                                                                                       //
Meteor.methods({                                                                                                       // 46
  updateQuota: function updateQuota() {                                                                                // 47
    return this.connection.sandstormDb.updateUserQuota(Meteor.user());                                                 // 48
    // This is a no-op if settings aren't enabled                                                                      //
  }                                                                                                                    // 50
});                                                                                                                    // 46
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"saml":{"saml-server.js":["url","/imports/server/accounts/saml-utils.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/saml/saml-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Url;module.import("url",{"default":function(v){Url=v}});var SAML;module.import("/imports/server/accounts/saml-utils.js",{"SAML":function(v){SAML=v}});
                                                                                                                       // 2
                                                                                                                       //
var Fiber = Npm.require("fibers");                                                                                     // 4
                                                                                                                       //
if (!Accounts.saml) {                                                                                                  // 6
  Accounts.saml = {};                                                                                                  // 7
}                                                                                                                      // 8
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 12
                                                                                                                       //
RoutePolicy.declare("/_saml/", "network");                                                                             // 14
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 16
                                                                                                                       //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                            //
//   replicated (but currently Sandstorm for Work is not replicated).                                                  //
var _loginResultForCredentialToken = {};                                                                               // 20
                                                                                                                       //
var retrieveCredential = function retrieveCredential(credentialToken) {                                                // 22
  var result = _loginResultForCredentialToken[credentialToken];                                                        // 23
  delete _loginResultForCredentialToken[credentialToken];                                                              // 24
  return result;                                                                                                       // 25
};                                                                                                                     // 26
                                                                                                                       //
Accounts.registerLoginHandler(function (loginRequest) {                                                                // 28
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                           // 29
    return undefined;                                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                   // 33
    throw new Meteor.Error(403, "SAML service is disabled.");                                                          // 34
  }                                                                                                                    // 35
                                                                                                                       //
  var loginResult = retrieveCredential(loginRequest.credentialToken);                                                  // 37
  if (!loginResult) {                                                                                                  // 38
    throw new Meteor.Error(500, "SAML login did not complete.");                                                       // 39
  } else if (loginResult.profile && loginResult.profile.email) {                                                       // 40
    var user = _.pick(loginResult.profile, "displayName", "email");                                                    // 41
    user.id = loginResult.profile.nameID;                                                                              // 42
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                           // 43
  } else {                                                                                                             // 44
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                      // 45
  }                                                                                                                    // 46
});                                                                                                                    // 47
                                                                                                                       //
var samlUrlToObject = function samlUrlToObject(url) {                                                                  // 49
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                                //
  if (!url) return null;                                                                                               // 51
                                                                                                                       //
  var splitPath = url.split("/");                                                                                      // 54
                                                                                                                       //
  // Any non-saml request will continue down the default                                                               //
  // middlewares.                                                                                                      //
  if (splitPath[1] !== "_saml") return null;                                                                           // 58
                                                                                                                       //
  return {                                                                                                             // 61
    actionName: splitPath[2],                                                                                          // 62
    serviceName: splitPath[3],                                                                                         // 63
    credentialToken: splitPath[4]                                                                                      // 64
  };                                                                                                                   // 61
};                                                                                                                     // 66
                                                                                                                       //
var closePopup = function closePopup(res, err) {                                                                       // 68
  res.writeHead(200, { "Content-Type": "text/html" });                                                                 // 69
  var content = "<html><head><script>window.close()</script></head></html>";                                           // 70
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a> <a href="/admin/status" target="_blank">View system log (admin only)</a></body></html>';
  res.end(content, "utf-8");                                                                                           // 74
};                                                                                                                     // 75
                                                                                                                       //
var generateService = function generateService() {                                                                     // 77
  // TODO(cleanup): Inject the db.                                                                                     //
  var db = new SandstormDb();                                                                                          // 79
                                                                                                                       //
  var entityId = db.getSamlEntityId();                                                                                 // 81
  var service = {                                                                                                      // 82
    "provider": "default",                                                                                             // 83
    "entryPoint": db.getSamlEntryPoint(),                                                                              // 84
    // TODO(someday): find a better way to inject the DB                                                               //
    "issuer": entityId || HOSTNAME,                                                                                    // 86
    // If the certificate has "-----BEGIN CERTIFICATE-----" markers, automatically remove those.                       //
    "cert": db.getSamlPublicCert().replace(/-[^\n]*-/g, "").trim()                                                     // 88
  };                                                                                                                   // 82
  return service;                                                                                                      // 90
};                                                                                                                     // 91
                                                                                                                       //
var middleware = function middleware(req, res, next) {                                                                 // 93
  // Make sure to catch any exceptions because otherwise we'd crash                                                    //
  // the runner                                                                                                        //
  try {                                                                                                                // 96
    var samlObject = samlUrlToObject(req.url);                                                                         // 97
    if (!samlObject || !samlObject.serviceName) {                                                                      // 98
      next();                                                                                                          // 99
      return;                                                                                                          // 100
    }                                                                                                                  // 101
                                                                                                                       //
    if (samlObject.actionName === "config") {                                                                          // 103
      var _saml = new SAML(generateService());                                                                         // 104
      res.writeHead(200, { "Content-Type": "text/xml" });                                                              // 105
      res.end(_saml.generateServiceProviderMetadata());                                                                // 106
      return;                                                                                                          // 107
    }                                                                                                                  // 108
                                                                                                                       //
    if (!Accounts.identityServices.saml.isEnabled()) {                                                                 // 110
      next();                                                                                                          // 111
      return;                                                                                                          // 112
    }                                                                                                                  // 113
                                                                                                                       //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                                // 115
                                                                                                                       //
    var service = generateService();                                                                                   // 118
                                                                                                                       //
    // Skip everything if there's no service set by the saml middleware                                                //
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                       //
    if (samlObject.actionName === "authorize") {                                                                       // 124
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                                  // 125
      service.id = samlObject.credentialToken;                                                                         // 126
      var _saml2 = new SAML(service);                                                                                  // 127
      _saml2.getAuthorizeUrl(req, function (err, url) {                                                                // 128
        if (err) throw new Error("Unable to generate authorize url");                                                  // 129
        res.writeHead(302, { "Location": url });                                                                       // 131
        res.end();                                                                                                     // 132
      });                                                                                                              // 133
    } else if (samlObject.actionName === "validate") {                                                                 // 134
      var _saml3 = new SAML(service);                                                                                  // 135
      _saml3.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut, responseText) {                // 136
        if (err) {                                                                                                     // 138
          console.error("Error validating SAML response:", err.toString(), "\nFull SAML response XML:\n", responseText);
          throw new Error("Unable to validate SAML response.");                                                        // 141
        }                                                                                                              // 142
                                                                                                                       //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                     //
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                          // 145
        if (!credentialToken) {                                                                                        // 146
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                              // 151
                                                                                                                       //
        _loginResultForCredentialToken[credentialToken] = {                                                            // 153
          profile: profile                                                                                             // 154
        };                                                                                                             // 153
                                                                                                                       //
        closePopup(res);                                                                                               // 157
      });                                                                                                              // 158
    } else {                                                                                                           // 159
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                              // 160
    }                                                                                                                  // 161
  } catch (err) {                                                                                                      // 162
    console.error(err.stack);                                                                                          // 163
    closePopup(res, err);                                                                                              // 164
  }                                                                                                                    // 165
};                                                                                                                     // 166
                                                                                                                       //
// Listen to incoming OAuth http requests                                                                              //
WebApp.connectHandlers.use(connect.urlencoded()).use(function (req, res, next) {                                       // 169
  // Need to create a Fiber since we're using synchronous http calls and nothing                                       //
  // else is wrapping this in a fiber automatically                                                                    //
  Fiber(function () {                                                                                                  // 172
    middleware(req, res, next);                                                                                        // 173
  }).run();                                                                                                            // 174
});                                                                                                                    // 175
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"accounts-server.js":["meteor/accounts-base","/imports/server/accounts/picture.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Accounts;module.import("meteor/accounts-base",{"Accounts":function(v){Accounts=v}});var fetchPicture,userPictureUrl;module.import("/imports/server/accounts/picture.js",{"fetchPicture":function(v){fetchPicture=v},"userPictureUrl":function(v){userPictureUrl=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 20
var Future = Npm.require("fibers/future");                                                                             // 21
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 23
  check(handle, String);                                                                                               // 24
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 25
});                                                                                                                    // 26
                                                                                                                       //
Accounts.onCreateUser(function (options, user) {                                                                       // 28
  if (user.loginIdentities) {                                                                                          // 29
    // it's an account                                                                                                 //
    check(user, { _id: String,                                                                                         // 31
      createdAt: Date,                                                                                                 // 32
      isAdmin: Match.Optional(Boolean),                                                                                // 33
      hasCompletedSignup: Match.Optional(Boolean),                                                                     // 34
      signupKey: Match.Optional(String),                                                                               // 35
      signupNote: Match.Optional(String),                                                                              // 36
      signupEmail: Match.Optional(String),                                                                             // 37
      expires: Match.Optional(Date),                                                                                   // 38
      appDemoId: Match.Optional(String),                                                                               // 39
      loginIdentities: [{ id: String }],                                                                               // 40
      nonloginIdentities: [{ id: String }] });                                                                         // 41
                                                                                                                       //
    if (globalDb.isReferralEnabled()) {                                                                                // 43
      user.experiments = user.experiments || {};                                                                       // 44
      user.experiments = {                                                                                             // 45
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                               // 46
      };                                                                                                               // 45
      if (!("expires" in user)) {                                                                                      // 48
        globalDb.sendReferralProgramNotification(user._id);                                                            // 49
      }                                                                                                                // 50
    }                                                                                                                  // 51
                                                                                                                       //
    globalDb.preinstallAppsForUser(user._id);                                                                          // 53
                                                                                                                       //
    return user;                                                                                                       // 55
  }                                                                                                                    // 56
                                                                                                                       //
  if (globalDb.getOrganizationDisallowGuests() && !globalDb.isIdentityInOrganization(user)) {                          // 58
    throw new Meteor.Error(400, "User not in organization.");                                                          // 60
  }                                                                                                                    // 61
                                                                                                                       //
  // Check profile.                                                                                                    //
  if (options.profile) {                                                                                               // 64
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                               //
    check(options.profile, Match.ObjectIncluding({                                                                     // 66
      name: Match.OneOf(null, Match.Optional(String)),                                                                 // 67
      handle: Match.Optional(ValidHandle),                                                                             // 68
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                       // 69
    }));                                                                                                               // 66
  }                                                                                                                    // 71
                                                                                                                       //
  check(options.unverifiedEmail, Match.Optional(String));                                                              // 73
                                                                                                                       //
  if (options.unverifiedEmail) {                                                                                       // 75
    user.unverifiedEmail = options.unverifiedEmail;                                                                    // 76
  }                                                                                                                    // 77
                                                                                                                       //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronoun");                                           // 79
                                                                                                                       //
  // Try downloading avatar.                                                                                           //
  var url = userPictureUrl(user);                                                                                      // 82
  if (url) {                                                                                                           // 83
    var assetId = fetchPicture(globalDb, url);                                                                         // 84
    if (assetId) {                                                                                                     // 85
      user.profile.picture = assetId;                                                                                  // 86
    }                                                                                                                  // 87
  }                                                                                                                    // 88
                                                                                                                       //
  var serviceUserId = void 0;                                                                                          // 90
  if (user.services && user.services.dev) {                                                                            // 91
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                         // 92
    serviceUserId = user.services.dev.name;                                                                            // 93
    user.profile.service = "dev";                                                                                      // 94
  } else if ("expires" in user) {                                                                                      // 95
    serviceUserId = user._id;                                                                                          // 96
    user.profile.service = "demo";                                                                                     // 97
  } else if (user.services && user.services.email) {                                                                   // 98
    check(user.services.email, {                                                                                       // 99
      email: String,                                                                                                   // 100
      tokens: [{                                                                                                       // 101
        digest: String,                                                                                                // 103
        algorithm: String,                                                                                             // 104
        createdAt: Date,                                                                                               // 105
        secureBox: Match.Optional({                                                                                    // 106
          version: Number,                                                                                             // 107
          salt: String,                                                                                                // 108
          iv: String,                                                                                                  // 109
          boxedValue: String                                                                                           // 110
        })                                                                                                             // 106
      }]                                                                                                               // 102
    });                                                                                                                // 99
    serviceUserId = user.services.email.email;                                                                         // 115
    user.profile.service = "email";                                                                                    // 116
  } else if (user.services && "google" in user.services) {                                                             // 117
    serviceUserId = user.services.google.id;                                                                           // 118
    user.profile.service = "google";                                                                                   // 119
  } else if (user.services && "github" in user.services) {                                                             // 120
    serviceUserId = user.services.github.id;                                                                           // 121
    user.profile.service = "github";                                                                                   // 122
  } else if (user.services && "ldap" in user.services) {                                                               // 123
    serviceUserId = user.services.ldap.id;                                                                             // 124
    user.profile.service = "ldap";                                                                                     // 125
  } else if (user.services && "saml" in user.services) {                                                               // 126
    serviceUserId = user.services.saml.id;                                                                             // 127
    user.profile.service = "saml";                                                                                     // 128
  } else {                                                                                                             // 129
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));         // 130
  }                                                                                                                    // 132
                                                                                                                       //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");             // 134
                                                                                                                       //
  return user;                                                                                                         // 137
});                                                                                                                    // 138
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 140
  if (!attempt.allowed) {                                                                                              // 141
    return false;                                                                                                      // 142
  }                                                                                                                    // 143
                                                                                                                       //
  var db = attempt.connection.sandstormDb;                                                                             // 145
  var user = attempt.user;                                                                                             // 146
                                                                                                                       //
  if (user.suspended && user.suspended.admin) {                                                                        // 148
    throw new Meteor.Error(403, "User has been suspended. Please contact the administrator " + "of this server if you believe this to be in error.");
  }                                                                                                                    // 151
                                                                                                                       //
  if (user.loginIdentities) {                                                                                          // 153
    // it's an account                                                                                                 //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                        // 155
      throw new Meteor.Error(403, "User not in organization.");                                                        // 157
    }                                                                                                                  // 158
                                                                                                                       //
    db.updateUserQuota(user); // This is a no-op if settings aren't enabled                                            // 160
  } else {                                                                                                             // 161
      if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                  // 162
        throw new Meteor.Error(403, "User not in organization.");                                                      // 164
      }                                                                                                                // 165
    }                                                                                                                  // 166
                                                                                                                       //
  return true;                                                                                                         // 168
});                                                                                                                    // 169
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"accounts-ui-methods.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-methods.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file contains method definitions which are available on both client and server (on the                         //
// client for prediction purposes, on the server for actual execution).                                                //
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 20
  check(handle, String);                                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  updateProfile: function updateProfile(identityId, profile) {                                                         // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                                //
    check(identityId, String);                                                                                         // 28
                                                                                                                       //
    check(profile, {                                                                                                   // 30
      name: String,                                                                                                    // 31
      handle: ValidHandle,                                                                                             // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                                      // 33
      unverifiedEmail: Match.Optional(String)                                                                          // 34
    });                                                                                                                // 30
                                                                                                                       //
    if (!this.userId) {                                                                                                // 37
      throw new Meteor.Error(403, "not logged in");                                                                    // 38
    }                                                                                                                  // 39
                                                                                                                       //
    var userToUpdate = Meteor.users.findOne({ _id: identityId });                                                      // 41
                                                                                                                       //
    if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                 // 43
      throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);                            // 45
    }                                                                                                                  // 46
                                                                                                                       //
    var newValues = {                                                                                                  // 48
      "profile.name": profile.name,                                                                                    // 49
      "profile.handle": profile.handle,                                                                                // 50
      "profile.pronoun": profile.pronoun                                                                               // 51
    };                                                                                                                 // 48
                                                                                                                       //
    Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                                               // 54
                                                                                                                       //
    if (!Meteor.user().hasCompletedSignup) {                                                                           // 56
      Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });                               // 57
    }                                                                                                                  // 58
  },                                                                                                                   // 59
                                                                                                                       //
  testFirstSignup: function testFirstSignup(profile) {                                                                 // 61
    if (!this.userId) {                                                                                                // 62
      throw new Meteor.Error(403, "not logged in");                                                                    // 63
    }                                                                                                                  // 64
                                                                                                                       //
    Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                                          // 66
  },                                                                                                                   // 67
                                                                                                                       //
  uploadProfilePicture: function uploadProfilePicture(identityId) {                                                    // 69
    check(identityId, String);                                                                                         // 70
    if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                       // 71
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 72
    }                                                                                                                  // 73
                                                                                                                       //
    return this.connection.sandstormDb.newAssetUpload({                                                                // 75
      profilePicture: { userId: this.userId, identityId: identityId }                                                  // 76
    });                                                                                                                // 75
  },                                                                                                                   // 78
                                                                                                                       //
  cancelUploadProfilePicture: function cancelUploadProfilePicture(id) {                                                // 80
    check(id, String);                                                                                                 // 81
    this.connection.sandstormDb.fulfillAssetUpload(id);                                                                // 82
  },                                                                                                                   // 83
                                                                                                                       //
  setPrimaryEmail: function setPrimaryEmail(email) {                                                                   // 85
    check(email, String);                                                                                              // 86
    if (!this.userId) {                                                                                                // 87
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 88
    }                                                                                                                  // 89
                                                                                                                       //
    var emails = SandstormDb.getUserEmails(Meteor.user());                                                             // 91
    if (!_.findWhere(emails, { email: email, verified: true })) {                                                      // 92
      throw new Meteor.Error(403, "Not a verified email of the current user: " + email);                               // 93
    }                                                                                                                  // 94
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                                      // 96
  }                                                                                                                    // 97
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"accounts-ui-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-server.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                                       //
Meteor.users.deny({                                                                                                    // 18
  insert: function insert() {                                                                                          // 19
    return true;                                                                                                       // 19
  },                                                                                                                   // 19
                                                                                                                       //
  update: function update() {                                                                                          // 21
    return true;                                                                                                       // 21
  },                                                                                                                   // 21
                                                                                                                       //
  remove: function remove() {                                                                                          // 23
    return true;                                                                                                       // 23
  },                                                                                                                   // 23
                                                                                                                       //
  fetch: []                                                                                                            // 25
});                                                                                                                    // 18
                                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                                             // 28
  var db = this.connection.sandstormDb;                                                                                // 29
  if (this.userId) {                                                                                                   // 30
    // TODO(someday): Make this reactive.                                                                              //
    var user = Meteor.users.findOne(this.userId);                                                                      // 32
    var usage = db.getMyUsage(user);                                                                                   // 33
    this.added("users", this.userId, {                                                                                 // 34
      pseudoUsage: usage                                                                                               // 35
    });                                                                                                                // 34
  }                                                                                                                    // 37
                                                                                                                       //
  this.ready();                                                                                                        // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function setMaintenanceMessage(params) {                                                      // 12
    checkAuth(undefined);                                                                                              // 13
    check(params, maintenanceMessageShape);                                                                            // 14
    var db = this.connection.sandstormDb;                                                                              // 15
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                                 // 17
    db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                   // 18
    db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                     // 19
  }                                                                                                                    // 20
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String,                                                                                            // 10
                                                                                                                       //
  whitelabelCustomLoginProviderName: String,                                                                           // 12
  whitelabelHideSendFeedback: Boolean,                                                                                 // 13
  whitelabelHideTroubleshooting: Boolean,                                                                              // 14
  whiteLabelHideAbout: Boolean,                                                                                        // 15
  whitelabelUseServerTitleForHomeText: Boolean                                                                         // 16
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  setPersonalizationSettings: function setPersonalizationSettings(params) {                                            // 20
    checkAuth(undefined);                                                                                              // 21
    check(params, personalizationMessageShape);                                                                        // 22
    var db = this.connection.sandstormDb;                                                                              // 23
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                             // 25
    db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                                 // 26
    db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                           // 27
    db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                          // 28
    db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                         // 29
                                                                                                                       //
    db.collections.settings.upsert({ _id: "whitelabelCustomLoginProviderName" }, { value: params.whitelabelCustomLoginProviderName });
    db.collections.settings.upsert({ _id: "whitelabelHideSendFeedback" }, { value: params.whitelabelHideSendFeedback });
    db.collections.settings.upsert({ _id: "whitelabelHideTroubleshooting" }, { value: params.whitelabelHideTroubleshooting });
    db.collections.settings.upsert({ _id: "whiteLabelHideAbout" }, { value: params.whiteLabelHideAbout });             // 37
    db.collections.settings.upsert({ _id: "whitelabelUseServerTitleForHomeText" }, { value: params.whitelabelUseServerTitleForHomeText });
  },                                                                                                                   // 41
  getWhitelabelLogoUploadToken: function getWhitelabelLogoUploadToken() {                                              // 43
    checkAuth(undefined);                                                                                              // 44
    var db = this.connection.sandstormDb;                                                                              // 45
    return db.newAssetUpload({ loginLogo: {} });                                                                       // 46
  },                                                                                                                   // 47
  resetWhitelabelLogo: function resetWhitelabelLogo() {                                                                // 49
    checkAuth(undefined);                                                                                              // 50
    var db = this.connection.sandstormDb;                                                                              // 51
    var result = globalDb.collections.settings.findAndModify({                                                         // 52
      query: { _id: "whitelabelCustomLogoAssetId" },                                                                   // 53
      remove: true,                                                                                                    // 54
      fields: { value: 1 }                                                                                             // 55
    });                                                                                                                // 52
                                                                                                                       //
    if (result.ok) {                                                                                                   // 58
      var old = result.value;                                                                                          // 59
      if (old) {                                                                                                       // 60
        db.unrefStaticAsset(old.value);                                                                                // 61
      }                                                                                                                // 62
    } else {                                                                                                           // 63
      throw new Meteor.Error(500, "Couldn't remove whitelabelCustomLogoAssetId");                                      // 64
    }                                                                                                                  // 65
  }                                                                                                                    // 66
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs","/imports/server/auth.js","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       //
                                                                                                                       // 8
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 10
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 11
};                                                                                                                     // 12
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 16
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  adminGetServerLogDownloadToken: function adminGetServerLogDownloadToken(setupToken) {                                // 20
    checkAuth(setupToken);                                                                                             // 21
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 23
    SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                    // 24
    setTimeout(function () {                                                                                           // 25
      if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                         // 26
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                      // 27
      }                                                                                                                // 28
    }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                               // 29
    return token;                                                                                                      // 30
  }                                                                                                                    // 31
});                                                                                                                    // 19
                                                                                                                       //
Router.map(function () {                                                                                               // 34
  this.route("adminDownloadServerLog", {                                                                               // 35
    where: "server",                                                                                                   // 36
    path: "/admin/status/server-log/:tokenId",                                                                         // 37
    action: function action() {                                                                                        // 38
      var token = this.params.tokenId;                                                                                 // 39
      var response = this.response;                                                                                    // 40
      var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                               // 41
      delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                             // 42
      if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {           // 43
        // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                           //
        // method being called.                                                                                        //
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 47
        return response.end("Invalid server log download token.");                                                     // 48
      }                                                                                                                // 49
                                                                                                                       //
      var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                           // 51
      var fd = Fs.openSync(logFilePath, "r");                                                                          // 52
      var stats = Fs.fstatSync(fd);                                                                                    // 53
      var initialSize = stats.size;                                                                                    // 54
      var readStream = Fs.createReadStream(undefined, {                                                                // 55
        fd: fd,                                                                                                        // 56
        start: 0,                                                                                                      // 57
        end: initialSize                                                                                               // 58
      });                                                                                                              // 55
                                                                                                                       //
      response.writeHead(200, {                                                                                        // 61
        "Content-Length": initialSize,                                                                                 // 62
        "Content-Type": "text/plain",                                                                                  // 63
        "content-Disposition": "attachment;filename=\"sandstorm.log\""                                                 // 64
      });                                                                                                              // 61
      readStream.pipe(response);                                                                                       // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 35
});                                                                                                                    // 69
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 71
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 74
  if (!db.isAdminById(this.userId)) {                                                                                  // 75
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 76
  }                                                                                                                    // 77
                                                                                                                       //
  var _this = this;                                                                                                    // 79
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 80
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 81
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 83
  var grainIdCount = 0;                                                                                                // 84
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 86
    activeUsers: userIdCount,                                                                                          // 87
    activeGrains: grainIdCount                                                                                         // 88
  });                                                                                                                  // 86
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 91
  var handle = query.observe({                                                                                         // 92
    added: function added(session) {                                                                                   // 93
      var hashedSessionId = hashSessionId(session._id);                                                                // 94
      var changed = {};                                                                                                // 95
                                                                                                                       //
      // Update userId cache.                                                                                          //
      if (session.userId) {                                                                                            // 98
        if (userIdToSessionHashes[session.userId] === undefined) {                                                     // 99
          userIdToSessionHashes[session.userId] = [];                                                                  // 100
          userIdCount = userIdCount + 1;                                                                               // 101
          changed.activeUsers = userIdCount;                                                                           // 102
        }                                                                                                              // 103
                                                                                                                       //
        userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);     // 105
      }                                                                                                                // 107
                                                                                                                       //
      // Update grainId cache.                                                                                         //
      if (grainIdToSessionHashes[session.grainId] === undefined) {                                                     // 110
        grainIdToSessionHashes[session.grainId] = [];                                                                  // 111
        grainIdCount = grainIdCount + 1;                                                                               // 112
        changed.activeGrains = grainIdCount;                                                                           // 113
      }                                                                                                                // 114
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);   // 116
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 119
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 120
      }                                                                                                                // 121
    },                                                                                                                 // 122
    removed: function removed(session) {                                                                               // 124
      var hashedSessionId = hashSessionId(session._id);                                                                // 125
      var changed = {};                                                                                                // 126
                                                                                                                       //
      if (session.userId) {                                                                                            // 128
        userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);     // 129
                                                                                                                       //
        if (userIdToSessionHashes[session.userId].length === 0) {                                                      // 132
          delete userIdToSessionHashes[session.userId];                                                                // 133
          userIdCount = userIdCount - 1;                                                                               // 134
          changed.activeUsers = userIdCount;                                                                           // 135
        }                                                                                                              // 136
      }                                                                                                                // 137
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);   // 139
                                                                                                                       //
      if (grainIdToSessionHashes[session.grainId].length === 0) {                                                      // 142
        delete grainIdToSessionHashes[session.grainId];                                                                // 143
        grainIdCount = grainIdCount - 1;                                                                               // 144
        changed.activeGrains = grainIdCount;                                                                           // 145
      }                                                                                                                // 146
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 148
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 149
      }                                                                                                                // 150
    }                                                                                                                  // 151
  });                                                                                                                  // 92
                                                                                                                       //
  this.onStop(function () {                                                                                            // 154
    handle.stop();                                                                                                     // 155
  });                                                                                                                  // 156
  this.ready();                                                                                                        // 157
});                                                                                                                    // 158
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 160
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 163
  if (!db.isAdminById(this.userId)) {                                                                                  // 164
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 165
  }                                                                                                                    // 166
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 168
    expires: {                                                                                                         // 169
      $gt: new Date()                                                                                                  // 170
    },                                                                                                                 // 169
    loginIdentities: {                                                                                                 // 172
      $exists: true                                                                                                    // 173
    }                                                                                                                  // 172
  }, {                                                                                                                 // 168
    expires: 1,                                                                                                        // 176
    loginIdentities: 1                                                                                                 // 177
  });                                                                                                                  // 175
});                                                                                                                    // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
var Url = Npm.require("url");                                                                                          // 19
var Http = Npm.require("http");                                                                                        // 20
var Https = Npm.require("https");                                                                                      // 21
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 22
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 24
  function ExternalUiView(url, grainId, token) {                                                                       // 25
    _classCallCheck(this, ExternalUiView);                                                                             // 25
                                                                                                                       //
    this.url = url;                                                                                                    // 26
    this.grainId = grainId;                                                                                            // 27
    this.token = token;                                                                                                // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ExternalUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams) {           // 24
    if (sessionType !== ApiSession.typeId) {                                                                           // 32
      throw new Error("SessionType must be ApiSession.");                                                              // 33
    }                                                                                                                  // 34
                                                                                                                       //
    var options = {};                                                                                                  // 36
                                                                                                                       //
    if (this.token) {                                                                                                  // 38
      options.headers = {                                                                                              // 39
        authorization: "Bearer " + this.token                                                                          // 40
      };                                                                                                               // 39
    }                                                                                                                  // 42
                                                                                                                       //
    return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };     // 44
  };                                                                                                                   // 45
                                                                                                                       //
  return ExternalUiView;                                                                                               // 24
}();                                                                                                                   // 24
                                                                                                                       //
var responseCodes = {                                                                                                  // 48
  200: { type: "content", code: "ok" },                                                                                // 49
  201: { type: "content", code: "created" },                                                                           // 50
  202: { type: "content", code: "accepted" },                                                                          // 51
  204: { type: "noContent", shouldResetForm: false },                                                                  // 52
  205: { type: "noContent", shouldResetForm: true },                                                                   // 53
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 58
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 59
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 60
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 65
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 66
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 67
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 68
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 69
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 70
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 71
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 72
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 73
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 75
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 76
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 77
  500: { type: "serverError" },                                                                                        // 78
  501: { type: "serverError" },                                                                                        // 79
  502: { type: "serverError" },                                                                                        // 80
  503: { type: "serverError" },                                                                                        // 81
  504: { type: "serverError" },                                                                                        // 82
  505: { type: "serverError" }                                                                                         // 83
};                                                                                                                     // 48
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 86
  function ExternalWebSession(url, grainId, options) {                                                                 // 87
    _classCallCheck(this, ExternalWebSession);                                                                         // 87
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 88
    this.host = parsedUrl.hostname;                                                                                    // 89
    this.port = parsedUrl.port;                                                                                        // 90
    this.protocol = parsedUrl.protocol;                                                                                // 91
    this.grainId = grainId;                                                                                            // 92
    this.options = options || {};                                                                                      // 93
  }                                                                                                                    // 94
                                                                                                                       //
  ExternalWebSession.prototype.get = function get(path, context) {                                                     // 86
    return this._requestHelper("GET", path, context);                                                                  // 97
  };                                                                                                                   // 98
                                                                                                                       //
  ExternalWebSession.prototype.post = function post(path, content, context) {                                          // 86
    return this._requestHelper("POST", path, context, content.content, content.mimeType);                              // 101
  };                                                                                                                   // 102
                                                                                                                       //
  ExternalWebSession.prototype.put = function put(path, content, context) {                                            // 86
    return this._requestHelper("PUT", path, context, content.content, content.mimeType);                               // 105
  };                                                                                                                   // 106
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function _delete(path, context) {                                           // 86
    return this._requestHelper("DELETE", path, context);                                                               // 109
  };                                                                                                                   // 110
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function _requestHelper(method, path, context, content, contentType) {
    var _this = this;                                                                                                  // 123
    var session = _this;                                                                                               // 124
    return new Promise(function (resolve, reject) {                                                                    // 125
      var options = _.clone(session.options);                                                                          // 126
      options.headers = options.headers || {};                                                                         // 127
      options.path = path;                                                                                             // 128
      options.method = method;                                                                                         // 129
      if (contentType) {                                                                                               // 130
        options.headers["content-type"] = contentType;                                                                 // 131
      }                                                                                                                // 132
                                                                                                                       //
      // set accept header                                                                                             //
      if ("accept" in context) {                                                                                       // 135
        options.headers.accept = context.accept.map(function (acceptedType) {                                          // 136
          return acceptedType.mimeType + "; " + acceptedType.qValue;                                                   // 137
        }).join(", ");                                                                                                 // 138
      } else if (!("accept" in options.headers)) {                                                                     // 139
        options.headers.accept = "*/*";                                                                                // 140
      }                                                                                                                // 141
                                                                                                                       //
      // set cookies                                                                                                   //
      if (context.cookies && context.cookies.length > 0) {                                                             // 144
        options.headers.cookies = options.headers.cookies || "";                                                       // 145
        context.cookies.forEach(function (keyVal) {                                                                    // 146
          options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                              // 147
        });                                                                                                            // 148
        options.headers.cookies = options.headers.cookies.slice(0, -1);                                                // 149
      }                                                                                                                // 150
                                                                                                                       //
      options.host = session.host;                                                                                     // 152
      options.port = session.port;                                                                                     // 153
                                                                                                                       //
      var requestMethod = Http.request;                                                                                // 155
      if (session.protocol === "https:") {                                                                             // 156
        requestMethod = Https.request;                                                                                 // 157
      }                                                                                                                // 158
                                                                                                                       //
      req = requestMethod(options, function (resp) {                                                                   // 160
        var buffers = [];                                                                                              // 161
        var statusInfo = responseCodes[resp.statusCode];                                                               // 162
                                                                                                                       //
        var rpcResponse = {};                                                                                          // 164
                                                                                                                       //
        switch (statusInfo.type) {                                                                                     // 166
          case "content":                                                                                              // 167
            resp.on("data", function (buf) {                                                                           // 168
              buffers.push(buf);                                                                                       // 169
            });                                                                                                        // 170
                                                                                                                       //
            resp.on("end", function () {                                                                               // 172
              var content = {};                                                                                        // 173
              rpcResponse.content = content;                                                                           // 174
                                                                                                                       //
              content.statusCode = statusInfo.code;                                                                    // 176
              if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];             // 177
              if ("content-language" in resp.headers) content.language = resp.headers["content-language"];             // 178
              if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                     // 179
              if ("content-disposition" in resp.headers) {                                                             // 180
                var disposition = resp.headers["content-disposition"];                                                 // 181
                var parts = disposition.split(";");                                                                    // 182
                if (parts[0].toLowerCase().trim() === "attachment") {                                                  // 183
                  parts.forEach(function (part) {                                                                      // 184
                    var splitPart = part.split("=");                                                                   // 185
                    if (splitPart[0].toLowerCase().trim() === "filename") {                                            // 186
                      content.disposition = { download: splitPart[1].trim() };                                         // 187
                    }                                                                                                  // 188
                  });                                                                                                  // 189
                }                                                                                                      // 190
              }                                                                                                        // 191
                                                                                                                       //
              content.body = {};                                                                                       // 193
              content.body.bytes = Buffer.concat(buffers);                                                             // 194
                                                                                                                       //
              resolve(rpcResponse);                                                                                    // 196
            });                                                                                                        // 197
            break;                                                                                                     // 198
          case "noContent":                                                                                            // 199
            var noContent = {};                                                                                        // 200
            rpcResponse.noContent = noContent;                                                                         // 201
            noContent.setShouldResetForm = statusInfo.shouldResetForm;                                                 // 202
            resolve(rpcResponse);                                                                                      // 203
            break;                                                                                                     // 204
          case "redirect":                                                                                             // 205
            var redirect = {};                                                                                         // 206
            rpcResponse.redirect = redirect;                                                                           // 207
            redirect.isPermanent = statusInfo.isPermanent;                                                             // 208
            redirect.switchToGet = statusInfo.switchToGet;                                                             // 209
            if ("location" in resp.headers) redirect.location = resp.headers.location;                                 // 210
            resolve(rpcResponse);                                                                                      // 211
            break;                                                                                                     // 212
          case "clientError":                                                                                          // 213
            var clientError = {};                                                                                      // 214
            rpcResponse.clientError = clientError;                                                                     // 215
            clientError.statusCode = statusInfo.clientErrorCode;                                                       // 216
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 217
            resolve(rpcResponse);                                                                                      // 218
            break;                                                                                                     // 219
          case "serverError":                                                                                          // 220
            var serverError = {};                                                                                      // 221
            rpcResponse.serverError = serverError;                                                                     // 222
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 223
            resolve(rpcResponse);                                                                                      // 224
            break;                                                                                                     // 225
          default:                                                                                                     // 226
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 227
            reject(err);                                                                                               // 228
            break;                                                                                                     // 229
        }                                                                                                              // 166
      });                                                                                                              // 231
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 233
        reject(e);                                                                                                     // 234
      });                                                                                                              // 235
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 237
        req.abort();                                                                                                   // 238
        err = new Error("Request timed out.");                                                                         // 239
        err.kjType = "overloaded";                                                                                     // 240
        reject(err);                                                                                                   // 241
      });                                                                                                              // 242
                                                                                                                       //
      if (content) {                                                                                                   // 244
        req.end(content);                                                                                              // 245
      } else {                                                                                                         // 246
        req.end();                                                                                                     // 247
      }                                                                                                                // 248
    });                                                                                                                // 249
  };                                                                                                                   // 250
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 86
}();                                                                                                                   // 86
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","bignum","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Future = Npm.require("fibers/future");                                                                             // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 24
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 26
  function ByteStreamConnection(connection) {                                                                          // 27
    _classCallCheck(this, ByteStreamConnection);                                                                       // 27
                                                                                                                       //
    this.connection = connection;                                                                                      // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ByteStreamConnection.prototype.done = function done() {                                                              // 26
    this.connection.end();                                                                                             // 32
  };                                                                                                                   // 33
                                                                                                                       //
  ByteStreamConnection.prototype.write = function write(data) {                                                        // 26
    this.connection.write(data);                                                                                       // 36
  };                                                                                                                   // 37
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 26
}();                                                                                                                   // 26
                                                                                                                       //
var IpInterfaceImpl = function (_PersistentImpl) {                                                                     //
  _inherits(IpInterfaceImpl, _PersistentImpl);                                                                         //
                                                                                                                       //
  function IpInterfaceImpl(db, saveTemplate) {                                                                         // 44
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 44
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                             // 44
  }                                                                                                                    // 46
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function listenTcp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 49
      var resolved = false;                                                                                            // 50
      var server = Net.createServer(function (connection) {                                                            // 51
        var wrappedConnection = new ByteStreamConnection(connection);                                                  // 52
        var upstream = port.connect(wrappedConnection).upstream;                                                       // 53
                                                                                                                       //
        connection.on("data", function (data) {                                                                        // 55
          upstream.write(data);                                                                                        // 56
        });                                                                                                            // 57
                                                                                                                       //
        connection.on("close", function (hadError) {                                                                   // 59
          upstream.done();                                                                                             // 60
        });                                                                                                            // 61
                                                                                                                       //
        connection.on("error", function (err) {                                                                        // 63
          if (resolved) {                                                                                              // 64
            connection.write = errorWrite;                                                                             // 65
          } else {                                                                                                     // 66
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 68
          }                                                                                                            // 69
        });                                                                                                            // 70
      });                                                                                                              // 71
                                                                                                                       //
      server.listen(portNum, function () {                                                                             // 73
        resolved = true;                                                                                               // 74
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 75
      });                                                                                                              // 76
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 78
        if (!resolved) {                                                                                               // 79
          reject(err);                                                                                                 // 80
        }                                                                                                              // 81
      });                                                                                                              // 82
    });                                                                                                                // 83
  };                                                                                                                   // 84
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function listenUdp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 87
      var portMap = {};                                                                                                // 88
      var resolved = false;                                                                                            // 89
      var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                               // 90
      server.bind(portNum);                                                                                            // 91
                                                                                                                       //
      server.on("listening", function () {                                                                             // 93
        // Although UDP is connectionless, we don't resolve until here so that we can handle bind                      //
        // errors such as invalid host                                                                                 //
        resolved = true;                                                                                               // 96
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 97
      });                                                                                                              // 98
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 100
        // TODO(someday): do something about errors after the promise is resolved                                      //
        if (!resolved) {                                                                                               // 102
          reject(err);                                                                                                 // 103
        } else {                                                                                                       // 104
          console.error("error in listenUdp: " + err);                                                                 // 105
        }                                                                                                              // 106
      });                                                                                                              // 107
                                                                                                                       //
      var returnMap = {};                                                                                              // 109
      server.on("message", function (msg, rinfo) {                                                                     // 110
        var address = rinfo.address + "]:" + rinfo.port;                                                               // 111
        var returnPort = returnMap[address];                                                                           // 112
                                                                                                                       //
        if (!returnPort) {                                                                                             // 114
          returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                   // 115
        }                                                                                                              // 116
                                                                                                                       //
        port.send(msg, returnPort);                                                                                    // 118
      });                                                                                                              // 119
    });                                                                                                                // 120
  };                                                                                                                   // 121
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 122
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 126
  globalFrontendRefRegistry.register({                                                                                 // 127
    frontendRefField: "ipInterface",                                                                                   // 128
    typeId: IpRpc.IpInterface.typeId,                                                                                  // 129
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 131
      return new Capnp.Capability(new IpInterfaceImpl(db, saveTemplate), IpRpc.PersistentIpInterface);                 // 132
    },                                                                                                                 // 134
    validate: function validate(db, session, value) {                                                                  // 136
      check(value, true);                                                                                              // 137
                                                                                                                       //
      if (!session.userId) {                                                                                           // 139
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 140
      }                                                                                                                // 141
                                                                                                                       //
      return {                                                                                                         // 143
        descriptor: { tags: [{ id: IpRpc.IpInterface.typeId }] },                                                      // 144
        requirements: [{ userIsAdmin: session.userId }],                                                               // 145
        frontendRef: value                                                                                             // 146
      };                                                                                                               // 143
    },                                                                                                                 // 148
    query: function query(db, userId, value) {                                                                         // 150
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 151
        return [{                                                                                                      // 152
          _id: "frontendref-ipinterface",                                                                              // 154
          frontendRef: { ipInterface: true },                                                                          // 155
          cardTemplate: "ipInterfacePowerboxCard"                                                                      // 156
        }];                                                                                                            // 153
      } else {                                                                                                         // 159
        return [];                                                                                                     // 160
      }                                                                                                                // 161
    }                                                                                                                  // 162
  });                                                                                                                  // 127
});                                                                                                                    // 164
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 166
  function BoundUdpPortImpl(server, address, port) {                                                                   // 167
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 167
                                                                                                                       //
    this.server = server;                                                                                              // 168
    this.address = address;                                                                                            // 169
    this.port = port;                                                                                                  // 170
  }                                                                                                                    // 171
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function send(message, returnPort) {                                               // 166
    // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                           //
    // capabilities or build a map with them. What we should be doing is mapping all ports to                          //
    // their raw physical address/port, and using that here                                                            //
    this.server.send(message, 0, message.length, this.port, this.address);                                             // 177
  };                                                                                                                   // 178
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 166
}();                                                                                                                   // 166
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 181
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 182
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 184
  var part1 = num & 255;                                                                                               // 185
  var part2 = num >> 8 & 255;                                                                                          // 186
  var part3 = num >> 16 & 255;                                                                                         // 187
  var part4 = num >> 24 & 255;                                                                                         // 188
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 190
};                                                                                                                     // 191
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 193
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 194
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 196
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 198
    return intToIpv4(ipv4num);                                                                                         // 199
  }                                                                                                                    // 200
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 202
  var numColons = 0;                                                                                                   // 203
  var out = "";                                                                                                        // 204
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 206
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 209
    if ((i + 1) % 4 === 0) {                                                                                           // 210
      out += ":";                                                                                                      // 211
      ++numColons;                                                                                                     // 212
    }                                                                                                                  // 213
  }                                                                                                                    // 214
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 217
    out += "::";                                                                                                       // 218
  }                                                                                                                    // 219
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 221
};                                                                                                                     // 222
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 224
  var type = "udp4";                                                                                                   // 225
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 229
    type = "udp6";                                                                                                     // 230
  }                                                                                                                    // 231
                                                                                                                       //
  return type;                                                                                                         // 233
};                                                                                                                     // 234
                                                                                                                       //
var IpNetworkImpl = function (_PersistentImpl2) {                                                                      //
  _inherits(IpNetworkImpl, _PersistentImpl2);                                                                          //
                                                                                                                       //
  function IpNetworkImpl(db, saveTemplate) {                                                                           // 237
    _classCallCheck(this, IpNetworkImpl);                                                                              // 237
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 237
  }                                                                                                                    // 239
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function getRemoteHost(address) {                                            //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 242
  };                                                                                                                   // 243
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function getRemoteHostByName(address) {                                //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 246
  };                                                                                                                   // 247
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 248
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 252
  globalFrontendRefRegistry.register({                                                                                 // 253
    frontendRefField: "ipNetwork",                                                                                     // 254
    typeId: IpRpc.IpNetwork.typeId,                                                                                    // 255
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 257
      return new Capnp.Capability(new IpNetworkImpl(db, saveTemplate), IpRpc.PersistentIpNetwork);                     // 258
    },                                                                                                                 // 260
    validate: function validate(db, session, value) {                                                                  // 262
      check(value, true);                                                                                              // 263
                                                                                                                       //
      if (!session.userId) {                                                                                           // 265
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 266
      }                                                                                                                // 267
                                                                                                                       //
      return {                                                                                                         // 269
        descriptor: { tags: [{ id: IpRpc.IpNetwork.typeId }] },                                                        // 270
        requirements: [{ userIsAdmin: session.userId }],                                                               // 271
        frontendRef: value                                                                                             // 272
      };                                                                                                               // 269
    },                                                                                                                 // 274
    query: function query(db, userId, value) {                                                                         // 276
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 277
        return [{                                                                                                      // 278
          _id: "frontendref-ipnetwork",                                                                                // 280
          frontendRef: { ipNetwork: true },                                                                            // 281
          cardTemplate: "ipNetworkPowerboxCard"                                                                        // 282
        }];                                                                                                            // 279
      } else {                                                                                                         // 285
        return [];                                                                                                     // 286
      }                                                                                                                // 287
    }                                                                                                                  // 288
  });                                                                                                                  // 253
});                                                                                                                    // 290
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 292
  function IpRemoteHostImpl(address) {                                                                                 // 293
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 293
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 294
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 296
    } else {                                                                                                           // 297
      this.address = address;                                                                                          // 298
    }                                                                                                                  // 299
  }                                                                                                                    // 300
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function getTcpPort(portNum) {                                               // 292
    return { port: new TcpPortImpl(this.address, portNum) };                                                           // 303
  };                                                                                                                   // 304
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function getUdpPort(portNum) {                                               // 292
    return { port: new UdpPortImpl(this.address, portNum) };                                                           // 307
  };                                                                                                                   // 308
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             // 292
}();                                                                                                                   // 292
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 311
  function TcpPortImpl(address, portNum) {                                                                             // 312
    _classCallCheck(this, TcpPortImpl);                                                                                // 312
                                                                                                                       //
    this.address = address;                                                                                            // 313
    this.port = portNum;                                                                                               // 314
  }                                                                                                                    // 315
                                                                                                                       //
  TcpPortImpl.prototype.connect = function connect(downstream) {                                                       // 311
    var _this = this;                                                                                                  // 318
    var resolved = false;                                                                                              // 319
    return new Promise(function (resolve, reject) {                                                                    // 320
      var client = Net.connect({ host: _this.address, port: _this.port }, function () {                                // 321
        resolved = true;                                                                                               // 322
        resolve({ upstream: new ByteStreamConnection(client) });                                                       // 323
      });                                                                                                              // 324
                                                                                                                       //
      client.on("data", function (data) {                                                                              // 326
        downstream.write(data);                                                                                        // 327
      });                                                                                                              // 328
                                                                                                                       //
      client.on("close", function (hadError) {                                                                         // 330
        downstream.done();                                                                                             // 331
      });                                                                                                              // 332
                                                                                                                       //
      client.on("error", function (err) {                                                                              // 334
        if (resolved) {                                                                                                // 335
          client.write = errorWrite;                                                                                   // 336
        } else {                                                                                                       // 337
          // upstream hasn't been resolved yet, so it's safe to reject                                                 //
          reject(err);                                                                                                 // 339
        }                                                                                                              // 340
      });                                                                                                              // 341
    });                                                                                                                // 342
  };                                                                                                                   // 343
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 311
}();                                                                                                                   // 311
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 346
  throw new Error("error occurred in connection");                                                                     // 347
};                                                                                                                     // 348
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 350
  function UdpPortImpl(address, portNum) {                                                                             // 351
    _classCallCheck(this, UdpPortImpl);                                                                                // 351
                                                                                                                       //
    this.address = address;                                                                                            // 352
    this.port = portNum;                                                                                               // 353
                                                                                                                       //
    var type = addressType(address);                                                                                   // 355
    this.socket = Dgram.createSocket(type);                                                                            // 356
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 364
                                                                                                                       //
    var _this = this;                                                                                                  // 366
    this.socket.on("message", function (msg, rinfo) {                                                                  // 367
      if (_this.returnPort) {                                                                                          // 368
        _this.returnPort.send(msg, _this);                                                                             // 369
      }                                                                                                                // 370
    });                                                                                                                // 371
  }                                                                                                                    // 372
                                                                                                                       //
  UdpPortImpl.prototype.send = function send(message, returnPort) {                                                    // 350
    this.returnPort = returnPort;                                                                                      // 375
    this.socket.send(message, 0, message.length, this.port, this.address);                                             // 376
                                                                                                                       //
    // TODO(someday): use callback to catch errors and do something with them                                          //
  };                                                                                                                   // 379
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 350
}();                                                                                                                   // 350
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","smtp-server","mailparser","/imports/server/persistent.js","/imports/server/email.js","/imports/server/backend.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var SMTPServer;module.import("smtp-server",{"SMTPServer":function(v){SMTPServer=v}});var MailParser;module.import("mailparser",{"MailParser":function(v){MailParser=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var rawSend;module.import("/imports/server/email.js",{"rawSend":function(v){rawSend=v}});var shouldRestartGrain;module.import("/imports/server/backend.js",{"shouldRestartGrain":function(v){shouldRestartGrain=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
                                                                                                                       //
                                                                                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 25
var Future = Npm.require("fibers/future");                                                                             // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 29
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 30
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 31
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 32
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 37
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 38
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 40
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 42
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 48
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 49
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 53
}                                                                                                                      // 54
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 56
  var server = new SMTPServer({                                                                                        // 57
    banner: "Sandstorm Mail Server",                                                                                   // 58
    authOptional: true,                                                                                                // 59
    disabledCommands: ["STARTTLS", "AUTH"],                                                                            // 60
    onData: function onData(req, session, callback) {                                                                  // 61
      var mailparser = new MailParser();                                                                               // 62
      req.pipe(mailparser);                                                                                            // 63
                                                                                                                       //
      mailparser.on("end", function (mail) {                                                                           // 65
        // Wrap in outer promise for easier error handling.                                                            //
        Promise.resolve().then(function () {                                                                           // 67
          // Extract the 'from' address.                                                                               //
          var from = void 0;                                                                                           // 69
          if (mail.from && mail.from.length > 0) {                                                                     // 70
            // It's theoretically possible for the message to have multiple 'from' headers, but this                   //
            // never really happens in legitimate practice so we'll just take the first one.                           //
            from = mail.from[0];                                                                                       // 73
          } else {                                                                                                     // 74
            // The mail body is missing a 'From:' header. We'll use the bounce address instead,                        //
            // with the caveat that this is sometimes *not* the original sender                                        //
            // but rather some intermediate agent (e.g. a mailing list daemon). See:                                   //
            //   http://en.wikipedia.org/wiki/Bounce_address                                                           //
            // TODO(someday): Is this really right, or should we report a blank address instead?                       //
            from = { address: session.envelope.mailFrom, name: false };                                                // 80
          }                                                                                                            // 81
                                                                                                                       //
          var attachments = [];                                                                                        // 83
          if (mail.attachments) {                                                                                      // 84
            attachments = mail.attachments.map(function (attachment) {                                                 // 85
              var disposition = attachment.contentDisposition || "attachment";                                         // 86
              disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';          // 87
              return {                                                                                                 // 88
                contentType: attachment.contentType,                                                                   // 89
                contentDisposition: disposition,                                                                       // 90
                contentId: attachment.contentId,                                                                       // 91
                content: attachment.content                                                                            // 92
              };                                                                                                       // 88
            });                                                                                                        // 94
          }                                                                                                            // 95
                                                                                                                       //
          if (mail.replyTo && mail.replyTo.length > 1) {                                                               // 97
            console.error("More than one reply-to address address was received in an email.");                         // 98
          }                                                                                                            // 99
                                                                                                                       //
          var mailMessage = {                                                                                          // 101
            // Note that converting the date to nanoseconds actually goes outside the range of                         //
            // integers that Javascript can represent precisely. But this is OK because dates aren't                   //
            // precise anyway.                                                                                         //
            date: (mail.date || new Date()).getTime() * 1000000,                                                       // 105
            from: from,                                                                                                // 106
            to: mail.to,                                                                                               // 107
            cc: mail.cc || [],                                                                                         // 108
            bcc: mail.bcc || [],                                                                                       // 109
            replyTo: mail.replyTo && mail.replyTo[0] || {},                                                            // 110
            messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                   // 111
            references: mail.references || [],                                                                         // 112
            inReplyTo: mail.inReplyTo || [],                                                                           // 113
            subject: mail.subject || "",                                                                               // 114
            text: mail.text || null,                                                                                   // 115
            html: mail.html || null,                                                                                   // 116
            attachments: attachments                                                                                   // 117
          };                                                                                                           // 101
                                                                                                                       //
          // Get list of grain IDs.                                                                                    //
          var grainPublicIds = _.uniq(session.envelope.rcptTo.map(function (deliverTo) {                               // 121
            // smtp-server already validates that the address contains an @.                                           //
            // To simplify things, we ignore the hostname part of the address and assume that the                      //
            // message would not have been sent here if it weren't intended for our host. Usually                      //
            // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                        //
            // globally unique anyway, so an e-mail meant for another server presumably won't match                    //
            // any ID at this one anyway.                                                                              //
            var address = deliverTo.address;                                                                           // 121
                                                                                                                       //
            return address.slice(0, address.indexOf("@"));                                                             // 129
          }));                                                                                                         // 130
                                                                                                                       //
          // Deliver to each grain in parallel.                                                                        //
          return Promise.all(grainPublicIds.map(function (publicId) {                                                  // 133
            // Wrap in a function so that we can call it recursively to retry.                                         //
            var tryDeliver = function tryDeliver(retryCount) {                                                         // 135
              var grainId = void 0;                                                                                    // 136
              return inMeteor(function () {                                                                            // 137
                var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                    // 138
                if (grain) {                                                                                           // 139
                  grainId = grain._id;                                                                                 // 140
                  return globalBackend.continueGrain(grainId, retryCount > 0);                                         // 141
                } else {                                                                                               // 142
                  // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                //
                  // fails in this case, by adding an onRcptTo() callback.                                             //
                  throw new Error("No such grain: " + publicId);                                                       // 145
                }                                                                                                      // 146
              }).then(function (grainInfo) {                                                                           // 147
                var supervisor = grainInfo.supervisor;                                                                 // 148
                var uiView = supervisor.getMainView().view;                                                            // 149
                                                                                                                       //
                // Create an arbitrary struct to use as the session params. E-mail sessions actually                   //
                // require no params, but node-capnp won't let us pass null and we don't have an                       //
                // EmptyStruct type available, so we just use EmailAddress, but any struct type would                  //
                // work.                                                                                               //
                // TODO(cleanup): Fix node-capnp to accept null.                                                       //
                var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                          // 156
                                                                                                                       //
                // Create a new session of type HackEmailSession. This is a short-term hack until                      //
                // persistent capabilities and the Powerbox are implemented. We need to pass along a                   //
                // HackSessionContext because old versions of sandstorm-http-bridge always use                         //
                // the context of the most recent session; if an old RoundCube grain has a                             //
                // WebSession open, receives an email, and then tries to send an email, the request                    //
                // will go out on the SessionContext associated with the HackEmailSession that                         //
                // delivered the email.                                                                                //
                var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
                return session.send(mailMessage);                                                                      // 169
              })["catch"](function (err) {                                                                             // 170
                if (shouldRestartGrain(err, retryCount)) {                                                             // 171
                  return tryDeliver(retryCount + 1);                                                                   // 172
                } else {                                                                                               // 173
                  throw err;                                                                                           // 174
                }                                                                                                      // 175
              });                                                                                                      // 176
            };                                                                                                         // 177
                                                                                                                       //
            return tryDeliver(0);                                                                                      // 179
          }));                                                                                                         // 180
        }).then(function () {                                                                                          // 181
          callback(null, "Message delivered");                                                                         // 182
        }, function (err) {                                                                                            // 183
          console.error("E-mail delivery failure:", err.stack);                                                        // 184
          var mailErr = new Error(err.message);                                                                        // 185
          err.responseCode = 451;                                                                                      // 186
          callback(err.message);                                                                                       // 187
        });                                                                                                            // 188
      });                                                                                                              // 189
    }                                                                                                                  // 190
  });                                                                                                                  // 57
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 193
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 194
  } else {                                                                                                             // 195
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 197
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 198
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 199
  }                                                                                                                    // 200
});                                                                                                                    // 201
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 203
  return inMeteor(function () {                                                                                        // 204
    var recipientCount = 0;                                                                                            // 205
    recipientCount += email.to ? email.to.length : 0;                                                                  // 206
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 207
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 208
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 209
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 214
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 216
    var userAddress = session._getUserAddress();                                                                       // 217
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 220
      email.from = {                                                                                                   // 221
        address: grainAddress                                                                                          // 222
      };                                                                                                               // 221
    }                                                                                                                  // 224
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 226
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 230
                                                                                                                       //
    // Unpack fields                                                                                                   //
    var from = email.from;                                                                                             // 204
    var to = email.to;                                                                                                 // 204
    var cc = email.cc;                                                                                                 // 204
    var bcc = email.bcc;                                                                                               // 204
    var replyTo = email.replyTo;                                                                                       // 204
    var subject = email.subject;                                                                                       // 204
    var text = email.text;                                                                                             // 204
    var html = email.html;                                                                                             // 204
                                                                                                                       //
                                                                                                                       //
    var options = {                                                                                                    // 235
      from: from,                                                                                                      // 236
      to: to,                                                                                                          // 237
      cc: cc,                                                                                                          // 238
      bcc: bcc,                                                                                                        // 239
      replyTo: replyTo,                                                                                                // 240
      subject: subject,                                                                                                // 241
      text: text,                                                                                                      // 242
      html: html,                                                                                                      // 243
      envelope: {                                                                                                      // 244
        from: grainAddress,                                                                                            // 245
        to: to,                                                                                                        // 246
        cc: cc,                                                                                                        // 247
        bcc: bcc                                                                                                       // 248
      }                                                                                                                // 244
    };                                                                                                                 // 235
                                                                                                                       //
    var headers = {};                                                                                                  // 252
    if (email.messageId) {                                                                                             // 253
      headers["message-id"] = email.messageId;                                                                         // 254
    }                                                                                                                  // 255
                                                                                                                       //
    if (email.references) {                                                                                            // 257
      headers["references"] = email.references; // jscs:ignore requireDotNotation                                      // 258
    }                                                                                                                  // 259
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 261
      headers["in-reply-to"] = email.inReplyTo;                                                                        // 262
    }                                                                                                                  // 263
                                                                                                                       //
    if (email.date) {                                                                                                  // 265
      var date = new Date(email.date / 1000000);                                                                       // 266
      if (!isNaN(date.getTime())) {                                                                                    // 267
        // Check to make sure date is valid                                                                            //
        headers["date"] = date.toUTCString(); // jscs:ignore requireDotNotation                                        // 268
      }                                                                                                                // 269
    }                                                                                                                  // 270
                                                                                                                       //
    options.headers = headers;                                                                                         // 272
                                                                                                                       //
    if (email.attachments) {                                                                                           // 274
      (function () {                                                                                                   // 274
        var attachments = [];                                                                                          // 275
        email.attachments.forEach(function (attachment) {                                                              // 276
          attachments.push({                                                                                           // 277
            filename: false, // Tell nodemailer not to generate a new filename.                                        // 278
            cid: attachment.contentId,                                                                                 // 279
            contentType: attachment.contentType,                                                                       // 280
            contentDisposition: attachment.contentDisposition,                                                         // 281
            content: attachment.content                                                                                // 282
          });                                                                                                          // 277
        });                                                                                                            // 284
        options.attachments = attachments;                                                                             // 285
      })();                                                                                                            // 274
    }                                                                                                                  // 286
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 288
    if (!grain) throw new Error("Grain does not exist.");                                                              // 289
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 290
                                                                                                                       //
    rawSend(options);                                                                                                  // 292
  }.bind(_this))["catch"](function (err) {                                                                             // 293
    console.error("Error sending e-mail:", err.stack);                                                                 // 294
    throw err;                                                                                                         // 295
  });                                                                                                                  // 296
};                                                                                                                     // 297
                                                                                                                       //
var EmailVerifierImpl = function (_PersistentImpl) {                                                                   //
  _inherits(EmailVerifierImpl, _PersistentImpl);                                                                       //
                                                                                                                       //
  function EmailVerifierImpl(db, saveTemplate, params) {                                                               // 300
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 300
                                                                                                                       //
    var _this2 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 300
                                                                                                                       //
    _this2._id = params.id;                                                                                            // 302
    _this2._services = params.services;                                                                                // 303
    return _this2;                                                                                                     // 300
  }                                                                                                                    // 304
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function getId() {                                                               //
    return { id: new Buffer(this._id, "base64") };                                                                     // 307
  };                                                                                                                   // 308
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function verifyEmail(tabId, verification) {                                //
    var _this3 = this;                                                                                                 // 310
                                                                                                                       //
    return unwrapFrontendCap(verification, "verifiedEmail", function (verification) {                                  // 311
      if (verification.tabId !== tabId.toString("hex")) {                                                              // 312
        throw new Error("VerifiedEmail is from a different tab");                                                      // 313
      }                                                                                                                // 314
                                                                                                                       //
      if (_this3._services) {                                                                                          // 316
        // Since this verifier is restricted to specific services, only indicate a match if the                        //
        // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                           //
        // match all services, and therefore all VerifiedEmails.)                                                      //
        if (verification.verifierId !== _this3._id) {                                                                  // 320
          throw new Error("VerifierEmail is for a different EmailVerifier.");                                          // 321
        }                                                                                                              // 322
      }                                                                                                                // 323
                                                                                                                       //
      return verification.address;                                                                                     // 325
    });                                                                                                                // 326
  };                                                                                                                   // 327
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 328
                                                                                                                       //
var VerifiedEmailImpl = function (_PersistentImpl2) {                                                                  //
  _inherits(VerifiedEmailImpl, _PersistentImpl2);                                                                      //
                                                                                                                       //
  function VerifiedEmailImpl(db, saveTemplate) {                                                                       // 331
    _classCallCheck(this, VerifiedEmailImpl);                                                                          // 331
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 331
  }                                                                                                                    // 333
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
function getVerifiedEmails(db, userId, verifierId) {                                                                   // 336
  // Get all of the email addresses verified as belonging to the given user using the given                            //
  // verifier.                                                                                                         //
                                                                                                                       //
  var services = null;                                                                                                 // 340
  var couldAddAnother = true;                                                                                          // 341
                                                                                                                       //
  if (verifierId) {                                                                                                    // 343
    var verifier = db.collections.apiTokens.findOne({ "frontendRef.emailVerifier.id": verifierId });                   // 344
    if (!verifier) return []; // invalid verifier                                                                      // 346
    var verifierInfo = verifier.frontendRef.emailVerifier;                                                             // 347
                                                                                                                       //
    if (verifierInfo.services) {                                                                                       // 349
      // Limit to the listed services.                                                                                 //
      services = {};                                                                                                   // 351
      verifierInfo.services.forEach(function (service) {                                                               // 352
        return services[service] = true;                                                                               // 352
      });                                                                                                              // 352
      couldAddAnother = !!services.email;                                                                              // 353
    }                                                                                                                  // 354
  }                                                                                                                    // 355
                                                                                                                       //
  var user = Meteor.users.findOne(userId);                                                                             // 357
  var emails = {}; // map address -> true, for uniquification                                                          // 358
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {              // 359
    if (!services || services[identity.profile.service]) {                                                             // 360
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                               // 361
        emails[email.email] = true;                                                                                    // 361
      });                                                                                                              // 361
    }                                                                                                                  // 362
  });                                                                                                                  // 363
                                                                                                                       //
  return { emails: Object.keys(emails), couldAddAnother: couldAddAnother };                                            // 365
}                                                                                                                      // 366
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 370
  globalFrontendRefRegistry.register({                                                                                 // 371
    frontendRefField: "emailVerifier",                                                                                 // 372
    typeId: EmailRpc.EmailVerifier.typeId,                                                                             // 373
                                                                                                                       //
    restore: function restore(db, saveTemplate, params) {                                                              // 375
      return new Capnp.Capability(new EmailVerifierImpl(db, saveTemplate, params), EmailImpl.PersistentEmailVerifier);
    },                                                                                                                 // 378
    validate: function validate(db, session, value) {                                                                  // 380
      check(value, { services: Match.Optional([String]) });                                                            // 381
                                                                                                                       //
      var services = value.services;                                                                                   // 383
      if (services) {                                                                                                  // 384
        services.forEach(function (service) {                                                                          // 385
          if (!Accounts.identityServices[service]) {                                                                   // 386
            throw new Error("No such identity service: " + service);                                                   // 387
          }                                                                                                            // 388
        });                                                                                                            // 389
      }                                                                                                                // 390
                                                                                                                       //
      value.id = Crypto.randomBytes(16).toString("base64");                                                            // 392
                                                                                                                       //
      return {                                                                                                         // 394
        descriptor: { tags: [{ id: EmailRpc.EmailVerifier.typeId }] },                                                 // 395
        requirements: [],                                                                                              // 396
        frontendRef: value                                                                                             // 397
      };                                                                                                               // 394
    },                                                                                                                 // 399
    query: function query(db, userId, value) {                                                                         // 401
      var results = [];                                                                                                // 402
                                                                                                                       //
      results.push({                                                                                                   // 404
        _id: "emailverifier-all",                                                                                      // 405
        frontendRef: { emailVerifier: {} },                                                                            // 406
        cardTemplate: "emailVerifierPowerboxCard"                                                                      // 407
      });                                                                                                              // 404
                                                                                                                       //
      for (var name in Accounts.identityServices) {                                                                    // 410
        if (Accounts.identityServices[name].isEnabled()) {                                                             // 411
          results.push({                                                                                               // 412
            _id: "emailverifier-" + name,                                                                              // 413
            frontendRef: { emailVerifier: { services: [name] } },                                                      // 414
            cardTemplate: "emailVerifierPowerboxCard"                                                                  // 415
          });                                                                                                          // 412
        }                                                                                                              // 417
      };                                                                                                               // 418
                                                                                                                       //
      return results;                                                                                                  // 420
    }                                                                                                                  // 421
  });                                                                                                                  // 371
                                                                                                                       //
  globalFrontendRefRegistry.register({                                                                                 // 424
    frontendRefField: "verifiedEmail",                                                                                 // 425
    typeId: EmailRpc.VerifiedEmail.typeId,                                                                             // 426
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 428
      return new Capnp.Capability(new VerifiedEmailImpl(db, saveTemplate), EmailImpl.PersistentVerifiedEmail);         // 429
    },                                                                                                                 // 431
    validate: function validate(db, session, value) {                                                                  // 433
      check(value, { verifierId: Match.Optional(String), address: String });                                           // 434
                                                                                                                       //
      if (!session.userId) {                                                                                           // 436
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 437
      }                                                                                                                // 438
                                                                                                                       //
      // Verify that the address actually belongs to the user.                                                         //
                                                                                                                       //
      if (!_.contains(getVerifiedEmails(db, session.userId, value.verifierId).emails, value.address)) {                // 442
        throw new Meteor.Error(403, "User has no such verified address");                                              // 444
      }                                                                                                                // 445
                                                                                                                       //
      // Add the session's tabId.                                                                                      //
      value.tabId = session.tabId;                                                                                     // 448
                                                                                                                       //
      // Build the descriptor, which contains the verifier ID.                                                         //
      var tagValue = value.verifierId && Capnp.serialize(EmailRpc.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(value.verifierId, "hex") });
                                                                                                                       //
      return {                                                                                                         // 455
        descriptor: { tags: [{ id: EmailRpc.VerifiedEmail.typeId, value: tagValue }] },                                // 456
        requirements: [],                                                                                              // 457
        frontendRef: value                                                                                             // 458
      };                                                                                                               // 455
    },                                                                                                                 // 460
    query: function query(db, userId, value) {                                                                         // 462
      var verifierId = value && Capnp.parse(EmailRpc.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");  // 463
      var verified = getVerifiedEmails(db, userId, verifierId);                                                        // 465
      var result = verified.emails.map(function (address) {                                                            // 466
        return {                                                                                                       // 466
          _id: "email-" + address,                                                                                     // 467
          frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } },                                // 468
          cardTemplate: "verifiedEmailPowerboxCard",                                                                   // 469
          searchTerms: [address]                                                                                       // 470
        };                                                                                                             // 466
      });                                                                                                              // 466
                                                                                                                       //
      if (verified.couldAddAnother) {                                                                                  // 473
        result.push({                                                                                                  // 474
          _id: "email-add-a-new-one",                                                                                  // 475
          frontendRef: { verifiedEmail: { verifierId: verifierId } },                                                  // 476
          cardTemplate: "addNewVerifiedEmailPowerboxCard",                                                             // 477
          configureTemplate: "addNewVerifiedEmailPowerboxConfiguration"                                                // 478
        });                                                                                                            // 474
      }                                                                                                                // 480
                                                                                                                       //
      return result;                                                                                                   // 482
    }                                                                                                                  // 483
  });                                                                                                                  // 424
});                                                                                                                    // 485
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"00-startup.js":["/imports/db-deprecated.js","/imports/server/frontend-ref.js","/imports/server/persistent.js","/imports/server/migrations.js","/imports/constants.js","/imports/server/async-helpers.js","fibers","url","capnp",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/00-startup.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.import("/imports/db-deprecated.js");var FrontendRefRegistry;module.import("/imports/server/frontend-ref.js",{"FrontendRefRegistry":function(v){FrontendRefRegistry=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var migrateToLatest;module.import("/imports/server/migrations.js",{"migrateToLatest":function(v){migrateToLatest=v}});var ACCOUNT_DELETION_SUSPENSION_TIME;module.import("/imports/constants.js",{"ACCOUNT_DELETION_SUSPENSION_TIME":function(v){ACCOUNT_DELETION_SUSPENSION_TIME=v}});var onInMeteor;module.import("/imports/server/async-helpers.js",{"onInMeteor":function(v){onInMeteor=v}});var Fiber;module.import("fibers",{"default":function(v){Fiber=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
var url = require("url");                                                                                              // 23
var Capnp = require("capnp");                                                                                          // 24
                                                                                                                       //
globalFrontendRefRegistry = new FrontendRefRegistry();                                                                 // 26
                                                                                                                       //
SandstormPowerbox.registerUiViewQueryHandler(globalFrontendRefRegistry);                                               // 28
                                                                                                                       //
if (global.BlackrockPayments && BlackrockPayments.registerPaymentsApi) {                                               // 30
  // TODO(cleanup): Meteor.startup() needed because unwrapFrontendCap is not defined yet when this                     //
  //   first runs. Move it into an import.                                                                             //
  Meteor.startup(function () {                                                                                         // 33
    BlackrockPayments.registerPaymentsApi(globalFrontendRefRegistry, PersistentImpl, unwrapFrontendCap);               // 34
  });                                                                                                                  // 36
}                                                                                                                      // 37
                                                                                                                       //
getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                         // 39
                                                                                                                       //
Meteor.onConnection(function (connection) {                                                                            // 41
  // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                           //
  //   packages to actually use the DB, but it's pretty sad.                                                           //
  connection.sandstormDb = globalDb;                                                                                   // 44
  connection.frontendRefRegistry = globalFrontendRefRegistry;                                                          // 45
});                                                                                                                    // 46
SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                     // 47
SandstormDb.periodicCleanup(10 * 60 * 1000, SandstormPermissions.cleanupClientPowerboxTokens(globalDb));               // 48
SandstormDb.periodicCleanup(60 * 60 * 1000, function () {                                                              // 50
  globalDb.cleanupExpiredAssetUploads();                                                                               // 51
});                                                                                                                    // 52
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 53
  SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                    // 54
});                                                                                                                    // 55
var deleteAccount = global.BlackrockPayments && global.BlackrockPayments.deleteAccount;                                // 56
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 57
  globalDb.deletePendingAccounts(ACCOUNT_DELETION_SUSPENSION_TIME, globalBackend, deleteAccount);                      // 58
});                                                                                                                    // 60
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 62
  migrateToLatest(globalDb, globalBackend);                                                                            // 62
});                                                                                                                    // 62
                                                                                                                       //
// If there are multiple replicas, prefix every log message with our replica number.                                   //
if ("replicaNumber" in Meteor.settings) {                                                                              // 65
  (function () {                                                                                                       // 65
    var patchConsole = function patchConsole(name) {                                                                   // 65
      var old = console[name];                                                                                         // 69
      console[name] = function () {                                                                                    // 70
        // Meteor in dev mode writes "LISTENING" to tell the dev runner that it's ready to accept                      //
        // connections.                                                                                                //
        if (arguments.length == 1 && arguments[0] == "LISTENING") {                                                    // 73
          old.apply(this, arguments);                                                                                  // 74
        } else {                                                                                                       // 75
          old.apply(this, [prefix].concat(Array.prototype.slice.call(arguments)));                                     // 76
        }                                                                                                              // 77
      };                                                                                                               // 78
    };                                                                                                                 // 79
                                                                                                                       //
    var prefix = "replica" + Meteor.settings.replicaNumber.toString() + ":";                                           // 66
                                                                                                                       //
    patchConsole("log");                                                                                               // 81
    patchConsole("info");                                                                                              // 82
    patchConsole("warn");                                                                                              // 83
    patchConsole("error");                                                                                             // 84
  })();                                                                                                                // 65
}                                                                                                                      // 85
                                                                                                                       //
// Make the fiber pool size infinite(ish)!                                                                             //
//                                                                                                                     //
// Each fiber created adds an entry to `v8::Isolate::ThreadDataTable`. Unfortunatley, items are                        //
// never deleted from this table. So if we create and delete a lot of fibers, then we leak memory.                     //
// Worse yet, the table is represented as a linked list, and v8 performs a linear scan of this                         //
// linked list every time we switch fibers. We've seen cases where Sandstorm was spending 65% of                       //
// its CPU time just scanning this list! The v8 people say this is "working as intended".                              //
//                                                                                                                     //
// The fibers package has implemented a work-around by maintaining a fiber pool. Fibers are not                        //
// deleted; they are returned to the pool. Unfortunately the pool has a default size of 120. So                        //
// if we pass 120 simultaneous fibers, we start leaking and slowing down. It's very easy to hit                        //
// this number with a few dozen users present.                                                                         //
//                                                                                                                     //
// Up until it hits the limit, the fibers module will grow the pool dynamically, starting with an                      //
// empty pool and adding each new fiber to it. Therefore, if we set the pool size to an impossibly                     //
// large number, we effectively get a pool size equal to the maximum number of simultaneous fibers                     //
// seen. This is exactly what we want! Now no fibers are ever deleted, so we never leak. A                             //
// Sandstorm server that sees a brief surge of traffic may end up holding on to unused RAM                             //
// long-term, but this is a relatively obscure problem.                                                                //
//                                                                                                                     //
// I initially tried to use the value `Infinity` here, but somehow when this made its way down into                    //
// the C++ code and was converted to an integer, that integer ended up being zero. So instead we                       //
// use 1e9 (1 billion), which ought to be enough for anyone.                                                           //
//                                                                                                                     //
// Third-party issues, for reference:                                                                                  //
//                                                                                                                     //
//    https://bugs.chromium.org/p/v8/issues/detail?id=5338                                                             //
//    https://bugs.chromium.org/p/v8/issues/detail?id=3777                                                             //
//    https://github.com/laverdet/node-fibers/issues/305                                                               //
                                                                                                                       // 116
Fiber.poolSize = 1e9;                                                                                                  // 117
                                                                                                                       //
// Special debugging enabled on Blackrock only.                                                                        //
if ("replicaNumber" in Meteor.settings) {                                                                              // 120
  (function () {                                                                                                       // 120
    var sampleStackIfTooManyFibers = function sampleStackIfTooManyFibers() {                                           // 120
      if (Fiber.fibersCreated > TOO_MANY_FIBERS && sampleCounter++ % FIBER_SAMPLING_PERIOD == 0) {                     // 145
        var stack = new Error().stack;                                                                                 // 146
        console.warn("There are too many fibers!", stack);                                                             // 147
      }                                                                                                                // 148
    };                                                                                                                 // 149
                                                                                                                       //
    // Sample calls to inMeteor().                                                                                     //
                                                                                                                       //
                                                                                                                       //
    // Also take samples from various Meteor infrastructure that schedules fibers.                                     //
                                                                                                                       //
    var addFiberSampling = function addFiberSampling(prototype, functionName) {                                        // 120
      var old = prototype[functionName];                                                                               // 156
      prototype[functionName] = function () {                                                                          // 157
        sampleStackIfTooManyFibers();                                                                                  // 158
        return old.apply(this, arguments);                                                                             // 159
      };                                                                                                               // 160
    };                                                                                                                 // 161
                                                                                                                       //
    console.warn("Fiber bomb defense enabled.");                                                                       // 121
                                                                                                                       //
    // TEMPORARY: Monitor the number of fibers created and kill the process any time it goes over                      //
    //   2000. Unfortunately, due to the aforementioned linked list in ThreadDataTable, the process                    //
    //   will become unreasonably slow once the list gets this big. It's better to kill the process                    //
    //   so that it restarts fresh rather than to let the Sandstorm server become unresponsive.                        //
    // TODO(soon): Remove this when the bug is fixed.                                                                  //
    setInterval(function () {                                                                                          // 128
      if (Fiber.fibersCreated > 2000) {                                                                                // 129
        console.error("Process has allocated more than 2000 concurrent fibers. Due to " + "https://bugs.chromium.org/p/v8/issues/detail?id=5338 it will become extremely slow " + "unless we restart it. ABORTING");
        process.abort();                                                                                               // 134
      }                                                                                                                // 135
    }, 5000);                                                                                                          // 136
                                                                                                                       //
    // Let's also log some stack traces when fiber count gets high so we can find out what's                           //
    // happening.                                                                                                      //
    var TOO_MANY_FIBERS = 1000; // Start sampling when we have more than this many fibers.                             // 140
    var FIBER_SAMPLING_PERIOD = 100; // Sample one stack per this many fibers created.                                 // 141
                                                                                                                       //
    var sampleCounter = 0;                                                                                             // 143
    onInMeteor(sampleStackIfTooManyFibers);                                                                            // 152
                                                                                                                       //
    addFiberSampling(Meteor._SynchronousQueue.prototype, "runTask");                                                   // 163
    addFiberSampling(Meteor._SynchronousQueue.prototype, "queueTask");                                                 // 164
    addFiberSampling(Meteor, "bindEnvironment");                                                                       // 165
  })();                                                                                                                // 120
}                                                                                                                      // 166
                                                                                                                       //
if ("replicaNumber" in Meteor.settings) {                                                                              // 168
  // On Blackrock, dump debug info about local capability counts every minute.                                         //
  Meteor.setInterval(Capnp.dumpLocalCapTypeCounts, 60000);                                                             // 170
}                                                                                                                      // 171
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 173
  Meteor.startup(function () {                                                                                         // 174
    // Defined in feature-key.js.                                                                                      //
    keepFeatureKeyRenewed(globalDb);                                                                                   // 176
  });                                                                                                                  // 177
}                                                                                                                      // 178
                                                                                                                       //
OAuth._checkRedirectUrlOrigin = function (redirectUrl) {                                                               // 180
  // Mostly copied from meteor/packages/oauth/oauth_server.js                                                          //
  // We override this method in order to support login from stand-alone grain domains.                                 //
  var appHost = Meteor.absoluteUrl();                                                                                  // 183
  var appHostReplacedLocalhost = Meteor.absoluteUrl(undefined, {                                                       // 184
    replaceLocalhost: true                                                                                             // 185
  });                                                                                                                  // 184
                                                                                                                       //
  var redirectParsed = url.parse(redirectUrl);                                                                         // 188
                                                                                                                       //
  return !(redirectUrl.substr(0, appHost.length) === appHost || redirectUrl.substr(0, appHostReplacedLocalhost.length) === appHostReplacedLocalhost || globalDb.hostIsStandalone(redirectParsed.hostname));
};                                                                                                                     // 195
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"account-suspension.js":["/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/account-suspension.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var send;module.import("/imports/server/email.js",{"send":function(v){send=v}});// Sandstorm - Personal Cloud Sandbox  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
function sendDeletionEmails(db, deletedUserId, byAdminUserId, feedback) {                                              // 19
  var deletedUser = db.getUser(deletedUserId);                                                                         // 20
                                                                                                                       //
  var userEmail = _.findWhere(SandstormDb.getUserEmails(deletedUser), { primary: true });                              // 22
  if (!byAdminUserId) {                                                                                                // 23
    // This was initiated by the user, send them an email                                                              //
    if (!userEmail) {                                                                                                  // 24
      console.error("Couldn't send deletion email. No address found for user with userId:", deletedUser._id);          // 25
    } else {                                                                                                           // 27
      var _emailOptions = {                                                                                            // 28
        from: db.getReturnAddress(),                                                                                   // 29
        subject: "Your account on " + db.getServerTitle() + " will be deleted in 7 days.",                             // 30
        text: "You have requested that your Sandstorm account on " + db.getServerTitle() + " be deleted. Your account has been suspended and will be fully deleted in seven days. If you change your mind, log into " + process.env.ROOT_URL + " to cancel the process.\n\nIf you did not request this deletion, please contact the server administrator immediately."
      };                                                                                                               // 28
      try {                                                                                                            // 35
        _emailOptions.to = userEmail.email;                                                                            // 36
        send(_emailOptions);                                                                                           // 37
      } catch (err) {                                                                                                  // 38
        console.error("Failed to send deletion email to user (id=" + deletedUser._id + ") with error: " + err);        // 39
      }                                                                                                                // 41
    }                                                                                                                  // 42
  }                                                                                                                    // 43
                                                                                                                       //
  var deleteUserString = userEmail && userEmail.email || "userId=" + deletedUser._id;                                  // 45
  var emailOptions = {                                                                                                 // 46
    from: db.getReturnAddress(),                                                                                       // 47
    subject: "Account for " + deleteUserString + " on " + db.getServerTitle() + " will be deleted in 7 days"           // 48
  };                                                                                                                   // 46
                                                                                                                       //
  if (byAdminUserId) {                                                                                                 // 51
    var initiatingAdmin = db.getUser(byAdminUserId);                                                                   // 52
    var adminName = db.getIdentity(initiatingAdmin.loginIdentities[0].id).profile.name;                                // 53
    emailOptions.text = adminName + " has requested that the Sandstorm account held by " + deleteUserString + " on " + db.getServerTitle() + " be deleted. The account has been suspended and will be fully deleted in seven days. To cancel the deletion, go to: " + process.env.ROOT_URL + "/admin/users/" + deletedUser._id;
  } else {                                                                                                             // 55
    emailOptions.text = deleteUserString + " has requested that their account be deleted on " + db.getServerTitle() + ". The account has been suspended and will be fully deleted in seven days. To cancel the deletion, go to: " + process.env.ROOT_URL + "/admin/users/" + deletedUser._id;
    if (feedback) {                                                                                                    // 57
      emailOptions.text += "\nUser gave the following feedback: " + feedback;                                          // 58
    }                                                                                                                  // 59
  }                                                                                                                    // 60
                                                                                                                       //
  Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                                       // 62
    var email = _.findWhere(SandstormDb.getUserEmails(user), { primary: true });                                       // 63
    if (!email) {                                                                                                      // 64
      console.error("No email found for admin with userId:", user._id);                                                // 65
      return;                                                                                                          // 66
    }                                                                                                                  // 67
                                                                                                                       //
    try {                                                                                                              // 69
      emailOptions.to = email.email;                                                                                   // 70
      send(emailOptions);                                                                                              // 71
    } catch (err) {                                                                                                    // 72
      console.error("Failed to send deletion email to admin (id=" + user._id + ") with error: " + err);                // 73
    }                                                                                                                  // 75
  });                                                                                                                  // 76
}                                                                                                                      // 77
                                                                                                                       //
Meteor.methods({                                                                                                       // 79
  suspendAccount: function suspendAccount(userId, willDelete) {                                                        // 80
    check(userId, String);                                                                                             // 81
    check(willDelete, Boolean);                                                                                        // 82
                                                                                                                       //
    if (!isAdmin()) {                                                                                                  // 84
      throw new Meteor.Error(403, "Only admins can suspend other users.");                                             // 85
    }                                                                                                                  // 86
                                                                                                                       //
    if (userId === Meteor.userId()) {                                                                                  // 88
      throw new Meteor.Error(400, "Admins cannot suspend their own accounts from the admin page. Please go to your account setttings.");
    }                                                                                                                  // 90
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 92
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 94
      BlackrockPayments.suspendAccount(db, userId);                                                                    // 95
    }                                                                                                                  // 96
                                                                                                                       //
    db.suspendAccount(userId, Meteor.userId(), willDelete);                                                            // 98
                                                                                                                       //
    if (willDelete) {                                                                                                  // 100
      sendDeletionEmails(db, userId, Meteor.userId());                                                                 // 101
    }                                                                                                                  // 102
  },                                                                                                                   // 103
  deleteOwnAccount: function deleteOwnAccount(feedback) {                                                              // 105
    var db = this.connection.sandstormDb;                                                                              // 106
    if (!Meteor.userId()) {                                                                                            // 107
      throw new Meteor.Error(403, "Must be logged in to delete an account");                                           // 108
    }                                                                                                                  // 109
                                                                                                                       //
    if (db.isUserInOrganization(Meteor.user())) {                                                                      // 111
      throw new Meteor.Error(403, "Users in an organization cannot delete their own account. " + "Please ask your admin to do it for you.");
    }                                                                                                                  // 114
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 116
      BlackrockPayments.suspendAccount(db, Meteor.userId());                                                           // 117
    }                                                                                                                  // 118
                                                                                                                       //
    db.suspendAccount(Meteor.userId(), null, true);                                                                    // 120
                                                                                                                       //
    sendDeletionEmails(db, Meteor.userId(), null, feedback);                                                           // 122
  },                                                                                                                   // 123
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 125
    check(userId, String);                                                                                             // 126
                                                                                                                       //
    if (!isAdmin()) {                                                                                                  // 128
      throw new Meteor.Error(403, "Only admins can unsuspend other users.");                                           // 129
    }                                                                                                                  // 130
                                                                                                                       //
    this.connection.sandstormDb.unsuspendAccount(userId, Meteor.userId());                                             // 132
  },                                                                                                                   // 133
  unsuspendOwnAccount: function unsuspendOwnAccount() {                                                                // 135
    if (!Meteor.userId()) {                                                                                            // 136
      throw new Meteor.Error(403, "Must be logged in to unsuspend an account");                                        // 137
    }                                                                                                                  // 138
                                                                                                                       //
    this.connection.sandstormDb.unsuspendAccount(Meteor.userId());                                                     // 140
  }                                                                                                                    // 141
});                                                                                                                    // 79
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","heapdump","/imports/server/constants.js","/imports/server/auth.js","/imports/server/email.js","/imports/server/observe-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});var fillUndefinedForChangedDoc;module.import("/imports/server/observe-helpers.js",{"fillUndefinedForChangedDoc":function(v){fillUndefinedForChangedDoc=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings", "whitelabelCustomLoginProviderName", "whitelabelCustomLogoAssetId", "whitelabelHideSendFeedback", "whitelabelHideTroubleshooting", "whiteLabelHideAbout", "whitelabelUseServerTitleForHomeText", "quotaEnabled", "quotaLdapEnabled", "billingPromptUrl"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit", "secret", "renewalProblem"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 48
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 52
  hostname: String,                                                                                                    // 53
  port: Number,                                                                                                        // 54
  auth: {                                                                                                              // 55
    user: String,                                                                                                      // 56
    pass: String                                                                                                       // 57
  },                                                                                                                   // 55
  returnAddress: String                                                                                                // 59
};                                                                                                                     // 52
                                                                                                                       //
Meteor.methods({                                                                                                       // 62
  setAccountSetting: function setAccountSetting(token, serviceName, value) {                                           // 63
    checkAuth(token);                                                                                                  // 64
    check(serviceName, String);                                                                                        // 65
    check(value, Boolean);                                                                                             // 66
                                                                                                                       //
    // TODO(someday): currently this relies on the fact that an account is tied to a single                            //
    // identity, and thus has only that entry in "services". This will need to be looked at when                       //
    // multiple login methods/identities are allowed for a single account.                                             //
    if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {      // 71
      throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                    // 72
    }                                                                                                                  // 74
                                                                                                                       //
    // Only check configurations for OAuth services.                                                                   //
    var oauthServices = ["google", "github"];                                                                          // 77
    if (value && oauthServices.indexOf(serviceName) != -1) {                                                           // 78
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 79
      var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                              // 80
      if (!config) {                                                                                                   // 81
        throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 84
                                                                                                                       //
      if (!config.clientId || !config.secret) {                                                                        // 86
        throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 89
    }                                                                                                                  // 90
                                                                                                                       //
    Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                                 // 92
    if (value) {                                                                                                       // 93
      Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                    // 94
    }                                                                                                                  // 95
  },                                                                                                                   // 96
                                                                                                                       //
  setSmtpConfig: function setSmtpConfig(token, config) {                                                               // 98
    checkAuth(token);                                                                                                  // 99
    check(config, smtpConfigShape);                                                                                    // 100
                                                                                                                       //
    Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                               // 102
  },                                                                                                                   // 103
                                                                                                                       //
  disableEmail: function disableEmail(token) {                                                                         // 105
    checkAuth(token);                                                                                                  // 106
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 108
    db.collections.settings.update({ _id: "smtpConfig" }, { $set: { "value.hostname": "" } });                         // 109
  },                                                                                                                   // 110
                                                                                                                       //
  setSetting: function setSetting(token, name, value) {                                                                // 112
    checkAuth(token);                                                                                                  // 113
    check(name, String);                                                                                               // 114
    check(value, Match.OneOf(null, String, Date, Boolean));                                                            // 115
                                                                                                                       //
    Settings.upsert({ _id: name }, { $set: { value: value } });                                                        // 117
  },                                                                                                                   // 118
                                                                                                                       //
  submitFeatureKey: function submitFeatureKey(token, textBlock) {                                                      // 120
    checkAuth(token);                                                                                                  // 121
    check(textBlock, Match.OneOf(null, String));                                                                       // 122
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 124
                                                                                                                       //
    // setNewFeatureKey is provided in feature-key.js                                                                  //
    setNewFeatureKey(db, textBlock);                                                                                   // 127
  },                                                                                                                   // 128
                                                                                                                       //
  renewFeatureKey: function (_renewFeatureKey) {                                                                       // 130
    function renewFeatureKey(_x) {                                                                                     // 130
      return _renewFeatureKey.apply(this, arguments);                                                                  // 130
    }                                                                                                                  // 130
                                                                                                                       //
    renewFeatureKey.toString = function () {                                                                           // 130
      return _renewFeatureKey.toString();                                                                              // 130
    };                                                                                                                 // 130
                                                                                                                       //
    return renewFeatureKey;                                                                                            // 130
  }(function (token) {                                                                                                 // 130
    checkAuth(token);                                                                                                  // 131
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 133
                                                                                                                       //
    // renewFeatureKey is provided in feature-key.js.                                                                  //
    renewFeatureKey(db, { interactive: true });                                                                        // 136
  }),                                                                                                                  // 137
                                                                                                                       //
  saveOrganizationSettings: function saveOrganizationSettings(token, params) {                                         // 139
    checkAuth(token);                                                                                                  // 140
    check(params, {                                                                                                    // 141
      membership: {                                                                                                    // 142
        emailToken: {                                                                                                  // 143
          enabled: Boolean,                                                                                            // 144
          domain: String                                                                                               // 145
        },                                                                                                             // 143
        google: {                                                                                                      // 147
          enabled: Boolean,                                                                                            // 148
          domain: String                                                                                               // 149
        },                                                                                                             // 147
        ldap: {                                                                                                        // 151
          enabled: Boolean                                                                                             // 152
        },                                                                                                             // 151
        saml: {                                                                                                        // 154
          enabled: Boolean                                                                                             // 155
        }                                                                                                              // 154
      },                                                                                                               // 142
      settings: {                                                                                                      // 158
        disallowGuests: Boolean,                                                                                       // 159
        shareContacts: Boolean                                                                                         // 160
      }                                                                                                                // 158
    });                                                                                                                // 141
                                                                                                                       //
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
  },                                                                                                                   // 166
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function adminConfigureLoginService(token, options) {                                    // 168
    checkAuth(token);                                                                                                  // 169
    check(options, Match.ObjectIncluding({ service: String }));                                                        // 170
                                                                                                                       //
    var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                  // 172
                                                                                                                       //
    ServiceConfiguration.configurations.upsert({ service: options.service }, options);                                 // 174
  },                                                                                                                   // 175
                                                                                                                       //
  clearResumeTokensForService: function clearResumeTokensForService(token, serviceName) {                              // 177
    checkAuth(token);                                                                                                  // 178
    check(serviceName, String);                                                                                        // 179
                                                                                                                       //
    var query = {};                                                                                                    // 181
    query["services." + serviceName] = { $exists: true };                                                              // 182
    Meteor.users.find(query).forEach(function (identity) {                                                             // 183
      if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
        Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                   // 186
      }                                                                                                                // 187
                                                                                                                       //
      Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });    // 189
    });                                                                                                                // 191
  },                                                                                                                   // 192
                                                                                                                       //
  adminUpdateUser: function adminUpdateUser(token, userInfo) {                                                         // 194
    checkAuth(token);                                                                                                  // 195
    check(userInfo, {                                                                                                  // 196
      userId: String,                                                                                                  // 197
      signupKey: Boolean,                                                                                              // 198
      isAdmin: Boolean                                                                                                 // 199
    });                                                                                                                // 196
                                                                                                                       //
    var userId = userInfo.userId;                                                                                      // 202
    if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                             // 203
      throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                                // 204
    }                                                                                                                  // 205
                                                                                                                       //
    Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                               // 207
  },                                                                                                                   // 208
                                                                                                                       //
  testSend: function testSend(token, smtpConfig, to) {                                                                 // 210
    checkAuth(token);                                                                                                  // 211
    check(smtpConfig, smtpConfigShape);                                                                                // 212
    check(to, String);                                                                                                 // 213
    var returnAddress = smtpConfig.returnAddress;                                                                      // 210
                                                                                                                       //
    var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                          // 210
                                                                                                                       //
    try {                                                                                                              // 216
      sendEmail({                                                                                                      // 217
        to: to,                                                                                                        // 218
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 219
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 220
        text: "Success! Your outgoing SMTP is working.",                                                               // 221
        smtpConfig: restConfig                                                                                         // 222
      });                                                                                                              // 217
    } catch (e) {                                                                                                      // 224
      // Attempt to give more accurate error messages for a variety of known failure modes,                            //
      // and the actual exception data in the event a user hits a new failure mode.                                    //
      if (e.syscall === "getaddrinfo") {                                                                               // 227
        if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                              // 228
          throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
        }                                                                                                              // 230
      } else if (e.syscall === "connect") {                                                                            // 231
        if (e.code === "ECONNREFUSED") {                                                                               // 232
          throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
        }                                                                                                              // 234
      } else if (e.name === "AuthError") {                                                                             // 235
        throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
      }                                                                                                                // 238
                                                                                                                       //
      throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
    }                                                                                                                  // 241
  },                                                                                                                   // 242
                                                                                                                       //
  createSignupKey: function createSignupKey(token, note, quota) {                                                      // 244
    checkAuth(token);                                                                                                  // 245
    check(note, String);                                                                                               // 246
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 247
                                                                                                                       //
    var key = Random.id();                                                                                             // 249
    var content = { _id: key, used: false, note: note };                                                               // 250
    if (typeof quota === "number") content.quota = quota;                                                              // 251
    SignupKeys.insert(content);                                                                                        // 252
    return key;                                                                                                        // 253
  },                                                                                                                   // 254
                                                                                                                       //
  sendInvites: function sendInvites(token, origin, from, list, subject, message, quota) {                              // 256
    checkAuth(token);                                                                                                  // 257
    check([origin, from, list, subject, message], [String]);                                                           // 258
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 259
                                                                                                                       //
    if (!from.trim()) {                                                                                                // 261
      throw new Meteor.Error(403, "Must enter 'from' address.");                                                       // 262
    }                                                                                                                  // 263
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 265
      throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                       // 266
    }                                                                                                                  // 267
                                                                                                                       //
    this.unblock();                                                                                                    // 269
                                                                                                                       //
    list = list.split("\n");                                                                                           // 271
    for (var i in list) {                                                                                              // 272
      var email = list[i].trim();                                                                                      // 273
                                                                                                                       //
      if (email) {                                                                                                     // 275
        var key = Random.id();                                                                                         // 276
                                                                                                                       //
        var content = {                                                                                                // 278
          _id: key,                                                                                                    // 279
          used: false,                                                                                                 // 280
          note: "E-mail invite to " + email,                                                                           // 281
          email: email,                                                                                                // 282
          definitelySent: false                                                                                        // 283
        };                                                                                                             // 278
        if (typeof quota === "number") content.quota = quota;                                                          // 285
        SignupKeys.insert(content);                                                                                    // 286
        sendEmail({                                                                                                    // 287
          to: email,                                                                                                   // 288
          from: from,                                                                                                  // 289
          envelopeFrom: globalDb.getReturnAddress(),                                                                   // 290
          subject: subject,                                                                                            // 291
          text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                   // 292
        });                                                                                                            // 287
        SignupKeys.update(key, { $set: { definitelySent: true } });                                                    // 294
      }                                                                                                                // 295
    }                                                                                                                  // 296
                                                                                                                       //
    return { sent: true };                                                                                             // 298
  },                                                                                                                   // 299
                                                                                                                       //
  adminToggleDisableCap: function adminToggleDisableCap(token, capId, value) {                                         // 301
    checkAuth(token);                                                                                                  // 302
    check(capId, String);                                                                                              // 303
    check(value, Boolean);                                                                                             // 304
                                                                                                                       //
    if (value) {                                                                                                       // 306
      ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                   // 307
    } else {                                                                                                           // 308
      ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                  // 309
    }                                                                                                                  // 310
  },                                                                                                                   // 311
                                                                                                                       //
  updateQuotas: function updateQuotas(token, list, quota) {                                                            // 313
    checkAuth(token);                                                                                                  // 314
    check(list, String);                                                                                               // 315
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 316
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 318
      throw new Meteor.Error(400, "Must enter addresses.");                                                            // 319
    }                                                                                                                  // 320
                                                                                                                       //
    var items = list.split("\n");                                                                                      // 322
    var invalid = [];                                                                                                  // 323
    for (var i in items) {                                                                                             // 324
      var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };               // 325
      var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                       // 327
      n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                  // 328
                                                                                                                       //
      if (n < 1) invalid.push(items[i]);                                                                               // 330
    }                                                                                                                  // 331
                                                                                                                       //
    if (invalid.length > 0) {                                                                                          // 333
      throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));        // 334
    }                                                                                                                  // 336
  },                                                                                                                   // 337
                                                                                                                       //
  dismissAdminStatsNotifications: function dismissAdminStatsNotifications(token) {                                     // 339
    checkAuth(token);                                                                                                  // 340
    globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                        // 341
  },                                                                                                                   // 342
                                                                                                                       //
  signUpAsAdmin: function signUpAsAdmin(token) {                                                                       // 344
    check(token, String);                                                                                              // 345
    checkAuth(token);                                                                                                  // 346
    if (!this.userId) {                                                                                                // 347
      throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                           // 348
    }                                                                                                                  // 349
                                                                                                                       //
    if (!Meteor.user().loginIdentities) {                                                                              // 351
      throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                              // 352
    }                                                                                                                  // 353
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                        // 355
    clearAdminToken(token);                                                                                            // 356
  },                                                                                                                   // 357
                                                                                                                       //
  redeemSetupToken: function redeemSetupToken(token) {                                                                 // 359
    // Redeem an admin token into a setup session.                                                                     //
    check(token, String);                                                                                              // 361
    if (tokenIsValid(token)) {                                                                                         // 362
      var sessId = Random.secret();                                                                                    // 363
      var creationDate = new Date();                                                                                   // 364
      var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                               // 365
      this.connection.sandstormDb.collections.setupSession.upsert({                                                    // 366
        _id: "current-session"                                                                                         // 367
      }, {                                                                                                             // 366
        creationDate: creationDate,                                                                                    // 369
        hashedSessionId: hashedSessionId                                                                               // 370
      });                                                                                                              // 368
      // Then, invalidate the token, so one one else can use it.                                                       //
      clearAdminToken(token);                                                                                          // 373
      return sessId;                                                                                                   // 374
    } else {                                                                                                           // 375
      throw new Meteor.Error(401, "Invalid setup token");                                                              // 376
    }                                                                                                                  // 377
  },                                                                                                                   // 378
  heapdump: function heapdump() {                                                                                      // 380
    // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                                 //
    //                                                                                                                 //
    // Call this from the JS console like:                                                                             //
    //   Meteor.call("heapdump");                                                                                      //
                                                                                                                       //
    checkAuth();                                                                                                       // 386
                                                                                                                       //
    // We use /var/log because it's a location in the container to which the front-end is allowed                      //
    // to write.                                                                                                       //
    var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                             // 390
    Heapdump.writeSnapshot(name);                                                                                      // 391
    console.log("Wrote heapdump: /opt/sandstorm" + name);                                                              // 392
    return name;                                                                                                       // 393
  },                                                                                                                   // 394
                                                                                                                       //
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 396
    checkAuth();                                                                                                       // 397
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 398
                                                                                                                       //
    this.connection.sandstormDb.setPreinstalledApps(appAndPackageIds);                                                 // 400
  }                                                                                                                    // 401
});                                                                                                                    // 62
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 404
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 407
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 409
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 410
  return Settings.find();                                                                                              // 411
});                                                                                                                    // 412
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 414
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 415
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 416
});                                                                                                                    // 417
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 419
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 420
});                                                                                                                    // 421
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 423
  check(token, String);                                                                                                // 424
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 425
  this.ready();                                                                                                        // 426
});                                                                                                                    // 427
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 429
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 430
  return Meteor.users.find();                                                                                          // 431
});                                                                                                                    // 432
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 434
  var _this2 = this;                                                                                                   // 434
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 435
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 439
  var accountId = userId;                                                                                              // 440
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 442
    if (!identitySubs[identityId]) {                                                                                   // 443
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 446
      return;                                                                                                          // 447
    }                                                                                                                  // 448
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 450
    delete identitySubs[identityId];                                                                                   // 451
    observeHandle.stop();                                                                                              // 452
    _this2.removed("users", identityId);                                                                               // 453
  };                                                                                                                   // 454
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 456
    if (identitySubs[identityId]) {                                                                                    // 457
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 460
      return;                                                                                                          // 461
    }                                                                                                                  // 462
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 464
    var observeHandle = cursor.observe({                                                                               // 465
      added: function added(doc) {                                                                                     // 466
        _this2.added("users", doc._id, doc);                                                                           // 467
      },                                                                                                               // 468
                                                                                                                       //
      changed: function changed(newDoc, oldDoc) {                                                                      // 470
        fillUndefinedForChangedDoc(newDoc, oldDoc);                                                                    // 471
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 472
      },                                                                                                               // 473
                                                                                                                       //
      removed: function removed(oldDoc) {                                                                              // 475
        _this2.removed("users", oldDoc._id);                                                                           // 476
      }                                                                                                                // 477
    });                                                                                                                // 465
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 480
  };                                                                                                                   // 481
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 483
  var accountSubHandle = accountCursor.observe({                                                                       // 484
    added: function added(newDoc) {                                                                                    // 485
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 486
      newIdentities.forEach(function (identityId) {                                                                    // 487
        refIdentity(identityId);                                                                                       // 488
      });                                                                                                              // 489
                                                                                                                       //
      _this2.added("users", newDoc._id, newDoc);                                                                       // 491
    },                                                                                                                 // 492
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 494
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 495
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 496
                                                                                                                       //
      // Those in newDoc - oldDoc, ref.                                                                                //
      var identitiesAdded = _.difference(newIdentities, oldIdentities);                                                // 499
      identitiesAdded.forEach(function (identityId) {                                                                  // 500
        refIdentity(identityId);                                                                                       // 501
      });                                                                                                              // 502
                                                                                                                       //
      // Those in oldDoc - newDoc, unref.                                                                              //
      var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                              // 505
      identitiesRemoved.forEach(function (identityId) {                                                                // 506
        unrefIdentity(identityId);                                                                                     // 507
      });                                                                                                              // 508
                                                                                                                       //
      fillUndefinedForChangedDoc(newDoc, oldDoc);                                                                      // 510
                                                                                                                       //
      _this2.changed("users", newDoc._id, newDoc);                                                                     // 512
    },                                                                                                                 // 513
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 515
      _this2.removed("users", oldDoc._id);                                                                             // 516
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 517
      oldIdentities.forEach(function (identityId) {                                                                    // 518
        unrefIdentity(identityId);                                                                                     // 519
      });                                                                                                              // 520
    }                                                                                                                  // 521
  });                                                                                                                  // 484
                                                                                                                       //
  this.onStop(function () {                                                                                            // 524
    accountSubHandle.stop();                                                                                           // 525
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 527
    subs.forEach(function (sub) {                                                                                      // 528
      sub.stop();                                                                                                      // 529
    });                                                                                                                // 530
  });                                                                                                                  // 531
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 535
});                                                                                                                    // 536
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 538
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 539
  return ActivityStats.find();                                                                                         // 540
});                                                                                                                    // 541
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 543
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 544
  return StatsTokens.find();                                                                                           // 545
});                                                                                                                    // 546
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 548
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 549
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 550
      "manifest.actions": 1, "manifest.appTitle": 1, progress: 1, status: 1 } });                                      // 552
});                                                                                                                    // 553
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 555
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 556
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 559
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 562
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 563
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 564
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 568
});                                                                                                                    // 569
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 571
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 572
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 574
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 576
  var startSize = Fs.fstatSync(fd).size;                                                                               // 577
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 580
                                                                                                                       //
  var _this = this;                                                                                                    // 582
  function doTail() {                                                                                                  // 583
    for (;;) {                                                                                                         // 584
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 585
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 586
      if (n <= 0) break;                                                                                               // 587
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 588
      offset += n;                                                                                                     // 589
    }                                                                                                                  // 590
  }                                                                                                                    // 591
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 594
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 597
    watcher.close();                                                                                                   // 598
    Fs.closeSync(fd);                                                                                                  // 599
  });                                                                                                                  // 600
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 603
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 606
});                                                                                                                    // 607
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 609
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 610
  return ApiTokens.find({                                                                                              // 611
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 612
  }, {                                                                                                                 // 611
    fields: {                                                                                                          // 617
      frontendRef: 1,                                                                                                  // 618
      created: 1,                                                                                                      // 619
      requirements: 1,                                                                                                 // 620
      revoked: 1,                                                                                                      // 621
      owner: 1                                                                                                         // 622
    }                                                                                                                  // 617
  });                                                                                                                  // 616
});                                                                                                                    // 625
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 627
  var _this3 = this;                                                                                                   // 627
                                                                                                                       //
  // Note: we publish the *raw* feature key data to the client, exactly as it was loaded from the                      //
  // signed blob.  Any mapping from the raw data to "effective" feature key/limits should be applied                   //
  // in the implementation of db.currentFeatureKey().                                                                  //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 631
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 633
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 636
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 637
  var observeHandle = featureKeyQuery.observe({                                                                        // 638
    added: function added(doc) {                                                                                       // 639
      // Load and verify the signed feature key.                                                                       //
      var buf = new Buffer(doc.value);                                                                                 // 641
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 642
      if (doc.renewalProblem) {                                                                                        // 643
        featureKey.renewalProblem = doc.renewalProblem;                                                                // 644
      }                                                                                                                // 645
                                                                                                                       //
      if (featureKey) {                                                                                                // 647
        var _ref;                                                                                                      // 647
                                                                                                                       //
        // If the signature is valid, publish the feature key information.                                             //
        var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                             // 649
        _this3.added("featureKey", doc._id, filteredFeatureKey);                                                       // 650
      }                                                                                                                // 651
    },                                                                                                                 // 652
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 654
      // Load and reverify the new signed feature key.                                                                 //
      var buf = new Buffer(newDoc.value);                                                                              // 656
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 657
      if (newDoc.renewalProblem) {                                                                                     // 658
        featureKey.renewalProblem = newDoc.renewalProblem;                                                             // 659
      } else if (oldDoc.renewalProblem) {                                                                              // 660
        featureKey.renewalProblem = undefined;                                                                         // 661
      }                                                                                                                // 662
                                                                                                                       //
      if (featureKey) {                                                                                                // 664
        var _ref2;                                                                                                     // 664
                                                                                                                       //
        // If the signature is valid, call this.changed() with the interesting fields.                                 //
        var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                           // 666
        _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                  // 667
      } else {                                                                                                         // 668
        // Otherwise, call this.removed(), since the new feature key is invalid.                                       //
        _this3.removed("featureKey", oldDoc._id);                                                                      // 670
      }                                                                                                                // 671
    },                                                                                                                 // 672
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 674
      _this3.removed("featureKey", oldDoc._id);                                                                        // 675
    }                                                                                                                  // 676
  });                                                                                                                  // 638
                                                                                                                       //
  this.onStop(function () {                                                                                            // 679
    observeHandle.stop();                                                                                              // 680
  });                                                                                                                  // 681
                                                                                                                       //
  this.ready();                                                                                                        // 683
});                                                                                                                    // 684
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 686
  var _this4 = this;                                                                                                   // 686
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 688
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 691
  if (cursor.count() > 0) {                                                                                            // 692
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 693
  } else {                                                                                                             // 694
    (function () {                                                                                                     // 694
      var handle = cursor.observeChanges({                                                                             // 695
        added: function added(id) {                                                                                    // 696
          _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                    // 697
          handle.stop();                                                                                               // 698
          handle = null;                                                                                               // 699
        }                                                                                                              // 700
      });                                                                                                              // 695
      _this4.onStop(function () {                                                                                      // 702
        if (handle) handle.stop();                                                                                     // 703
      });                                                                                                              // 704
    })();                                                                                                              // 694
  }                                                                                                                    // 705
                                                                                                                       //
  this.ready();                                                                                                        // 707
});                                                                                                                    // 708
                                                                                                                       //
Meteor.publish("appIndexAdmin", function (token) {                                                                     // 710
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 711
  return globalDb.collections.appIndex.find();                                                                         // 712
});                                                                                                                    // 713
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 715
  Settings.find({ _id: name, value: true }).observe({                                                                  // 716
    added: function added() {                                                                                          // 717
      // Tell the oauth library it should accept login attempts from this service.                                     //
      Accounts.oauth.registerService(name);                                                                            // 719
    },                                                                                                                 // 720
                                                                                                                       //
    removed: function removed() {                                                                                      // 722
      // Tell the oauth library it should deny login attempts from this service.                                       //
      Accounts.oauth.unregisterService(name);                                                                          // 724
    }                                                                                                                  // 725
  });                                                                                                                  // 716
}                                                                                                                      // 727
                                                                                                                       //
observeOauthService("github");                                                                                         // 729
observeOauthService("google");                                                                                         // 730
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":["babel-runtime/helpers/typeof","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Capnp = Npm.require("capnp");                                                                                      // 21
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 23
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 120; // Give enough time for large uploads on slow connections.                            // 25
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 26
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 28
  check(tokenId, String);                                                                                              // 29
  FileTokens.remove({ _id: tokenId });                                                                                 // 30
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 31
}                                                                                                                      // 32
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 34
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 36
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 37
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 39
      cleanupToken(token._id);                                                                                         // 40
    });                                                                                                                // 41
  });                                                                                                                  // 42
});                                                                                                                    // 43
                                                                                                                       //
Meteor.methods({                                                                                                       // 45
  backupGrain: function backupGrain(grainId) {                                                                         // 46
    check(grainId, String);                                                                                            // 47
    var grain = Grains.findOne(grainId);                                                                               // 48
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 49
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 50
    }                                                                                                                  // 51
                                                                                                                       //
    this.unblock();                                                                                                    // 53
                                                                                                                       //
    var token = {                                                                                                      // 55
      _id: Random.id(),                                                                                                // 56
      timestamp: new Date(),                                                                                           // 57
      name: grain.title                                                                                                // 58
    };                                                                                                                 // 55
                                                                                                                       //
    // TODO(soon): does the grain need to be offline?                                                                  //
                                                                                                                       //
    var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                     // 63
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 65
    waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                          // 66
                                                                                                                       //
    return token._id;                                                                                                  // 68
  },                                                                                                                   // 69
  newRestoreToken: function newRestoreToken() {                                                                        // 71
    if (!isSignedUpOrDemo()) {                                                                                         // 72
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can restore backups.");                          // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 76
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 77
    }                                                                                                                  // 79
                                                                                                                       //
    var token = {                                                                                                      // 81
      _id: Random.id(),                                                                                                // 82
      timestamp: new Date()                                                                                            // 83
    };                                                                                                                 // 81
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 86
                                                                                                                       //
    return token._id;                                                                                                  // 88
  },                                                                                                                   // 89
  restoreGrain: function restoreGrain(tokenId, identityId) {                                                           // 91
    check(tokenId, String);                                                                                            // 92
    check(identityId, String);                                                                                         // 93
    var token = FileTokens.findOne(tokenId);                                                                           // 94
    if (!token || !isSignedUpOrDemo()) {                                                                               // 95
      throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");                // 96
    }                                                                                                                  // 98
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 100
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 101
    }                                                                                                                  // 103
                                                                                                                       //
    this.unblock();                                                                                                    // 105
                                                                                                                       //
    var grainId = Random.id(22);                                                                                       // 107
                                                                                                                       //
    try {                                                                                                              // 109
      var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
        console.error("Unzip failure:", err.message);                                                                  // 112
        throw new Meteor.Error(500, "Invalid backup file.");                                                           // 113
      })).info;                                                                                                        // 114
      if (!grainInfo.appId) {                                                                                          // 115
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 116
        throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                                // 117
      }                                                                                                                // 118
                                                                                                                       //
      var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                               // 120
                                                                                                                       //
      // Create variables we'll use for later Mongo query.                                                             //
      var packageId = void 0;                                                                                          // 123
      var appVersion = void 0;                                                                                         // 124
                                                                                                                       //
      // DevPackages are system-wide, so we do not check the user ID.                                                  //
      var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                                // 127
      if (devPackage) {                                                                                                // 128
        // If the dev app package exists, it should override the user action.                                          //
        packageId = devPackage.packageId;                                                                              // 130
        appVersion = devPackage.manifest.appVersion;                                                                   // 131
      } else if (action) {                                                                                             // 132
        // The app is installed, so we can continue restoring this                                                     //
        // grain.                                                                                                      //
        packageId = action.packageId;                                                                                  // 135
        appVersion = action.appVersion;                                                                                // 136
      } else {                                                                                                         // 137
        // If the package isn't installed at all, bail out.                                                            //
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 139
        throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);          // 140
      }                                                                                                                // 143
                                                                                                                       //
      if (appVersion < grainInfo.appVersion) {                                                                         // 145
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 146
        throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
      }                                                                                                                // 152
                                                                                                                       //
      Grains.insert({                                                                                                  // 154
        _id: grainId,                                                                                                  // 155
        packageId: packageId,                                                                                          // 156
        appId: grainInfo.appId,                                                                                        // 157
        appVersion: appVersion,                                                                                        // 158
        userId: this.userId,                                                                                           // 159
        identityId: identityId,                                                                                        // 160
        title: grainInfo.title,                                                                                        // 161
        "private": true,                                                                                               // 162
        size: 0                                                                                                        // 163
      });                                                                                                              // 154
    } finally {                                                                                                        // 165
      cleanupToken(tokenId);                                                                                           // 166
    }                                                                                                                  // 167
                                                                                                                       //
    return grainId;                                                                                                    // 169
  }                                                                                                                    // 170
});                                                                                                                    // 45
                                                                                                                       //
Router.map(function () {                                                                                               // 173
  this.route("downloadBackup", {                                                                                       // 174
    where: "server",                                                                                                   // 175
    path: "/downloadBackup/:tokenId",                                                                                  // 176
    action: function action() {                                                                                        // 177
      var token = FileTokens.findOne(this.params.tokenId);                                                             // 178
      var response = this.response;                                                                                    // 179
      if (!token) {                                                                                                    // 180
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 181
        return response.end("File does not exist");                                                                    // 182
      }                                                                                                                // 183
                                                                                                                       //
      var started = false;                                                                                             // 185
      var encodedFilename = encodeURIComponent(token.name || "backup") + ".zip";                                       // 186
      var sawEnd = false;                                                                                              // 187
                                                                                                                       //
      var stream = {                                                                                                   // 189
        expectSize: function expectSize(size) {                                                                        // 190
          if (!started) {                                                                                              // 191
            started = true;                                                                                            // 192
            response.writeHead(200, {                                                                                  // 193
              "Content-Length": size,                                                                                  // 194
              "Content-Type": "application/zip",                                                                       // 195
              "Content-Disposition": "attachment;filename*=utf-8''" + encodedFilename                                  // 196
            });                                                                                                        // 193
          }                                                                                                            // 198
        },                                                                                                             // 199
        write: function write(data) {                                                                                  // 201
          if (!started) {                                                                                              // 202
            started = true;                                                                                            // 203
            response.writeHead(200, {                                                                                  // 204
              "Content-Type": "application/zip",                                                                       // 205
              "Content-Disposition": "attachment;filename*=utf-8''" + encodedFilename                                  // 206
            });                                                                                                        // 204
          }                                                                                                            // 208
                                                                                                                       //
          response.write(data);                                                                                        // 210
        },                                                                                                             // 211
        done: function done(data) {                                                                                    // 213
          if (!started) {                                                                                              // 214
            started = true;                                                                                            // 215
            response.writeHead(200, {                                                                                  // 216
              "Content-Length": 0,                                                                                     // 217
              "Content-Type": "application/zip",                                                                       // 218
              "Content-Disposition": "attachment;filename*=utf-8''" + encodedFilename                                  // 219
            });                                                                                                        // 216
          }                                                                                                            // 221
                                                                                                                       //
          sawEnd = true;                                                                                               // 223
          response.end();                                                                                              // 224
        }                                                                                                              // 225
      };                                                                                                               // 189
                                                                                                                       //
      waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                    // 228
                                                                                                                       //
      if (!sawEnd) {                                                                                                   // 230
        console.error("backend failed to call done() when downloading backup");                                        // 231
        if (!started) {                                                                                                // 232
          throw new Meteor.Error(500, "backend failed to produce data");                                               // 233
        }                                                                                                              // 234
                                                                                                                       //
        response.end();                                                                                                // 236
      }                                                                                                                // 237
                                                                                                                       //
      cleanupToken(this.params.tokenId);                                                                               // 239
    }                                                                                                                  // 240
  });                                                                                                                  // 174
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 243
    where: "server",                                                                                                   // 244
    path: "/uploadBackup/:token",                                                                                      // 245
    action: function action() {                                                                                        // 246
      var _this = this;                                                                                                // 246
                                                                                                                       //
      if (this.request.method === "POST") {                                                                            // 247
        var _ret = function () {                                                                                       // 247
          var token = FileTokens.findOne(_this.params.token);                                                          // 248
          if (!_this.params.token || !token) {                                                                         // 249
            _this.response.writeHead(403, {                                                                            // 250
              "Content-Type": "text/plain"                                                                             // 251
            });                                                                                                        // 250
            _this.response.write("Invalid upload token.");                                                             // 253
            _this.response.end();                                                                                      // 254
            return {                                                                                                   // 255
              v: void 0                                                                                                // 255
            };                                                                                                         // 255
          }                                                                                                            // 256
                                                                                                                       //
          var request = _this.request;                                                                                 // 258
          try {                                                                                                        // 259
            (function () {                                                                                             // 259
              var stream = globalBackend.cap().uploadBackup(_this.params.token).stream;                                // 260
                                                                                                                       //
              waitPromise(new Promise(function (resolve, reject) {                                                     // 262
                request.on("data", function (data) {                                                                   // 263
                  stream.write(data);                                                                                  // 264
                });                                                                                                    // 265
                request.on("end", function () {                                                                        // 266
                  resolve(stream.done());                                                                              // 267
                });                                                                                                    // 268
                request.on("error", function (err) {                                                                   // 269
                  stream.close();                                                                                      // 270
                });                                                                                                    // 271
              }));                                                                                                     // 272
                                                                                                                       //
              _this.response.writeHead(204);                                                                           // 274
              _this.response.end();                                                                                    // 275
            })();                                                                                                      // 259
          } catch (error) {                                                                                            // 276
            console.error(error.stack);                                                                                // 277
            _this.response.writeHead(500, {                                                                            // 278
              "Content-Type": "text/plain"                                                                             // 279
            });                                                                                                        // 278
            _this.response.write(error.stack);                                                                         // 281
            _this.response.end();                                                                                      // 282
          }                                                                                                            // 283
        }();                                                                                                           // 247
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                   // 247
      } else {                                                                                                         // 284
        this.response.writeHead(405, {                                                                                 // 285
          "Content-Type": "text/plain"                                                                                 // 286
        });                                                                                                            // 285
        this.response.write("You can only POST here.");                                                                // 288
        this.response.end();                                                                                           // 289
      }                                                                                                                // 290
    }                                                                                                                  // 291
  });                                                                                                                  // 243
});                                                                                                                    // 293
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"contacts-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/contacts-server.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.publish("contactProfiles", function (showAll) {                                                                 // 17
  var db = this.connection.sandstormDb;                                                                                // 18
  var _this = this;                                                                                                    // 19
  var userId = this.userId;                                                                                            // 20
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var contactIdentities = {};                                                                                          // 23
  var disallowGuests = db.getOrganizationDisallowGuests();                                                             // 24
                                                                                                                       //
  function addIdentityOfContact(identityId) {                                                                          // 26
    if (!(identityId in contactIdentities)) {                                                                          // 27
      var user = Meteor.users.findOne({ _id: identityId });                                                            // 28
                                                                                                                       //
      if (disallowGuests && !showAll) {                                                                                // 30
        if (!db.isIdentityInOrganization(user)) {                                                                      // 31
          return;                                                                                                      // 32
        }                                                                                                              // 33
      }                                                                                                                // 34
                                                                                                                       //
      if (user) {                                                                                                      // 36
        SandstormDb.fillInProfileDefaults(user);                                                                       // 37
        SandstormDb.fillInIntrinsicName(user);                                                                         // 38
        var filteredUser = _.pick(user, "_id", "profile");                                                             // 39
        _this.added("contactProfiles", user._id, filteredUser);                                                        // 40
      }                                                                                                                // 41
                                                                                                                       //
      contactIdentities[identityId] = Meteor.users.find({ _id: identityId }, { fields: { profile: 1 } }).observeChanges({
        changed: function changed(id, fields) {                                                                        // 45
          _this.changed("contactProfiles", id, fields);                                                                // 46
        }                                                                                                              // 47
      });                                                                                                              // 44
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  var cursor = db.collections.contacts.find({ ownerId: userId });                                                      // 52
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 54
    added: function added(contact) {                                                                                   // 55
      addIdentityOfContact(contact.identityId);                                                                        // 56
    },                                                                                                                 // 57
                                                                                                                       //
    changed: function changed(contact) {                                                                               // 59
      addIdentityOfContact(contact.identityId);                                                                        // 60
    },                                                                                                                 // 61
                                                                                                                       //
    removed: function removed(contact) {                                                                               // 63
      _this.removed("contactProfiles", contact.identityId);                                                            // 64
      var contactIdentity = contactIdentities[contact.identityId];                                                     // 65
      if (contactIdentity) contactIdentities[contact.identityId].stop();                                               // 66
      delete contactIdentities[contact.identityId];                                                                    // 67
    }                                                                                                                  // 68
  });                                                                                                                  // 54
                                                                                                                       //
  var orgHandle = void 0;                                                                                              // 71
                                                                                                                       //
  if (db.getOrganizationShareContacts() && db.isUserInOrganization(db.collections.users.findOne({ _id: userId }))) {   // 73
    var orgCursor = db.collections.users.find({ profile: { $exists: 1 } });                                            // 75
    // TODO(perf): make a mongo query that can find all identities in an organization and add                          //
    // indices for it. Currently, we do some case insensitive matching which mongo can't                               //
    // handle well.                                                                                                    //
                                                                                                                       //
    orgHandle = orgCursor.observe({                                                                                    // 80
      added: function added(user) {                                                                                    // 81
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 82
          addIdentityOfContact(user._id);                                                                              // 83
        }                                                                                                              // 84
      },                                                                                                               // 85
                                                                                                                       //
      changed: function changed(user) {                                                                                // 87
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 88
          addIdentityOfContact(user._id);                                                                              // 89
        }                                                                                                              // 90
      },                                                                                                               // 91
                                                                                                                       //
      removed: function removed(user) {                                                                                // 93
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 94
          _this.removed("contactProfiles", user._id);                                                                  // 95
          var contactIdentity = contactIdentities[contact.identityId];                                                 // 96
          if (contactIdentity) contactIdentities[contact.identityId].stop();                                           // 97
          delete contactIdentities[user._id];                                                                          // 98
        }                                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 80
  }                                                                                                                    // 102
                                                                                                                       //
  this.ready();                                                                                                        // 104
                                                                                                                       //
  this.onStop(function () {                                                                                            // 106
    handle.stop();                                                                                                     // 107
    if (orgHandle) {                                                                                                   // 108
      orgHandle.stop();                                                                                                // 109
    }                                                                                                                  // 110
                                                                                                                       //
    Object.keys(contactIdentities).forEach(function (identityId) {                                                     // 112
      contactIdentities[identityId].stop();                                                                            // 113
      delete contactIdentities[identityId];                                                                            // 114
    });                                                                                                                // 115
  });                                                                                                                  // 116
});                                                                                                                    // 117
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/async-helpers.js","/imports/server/static-asset.js","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});var StaticAssetImpl,IdenticonStaticAssetImpl;module.import("/imports/server/static-asset.js",{"StaticAssetImpl":function(v){StaticAssetImpl=v},"IdenticonStaticAssetImpl":function(v){IdenticonStaticAssetImpl=v}});var PersistentImpl,hashSturdyRef,generateSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v},"hashSturdyRef":function(v){hashSturdyRef=v},"generateSturdyRef":function(v){generateSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Crypto = Npm.require("crypto");                                                                                    // 20
                                                                                                                       // 21
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 24
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 25
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 26
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 27
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 28
var StaticAsset = Capnp.importSystem("sandstorm/util.capnp").StaticAsset;                                              // 29
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 30
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(db, grainId) {                                                                            // 33
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 33
                                                                                                                       //
    this.db = db;                                                                                                      // 34
    this.grainId = grainId;                                                                                            // 35
  }                                                                                                                    // 36
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function restore(sturdyRef) {                                                  //
    var _this = this;                                                                                                  // 38
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 39
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 40
      var token = _this.db.collections.apiTokens.findOne({                                                             // 41
        _id: hashedSturdyRef,                                                                                          // 42
        "owner.grain.grainId": _this.grainId                                                                           // 43
      });                                                                                                              // 41
                                                                                                                       //
      if (!token) {                                                                                                    // 46
        throw new Error("no such token");                                                                              // 47
      }                                                                                                                // 48
                                                                                                                       //
      if (token.owner.grain.introducerIdentity) {                                                                      // 50
        throw new Error("Cannot restore grain-owned sturdyref that contains the obsolete " + "introducerIdentity field. Please request a new capability.");
      }                                                                                                                // 53
                                                                                                                       //
      return restoreInternal(_this.db, sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) }, [], token);
    });                                                                                                                // 58
  };                                                                                                                   // 59
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function drop(sturdyRef) {                                                        //
    var _this2 = this;                                                                                                 // 61
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 62
      return dropInternal(_this2.db, sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this2.grainId }) });        // 63
    });                                                                                                                // 64
  };                                                                                                                   // 65
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function makeToken(ref, owner, requirements) {                               //
    var _this3 = this;                                                                                                 // 67
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 68
      var sturdyRef = new Buffer(generateSturdyRef());                                                                 // 69
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 70
      _this3.db.collections.apiTokens.insert({                                                                         // 71
        _id: hashedSturdyRef,                                                                                          // 72
        grainId: _this3.grainId,                                                                                       // 73
        objectId: ref,                                                                                                 // 74
        owner: owner,                                                                                                  // 75
        created: new Date(),                                                                                           // 76
        requirements: requirements                                                                                     // 77
      });                                                                                                              // 71
                                                                                                                       //
      return {                                                                                                         // 80
        token: sturdyRef                                                                                               // 81
      };                                                                                                               // 80
    });                                                                                                                // 83
  };                                                                                                                   // 84
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function makeChildToken(parent, owner, requirements) {                  //
    var _this4 = this;                                                                                                 // 86
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 87
      // Compute the save ApiToken template.                                                                           //
      return makeSaveTemplateForChild(_this4.db, parent.toString(), requirements);                                     // 89
    }).then(function (saveTemplate) {                                                                                  // 90
      // Create a dummy PersistentImpl and invoke its own save() method.                                               //
      return new PersistentImpl(_this4.db, saveTemplate).save({ sealFor: owner });                                     // 92
    }).then(function (saveResult) {                                                                                    // 93
      // Transform to expected result structure.                                                                       //
      return { token: saveResult.sturdyRef };                                                                          // 95
    });                                                                                                                // 96
  };                                                                                                                   // 97
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function getOwnerNotificationTarget() {                     //
    var _this5 = this;                                                                                                 // 99
                                                                                                                       //
    var grainId = this.grainId;                                                                                        // 100
    return {                                                                                                           // 101
      owner: {                                                                                                         // 102
        addOngoing: function addOngoing(displayInfo, notification) {                                                   // 103
          return inMeteor(function () {                                                                                // 104
            var grain = _this5.db.collections.grains.findOne({ _id: grainId });                                        // 105
            if (!grain) {                                                                                              // 106
              throw new Error("Grain not found.");                                                                     // 107
            }                                                                                                          // 108
                                                                                                                       //
            var castedNotification = notification.castAs(PersistentOngoingNotification);                               // 110
            var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                      // 111
                                                                                                                       //
            // We have to close both the casted cap and the original. Perhaps this should be fixed in                  //
            // node-capnp?                                                                                             //
            castedNotification.close();                                                                                // 115
            notification.close();                                                                                      // 116
            var notificationId = _this5.db.collections.notifications.insert({                                          // 117
              ongoing: wakelockToken,                                                                                  // 118
              grainId: grainId,                                                                                        // 119
              userId: grain.userId,                                                                                    // 120
              text: displayInfo.caption,                                                                               // 121
              timestamp: new Date(),                                                                                   // 122
              isUnread: true                                                                                           // 123
            });                                                                                                        // 117
                                                                                                                       //
            return {                                                                                                   // 126
              handle: globalFrontendRefRegistry.create(_this5.db, { notificationHandle: notificationId })              // 127
            };                                                                                                         // 126
          });                                                                                                          // 130
        }                                                                                                              // 131
      }                                                                                                                // 102
    };                                                                                                                 // 101
  };                                                                                                                   // 134
                                                                                                                       //
  SandstormCoreImpl.prototype.backgroundActivity = function backgroundActivity(event) {                                //
    var _this6 = this;                                                                                                 // 136
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 137
      logActivity(_this6.grainId, null, event);                                                                        // 138
    });                                                                                                                // 139
  };                                                                                                                   // 140
                                                                                                                       //
  SandstormCoreImpl.prototype.reportGrainSize = function reportGrainSize(bytes) {                                      //
    bytes = parseInt(bytes); // int64s are stringified but precision isn't critical here                               // 143
                                                                                                                       //
    var result = this.db.collections.grains.findAndModify({                                                            // 145
      query: { _id: this.grainId },                                                                                    // 146
      update: { $set: { size: bytes } },                                                                               // 147
      fields: { _id: 1, userId: 1, size: 1 }                                                                           // 148
    });                                                                                                                // 145
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 151
      throw new Error("Grain not found.");                                                                             // 152
    }                                                                                                                  // 153
                                                                                                                       //
    // If the grain did not have a "size" field before the update, then it is a grain created                          //
    // before per-grain size tracking was implemented. In that case, we don't want to update the                       //
    // user record because it may already be counting the grain (specifically on Blackrock, where                      //
    // whole-user size counting has existed for some time).                                                            //
    if (this.db.isQuotaEnabled() && "size" in result.value) {                                                          // 159
      // Update the user record, too. Note that we periodically recompute the user's storage usage                     //
      // from scratch as well, so this doesn't have to be perfectly reliable.                                          //
      var diff = bytes - (result.value.size || 0);                                                                     // 162
      this.db.collections.users.update(result.value.userId, { $inc: { storageUsage: diff } });                         // 163
    }                                                                                                                  // 164
  };                                                                                                                   // 165
                                                                                                                       //
  SandstormCoreImpl.prototype.getIdentityId = function getIdentityId(identity) {                                       //
    return unwrapFrontendCap(identity, "identity", function (identityId) {                                             // 168
      return { id: new Buffer(identityId, "hex") };                                                                    // 169
    });                                                                                                                // 170
  };                                                                                                                   // 171
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(db, grainId) {                                                      // 174
  return new Capnp.Capability(new SandstormCoreImpl(db, grainId), SandstormCore);                                      // 175
};                                                                                                                     // 176
                                                                                                                       //
var NotificationHandle = function (_PersistentImpl) {                                                                  //
  _inherits(NotificationHandle, _PersistentImpl);                                                                      //
                                                                                                                       //
  // TODO(cleanup): Move to a different file.                                                                          //
                                                                                                                       //
  function NotificationHandle(db, saveTemplate, notificationId) {                                                      // 181
    _classCallCheck(this, NotificationHandle);                                                                         // 181
                                                                                                                       //
    var _this7 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 181
                                                                                                                       //
    _this7.notificationId = notificationId;                                                                            // 183
    _this7.db = db;                                                                                                    // 184
    return _this7;                                                                                                     // 181
  }                                                                                                                    // 185
                                                                                                                       //
  NotificationHandle.prototype.close = function close() {                                                              //
    var _this8 = this;                                                                                                 // 187
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 188
      if (!_this8.isSaved()) {                                                                                         // 189
        _dismissNotification(_this8.db, _this8.notificationId);                                                        // 190
      }                                                                                                                // 191
    });                                                                                                                // 192
  };                                                                                                                   // 193
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var PersistentUiViewImpl = function (_PersistentImpl2) {                                                               //
  _inherits(PersistentUiViewImpl, _PersistentImpl2);                                                                   //
                                                                                                                       //
  // TODO(cleanup): Move out of core.js.                                                                               //
                                                                                                                       //
  function PersistentUiViewImpl(db, saveTemplate, grainId) {                                                           // 199
    _classCallCheck(this, PersistentUiViewImpl);                                                                       // 199
                                                                                                                       //
    var _this9 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 199
                                                                                                                       //
    check(grainId, String);                                                                                            // 201
    _this9._db = db;                                                                                                   // 202
    _this9._grainId = grainId;                                                                                         // 203
    return _this9;                                                                                                     // 199
  }                                                                                                                    // 204
                                                                                                                       //
  PersistentUiViewImpl.prototype.getViewInfo = function getViewInfo() {                                                //
    var _this10 = this;                                                                                                // 206
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 207
      var grain = _this10._db.getGrain(_this10._grainId);                                                              // 208
      if (!grain || grain.trashed) {                                                                                   // 209
        throw new Error("grain no longer exists");                                                                     // 210
      }                                                                                                                // 211
                                                                                                                       //
      var pkg = _this10._db.getPackage(grain.packageId) || DevPackages.findOne({ appId: grain.appId }) || {};          // 213
                                                                                                                       //
      var manifest = pkg.manifest || {};                                                                               // 217
                                                                                                                       //
      var viewInfo = grain.cachedViewInfo || {};                                                                       // 219
                                                                                                                       //
      if (!viewInfo.appTitle) {                                                                                        // 221
        viewInfo.appTitle = manifest.appTitle || {};                                                                   // 222
      }                                                                                                                // 223
                                                                                                                       //
      if (!viewInfo.grainIcon) {                                                                                       // 225
        var grainIcon = ((manifest.metadata || {}).icons || {}).grain;                                                 // 226
        if (grainIcon) {                                                                                               // 227
          viewInfo.grainIcon = new Capnp.Capability(new StaticAssetImpl(grainIcon.assetId), StaticAsset);              // 228
        } else {                                                                                                       // 230
          var hash = Identicon.hashAppIdForIdenticon(pkg.appId);                                                       // 231
          viewInfo.grainIcon = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);              // 232
        }                                                                                                              // 234
      }                                                                                                                // 235
                                                                                                                       //
      return viewInfo;                                                                                                 // 237
    });                                                                                                                // 238
  };                                                                                                                   // 239
                                                                                                                       //
  // All other UiView methods are currently unimplemented, which, while not strictly correct,                          //
  // results in the same overall behavior, since users can't call restore() on a PersistentUiView,                     //
  // and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                       //
                                                                                                                       //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(db, saveTemplate, grainId) {                                  // 246
  check(grainId, String);                                                                                              // 247
                                                                                                                       //
  // Verify that the grain exists and hasn't been trashed.                                                             //
  var grain = db.getGrain(grainId);                                                                                    // 250
  if (!grain || grain.trashed) {                                                                                       // 251
    throw new Meteor.Error(404, "grain not found");                                                                    // 252
  }                                                                                                                    // 253
                                                                                                                       //
  return new Capnp.Capability(new PersistentUiViewImpl(db, saveTemplate, grainId), PersistentUiView);                  // 255
};                                                                                                                     // 257
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 259
  frontendRefField: "notificationHandle",                                                                              // 260
                                                                                                                       //
  restore: function restore(db, saveTemplate, notificationId) {                                                        // 262
    return new Capnp.Capability(new NotificationHandle(db, saveTemplate, notificationId), PersistentHandle);           // 263
  }                                                                                                                    // 265
});                                                                                                                    // 259
                                                                                                                       //
function _dismissNotification(db, notificationId, callCancel) {                                                        // 268
  var notification = db.collections.notifications.findOne({ _id: notificationId });                                    // 269
  if (notification) {                                                                                                  // 270
    db.collections.notifications.remove({ _id: notificationId });                                                      // 271
    if (notification.ongoing) {                                                                                        // 272
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 275
                                                                                                                       //
      if (!callCancel) {                                                                                               // 277
        dropInternal(db, id, { frontend: null });                                                                      // 278
      } else {                                                                                                         // 279
        var notificationCap = restoreInternal(db, id, { frontend: null }, []).cap;                                     // 280
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 281
        dropInternal(db, id, { frontend: null });                                                                      // 282
        try {                                                                                                          // 283
          waitPromise(castedNotification.cancel());                                                                    // 284
          castedNotification.close();                                                                                  // 285
          notificationCap.close();                                                                                     // 286
        } catch (err) {                                                                                                // 287
          if (err.kjType !== "disconnected") {                                                                         // 288
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 291
          }                                                                                                            // 292
        }                                                                                                              // 293
      }                                                                                                                // 294
    } else if (notification.appUpdates) {                                                                              // 295
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 296
        db.deleteUnusedPackages(appId);                                                                                // 297
      });                                                                                                              // 298
    }                                                                                                                  // 299
  }                                                                                                                    // 300
}                                                                                                                      // 301
                                                                                                                       //
Meteor.methods({                                                                                                       // 303
  dismissNotification: function dismissNotification(notificationId) {                                                  // 304
    // This will remove notifications from the database and from view of the user.                                     //
    // For ongoing notifications, it will begin the process of cancelling and dropping them from                       //
    // the app.                                                                                                        //
                                                                                                                       //
    check(notificationId, String);                                                                                     // 309
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 311
                                                                                                                       //
    var notification = db.collections.notifications.findOne({ _id: notificationId });                                  // 313
    if (!notification) {                                                                                               // 314
      throw new Meteor.Error(404, "Notification id not found.");                                                       // 315
    } else if (notification.userId !== Meteor.userId()) {                                                              // 316
      throw new Meteor.Error(403, "Notification does not belong to current user.");                                    // 317
    } else {                                                                                                           // 318
      _dismissNotification(db, notificationId, true);                                                                  // 319
    }                                                                                                                  // 320
  },                                                                                                                   // 321
  readAllNotifications: function readAllNotifications() {                                                              // 323
    // Marks all notifications as read for the current user.                                                           //
    if (!Meteor.userId()) {                                                                                            // 325
      throw new Meteor.Error(403, "User not logged in.");                                                              // 326
    }                                                                                                                  // 327
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 329
    db.collections.notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });  // 330
  },                                                                                                                   // 334
  acceptPowerboxOffer: function acceptPowerboxOffer(sessionId, sturdyRef, sessionToken) {                              // 336
    var db = this.connection.sandstormDb;                                                                              // 337
    check(sessionId, String);                                                                                          // 338
    check(sturdyRef, String);                                                                                          // 339
    check(sessionToken, Match.OneOf(String, null, undefined));                                                         // 340
                                                                                                                       //
    var sessionQuery = { _id: sessionId };                                                                             // 342
    if (sessionToken) {                                                                                                // 343
      sessionQuery.hashedToken = hashSturdyRef(sessionToken);                                                          // 344
    } else {                                                                                                           // 345
      sessionQuery.userId = this.userId;                                                                               // 346
    }                                                                                                                  // 347
                                                                                                                       //
    var session = db.collections.sessions.findOne(sessionQuery);                                                       // 349
    if (!session) {                                                                                                    // 350
      throw new Meteor.Error(404, "No matching session found.");                                                       // 351
    }                                                                                                                  // 352
                                                                                                                       //
    var tokenId = hashSturdyRef(sturdyRef);                                                                            // 354
    var apiToken = db.collections.apiTokens.findOne({                                                                  // 355
      _id: tokenId,                                                                                                    // 356
      "owner.clientPowerboxOffer.sessionId": sessionId                                                                 // 357
    });                                                                                                                // 355
                                                                                                                       //
    if (!apiToken) {                                                                                                   // 360
      throw new Meteor.Error(404, "No such token.");                                                                   // 361
    }                                                                                                                  // 362
                                                                                                                       //
    var newSturdyRef = void 0;                                                                                         // 364
    var hashedNewSturdyRef = void 0;                                                                                   // 365
    if (sessionToken && apiToken.parentToken) {                                                                        // 366
      // An anonymous user is being offered a child token. To avoid bloating the database,                             //
      // we deterministically derive the sturdyref from the session token and the hashed parent                        //
      // token.                                                                                                        //
      //                                                                                                               //
      // Note that an attacker with read access to the database might be able to derive                                //
      // `newSturdyRef` from `sessionToken` and gain access to the capability without ever having                      //
      // been explicitly offered it by the grain. Therefore, grains must assume that offering                          //
      // a capability to an anonymous user can possibly make that capability accessible to any                         //
      // other anonymous user who has connected through the same URL.                                                  //
                                                                                                                       //
      newSturdyRef = Crypto.createHash("sha256").update(sessionToken).update(apiToken.parentToken).digest("base64").slice(0, -1) // removing trailing "="
      .replace(/\+/g, "-").replace(/\//g, "_"); // make URL-safe                                                       // 377
                                                                                                                       //
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 384
      if (db.collections.apiTokens.findOne({ _id: hashedNewSturdyRef })) {                                             // 385
        // We have already generated this token.                                                                       //
        db.removeApiTokens({ _id: tokenId });                                                                          // 387
        return newSturdyRef;                                                                                           // 388
      }                                                                                                                // 389
    } else {                                                                                                           // 390
      newSturdyRef = generateSturdyRef();                                                                              // 391
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 392
    }                                                                                                                  // 393
                                                                                                                       //
    apiToken._id = hashedNewSturdyRef;                                                                                 // 395
    apiToken.owner = { webkey: null };                                                                                 // 396
                                                                                                                       //
    db.collections.apiTokens.insert(apiToken);                                                                         // 398
    db.removeApiTokens({ _id: tokenId });                                                                              // 399
    return newSturdyRef;                                                                                               // 400
  }                                                                                                                    // 401
});                                                                                                                    // 303
                                                                                                                       //
var makeSaveTemplateForChild = function makeSaveTemplateForChild(db, parentToken, requirements, parentTokenInfo) {     // 405
  // Constructs (part of) an ApiToken record appropriate to be used when save()ing a capability                        //
  // that was originally created by restore()ing `parentToken`. This fills in everything that is                       //
  // appropriate to fill in based only on the parent. Some fields -- especially `owner`, `created`,                    //
  // and `_id` -- obviously cannot be filled in until `save()` is called.                                              //
  //                                                                                                                   //
  // `parentToken` is the raw SturdyRef of the parent.                                                                 //
  //                                                                                                                   //
  // `requirements` is a list of MembraneRequirements that should be added to any children.                            //
  //                                                                                                                   //
  // `parentTokenInfo` is the ApiToken record for `parentToken`. Provide this only if you have                         //
  // it handy; if omitted it will be looked up.                                                                        //
                                                                                                                       //
  parentTokenInfo = parentTokenInfo || db.collections.apiTokens.findOne(hashSturdyRef(parentToken));                   // 418
  if (!parentTokenInfo) {                                                                                              // 419
    throw new Error("no such token");                                                                                  // 420
  }                                                                                                                    // 421
                                                                                                                       //
  var parentOwner = parentTokenInfo.owner || {};                                                                       // 423
                                                                                                                       //
  var saveTemplate = void 0;                                                                                           // 425
  if (parentOwner.clientPowerboxRequest || parentOwner.clientPowerboxOffer) {                                          // 426
    // Saving this token should make a copy of the restored token, rather than make a child                            //
    // token.                                                                                                          //
                                                                                                                       //
    saveTemplate = _.clone(parentTokenInfo);                                                                           // 430
                                                                                                                       //
    // Don't copy over fields that should be determined at save() time.                                                //
    delete saveTemplate._id;                                                                                           // 433
    delete saveTemplate.owner;                                                                                         // 434
    delete saveTemplate.created;                                                                                       // 435
  } else {                                                                                                             // 436
    if (parentTokenInfo.identityId) {                                                                                  // 437
      // A UiView token. Need to denormalize some fields from the parent.                                              //
      saveTemplate = _.pick(parentTokenInfo, "grainId", "identityId", "accountId");                                    // 439
                                                                                                                       //
      // By default, a save()d copy should have the same permissions, so set an allAccess role                         //
      // assignment.                                                                                                   //
      saveTemplate.roleAssignment = { allAccess: null };                                                               // 443
    } else {                                                                                                           // 444
      // A non-UiView child token.                                                                                     //
      saveTemplate = {};                                                                                               // 446
    }                                                                                                                  // 447
                                                                                                                       //
    // Saved token should be a child of the restored token.                                                            //
    saveTemplate.parentToken = parentTokenInfo._id;                                                                    // 450
  }                                                                                                                    // 451
                                                                                                                       //
  if (requirements) {                                                                                                  // 453
    // Append additional requirements requested by caller.                                                             //
    saveTemplate.requirements = (saveTemplate.requirements || []).concat(requirements);                                // 455
  }                                                                                                                    // 456
                                                                                                                       //
  return saveTemplate;                                                                                                 // 458
};                                                                                                                     // 459
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 461
  function restoreInternal(_x, _x2, _x3, _x4, _x5, _x6) {                                                              // 461
    return _restoreInternal.apply(this, arguments);                                                                    // 461
  }                                                                                                                    // 461
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 461
    return _restoreInternal.toString();                                                                                // 461
  };                                                                                                                   // 461
                                                                                                                       //
  return restoreInternal;                                                                                              // 461
}(function (db, originalToken, ownerPattern, requirements, originalTokenInfo, currentTokenId) {                        // 461
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `originalTokenInfo` is optional. If specified, it should be the ApiToken record associated                        //
  // with `originalToken`. Provide this if you happen to have looked it up already.                                    //
  //                                                                                                                   //
  // `currentTokenId` is only provided when this function calls itself recursively. It is the                          //
  // _id (hashed token) of an ancestor of originalToken. The function recurses until it gets to                        //
  // the top-level token.                                                                                              //
                                                                                                                       //
  requirements = requirements || [];                                                                                   // 478
                                                                                                                       //
  if (!originalTokenInfo) {                                                                                            // 480
    originalTokenInfo = db.collections.apiTokens.findOne(hashSturdyRef(originalToken));                                // 481
    if (!originalTokenInfo) {                                                                                          // 482
      throw new Meteor.Error(403, "No token found to restore");                                                        // 483
    }                                                                                                                  // 484
  }                                                                                                                    // 485
                                                                                                                       //
  var token = currentTokenId ? db.collections.apiTokens.findOne(currentTokenId) : originalTokenInfo;                   // 487
  if (!token) {                                                                                                        // 489
    if (!originalTokenInfo) {                                                                                          // 490
      throw new Meteor.Error(403, "Couldn't restore token because parent token has been deleted");                     // 491
    }                                                                                                                  // 492
  }                                                                                                                    // 493
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 495
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 496
  }                                                                                                                    // 497
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 500
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  checkRequirements(db, token.requirements);                                                                           // 503
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 506
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 507
  }                                                                                                                    // 508
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 510
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 511
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 512
    } else {                                                                                                           // 513
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      db.collections.apiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                 // 515
    }                                                                                                                  // 516
  }                                                                                                                    // 517
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 520
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(db, originalToken, Match.Any, requirements, originalTokenInfo, token.parentToken);          // 523
  }                                                                                                                    // 525
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  checkRequirements(db, requirements);                                                                                 // 528
                                                                                                                       //
  if (token.objectId) {                                                                                                // 530
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 534
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 535
    }                                                                                                                  // 536
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 539
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // don't generate a saveTemplate here.                                                                           //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 542
    }));                                                                                                               // 543
  } else {                                                                                                             // 544
    // Construct a template ApiToken for use if the restored capability is save()d later.                              //
    var saveTemplate = makeSaveTemplateForChild(db, originalToken, requirements, originalTokenInfo);                   // 546
                                                                                                                       //
    if (token.frontendRef) {                                                                                           // 548
      // A token which represents a capability implemented by a pseudo-driver.                                         //
                                                                                                                       //
      var cap = globalFrontendRefRegistry.restore(db, saveTemplate, token.frontendRef);                                // 551
      return { cap: cap };                                                                                             // 552
    } else if (token.grainId) {                                                                                        // 553
      // It's a UiView.                                                                                                //
                                                                                                                       //
      // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                          //
      // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                  //
      // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                     //
      // do some transformation), which will return a different capability.                                            //
      return { cap: makePersistentUiView(db, saveTemplate, token.grainId) };                                           // 560
    } else {                                                                                                           // 561
      throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                             // 562
    }                                                                                                                  // 563
  }                                                                                                                    // 564
});                                                                                                                    // 565
                                                                                                                       //
function dropInternal(db, sturdyRef, ownerPattern) {                                                                   // 567
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 570
  var token = db.collections.apiTokens.findOne({ _id: hashedSturdyRef });                                              // 571
  if (!token) {                                                                                                        // 572
    return;                                                                                                            // 573
  }                                                                                                                    // 574
                                                                                                                       //
  if (!Match.test(token.owner, ownerPattern)) {                                                                        // 576
    // The caller of `drop()` does not own the token. From the caller's perspective, this means                        //
    // that there is actually nothing to be dropped. For example, perhaps a grain got backed up                        //
    // and restored, and now is trying to drop one of its pre-backup tokens. The call to                               //
    // `SandstormApi.drop()` should succeed, behaving exactly as if the token was not found.                           //
    return;                                                                                                            // 581
  }                                                                                                                    // 582
                                                                                                                       //
  if (token.frontendRef && token.frontendRef.notificationHandle) {                                                     // 584
    var notificationId = token.frontendRef.notificationHandle;                                                         // 585
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 586
    var anyToken = db.collections.apiTokens.findOne({ "frontendRef.notificationHandle": notificationId });             // 587
    if (!anyToken) {                                                                                                   // 588
      // No other tokens referencing this notification exist, so dismiss the notification                              //
      _dismissNotification(db, notificationId);                                                                        // 590
    }                                                                                                                  // 591
  } else if (token.objectId) {                                                                                         // 592
    waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                          // 593
      return supervisor.drop(token.objectId);                                                                          // 594
    }));                                                                                                               // 595
                                                                                                                       //
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 597
  } else {                                                                                                             // 598
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 599
  }                                                                                                                    // 600
}                                                                                                                      // 601
                                                                                                                       //
var SandstormCoreFactoryImpl = function () {                                                                           //
  function SandstormCoreFactoryImpl(db) {                                                                              // 604
    _classCallCheck(this, SandstormCoreFactoryImpl);                                                                   // 604
                                                                                                                       //
    this.db = db;                                                                                                      // 605
  }                                                                                                                    // 606
                                                                                                                       //
  SandstormCoreFactoryImpl.prototype.getSandstormCore = function getSandstormCore(grainId) {                           //
    return { core: makeSandstormCore(this.db, grainId) };                                                              // 609
  };                                                                                                                   // 610
                                                                                                                       //
  return SandstormCoreFactoryImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory(db) {                                                     // 613
  return new Capnp.Capability(new SandstormCoreFactoryImpl(db), SandstormCoreFactory);                                 // 614
};                                                                                                                     // 615
                                                                                                                       //
unwrapFrontendCap = function unwrapFrontendCap(cap, type, callback) {                                                  // 617
  // Expect that `cap` is a Cap'n Proto capability implemented by the frontend as a frontendRef                        //
  // with the given type (the name of one of the fields of frontendRef). Unwraps the capability                        //
  // and then calls callback() with the `frontendRef[type]` descriptor object as                                       //
  // the paramater. The callback runs in a Meteor fiber, but this function can be called from                          //
  // anywhere. The function returns a Promise for the result of the callback.                                          //
  //                                                                                                                   //
  // (The reason for the callback, rather than just returning a Promise for the descriptor, is                         //
  // so that you don't have to do your own inMeteor() dance.)                                                          //
                                                                                                                       //
  // For now, we save() the capability and then dig through ApiTokens to find where it leads.                          //
  // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                         //
  //   not available in Javascript yet and even if it were, it wouldn't work in the case where                         //
  //   there are multiple front-end replicas, since the capability could be on a different                             //
  //   replica.                                                                                                        //
                                                                                                                       //
  return cap.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                            // 633
    return inMeteor(function () {                                                                                      // 634
      var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                               // 635
      var tokenInfo = ApiTokens.findOne(tokenId);                                                                      // 636
                                                                                                                       //
      // Delete the token now since it's not needed.                                                                   //
      ApiTokens.remove(tokenId);                                                                                       // 639
                                                                                                                       //
      for (;;) {                                                                                                       // 641
        if (!tokenInfo) throw new Error("missing token?");                                                             // 642
        if (!tokenInfo.parentToken) break;                                                                             // 643
        tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                          // 644
      }                                                                                                                // 645
                                                                                                                       //
      if (!tokenInfo.frontendRef || !tokenInfo.frontendRef[type]) {                                                    // 647
        throw new Error("not a " + type + " capability");                                                              // 648
      }                                                                                                                // 649
                                                                                                                       //
      return callback(tokenInfo.frontendRef[type]);                                                                    // 651
    });                                                                                                                // 652
  });                                                                                                                  // 653
};                                                                                                                     // 654
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":["/imports/server/async-helpers.js","/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 20
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 21
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 23
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 26
    (function () {                                                                                                     // 26
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 27
      if (expireIn < 0) {                                                                                              // 28
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 29
      }                                                                                                                // 30
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 32
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 35
      }                                                                                                                // 36
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 40
      var handle = Meteor.setTimeout(function () {                                                                     // 41
        connection.close();                                                                                            // 41
      }, expireIn);                                                                                                    // 41
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 43
        Meteor.clearTimeout(handle);                                                                                   // 43
      });                                                                                                              // 43
    })();                                                                                                              // 26
  }                                                                                                                    // 44
                                                                                                                       //
  return true;                                                                                                         // 46
});                                                                                                                    // 47
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 49
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 52
  Meteor.users.find({ expires: { $lt: now }, loginIdentities: { $exists: true } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
    console.log("delete demo user: " + user._id);                                                                      // 56
    globalDb.deleteAccount(user._id, globalBackend);                                                                   // 57
                                                                                                                       //
    // Record stats about demo accounts.                                                                               //
    var deleteStatsType = "demoUser";                                                                                  // 60
    var isAppDemoUser = !!user.appDemoId;                                                                              // 61
    if (isAppDemoUser) {                                                                                               // 62
      deleteStatsType = "appDemoUser";                                                                                 // 63
    }                                                                                                                  // 64
                                                                                                                       //
    // Intentionally record deleted users at time of deletion to avoid miscounting users that                          //
    // were demoing just before the day rolled over.                                                                   //
    DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                      // 68
  });                                                                                                                  // 69
                                                                                                                       //
  // All demo identities should have been deleted as part of deleting the demo users, but just in                      //
  // case, check for them too.                                                                                         //
  Meteor.users.find({ expires: { $lt: now }, loginIdentities: { $exists: false } }, { fields: { _id: 1 } }).forEach(function (user) {
    console.log("delete demo identity: " + user._id);                                                                  // 76
    globalDb.deleteIdentity(user._id);                                                                                 // 77
  });                                                                                                                  // 78
}                                                                                                                      // 79
                                                                                                                       //
if (allowDemo) {                                                                                                       // 81
  Meteor.methods({                                                                                                     // 82
    createDemoUser: function createDemoUser(displayName, appDemoId) {                                                  // 83
      // This is a login method that creates a new temporary user                                                      //
      // every time it is used.                                                                                        //
      //                                                                                                               //
      // appDemoId is important for stats; see cleanupExpiredUsers().                                                  //
      check(displayName, String);                                                                                      // 88
      check(appDemoId, Match.OneOf(undefined, null, String));                                                          // 89
                                                                                                                       //
      // Create the new user.                                                                                          //
      var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                            // 92
      if (appDemoId) {                                                                                                 // 93
        newUser.appDemoId = appDemoId;                                                                                 // 94
      }                                                                                                                // 95
                                                                                                                       //
      var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                                // 97
                                                                                                                       //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                            // 100
        return { userId: userId };                                                                                     // 101
      });                                                                                                              // 101
    },                                                                                                                 // 102
                                                                                                                       //
    testExpireDemo: function testExpireDemo() {                                                                        // 104
      if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                               // 105
                                                                                                                       //
      var newExpires = new Date(Date.now() + 15000);                                                                   // 107
      if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                    // 108
        throw new Meteor.Error(403, "can't exend demo");                                                               // 109
      }                                                                                                                // 110
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                             // 112
    }                                                                                                                  // 113
  });                                                                                                                  // 82
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to information about an app by                         //
  // appId. If this were available in non-demo mode, then anonymous users could effectively ask the                    //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appDemoInfo", function (appId) {                                                                     // 119
    // This publishes info about an app, including the latest version of it. Once you log in, it                       //
    // also publishes your list of UserActions.                                                                        //
    check(appId, String);                                                                                              // 122
                                                                                                                       //
    // Get data about this app from the app index. Note that the app index cache on this server                        //
    // is typically 6-24 hours delayed from reality, so if an app is newly-available                                   //
    // in the app market, it won't be in the app index. Therefore we don't bail-out if the app                         //
    // is missing from the AppIndex collection.                                                                        //
    var appIndexData = globalDb.collections.appIndex.findOne({ appId: appId });                                        // 128
                                                                                                                       //
    // Prepare a helper function we can use to transform a package cursor into an appropriate return                   //
    // value for this function.                                                                                        //
    var packageCursorAndMaybeUserActions = function packageCursorAndMaybeUserActions(userId, appId, packageCursor) {   // 132
      // This allows us to avoid creating duplicate UserActions.                                                       //
      if (userId) {                                                                                                    // 134
        return [packageCursor, UserActions.find({ userId: userId, appId: appId })];                                    // 135
      }                                                                                                                // 139
                                                                                                                       //
      return packageCursor;                                                                                            // 141
    };                                                                                                                 // 142
                                                                                                                       //
    // If the app is in the app index, and the current version is installed, always return that. If                    //
    // that package isn't installed, store the version number so we can filter on it later.                            //
    var packageQuery = {};                                                                                             // 146
    if (appIndexData) {                                                                                                // 147
      var appIndexPackageQuery = Packages.find({ _id: appIndexData.packageId });                                       // 148
      if (appIndexPackageQuery.count() > 0) {                                                                          // 149
        return packageCursorAndMaybeUserActions(this.userId, appId, appIndexPackageQuery);                             // 150
      }                                                                                                                // 151
                                                                                                                       //
      // If the app index version isn't present, insist on a lower version than the app index                          //
      // version. This avoids accidentally catching some development version of the app that has the                   //
      // same version number as the app market version but isn't the app market version.                               //
      packageQuery["manifest.appVersion"] = { $lt: appIndexData.versionNumber };                                       // 156
    }                                                                                                                  // 157
                                                                                                                       //
    // If the specific package from the app index isn't installed, or the app isn't there at all, do                   //
    // our best.                                                                                                       //
    packageQuery.appId = appId;                                                                                        // 161
    var packageCursor = Packages.find(packageQuery, { sort: { "manifest.appVersion": -1 },                             // 162
      limit: 1                                                                                                         // 165
    });                                                                                                                // 164
    return packageCursorAndMaybeUserActions(this.userId, appId, packageCursor);                                        // 167
  });                                                                                                                  // 168
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 170
} else {                                                                                                               // 171
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 173
}                                                                                                                      // 174
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications-server.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/desktop-notifications-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});// Sandstorm - Personal Cloud Sandbox       //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
SandstormDb.periodicCleanup(120000, function () {                                                                      // 19
  // Remove old desktop notfications regularly.                                                                        //
  // periodicCleanup doesn't like runs more frequent than once every two minutes                                       //
  var now = Date.now();                                                                                                // 22
  var then = new Date(now - 30000); // Clear tokens older than 30 seconds.                                             // 23
  globalDb.collections.desktopNotifications.find({                                                                     // 24
    creationDate: { $lt: then }                                                                                        // 25
  }).forEach(function (doc) {                                                                                          // 24
    globalDb.collections.desktopNotifications.remove({                                                                 // 27
      _id: doc._id                                                                                                     // 28
    });                                                                                                                // 27
  });                                                                                                                  // 30
});                                                                                                                    // 31
                                                                                                                       //
Meteor.publish("desktopNotifications", function () {                                                                   // 33
  var _this = this;                                                                                                    // 33
                                                                                                                       //
  var subscribeTime = new Date();                                                                                      // 34
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 36
    // No desktop notifications for anonymous users.                                                                   //
    return [];                                                                                                         // 38
  }                                                                                                                    // 39
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 41
  var callbacks = {                                                                                                    // 42
    added: function added(doc) {                                                                                       // 43
      _this.added("desktopNotifications", doc._id, doc);                                                               // 44
    },                                                                                                                 // 45
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 47
      _this.changed("desktopNotifications", newDoc._id, newDoc);                                                       // 48
    },                                                                                                                 // 49
                                                                                                                       //
    removed: function removed(doc) {                                                                                   // 51
      _this.removed("desktopNotifications", doc._id);                                                                  // 52
    }                                                                                                                  // 53
  };                                                                                                                   // 42
                                                                                                                       //
  var sub = db.collections.desktopNotifications.find({                                                                 // 56
    userId: this.userId,                                                                                               // 57
    creationDate: { $gt: subscribeTime }                                                                               // 58
  }).observe(callbacks);                                                                                               // 56
                                                                                                                       //
  this.onStop(function () {                                                                                            // 61
    if (sub) {                                                                                                         // 62
      sub.stop();                                                                                                      // 63
    }                                                                                                                  // 64
  });                                                                                                                  // 65
                                                                                                                       //
  this.ready();                                                                                                        // 67
});                                                                                                                    // 68
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                        // 20
    // This is a login method that creates or logs in a dev account with the given displayName                         //
                                                                                                                       //
    check(displayName, String);                                                                                        // 23
    check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                             // 24
    check(profile, Match.OneOf(undefined, null, Object));                                                              // 25
    check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                      // 26
                                                                                                                       //
    if (!this.connection.sandstormDb.allowDevAccounts()) {                                                             // 28
      throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                      // 29
    }                                                                                                                  // 30
                                                                                                                       //
    isAdmin = isAdmin || false;                                                                                        // 32
                                                                                                                       //
    profile = profile || {};                                                                                           // 34
    profile.name = profile.name || displayName;                                                                        // 35
    var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                               // 36
                                                                                                                       //
    var user = Meteor.users.findOne({ "services.dev.name": displayName });                                             // 38
    var userId = void 0;                                                                                               // 39
                                                                                                                       //
    if (user) {                                                                                                        // 41
      userId = user._id;                                                                                               // 42
    } else {                                                                                                           // 43
      userId = Accounts.insertUserDoc({                                                                                // 44
        profile: profile,                                                                                              // 45
        unverifiedEmail: unverifiedEmail                                                                               // 46
      }, {                                                                                                             // 44
        services: {                                                                                                    // 48
          dev: {                                                                                                       // 49
            name: displayName,                                                                                         // 50
            isAdmin: isAdmin,                                                                                          // 51
            hasCompletedSignup: hasCompletedSignup                                                                     // 52
          }                                                                                                            // 49
        }                                                                                                              // 48
      });                                                                                                              // 47
    }                                                                                                                  // 56
    // Log them in on this connection.                                                                                 //
    return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                             // 58
      return { userId: userId };                                                                                       // 59
    });                                                                                                                // 59
  }                                                                                                                    // 60
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":["babel-runtime/helpers/typeof","/imports/server/email.js","bignum","ed25519",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var send;module.import("/imports/server/email.js",{"send":function(v){send=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var ed25519;module.import("ed25519",{"default":function(v){ed25519=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 21
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 27
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 28
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 29
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 30
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 37
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 40
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 47
  var signedData = buf.slice(64);                                                                                      // 48
                                                                                                                       //
  if (!ed25519.Verify(signedData, signature, signingKey)) {                                                            // 50
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 51
    return undefined;                                                                                                  // 52
  } else {                                                                                                             // 53
    return signedData;                                                                                                 // 54
  }                                                                                                                    // 55
};                                                                                                                     // 56
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 59
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 63
  if (verifiedFeatureKeyBlob) {                                                                                        // 64
    var featureKey = Capnp.parse(FeatureKey, verifiedFeatureKeyBlob, { packed: true });                                // 65
    if (featureKey.isForTesting && !isTesting) {                                                                       // 66
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 69
    }                                                                                                                  // 70
                                                                                                                       //
    return featureKey;                                                                                                 // 72
  } else {                                                                                                             // 73
    return undefined;                                                                                                  // 74
  }                                                                                                                    // 75
};                                                                                                                     // 76
                                                                                                                       //
setNewFeatureKey = function setNewFeatureKey(db, textBlock) {                                                          // 78
  // Set a new feature key. If the new key is expired, check with Sandstorm to see if it was                           //
  // renewed, and use that copy instead.                                                                               //
  //                                                                                                                   //
  // This function under no circumstances stores an expired key to the database, because once                          //
  // a key is stored in the database it will be automatically renewed, and it would be surprising                      //
  // to users if accidentally uploading an old key suddenly caused that key to be renewed.                             //
                                                                                                                       //
  return setNewFeatureKeyInternal(db, textBlock, function (expiredKey) {                                               // 86
    // Key is expired. Try to fetch an updated copy.                                                                   //
                                                                                                                       //
    function throwExpired() {                                                                                          // 89
      throw new Meteor.Error(401, "Feature key is expired. Please purchase a new key.");                               // 90
    }                                                                                                                  // 91
                                                                                                                       //
    try {                                                                                                              // 93
      var newTextBlock = fetchUpdatedFeautureKeyFromVendor(expiredKey);                                                // 94
      return setNewFeatureKeyInternal(db, newTextBlock, throwExpired);                                                 // 95
    } catch (err) {                                                                                                    // 96
      console.error("couldn't fetch newer version of key", err);                                                       // 97
    }                                                                                                                  // 98
                                                                                                                       //
    // No luck.                                                                                                        //
    throwExpired();                                                                                                    // 101
  });                                                                                                                  // 102
};                                                                                                                     // 103
                                                                                                                       //
function setNewFeatureKeyInternal(db, textBlock, ifExpired) {                                                          // 105
  if (!textBlock) {                                                                                                    // 106
    // Delete the feature key.                                                                                         //
    db.collections.featureKey.remove("currentFeatureKey");                                                             // 108
    return;                                                                                                            // 109
  }                                                                                                                    // 110
                                                                                                                       //
  // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                        //
  var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                       // 113
    return line.length > 0 && line[0] !== "-";                                                                         // 114
  }).value().join("");                                                                                                 // 114
                                                                                                                       //
  var buf = new Buffer(featureKeyBase64, "base64");                                                                    // 118
  if (buf.length < 64) {                                                                                               // 119
    throw new Meteor.Error(401, "Invalid feature key");                                                                // 120
  }                                                                                                                    // 121
                                                                                                                       //
  var featureKey = loadSignedFeatureKey(buf);                                                                          // 123
  if (!featureKey) {                                                                                                   // 124
    throw new Meteor.Error(401, "Invalid feature key");                                                                // 125
  }                                                                                                                    // 126
                                                                                                                       //
  if (parseInt(featureKey.expires) * 1000 < Date.now()) {                                                              // 128
    return ifExpired(featureKey);                                                                                      // 129
  }                                                                                                                    // 130
                                                                                                                       //
  // Persist the feature key in the database.                                                                          //
  db.collections.featureKey.upsert("currentFeatureKey", {                                                              // 133
    _id: "currentFeatureKey",                                                                                          // 136
    value: buf                                                                                                         // 137
  });                                                                                                                  // 135
}                                                                                                                      // 140
                                                                                                                       //
// =======================================================================================                             //
// Renewal                                                                                                             //
                                                                                                                       //
var RENEW_API_HOST = "https://api.oasis.sandstorm.io";                                                                 // 145
var RENEW_API_TOKEN = "objFPmEL0gOGfwKYLIwHNmfdKp1FCgMNSrxW4lEeeLk";                                                   // 146
                                                                                                                       //
renewFeatureKey = function renewFeatureKey(db, options) {                                                              // 148
  // Attempts to renew the current feature key.                                                                        //
  //                                                                                                                   //
  // If any errors are detected, admins will be notified and the error information will be stored                      //
  // to the database for display on the feature key page.                                                              //
  //                                                                                                                   //
  // `options` is an object optionally containing:                                                                     //
  //   interactive: Set true if the function was called in response to an admin interactively                          //
  //     requesting the action. This suppresses sending notifications on error, as the admin                           //
  //     will see the error message on the feature key page.                                                           //
  //   dryRun: Go through as many of the motions of renewing as possible without actually renewing,                    //
  //     in order to detect and report if anything would go wrong, and also detect if a newer key                      //
  //     is already available. Useful to test for problems and warn the administrators in advance.                     //
                                                                                                                       //
  options = options || {};                                                                                             // 162
                                                                                                                       //
  var key = void 0;                                                                                                    // 164
  try {                                                                                                                // 165
    var _ret = function () {                                                                                           // 165
      key = db.currentFeatureKey();                                                                                    // 166
      if (!key) return {                                                                                               // 167
          v: void 0                                                                                                    // 167
        }; // nothing to do                                                                                            // 167
                                                                                                                       //
      // Count number of user accounts (not including visitors) active in the last month.                              //
      var count = 0;                                                                                                   // 170
      var oneMonthAgo = new Date(Date.now() - 30 * 86400000);                                                          // 171
      Meteor.users.find({ loginIdentities: { $exists: true }, lastActive: { $gt: oneMonthAgo } }).forEach(function (user) {
        if (db.isAccountSignedUp(user)) {                                                                              // 174
          ++count;                                                                                                     // 175
        }                                                                                                              // 176
      });                                                                                                              // 177
                                                                                                                       //
      console.log("Attempting to renew fetaure key. Active users:", count);                                            // 179
                                                                                                                       //
      // Request renewal.                                                                                              //
      var response = HTTP.post(RENEW_API_HOST + "/renew/" + key.secret.toString("hex"), {                              // 182
        headers: {                                                                                                     // 183
          "Authorization": "Bearer " + RENEW_API_TOKEN                                                                 // 184
        },                                                                                                             // 183
        data: {                                                                                                        // 186
          activeUsers: count,                                                                                          // 187
          dryRun: options.dryRun                                                                                       // 188
        }                                                                                                              // 186
      });                                                                                                              // 182
                                                                                                                       //
      var data = response.data;                                                                                        // 192
      if (data.noPaymentSource !== undefined) {                                                                        // 193
        reportRenewalProblem(db, key, options, { noPaymentSource: true });                                             // 194
      } else if (data.paymentFailed !== undefined) {                                                                   // 195
        reportRenewalProblem(db, key, options, { paymentFailed: data.paymentFailed });                                 // 196
      } else if (data.revoked !== undefined) {                                                                         // 197
        reportRenewalProblem(db, key, options, { revoked: true });                                                     // 198
      } else if (data.noSuchKey !== undefined) {                                                                       // 199
        reportRenewalProblem(db, key, options, { noSuchKey: true });                                                   // 200
      } else if (data.success !== undefined || data.tooEarly !== undefined || data.pendingPayment !== undefined) {     // 201
        // Either we successfully renewed the key, or the key had already been renewed out-of-band.                    //
        // Either way, the next step is to fetch it.                                                                   //
        //                                                                                                             //
        // If we're doing a dry run, then the key wasn't actually updated so there's nothing to                        //
        // fetch. However, if the server indicates that current key is newer than the one we have                      //
        // here, then we should take this chance to update to the current key.                                         //
        if (!options.dryRun || parseInt(data.expires) > parseInt(key.expries)) {                                       // 210
          var newTextBlock = fetchUpdatedFeautureKeyFromVendor(key);                                                   // 211
          setNewFeatureKeyInternal(db, newTextBlock, function () {                                                     // 212
            throw new Error("Renewal seemed to succeed but the service returned an expired key. " + "Is your system clock wrong?");
          });                                                                                                          // 215
        }                                                                                                              // 216
      } else {                                                                                                         // 217
        reportRenewalProblem(db, key, options, { unknownResponse: response.content });                                 // 218
      }                                                                                                                // 219
    }();                                                                                                               // 165
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 165
  } catch (err) {                                                                                                      // 220
    console.error("Exception when trying to renew feature key:", err.stack);                                           // 221
    reportRenewalProblem(db, key, options, { exception: err.message });                                                // 222
  }                                                                                                                    // 223
};                                                                                                                     // 224
                                                                                                                       //
function fetchUpdatedFeautureKeyFromVendor(key) {                                                                      // 226
  var fetchResponse = HTTP.get(RENEW_API_HOST + "/keys/" + key.secret.toString("hex"), {                               // 227
    headers: {                                                                                                         // 228
      "Authorization": "Bearer " + RENEW_API_TOKEN                                                                     // 229
    }                                                                                                                  // 228
  });                                                                                                                  // 227
  var result = fetchResponse.data.key;                                                                                 // 232
  if (!result) throw new Error("Renewal server returned invalid GetKeyResponse.");                                     // 233
  return result;                                                                                                       // 234
}                                                                                                                      // 235
                                                                                                                       //
function reportRenewalProblem(db, key, options, problem) {                                                             // 237
  var old = db.collections.featureKey.findOne("currentFeatureKey");                                                    // 238
                                                                                                                       //
  db.collections.featureKey.update("currentFeatureKey", { $set: { renewalProblem: problem } });                        // 240
                                                                                                                       //
  console.error("Couldn't renew feature key:", problem);                                                               // 242
                                                                                                                       //
  if (old && old.renewalProblem) {                                                                                     // 244
    // There was already a renewal problem reported. Don't report again.                                               //
  } else if (!options.interactive) {                                                                                   // 246
      (function () {                                                                                                   // 246
        if (key.isTrial) {                                                                                             // 247
          db.sendAdminNotification("trialFeatureKeyExpired", "/admin/feature-key");                                    // 248
        } else {                                                                                                       // 249
          db.sendAdminNotification("cantRenewFeatureKey", "/admin/feature-key");                                       // 250
        }                                                                                                              // 251
                                                                                                                       //
        var emailOptions = {                                                                                           // 253
          from: db.getReturnAddress(),                                                                                 // 254
          subject: key.isTrial ? "URGENT: Sandstorm for Work trial for " + db.getServerTitle() + " has expired" : "URGENT: Couldn't renew Sandstorm for Work subscription for " + db.getServerTitle()
        };                                                                                                             // 253
                                                                                                                       //
        emailOptions.text = key.isTrial ? "This is an automated message from your Sandstorm server. Your trial of Sandstorm for Work has expired. To continue using Sandstorm for Work, update your subscription here:" : "This is an automated message from your Sansdtorm server. There was an error when trying to renew your Sandstorm for Work subscription. To resolve the issue, please go to:";
                                                                                                                       //
        emailOptions.text += "\n\n" + process.env.ROOT_URL + "/admin/feature-key";                                     // 264
                                                                                                                       //
        Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                                 // 268
          var email = _.findWhere(SandstormDb.getUserEmails(user), { primary: true });                                 // 269
          if (!email) {                                                                                                // 270
            console.error("No email found for admin with userId:", user._id);                                          // 271
            return;                                                                                                    // 272
          }                                                                                                            // 273
                                                                                                                       //
          try {                                                                                                        // 275
            emailOptions.to = email.email;                                                                             // 276
            send(emailOptions);                                                                                        // 277
          } catch (err) {                                                                                              // 278
            console.error("Failed to send deletion email to admin (id=" + user._id + ") with error: " + err);          // 279
          }                                                                                                            // 281
        });                                                                                                            // 282
      })();                                                                                                            // 246
    }                                                                                                                  // 283
}                                                                                                                      // 284
                                                                                                                       //
var keyRenewalTimeout = null;                                                                                          // 286
var keyObserver = null;                                                                                                // 287
var currentlyRenewing = false;                                                                                         // 288
keepFeatureKeyRenewed = function keepFeatureKeyRenewed(db) {                                                           // 289
  // Whenever the feature key is expired, try to renew it.                                                             //
                                                                                                                       //
  if (keyObserver) keyObserver.stop();                                                                                 // 292
                                                                                                                       //
  keyObserver = db.observeFeatureKey(function (key) {                                                                  // 294
    if (keyRenewalTimeout) {                                                                                           // 295
      Meteor.clearTimeout(keyRenewalTimeout);                                                                          // 296
      keyRenewalTimeout = null;                                                                                        // 297
    }                                                                                                                  // 298
                                                                                                                       //
    if (!key) return;                                                                                                  // 300
                                                                                                                       //
    function scheduleRenewal() {                                                                                       // 302
      keyRenewalTimeout = null;                                                                                        // 303
                                                                                                                       //
      // Fucking Javascript setTimeout() treats any timeout longer than 2^31 as zero. Documented                       //
      // behavior. Same across all browsers. Node.js has its own custom setTimeout() implementation                    //
      // and still does it. WHHHHYYYYYYYYYYY?                                                                          //
      //                                                                                                               //
      // So instead we cap the delay and we re-check the time in the callback.                                         //
      var delay = Math.min(1e9, parseInt(key.expires) * 1000 - Date.now());                                            // 310
      if (delay > 0) {                                                                                                 // 311
        keyRenewalTimeout = Meteor.setTimeout(scheduleRenewal, delay);                                                 // 312
        return;                                                                                                        // 313
      }                                                                                                                // 314
                                                                                                                       //
      // OK, ready to renew now. Do it.                                                                                //
                                                                                                                       //
      // Careful that flapping doesn't cause us to make concurrent calls.                                              //
      if (!currentlyRenewing) {                                                                                        // 319
        currentlyRenewing = true;                                                                                      // 320
        try {                                                                                                          // 321
          renewFeatureKey(db);                                                                                         // 322
        } finally {                                                                                                    // 323
          currentlyRenewing = false;                                                                                   // 324
        }                                                                                                              // 325
      }                                                                                                                // 326
    }                                                                                                                  // 327
                                                                                                                       //
    scheduleRenewal();                                                                                                 // 329
  });                                                                                                                  // 330
};                                                                                                                     // 331
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"grain-server.js":["babel-runtime/helpers/typeof","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       // 18
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 20
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 22
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 27
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 29
  check(grainId, String);                                                                                              // 30
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 32
    _id: grainId,                                                                                                      // 34
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 35
  }, {                                                                                                                 // 33
    fields: {                                                                                                          // 40
      title: 1,                                                                                                        // 41
      userId: 1,                                                                                                       // 42
      identityId: 1,                                                                                                   // 43
      "private": 1                                                                                                     // 44
    }                                                                                                                  // 40
  })];                                                                                                                 // 39
  if (this.userId) {                                                                                                   // 48
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 49
    result.push(ApiTokens.find({                                                                                       // 50
      grainId: grainId,                                                                                                // 51
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 52
    }));                                                                                                               // 50
  }                                                                                                                    // 57
                                                                                                                       //
  return result;                                                                                                       // 59
});                                                                                                                    // 60
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 66
  check(grainId, String);                                                                                              // 67
  var publishThis = [];                                                                                                // 68
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 71
    _id: grainId,                                                                                                      // 72
    userId: this.userId                                                                                                // 73
  }, {                                                                                                                 // 71
    fields: { packageId: 1 }                                                                                           // 75
  });                                                                                                                  // 74
  publishThis.push(thisGrainCursor);                                                                                   // 77
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 79
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 80
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 81
    publishThis.push(thisPackageCursor);                                                                               // 82
  }                                                                                                                    // 83
                                                                                                                       //
  return publishThis;                                                                                                  // 85
});                                                                                                                    // 86
                                                                                                                       //
Meteor.publish("tokenInfo", function (token, isStandalone) {                                                           // 88
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 92
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 94
  var apiToken = ApiTokens.findOne({                                                                                   // 95
    _id: hashedToken                                                                                                   // 96
  }, {                                                                                                                 // 95
    fields: {                                                                                                          // 98
      grainId: 1,                                                                                                      // 99
      identityId: 1,                                                                                                   // 100
      owner: 1,                                                                                                        // 101
      revoked: 1                                                                                                       // 102
    }                                                                                                                  // 98
  });                                                                                                                  // 97
  if (!apiToken) {                                                                                                     // 105
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 106
  } else if (apiToken.revoked) {                                                                                       // 107
    this.added("tokenInfo", token, { revoked: true });                                                                 // 108
  } else {                                                                                                             // 109
    var grainId = apiToken.grainId;                                                                                    // 110
    var grain = Grains.findOne({                                                                                       // 111
      _id: grainId                                                                                                     // 112
    }, {                                                                                                               // 111
      fields: {                                                                                                        // 114
        packageId: 1,                                                                                                  // 115
        appId: 1,                                                                                                      // 116
        userId: 1                                                                                                      // 117
      }                                                                                                                // 114
    });                                                                                                                // 113
    if (!grain) {                                                                                                      // 120
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 121
    } else {                                                                                                           // 122
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 123
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 124
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 125
        if (identity && metadata) {                                                                                    // 126
          SandstormDb.fillInLoginId(identity);                                                                         // 127
          this.added("tokenInfo", token, {                                                                             // 128
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 129
            grainId: grainId,                                                                                          // 130
            grainMetadata: metadata                                                                                    // 131
          });                                                                                                          // 128
        } else {                                                                                                       // 133
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 134
        }                                                                                                              // 135
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 136
        if (this.userId && !isStandalone) {                                                                            // 137
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 138
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 139
          var childToken = ApiTokens.findOne({                                                                         // 140
            "owner.user.identityId": { $in: identityIds },                                                             // 141
            parentToken: apiToken._id                                                                                  // 142
          });                                                                                                          // 140
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 144
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 146
            this.ready();                                                                                              // 147
            return;                                                                                                    // 148
          }                                                                                                            // 149
        }                                                                                                              // 150
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 152
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 153
        var appIcon = undefined;                                                                                       // 154
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 155
          var icons = pkg.manifest.metadata.icons;                                                                     // 156
          appIcon = icons.grain || icons.appGrid;                                                                      // 157
        }                                                                                                              // 158
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 160
          appTitle: appTitle,                                                                                          // 161
          icon: appIcon,                                                                                               // 162
          appId: appIcon ? undefined : grain.appId                                                                     // 163
        };                                                                                                             // 160
        this.added("tokenInfo", token, {                                                                               // 165
          webkey: true,                                                                                                // 166
          grainId: grainId,                                                                                            // 167
          grainMetadata: denormalizedGrainMetadata                                                                     // 168
        });                                                                                                            // 165
      } else {                                                                                                         // 170
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 171
      }                                                                                                                // 172
    }                                                                                                                  // 173
  }                                                                                                                    // 174
                                                                                                                       //
  this.ready();                                                                                                        // 176
  return;                                                                                                              // 177
});                                                                                                                    // 178
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 180
  check(grainId, String);                                                                                              // 181
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 183
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 184
  }                                                                                                                    // 185
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 187
  if (!grain) {                                                                                                        // 188
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 189
  }                                                                                                                    // 190
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 192
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 193
  }                                                                                                                    // 195
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 197
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 198
                                                                                                                       //
  var _this = this;                                                                                                    // 201
  var query = ApiTokens.find({                                                                                         // 202
    grainId: grainId,                                                                                                  // 203
    identityId: { $in: ownerIdentityIds },                                                                             // 204
    parentToken: { $exists: false },                                                                                   // 205
    "owner.user.identityId": { $in: identityIds },                                                                     // 206
    revoked: { $ne: true }                                                                                             // 207
  });                                                                                                                  // 202
  var handle = query.observe({                                                                                         // 209
    added: function added(apiToken) {                                                                                  // 210
      _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
    }                                                                                                                  // 213
  });                                                                                                                  // 209
                                                                                                                       //
  this.onStop(function () {                                                                                            // 216
    return handle.stop();                                                                                              // 216
  });                                                                                                                  // 216
});                                                                                                                    // 217
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 219
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 220
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 221
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 222
  globalDb.deleteGrains({ trashed: { $lt: trashExpiration } }, globalBackend, "grain");                                // 223
});                                                                                                                    // 224
                                                                                                                       //
Meteor.methods({                                                                                                       // 226
  updateGrainPreferredIdentity: function updateGrainPreferredIdentity(grainId, identityId) {                           // 227
    check(grainId, String);                                                                                            // 228
    check(identityId, String);                                                                                         // 229
    if (!this.userId) {                                                                                                // 230
      throw new Meteor.Error(403, "Must be logged in.");                                                               // 231
    }                                                                                                                  // 232
                                                                                                                       //
    var grain = globalDb.getGrain(grainId) || {};                                                                      // 234
    if (!grain.userId === this.userId) {                                                                               // 235
      throw new Meteor.Error(403, "Grain not owned by current user.");                                                 // 236
    }                                                                                                                  // 237
                                                                                                                       //
    Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                             // 239
  },                                                                                                                   // 240
                                                                                                                       //
  updateGrainTitle: function updateGrainTitle(grainId, newTitle, identityId) {                                         // 242
    check(grainId, String);                                                                                            // 243
    check(newTitle, String);                                                                                           // 244
    check(identityId, String);                                                                                         // 245
    if (this.userId) {                                                                                                 // 246
      var grain = Grains.findOne(grainId);                                                                             // 247
      if (grain) {                                                                                                     // 248
        if (grain.userId === this.userId) {                                                                            // 249
          Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                         // 250
                                                                                                                       //
          // Denormalize new title out to all sharing tokens.                                                          //
          ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
        } else {                                                                                                       // 256
          if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                    // 257
            throw new Meteor.Error(403, "Current user does not have identity " + identityId);                          // 258
          }                                                                                                            // 259
                                                                                                                       //
          var token = ApiTokens.findOne({                                                                              // 261
            grainId: grainId,                                                                                          // 262
            objectId: { $exists: false },                                                                              // 263
            "owner.user.identityId": identityId                                                                        // 264
          }, {                                                                                                         // 261
            sort: { created: 1 } });                                                                                   // 266
          // The oldest token is our source of truth for the name.                                                     //
          if (token && token.owner.user.title !== newTitle) {                                                          // 268
            if (token.owner.user.upstreamTitle === newTitle) {                                                         // 269
              // User renamed grain to match upstream title. Act like they never renamed it at                         //
              // all.                                                                                                  //
              ApiTokens.update({                                                                                       // 272
                grainId: grainId,                                                                                      // 273
                "owner.user.identityId": identityId                                                                    // 274
              }, {                                                                                                     // 272
                $set: { "owner.user.title": newTitle },                                                                // 276
                $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                     // 277
              }, {                                                                                                     // 275
                multi: true                                                                                            // 279
              });                                                                                                      // 278
            } else {                                                                                                   // 281
              var modification = {                                                                                     // 282
                "owner.user.title": newTitle,                                                                          // 283
                "owner.user.renamed": true                                                                             // 284
              };                                                                                                       // 282
                                                                                                                       //
              if (!token.owner.user.upstreamTitle) {                                                                   // 287
                // If `upstreamTitle` isn't present then it is equal to the old title.                                 //
                modification["owner.user.upstreamTitle"] = token.owner.user.title;                                     // 289
              }                                                                                                        // 290
                                                                                                                       //
              ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
            }                                                                                                          // 295
          }                                                                                                            // 296
        }                                                                                                              // 297
      }                                                                                                                // 298
    }                                                                                                                  // 299
  },                                                                                                                   // 300
                                                                                                                       //
  privatizeGrain: function privatizeGrain(grainId) {                                                                   // 302
    check(grainId, String);                                                                                            // 303
    if (this.userId) {                                                                                                 // 304
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                             // 305
    }                                                                                                                  // 306
  },                                                                                                                   // 307
                                                                                                                       //
  inviteUsersToGrain: function inviteUsersToGrain(_origin, identityId, grainId, title, roleAssignment, contacts, message) {
    var _this2 = this;                                                                                                 // 310
                                                                                                                       //
    if ((typeof message === "undefined" ? "undefined" : _typeof(message)) === "object") {                              // 311
      // Older versions of the client passed an object here, but we only care about the `text`                         //
      // parameter. (This block can eventually be removed.)                                                            //
      message = message.text;                                                                                          // 314
    }                                                                                                                  // 315
                                                                                                                       //
    if (!this.isSimulation) {                                                                                          // 317
      var _ret = function () {                                                                                         // 317
        check(_origin, String);                                                                                        // 318
        check(identityId, String);                                                                                     // 319
        check(grainId, String);                                                                                        // 320
        check(title, String);                                                                                          // 321
        check(roleAssignment, roleAssignmentPattern);                                                                  // 322
        check(contacts, [{                                                                                             // 323
          _id: String,                                                                                                 // 325
          isDefault: Match.Optional(Boolean),                                                                          // 326
          profile: Match.ObjectIncluding({                                                                             // 327
            service: String,                                                                                           // 328
            name: String,                                                                                              // 329
            intrinsicName: String                                                                                      // 330
          })                                                                                                           // 327
        }]);                                                                                                           // 324
        check(message, String);                                                                                        // 334
        if (!_this2.userId) {                                                                                          // 335
          throw new Meteor.Error(403, "Must be logged in to share by email.");                                         // 336
        }                                                                                                              // 337
                                                                                                                       //
        if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                    // 339
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 340
        }                                                                                                              // 341
                                                                                                                       //
        if (contacts.length === 0) {                                                                                   // 343
          throw new Meteor.Error(400, "No contacts were provided.");                                                   // 344
        }                                                                                                              // 345
                                                                                                                       //
        if (globalDb.isDemoUser()) {                                                                                   // 347
          throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                                // 348
        }                                                                                                              // 349
                                                                                                                       //
        var escapedMessage = message.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/\n/g, "<br>");
                                                                                                                       //
        var accountId = _this2.userId;                                                                                 // 357
        var outerResult = { successes: [], failures: [] };                                                             // 358
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 359
        var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                                 // 360
        contacts.forEach(function (contact) {                                                                          // 361
          if (contact.isDefault && contact.profile.service === "email") {                                              // 362
            var emailAddress = contact.profile.intrinsicName;                                                          // 363
            var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
            var url = ROOT_URL + "/shared/" + result.token;                                                            // 368
            var html = escapedMessage + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
            try {                                                                                                      // 374
              globalDb.incrementDailySentMailCount(accountId);                                                         // 375
              sendEmail({                                                                                              // 376
                to: emailAddress,                                                                                      // 377
                from: fromEmail,                                                                                       // 378
                replyTo: replyTo,                                                                                      // 379
                subject: title + " - Invitation to collaborate",                                                       // 380
                text: message + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                html: html                                                                                             // 384
              });                                                                                                      // 376
            } catch (e) {                                                                                              // 386
              outerResult.failures.push({ contact: contact, error: e.toString() });                                    // 387
            }                                                                                                          // 388
          } else {                                                                                                     // 389
            var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
            var _url = ROOT_URL + "/shared/" + _result.token;                                                          // 394
            try {                                                                                                      // 395
              var identity = Meteor.users.findOne({ _id: contact._id });                                               // 396
              var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                     // 397
              if (email) {                                                                                             // 399
                var intrinsicName = contact.profile.intrinsicName;                                                     // 400
                var loginNote = void 0;                                                                                // 401
                if (contact.profile.service === "google") {                                                            // 402
                  loginNote = "Google account with address " + email.email;                                            // 403
                } else if (contact.profile.service === "github") {                                                     // 404
                  loginNote = "Github account with username " + intrinsicName;                                         // 405
                } else if (contact.profile.service === "email") {                                                      // 406
                  loginNote = "email address " + intrinsicName;                                                        // 407
                } else if (contact.profile.service === "ldap") {                                                       // 408
                  loginNote = "LDAP username " + intrinsicName;                                                        // 409
                } else if (contact.profile.service === "saml") {                                                       // 410
                  loginNote = "SAML ID " + intrinsicName;                                                              // 411
                } else {                                                                                               // 412
                  throw new Meteor.Error(500, "Unknown service to email share link.");                                 // 413
                }                                                                                                      // 414
                                                                                                                       //
                var _html = escapedMessage + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                globalDb.incrementDailySentMailCount(accountId);                                                       // 421
                sendEmail({                                                                                            // 422
                  to: email.email,                                                                                     // 423
                  from: fromEmail,                                                                                     // 424
                  replyTo: replyTo,                                                                                    // 425
                  subject: title + " - Invitation to collaborate",                                                     // 426
                  text: message + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                  html: _html                                                                                          // 430
                });                                                                                                    // 422
              } else {                                                                                                 // 432
                outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 436
            } catch (e) {                                                                                              // 437
              outerResult.failures.push({ contact: contact, error: e.toString(),                                       // 438
                warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
            }                                                                                                          // 441
          }                                                                                                            // 442
        });                                                                                                            // 443
                                                                                                                       //
        return {                                                                                                       // 445
          v: outerResult                                                                                               // 445
        };                                                                                                             // 445
      }();                                                                                                             // 317
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 317
    }                                                                                                                  // 446
  },                                                                                                                   // 447
                                                                                                                       //
  requestAccess: function requestAccess(_origin, grainId, identityId) {                                                // 449
    check(_origin, String);                                                                                            // 450
    check(grainId, String);                                                                                            // 451
    check(identityId, String);                                                                                         // 452
    if (!this.isSimulation) {                                                                                          // 453
      if (!this.userId) {                                                                                              // 454
        throw new Meteor.Error(403, "Must be logged in to request access.");                                           // 455
      }                                                                                                                // 456
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 458
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 459
      }                                                                                                                // 460
                                                                                                                       //
      var grain = Grains.findOne(grainId);                                                                             // 462
      if (!grain) {                                                                                                    // 463
        throw new Meteor.Error(404, "No such grain");                                                                  // 464
      }                                                                                                                // 465
                                                                                                                       //
      var grainOwner = globalDb.getUser(grain.userId);                                                                 // 467
      var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                               // 468
      if (!email) {                                                                                                    // 469
        throw new Meteor.Error("no email", "Grain owner has no email address.");                                       // 470
      }                                                                                                                // 471
                                                                                                                       //
      var emailAddress = email.email;                                                                                  // 473
                                                                                                                       //
      var identity = globalDb.getIdentity(identityId);                                                                 // 475
      globalDb.addContact(grainOwner._id, identityId);                                                                 // 476
                                                                                                                       //
      var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                            // 478
      var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                             // 479
                                                                                                                       //
      // TODO(soon): In the HTML version, we should display an identity card.                                          //
      var identityNote = "";                                                                                           // 482
      if (identity.profile.service === "google") {                                                                     // 483
        identityNote = " (" + identity.privateIntrinsicName + ")";                                                     // 484
      } else if (identity.profile.service === "github") {                                                              // 485
        identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                          // 486
      } else if (identity.profile.service === "email") {                                                               // 487
        identityNote = " (" + identity.profile.intrinsicName + ")";                                                    // 488
      } else if (identity.profile.service === "ldap") {                                                                // 489
        identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                            // 490
      } else if (identity.profile.service === "saml") {                                                                // 491
        identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                            // 492
      }                                                                                                                // 493
                                                                                                                       //
      var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
      var url = ROOT_URL + "/share/" + grainId + "/" + identityId;                                                     // 498
                                                                                                                       //
      var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                            // 500
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 503
      var ACCESS_REQUEST_LIMIT = 10;                                                                                   // 504
      var resetCount = true;                                                                                           // 505
      if (user.accessRequests) {                                                                                       // 506
        if (user.accessRequests.resetOn < new Date()) {                                                                // 507
          Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                   // 508
        } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                                // 509
          throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
        } else {                                                                                                       // 513
          resetCount = false;                                                                                          // 514
        }                                                                                                              // 515
      }                                                                                                                // 516
                                                                                                                       //
      var modifier = { $inc: { "accessRequests.count": 1 } };                                                          // 518
      if (resetCount) {                                                                                                // 519
        var tomorrow = new Date(Date.now() + 86400000);                                                                // 520
        modifier.$set = { "accessRequests.resetOn": tomorrow };                                                        // 521
      }                                                                                                                // 522
                                                                                                                       //
      Meteor.users.update({ _id: user._id }, modifier);                                                                // 524
                                                                                                                       //
      sendEmail({                                                                                                      // 526
        to: emailAddress,                                                                                              // 527
        from: fromEmail,                                                                                               // 528
        replyTo: replyTo,                                                                                              // 529
        subject: grain.title + " - Request for access",                                                                // 530
        text: message + "\n\nFollow this link to share access:\n\n" + url,                                             // 531
        html: html                                                                                                     // 532
      });                                                                                                              // 526
    }                                                                                                                  // 534
  }                                                                                                                    // 535
});                                                                                                                    // 226
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var hashSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"hashSturdyRef":function(v){hashSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 34
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 36
HOSTNAME = ROOT_URL.hostname;                                                                                          // 37
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 39
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 40
    _classCallCheck(this, SessionContextImpl);                                                                         // 40
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 41
    this.sessionId = sessionId;                                                                                        // 42
    this.identityId = identityId;                                                                                      // 43
    this.tabId = tabId;                                                                                                // 44
  }                                                                                                                    // 45
                                                                                                                       //
  SessionContextImpl.prototype.claimRequest = function claimRequest(sturdyRef, requiredPermissions) {                  // 39
    var _this2 = this;                                                                                                 // 47
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 48
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 49
                                                                                                                       //
      var token = ApiTokens.findOne({                                                                                  // 51
        _id: hashedSturdyRef,                                                                                          // 52
        "owner.clientPowerboxRequest.grainId": _this2.grainId,                                                         // 53
        "owner.clientPowerboxRequest.sessionId": _this2.sessionId                                                      // 54
      });                                                                                                              // 51
                                                                                                                       //
      if (!token) {                                                                                                    // 57
        throw new Error("no such token");                                                                              // 58
      }                                                                                                                // 59
                                                                                                                       //
      var session = Sessions.findOne({ _id: _this2.sessionId });                                                       // 61
                                                                                                                       //
      if (!session) {                                                                                                  // 63
        throw new Error("no such session");                                                                            // 64
      }                                                                                                                // 65
                                                                                                                       //
      // Honor `requiredPermissions`.                                                                                  //
      var requirements = [];                                                                                           // 68
      if (session.hashedToken) {                                                                                       // 69
        // Session is authorized by token. Note that it's important to check this before identityId                    //
        // e.g. in the case of standalone domains.                                                                     //
        requirements.push({                                                                                            // 72
          permissionsHeld: {                                                                                           // 73
            permissions: requiredPermissions || [],                                                                    // 74
            tokenId: session.hashedToken,                                                                              // 75
            grainId: _this2.grainId                                                                                    // 76
          }                                                                                                            // 73
        });                                                                                                            // 72
      } else if (session.identityId) {                                                                                 // 79
        // Session is authorized by identity.                                                                          //
        requirements.push({                                                                                            // 81
          permissionsHeld: {                                                                                           // 82
            permissions: requiredPermissions || [],                                                                    // 83
            identityId: session.identityId,                                                                            // 84
            grainId: _this2.grainId                                                                                    // 85
          }                                                                                                            // 82
        });                                                                                                            // 81
      } else {                                                                                                         // 88
        // This can only happen with old-style sharing which has been deprecated for years. If                         //
        // we wanted to support this, I suppose we could do so as long as requiredPermissions is                       //
        // all-false? But probably this will never come up.                                                            //
        throw new Error("Cannot accept powerbox request from anonymous session that " + "doesn't have a token.");      // 92
      }                                                                                                                // 94
                                                                                                                       //
      return restoreInternal(globalDb, new Buffer(sturdyRef), { clientPowerboxRequest: Match.ObjectIncluding({ grainId: _this2.grainId }) }, requirements, token);
    });                                                                                                                // 101
  };                                                                                                                   // 102
                                                                                                                       //
  SessionContextImpl.prototype.offer = function offer(cap, requiredPermissions, descriptor, displayInfo) {             // 39
    var _this3 = this;                                                                                                 // 104
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 105
                                                                                                                       //
      var session = Sessions.findOne({ _id: _this3.sessionId });                                                       // 107
                                                                                                                       //
      if (!session.identityId && !session.hashedToken) {                                                               // 109
        throw new Error("Session has neither an identityId nor a hashedToken.");                                       // 110
      }                                                                                                                // 111
                                                                                                                       //
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 113
      var apiTokenOwner = { clientPowerboxOffer: { sessionId: _this3.sessionId } };                                    // 114
      var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
      if (isUiView) {                                                                                                  // 118
        var tagValue = {};                                                                                             // 119
        if (descriptor.tags[0].value) {                                                                                // 120
          tagValue = Capnp.parse(Grain.UiView.PowerboxTag, descriptor.tags[0].value);                                  // 121
        }                                                                                                              // 122
                                                                                                                       //
        if (!tagValue.title) {                                                                                         // 124
          // TODO(someday): We should arguably throw here, but the collections app currently                           //
          //   fails to provide a title.                                                                               //
          tagValue.title = "offer()ed grain had no title";                                                             // 127
        }                                                                                                              // 128
                                                                                                                       //
        if (session.identityId) {                                                                                      // 130
          apiTokenOwner = {                                                                                            // 131
            user: {                                                                                                    // 132
              identityId: _this3.identityId,                                                                           // 133
              title: tagValue.title                                                                                    // 134
            }                                                                                                          // 132
          };                                                                                                           // 131
        }                                                                                                              // 137
      }                                                                                                                // 138
                                                                                                                       //
      // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                          //
      // are fully implemented for supervisors.                                                                        //
      var permissionsHeld = {                                                                                          // 142
        grainId: _this3.grainId,                                                                                       // 143
        permissions: requiredPermissions                                                                               // 144
      };                                                                                                               // 142
                                                                                                                       //
      // Note that if both hashedToken and identityId are present, this indicates that the session                     //
      // is authorized by a token which the user has NOT redeemed. Thus the identity does not                          //
      // directly have access to the grain; the token does. (This is the case in particular for                        //
      // standalone domains.) So clearly we want our requirement to be based on the token, not the                     //
      // identity.                                                                                                     //
      if (session.hashedToken) {                                                                                       // 152
        permissionsHeld.tokenId = session.hashedToken;                                                                 // 153
      } else if (session.identityId) {                                                                                 // 154
        permissionsHeld.identityId = session.identityId;                                                               // 155
      } else {                                                                                                         // 156
        throw new Error("Cannot offer to anonymous session that does not have a token.");                              // 157
      }                                                                                                                // 158
                                                                                                                       //
      var requirement = { permissionsHeld: permissionsHeld };                                                          // 160
                                                                                                                       //
      checkRequirements(globalDb, [requirement]);                                                                      // 162
                                                                                                                       //
      var save = castedCap.save(apiTokenOwner);                                                                        // 164
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 165
      ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                   // 166
                                                                                                                       //
      var powerboxView = void 0;                                                                                       // 168
      if (isUiView) {                                                                                                  // 169
        if (session.identityId) {                                                                                      // 170
          // Deduplicate.                                                                                              //
          var tokenId = hashSturdyRef(sturdyRef.toString());                                                           // 172
          var newApiToken = ApiTokens.findOne({ _id: tokenId });                                                       // 173
          var dupeQuery = _.pick(newApiToken, "grainId", "roleAssignment", "requirements", "parentToken", "identityId", "accountId");
          dupeQuery._id = { $ne: newApiToken._id };                                                                    // 176
          dupeQuery["owner.user.identityId"] = _this3.identityId;                                                      // 177
          dupeQuery.trashed = { $exists: false };                                                                      // 178
          dupeQuery.revoked = { $exists: false };                                                                      // 179
                                                                                                                       //
          var dupeToken = ApiTokens.findOne(dupeQuery);                                                                // 181
          if (dupeToken) {                                                                                             // 182
            globalDb.removeApiTokens({ _id: tokenId });                                                                // 183
            tokenId = dupeToken._id;                                                                                   // 184
          }                                                                                                            // 185
                                                                                                                       //
          powerboxView = { offer: { uiView: { tokenId: tokenId } } };                                                  // 187
        } else {                                                                                                       // 188
          powerboxView = { offer: { uiView: { token: sturdyRef.toString() } } };                                       // 189
        }                                                                                                              // 190
      } else {                                                                                                         // 191
        powerboxView = {                                                                                               // 192
          offer: {                                                                                                     // 193
            token: sturdyRef.toString()                                                                                // 194
          }                                                                                                            // 193
        };                                                                                                             // 192
      }                                                                                                                // 197
                                                                                                                       //
      Sessions.update({ _id: _this3.sessionId }, {                                                                     // 199
        $set: {                                                                                                        // 201
          powerboxView: powerboxView                                                                                   // 202
        }                                                                                                              // 201
      });                                                                                                              // 200
    });                                                                                                                // 206
  };                                                                                                                   // 207
                                                                                                                       //
  SessionContextImpl.prototype.activity = function activity(event) {                                                   // 39
    var _this4 = this;                                                                                                 // 209
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 210
      logActivity(_this4.grainId, _this4.identityId || "anonymous", event);                                            // 211
    });                                                                                                                // 212
  };                                                                                                                   // 213
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 39
}();                                                                                                                   // 39
                                                                                                                       //
Meteor.methods({                                                                                                       // 216
  finishPowerboxRequest: function finishPowerboxRequest(sessionId, webkeyUrl, saveLabel, identityId, grainId) {        // 217
    check(sessionId, String);                                                                                          // 218
    check(webkeyUrl, String);                                                                                          // 219
    check(saveLabel, Match.OneOf(undefined, null, String));                                                            // 220
    check(identityId, String);                                                                                         // 221
    check(grainId, String);                                                                                            // 222
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 224
                                                                                                                       //
    var userId = Meteor.userId();                                                                                      // 226
    if (!userId || !db.userHasIdentity(userId, identityId)) {                                                          // 227
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 228
    }                                                                                                                  // 229
                                                                                                                       //
    var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                    // 231
    var hostId = matchWildcardHost(parsedWebkey.host);                                                                 // 232
    if (!hostId || !db.isApiHostId(hostId)) {                                                                          // 233
      throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
    }                                                                                                                  // 236
                                                                                                                       //
    var token = parsedWebkey.hash;                                                                                     // 238
    if (!token) {                                                                                                      // 239
      throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
    }                                                                                                                  // 242
                                                                                                                       //
    token = token.slice(1);                                                                                            // 244
    if (db.isTokenSpecificHostId(hostId) && hostId !== db.apiHostIdForToken(token)) {                                  // 245
      // Note: This case is not security-sensitive. The client could easily compute the correct                        //
      //   host ID for this token. But since they've passed one that doesn't match, we assume                          //
      //   something is wrong and stop here.                                                                           //
      throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                    // 249
    }                                                                                                                  // 250
                                                                                                                       //
    var cap = restoreInternal(db, new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;   // 252
    var castedCap = cap.castAs(SystemPersistent);                                                                      // 254
    var owner = {                                                                                                      // 255
      clientPowerboxRequest: {                                                                                         // 256
        grainId: grainId,                                                                                              // 257
        introducerIdentity: identityId,                                                                                // 258
        sessionId: sessionId                                                                                           // 259
      }                                                                                                                // 256
    };                                                                                                                 // 255
    if (saveLabel) {                                                                                                   // 262
      grainOwner.saveLabel = {                                                                                         // 263
        defaultText: saveLabel                                                                                         // 264
      };                                                                                                               // 263
    }                                                                                                                  // 266
                                                                                                                       //
    var save = castedCap.save(owner);                                                                                  // 268
    var sturdyRef = waitPromise(save).sturdyRef;                                                                       // 269
    return sturdyRef.toString();                                                                                       // 270
  },                                                                                                                   // 271
  finishPowerboxOffer: function finishPowerboxOffer(sessionId) {                                                       // 273
    check(sessionId, String);                                                                                          // 274
                                                                                                                       //
    Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                           // 276
  },                                                                                                                   // 277
  getViewInfoForApiToken: function getViewInfoForApiToken(apiTokenId) {                                                // 279
    check(apiTokenId, String);                                                                                         // 280
    var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                    // 281
    if (!token) {                                                                                                      // 282
      throw new Meteor.Error(400, "No such token.");                                                                   // 283
    }                                                                                                                  // 284
                                                                                                                       //
    var grain = globalDb.collections.grains.findOne(token.grainId);                                                    // 286
    if (!grain) {                                                                                                      // 287
      throw new Meteor.Error(500, "No grain found for token.");                                                        // 288
    }                                                                                                                  // 289
                                                                                                                       //
    return grain.cachedViewInfo;                                                                                       // 291
  }                                                                                                                    // 292
});                                                                                                                    // 216
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 295
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 295
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 296
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 296
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 296
  }                                                                                                                    // 298
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function _getPublicId() {                                            // 295
    // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                      //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    while (!this.publicId) {                                                                                           // 305
      // We haven't looked up the public ID yet.                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                           // 307
      if (!grain) throw new Error("Grain does not exist.");                                                            // 308
                                                                                                                       //
      if (grain.publicId) {                                                                                            // 310
        this.publicId = grain.publicId;                                                                                // 311
      } else {                                                                                                         // 312
        // The grain doesn't have a public ID yet. Generate one.                                                       //
        var candidate = generateRandomHostname(20);                                                                    // 314
                                                                                                                       //
        if (Grains.findOne({ publicId: candidate })) {                                                                 // 316
          // This should never ever happen.                                                                            //
          console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");     // 318
          continue;                                                                                                    // 320
        }                                                                                                              // 321
                                                                                                                       //
        // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                    //
        // simultaneously.                                                                                             //
        if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
          // We won the race.                                                                                          //
          this.publicId = candidate;                                                                                   // 328
        }                                                                                                              // 329
      }                                                                                                                // 330
    }                                                                                                                  // 331
                                                                                                                       //
    return this.publicId;                                                                                              // 333
  };                                                                                                                   // 334
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function _getAddress() {                                              // 295
    // Get the grain's outgoing e-mail address.                                                                        //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    return this._getPublicId() + "@" + HOSTNAME;                                                                       // 341
  };                                                                                                                   // 342
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function _getUserAddress() {                                      // 295
    // Get the user's e-mail address.                                                                                  //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                           // 349
                                                                                                                       //
    var identity = globalDb.getIdentity(grain.identityId);                                                             // 351
                                                                                                                       //
    var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                        // 353
    var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                        // 354
                                                                                                                       //
    var result = {};                                                                                                   // 356
    if (email) {                                                                                                       // 357
      result.address = email;                                                                                          // 358
    }                                                                                                                  // 359
                                                                                                                       //
    if (identity.profile.name) {                                                                                       // 361
      result.name = identity.profile.name;                                                                             // 362
    }                                                                                                                  // 363
                                                                                                                       //
    return result;                                                                                                     // 365
  };                                                                                                                   // 366
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function send(email) {                                                       // 295
    return hackSendEmail(this, email);                                                                                 // 369
  };                                                                                                                   // 370
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function getPublicId() {                                              // 295
    return inMeteor(function () {                                                                                      // 373
      var result = {};                                                                                                 // 374
                                                                                                                       //
      result.publicId = this._getPublicId();                                                                           // 376
      result.hostname = HOSTNAME;                                                                                      // 377
      result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                   // 378
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                             // 380
      result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                   // 381
                                                                                                                       //
      return result;                                                                                                   // 383
    }.bind(this));                                                                                                     // 384
  };                                                                                                                   // 385
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function httpGet(url) {                                                   // 295
    var _this = this;                                                                                                  // 388
    var session = _this;                                                                                               // 389
                                                                                                                       //
    return new Promise(function (resolve, reject) {                                                                    // 391
      var requestMethod = Http.request;                                                                                // 392
      if (url.indexOf("https://") === 0) {                                                                             // 393
        requestMethod = Https.request;                                                                                 // 394
      } else if (url.indexOf("http://") !== 0) {                                                                       // 395
        err = new Error("Protocol not recognized.");                                                                   // 396
        err.nature = "precondition";                                                                                   // 397
        reject(err);                                                                                                   // 398
      }                                                                                                                // 399
                                                                                                                       //
      req = requestMethod(url, function (resp) {                                                                       // 401
        var buffers = [];                                                                                              // 402
        var err = void 0;                                                                                              // 403
                                                                                                                       //
        switch (Math.floor(resp.statusCode / 100)) {                                                                   // 405
          case 2:                                                                                                      // 406
            // 2xx response -- OK.                                                                                     //
            resp.on("data", function (buf) {                                                                           // 407
              buffers.push(buf);                                                                                       // 408
            });                                                                                                        // 409
                                                                                                                       //
            resp.on("end", function () {                                                                               // 411
              resolve({                                                                                                // 412
                content: Buffer.concat(buffers),                                                                       // 413
                mimeType: resp.headers["content-type"] || null                                                         // 414
              });                                                                                                      // 412
            });                                                                                                        // 416
            break;                                                                                                     // 417
          case 3:                                                                                                      // 418
            // 3xx response -- redirect.                                                                               //
            resolve(session.httpGet(resp.headers.location));                                                           // 419
            break;                                                                                                     // 420
          case 4:                                                                                                      // 421
            // 4xx response -- client error.                                                                           //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 422
            err.nature = "precondition";                                                                               // 423
            reject(err);                                                                                               // 424
            break;                                                                                                     // 425
          case 5:                                                                                                      // 426
            // 5xx response -- internal server error.                                                                  //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 427
            err.nature = "localBug";                                                                                   // 428
            reject(err);                                                                                               // 429
            break;                                                                                                     // 430
          default:                                                                                                     // 431
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 432
            err.nature = "localBug";                                                                                   // 433
            reject(err);                                                                                               // 434
            break;                                                                                                     // 435
        }                                                                                                              // 405
      });                                                                                                              // 437
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 439
        e.nature = "networkFailure";                                                                                   // 440
        reject(e);                                                                                                     // 441
      });                                                                                                              // 442
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 444
        req.abort();                                                                                                   // 445
        err = new Error("Request timed out.");                                                                         // 446
        err.nature = "localBug";                                                                                       // 447
        err.durability = "overloaded";                                                                                 // 448
        reject(err);                                                                                                   // 449
      });                                                                                                              // 450
                                                                                                                       //
      req.end();                                                                                                       // 452
    });                                                                                                                // 453
  };                                                                                                                   // 454
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function getUserAddress() {                                        // 295
    return inMeteor(function () {                                                                                      // 457
      return this._getUserAddress();                                                                                   // 458
    }.bind(this));                                                                                                     // 459
  };                                                                                                                   // 460
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function obsoleteGenerateApiToken(petname, userInfo, expires) {
    throw new Error("generateApiToken() has been removed. Use offer templates instead.");                              // 463
  };                                                                                                                   // 464
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function obsoleteListApiTokens() {                          // 295
    throw new Error("listApiTokens() has been removed. Use offer templates instead.");                                 // 467
  };                                                                                                                   // 468
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function obsoleteRevokeApiToken(tokenId) {                 // 295
    throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                                // 471
  };                                                                                                                   // 472
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function getUiViewForEndpoint(url) {                         // 295
    var parsedUrl = Url.parse(url);                                                                                    // 475
                                                                                                                       //
    if (parsedUrl.hash) {                                                                                              // 477
      // Assume that anything with a fragment is a webkey                                                              //
      if (parsedUrl.pathname && parsedUrl.pathname !== "/") {                                                          // 478
        throw new Error("Webkey urls cannot contain a path.");                                                         // 479
      }                                                                                                                // 480
                                                                                                                       //
      var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                         // 482
      var hostId = matchWildcardHost(parsedUrl.host);                                                                  // 483
      // Connecting to a remote server with a bearer token.                                                            //
      // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                             //
      return { view: new ExternalUiView(url, this.grainId, token) };                                                   // 486
    } else {                                                                                                           // 487
      return { view: new ExternalUiView(url, this.grainId) };                                                          // 488
    }                                                                                                                  // 489
  };                                                                                                                   // 490
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 295
}(SessionContextImpl);                                                                                                 // 295
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 493
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 494
};                                                                                                                     // 496
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 498
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 500
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 503
  for (var i = 0; i < length; i++) {                                                                                   // 504
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 505
  }                                                                                                                    // 506
                                                                                                                       //
  return digits.join("");                                                                                              // 508
};                                                                                                                     // 509
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"identity.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js","/imports/server/static-asset.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/identity.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var StaticAssetImpl,IdenticonStaticAssetImpl;module.import("/imports/server/static-asset.js",{"StaticAssetImpl":function(v){StaticAssetImpl=v},"IdenticonStaticAssetImpl":function(v){IdenticonStaticAssetImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var IdentityRpc = Capnp.importSystem("sandstorm/identity-impl.capnp");                                                 // 18
var Identity = Capnp.importSystem("sandstorm/identity.capnp").Identity;                                                // 19
                                                                                                                       // 20
                                                                                                                       // 21
var StaticAsset = Capnp.importSystem("sandstorm/util.capnp").StaticAsset;                                              // 22
                                                                                                                       //
var IdentityImpl = function (_PersistentImpl) {                                                                        //
  _inherits(IdentityImpl, _PersistentImpl);                                                                            //
                                                                                                                       //
  function IdentityImpl(db, saveTemplate, identityId) {                                                                // 25
    _classCallCheck(this, IdentityImpl);                                                                               // 25
                                                                                                                       //
    var _this = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                        // 25
                                                                                                                       //
    _this.identityId = identityId;                                                                                     // 27
    _this.db = db;                                                                                                     // 28
    return _this;                                                                                                      // 25
  }                                                                                                                    // 29
                                                                                                                       //
  IdentityImpl.prototype.getProfile = function getProfile() {                                                          //
    var identity = this.db.getIdentity(this.identityId);                                                               // 32
                                                                                                                       //
    var profile = {                                                                                                    // 34
      displayName: { defaultText: identity.profile.name },                                                             // 35
      preferredHandle: identity.profile.handle,                                                                        // 36
      pronouns: identity.profile.pronoun                                                                               // 37
    };                                                                                                                 // 34
                                                                                                                       //
    if (identity.profile.picture) {                                                                                    // 40
      profile.picture = new Capnp.Capability(new StaticAssetImpl(identity.profile.picture), StaticAsset);              // 41
    } else {                                                                                                           // 43
      var hash = this.identityId.slice(0, 32);                                                                         // 44
      profile.picture = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);                     // 45
    }                                                                                                                  // 47
                                                                                                                       //
    return { profile: profile };                                                                                       // 49
  };                                                                                                                   // 50
                                                                                                                       //
  return IdentityImpl;                                                                                                 //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 51
                                                                                                                       //
// TODO(cleanup): Find a better home for this.                                                                         //
var MembraneRequirement = Match.OneOf({ tokenValid: String }, { permissionsHeld: { identityId: String, grainId: String, permissions: Match.Optional([Boolean]) } }, { permissionsHeld: { tokenId: String, grainId: String, permissions: Match.Optional([Boolean]) } }, { userIsAdmin: String });
                                                                                                                       //
makeIdentity = function makeIdentity(identityId, requirements) {                                                       // 62
  var saveTemplate = { frontendRef: { identity: identityId } };                                                        // 63
  if (requirements) {                                                                                                  // 64
    check(requirements, [MembraneRequirement]);                                                                        // 65
    saveTemplate.requirements = requirements;                                                                          // 66
  }                                                                                                                    // 67
                                                                                                                       //
  return new Capnp.Capability(new IdentityImpl(globalDb, saveTemplate, identityId), IdentityRpc.PersistentIdentity);   // 69
};                                                                                                                     // 71
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 73
  frontendRefField: "identity",                                                                                        // 74
  typeId: Identity.typeId,                                                                                             // 75
                                                                                                                       //
  restore: function restore(db, saveTemplate, identityId) {                                                            // 77
    return new Capnp.Capability(new IdentityImpl(db, saveTemplate, identityId), IdentityRpc.PersistentIdentity);       // 78
  },                                                                                                                   // 80
  validate: function validate(db, session, value) {                                                                    // 82
    check(value, { id: String, roleAssignment: SandstormDb.prototype.roleAssignmentPattern });                         // 83
                                                                                                                       //
    if (!session.userId) {                                                                                             // 85
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 86
    }                                                                                                                  // 87
                                                                                                                       //
    var grain = db.getGrain(session.grainId);                                                                          // 89
    SandstormPermissions.createNewApiToken(db, { identityId: session.identityId,                                       // 90
      accountId: session.userId                                                                                        // 93
    }, session.grainId, "petname", value.roleAssignment, { user: { identityId: value.id, title: grain.title } });      // 92
                                                                                                                       //
    // TODO(soon): Somehow notify this user that they now have access.                                                 //
                                                                                                                       //
    // TODO(perf): This permissions computation happens once here and then once again when the                         //
    //   `permissionsHeld` requirement is checked. Is there a way to avoid the duplicated work?                        //
    var permissions = SandstormPermissions.grainPermissions(db, { grain: { _id: session.grainId, identityId: value.id } }, session.viewInfo || {}).permissions;
                                                                                                                       //
    return {                                                                                                           // 108
      descriptor: {                                                                                                    // 109
        tags: [{                                                                                                       // 110
          id: Identity.typeId,                                                                                         // 112
          value: Capnp.serialize(Identity.PowerboxTag, {                                                               // 113
            permissions: permissions                                                                                   // 116
          })                                                                                                           // 115
        }]                                                                                                             // 111
      },                                                                                                               // 109
      requirements: [{                                                                                                 // 121
        permissionsHeld: {                                                                                             // 123
          identityId: value.id,                                                                                        // 124
          grainId: session.grainId,                                                                                    // 125
          permissions: []                                                                                              // 126
        }                                                                                                              // 123
      }],                                                                                                              // 122
      frontendRef: value.id                                                                                            // 130
    };                                                                                                                 // 108
  },                                                                                                                   // 132
  query: function query(db, userId, value) {                                                                           // 134
    var result = [];                                                                                                   // 135
    var requestedPermissions = [];                                                                                     // 136
    if (value) {                                                                                                       // 137
      requestedPermissions = Capnp.parse(Identity.PowerboxTag, value).permissions || [];                               // 138
    }                                                                                                                  // 139
                                                                                                                       //
    db.collections.contacts.find({ ownerId: userId }).forEach(function (contact) {                                     // 141
      var identity = db.getIdentity(contact.identityId);                                                               // 142
      if (identity) {                                                                                                  // 143
        result.push({                                                                                                  // 144
          _id: "frontendref-identity-" + contact.identityId,                                                           // 145
          frontendRef: { identity: contact.identityId },                                                               // 146
          cardTemplate: "identityPowerboxCard",                                                                        // 147
          configureTemplate: "identityPowerboxConfiguration",                                                          // 148
          profile: identity.profile,                                                                                   // 149
          requestedPermissions: requestedPermissions,                                                                  // 150
          searchTerms: [identity.profile.name, identity.profile.handle, identity.profile.intrinsicName]                // 151
        });                                                                                                            // 144
      }                                                                                                                // 157
    });                                                                                                                // 158
                                                                                                                       //
    return result;                                                                                                     // 160
  }                                                                                                                    // 161
});                                                                                                                    // 73
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":["/imports/demo.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});var promiseToFuture;module.import("/imports/server/async-helpers.js",{"promiseToFuture":function(v){promiseToFuture=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 20
  defaultText: String,                                                                                                 // 21
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 22
};                                                                                                                     // 20
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 25
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 30
  cancelDownload: function (_cancelDownload) {                                                                         // 31
    function cancelDownload(_x) {                                                                                      // 31
      return _cancelDownload.apply(this, arguments);                                                                   // 31
    }                                                                                                                  // 31
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 31
      return _cancelDownload.toString();                                                                               // 31
    };                                                                                                                 // 31
                                                                                                                       //
    return cancelDownload;                                                                                             // 31
  }(function (packageId) {                                                                                             // 31
    check(packageId, String);                                                                                          // 32
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 35
  }),                                                                                                                  // 36
                                                                                                                       //
  newUploadToken: function newUploadToken() {                                                                          // 38
    if (!isSignedUp()) {                                                                                               // 39
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                              // 40
    }                                                                                                                  // 41
                                                                                                                       //
    if (globalDb.isUninvitedFreeUser()) {                                                                              // 43
      throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                                 // 44
    }                                                                                                                  // 45
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 47
    uploadTokens[token] = setTimeout(function () {                                                                     // 48
      delete uploadTokens[token];                                                                                      // 49
    }, 20 * 60 * 1000);                                                                                                // 50
                                                                                                                       //
    return token;                                                                                                      // 52
  },                                                                                                                   // 53
                                                                                                                       //
  upgradeGrains: function upgradeGrains(appId, version, packageId) {                                                   // 55
    this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                               // 56
  },                                                                                                                   // 57
                                                                                                                       //
  ensureInstalled: function ensureInstalled(packageId, url, isRetry) {                                                 // 59
    check(packageId, String);                                                                                          // 60
    check(url, Match.OneOf(String, undefined, null));                                                                  // 61
    check(isRetry, Boolean);                                                                                           // 62
                                                                                                                       //
    if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                          // 64
      throw new Meteor.Error(400, "The package ID contains illegal characters.");                                      // 65
    }                                                                                                                  // 66
                                                                                                                       //
    if (!this.userId) {                                                                                                // 68
      if (allowDemo && isSafeDemoAppUrl(url)) {                                                                        // 69
        // continue on                                                                                                 //
      } else {                                                                                                         // 71
          // jscs:ignore disallowEmptyBlocks                                                                           //
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 72
        }                                                                                                              // 73
    } else if (!isSignedUp() && !isDemoUser()) {                                                                       // 74
      throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");      // 75
    } else if (isUserOverQuota(Meteor.user())) {                                                                       // 77
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 78
    }                                                                                                                  // 80
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 82
                                                                                                                       //
    if (!pkg || pkg.status !== "ready") {                                                                              // 84
      if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                            // 85
        if (!isSafeDemoAppUrl(url)) {                                                                                  // 86
          // TODO(someday): Billing prompt on client side.                                                             //
          throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
        }                                                                                                              // 90
      }                                                                                                                // 91
    }                                                                                                                  // 92
                                                                                                                       //
    if (!pkg || isRetry) {                                                                                             // 94
      globalDb.startInstall(packageId, url, isRetry);                                                                  // 95
    }                                                                                                                  // 96
  }                                                                                                                    // 97
});                                                                                                                    // 30
                                                                                                                       //
Meteor.publish("packageInfo", function (packageId) {                                                                   // 100
  check(packageId, String);                                                                                            // 101
  var db = this.connection.sandstormDb;                                                                                // 102
  var pkgCursor = db.collections.packages.find(packageId);                                                             // 103
  var pkg = pkgCursor.fetch()[0];                                                                                      // 104
  if (pkg && this.userId) {                                                                                            // 105
    return [pkgCursor, db.collections.userActions.find({ userId: this.userId, appId: pkg.appId }), db.collections.grains.find({ userId: this.userId, appId: pkg.appId })];
  } else {                                                                                                             // 111
    return pkgCursor;                                                                                                  // 112
  }                                                                                                                    // 113
});                                                                                                                    // 114
                                                                                                                       //
Router.map(function () {                                                                                               // 116
  this.route("upload", {                                                                                               // 117
    where: "server",                                                                                                   // 118
    path: "/upload/:token",                                                                                            // 119
                                                                                                                       //
    action: function action() {                                                                                        // 121
      if (!this.params.token || !uploadTokens[this.params.token]) {                                                    // 122
        this.response.writeHead(403, {                                                                                 // 123
          "Content-Type": "text/plain"                                                                                 // 124
        });                                                                                                            // 123
        this.response.write("Invalid upload token.");                                                                  // 126
        this.response.end();                                                                                           // 127
      } else if (this.request.method === "POST") {                                                                     // 128
        try {                                                                                                          // 129
          var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                        // 130
          this.response.writeHead(200, {                                                                               // 131
            "Content-Length": packageId.length,                                                                        // 132
            "Content-Type": "text/plain"                                                                               // 133
          });                                                                                                          // 131
          this.response.write(packageId);                                                                              // 135
          this.response.end();                                                                                         // 136
          clearTimeout(uploadTokens[this.params.token]);                                                               // 137
          delete uploadTokens[this.params.token];                                                                      // 138
        } catch (error) {                                                                                              // 139
          console.error(error.stack);                                                                                  // 140
          this.response.writeHead(500, {                                                                               // 141
            "Content-Type": "text/plain"                                                                               // 142
          });                                                                                                          // 141
          this.response.write("Unpacking SPK failed; is it valid?");                                                   // 144
          this.response.end();                                                                                         // 145
        };                                                                                                             // 146
      } else {                                                                                                         // 147
        this.response.writeHead(405, {                                                                                 // 148
          "Content-Type": "text/plain"                                                                                 // 149
        });                                                                                                            // 148
        this.response.write("You can only POST here.");                                                                // 151
        this.response.end();                                                                                           // 152
      }                                                                                                                // 153
    }                                                                                                                  // 154
  });                                                                                                                  // 117
});                                                                                                                    // 156
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 28
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 30
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 32
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 39
  if (Meteor.settings.replicaNumber) {                                                                                 // 40
    throw new Error("This can only be called on the main front-end replica.");                                         // 41
  }                                                                                                                    // 42
};                                                                                                                     // 43
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 45
  verifyIsMainReplica();                                                                                               // 46
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 48
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 50
    return;                                                                                                            // 51
  }                                                                                                                    // 52
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 54
                                                                                                                       //
  try {                                                                                                                // 56
    var action = UserActions.findOne({ packageId: packageId });                                                        // 57
    var grain = Grains.findOne({ packageId: packageId });                                                              // 58
    var notificationQuery = {};                                                                                        // 59
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 60
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery)) && !globalDb.getAppIdForPreinstalledPackage(packageId)) {
      Packages.update({                                                                                                // 63
        _id: packageId                                                                                                 // 64
      }, {                                                                                                             // 63
        $set: { status: "delete" },                                                                                    // 66
        $unset: { shouldCleanup: "" }                                                                                  // 67
      });                                                                                                              // 65
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 69
      Packages.remove(packageId);                                                                                      // 70
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 73
        globalDb.unrefStaticAsset(assetId);                                                                            // 74
      });                                                                                                              // 75
    } else {                                                                                                           // 76
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 77
    }                                                                                                                  // 78
                                                                                                                       //
    delete installers[packageId];                                                                                      // 80
  } catch (error) {                                                                                                    // 81
    delete installers[packageId];                                                                                      // 82
    throw error;                                                                                                       // 83
  }                                                                                                                    // 84
};                                                                                                                     // 85
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 87
  verifyIsMainReplica();                                                                                               // 88
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 90
    return;                                                                                                            // 91
  }                                                                                                                    // 92
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 94
  installers[pkg._id] = installer;                                                                                     // 95
  installer.start();                                                                                                   // 96
};                                                                                                                     // 97
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 99
  Packages.remove({ _id: packageId, status: "download" });                                                             // 100
};                                                                                                                     // 101
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 103
  verifyIsMainReplica();                                                                                               // 104
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 106
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 109
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 111
      throw new Error("Canceled");                                                                                     // 112
    })();                                                                                                              // 113
  }                                                                                                                    // 114
};                                                                                                                     // 115
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 117
  installers = {};                                                                                                     // 118
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 120
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 122
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 125
      added: startInstallInternal,                                                                                     // 126
      removed: cancelDownloadInternal                                                                                  // 127
    });                                                                                                                // 125
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 131
      added: deletePackageInternal                                                                                     // 132
    });                                                                                                                // 131
  });                                                                                                                  // 134
}                                                                                                                      // 135
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 137
  return new Promise(function (resolve, reject) {                                                                      // 138
    var id = Random.id();                                                                                              // 139
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 141
    var hasher = Crypto.createHash("sha256");                                                                          // 142
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 144
      try {                                                                                                            // 145
        hasher.update(chunk);                                                                                          // 146
        backendStream.write(chunk);                                                                                    // 147
      } catch (err) {                                                                                                  // 148
        reject(err);                                                                                                   // 149
      }                                                                                                                // 150
    });                                                                                                                // 151
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 153
      try {                                                                                                            // 154
        (function () {                                                                                                 // 154
          backendStream.done();                                                                                        // 155
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 156
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 157
            return packageId;                                                                                          // 158
          }));                                                                                                         // 159
          backendStream.close();                                                                                       // 160
        })();                                                                                                          // 154
      } catch (err) {                                                                                                  // 161
        reject(err);                                                                                                   // 162
      }                                                                                                                // 163
    });                                                                                                                // 164
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 166
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 168
        backendStream.close();                                                                                         // 169
        reject(err);                                                                                                   // 170
      } catch (err2) {                                                                                                 // 171
        reject(err2);                                                                                                  // 172
      }                                                                                                                // 173
    });                                                                                                                // 174
  });                                                                                                                  // 175
};                                                                                                                     // 176
                                                                                                                       //
AppInstaller = function () {                                                                                           // 178
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 179
    _classCallCheck(this, AppInstaller);                                                                               // 179
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 180
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 182
    this.url = url;                                                                                                    // 183
    this.failed = false;                                                                                               // 184
    this.appId = appId;                                                                                                // 185
    this.isAutoUpdated = isAutoUpdated;                                                                                // 186
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 189
  }                                                                                                                    // 190
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function updateProgress(status, progress, error, manifest) {                 // 178
    // TODO(security):  On error, we should actually delete the package from the database and only                     //
    //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                       //
    //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                          //
    //   already-downloading package but specifies a different URL, we really should initiate an                       //
    //   entirely separate download...  but cancel it if the first download succeeds.)                                 //
                                                                                                                       //
    this.status = status;                                                                                              // 199
    this.progress = progress || -1;                                                                                    // 200
    this.error = error;                                                                                                // 201
    this.manifest = manifest || null;                                                                                  // 202
                                                                                                                       //
    var _this = this;                                                                                                  // 204
                                                                                                                       //
    // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                     //
    // occur in exactly the order in which we generate them, so we use a promise chain to serialize                    //
    // them.                                                                                                           //
    this.writeChain = this.writeChain.then(function () {                                                               // 209
      return inMeteor(function () {                                                                                    // 210
        if (manifest) extractManifestAssets(manifest);                                                                 // 211
                                                                                                                       //
        Packages.update(_this.packageId, {                                                                             // 213
          $set: {                                                                                                      // 214
            status: _this.status,                                                                                      // 215
            progress: _this.progress,                                                                                  // 216
            error: _this.error ? _this.error.message : null,                                                           // 217
            manifest: _this.manifest,                                                                                  // 218
            appId: _this.appId,                                                                                        // 219
            authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                     // 220
          }                                                                                                            // 214
        });                                                                                                            // 213
                                                                                                                       //
        if (_this.authorPgpKeyFingerprint) {                                                                           // 224
          globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                           // 225
        }                                                                                                              // 226
      })["catch"](function (err) {                                                                                     // 227
        console.error(err.stack);                                                                                      // 228
      });                                                                                                              // 229
    });                                                                                                                // 230
  };                                                                                                                   // 231
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function wrapCallback(method) {                                                // 178
    // Note that the function below must not be an arrow function, since arrow functions do not have                   //
    // access to the context's arguments array.                                                                        //
    var _this = this;                                                                                                  // 236
    return function () {                                                                                               // 237
      if (_this.failed) return;                                                                                        // 238
      try {                                                                                                            // 239
        return method.apply(_this, _.toArray(arguments));                                                              // 240
      } catch (err) {                                                                                                  // 241
        _this.failed = true;                                                                                           // 242
        _this.cleanup();                                                                                               // 243
        _this.updateProgress("failed", 0, err);                                                                        // 244
        _this.writeChain = _this.writeChain.then(function () {                                                         // 245
          delete installers[_this.packageId];                                                                          // 246
        });                                                                                                            // 247
        console.error("Failed to install app:", err.stack);                                                            // 248
      }                                                                                                                // 249
    };                                                                                                                 // 250
  };                                                                                                                   // 251
                                                                                                                       //
  AppInstaller.prototype.cleanup = function cleanup() {                                                                // 178
    if (this.uploadStream) {                                                                                           // 254
      try {                                                                                                            // 255
        this.uploadStream.close();                                                                                     // 256
      } catch (err) {}                                                                                                 // 257
                                                                                                                       //
      delete this.uploadStream;                                                                                        // 259
    }                                                                                                                  // 260
                                                                                                                       //
    if (this.downloadRequest) {                                                                                        // 262
      try {                                                                                                            // 263
        this.downloadRequest.abort();                                                                                  // 264
      } catch (err) {}                                                                                                 // 265
                                                                                                                       //
      delete this.downloadRequest;                                                                                     // 267
    }                                                                                                                  // 268
  };                                                                                                                   // 269
                                                                                                                       //
  AppInstaller.prototype.start = function start() {                                                                    // 178
    var _this2 = this;                                                                                                 // 271
                                                                                                                       //
    return this.wrapCallback(function () {                                                                             // 272
      _this2.cleanup();                                                                                                // 273
                                                                                                                       //
      globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                   // 275
        if (info.appId) {                                                                                              // 276
          _this2.appId = info.appId;                                                                                   // 277
          _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 278
          _this2.done(info.manifest);                                                                                  // 279
        } else {                                                                                                       // 280
          _this2.doDownload();                                                                                         // 281
        }                                                                                                              // 282
      }), _this2.wrapCallback(function (err) {                                                                         // 283
        throw err;                                                                                                     // 284
      }));                                                                                                             // 285
    })();                                                                                                              // 286
  };                                                                                                                   // 287
                                                                                                                       //
  AppInstaller.prototype.doDownload = function doDownload() {                                                          // 178
    if (!this.url) {                                                                                                   // 290
      throw new Error("Unknown package ID, and no URL was provided.");                                                 // 291
    }                                                                                                                  // 292
                                                                                                                       //
    console.log("Downloading app:", this.url);                                                                         // 294
    this.updateProgress("download");                                                                                   // 295
                                                                                                                       //
    this.uploadStream = globalBackend.cap().installPackage().stream;                                                   // 297
    return this.doDownloadTo(this.uploadStream);                                                                       // 298
  };                                                                                                                   // 299
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function doDownloadTo(out) {                                                   // 178
    var _this3 = this;                                                                                                 // 301
                                                                                                                       //
    var url = Url.parse(this.url);                                                                                     // 302
    var options = {                                                                                                    // 303
      hostname: url.hostname,                                                                                          // 304
      port: url.port,                                                                                                  // 305
      path: url.path                                                                                                   // 306
    };                                                                                                                 // 303
                                                                                                                       //
    var protocol = void 0;                                                                                             // 309
    if (url.protocol === "http:" || url.protocol === "https:") {                                                       // 310
      protocol = Request.defaults({                                                                                    // 311
        maxRedirects: 20,                                                                                              // 312
        // Since we will verify the download against a hash anyway, we don't need to verify the                        //
        // server's certificate. In fact, the only reason we support HTTPS at all here is because                      //
        // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                   //
        // certificate check here is helpful in that it means we don't have to worry about having a                    //
        // reasonable list of trusted CAs available to Sandstorm.                                                      //
        strictSSL: false                                                                                               // 318
      });                                                                                                              // 311
    } else {                                                                                                           // 320
      throw new Error("Protocol not supported: " + url.protocol);                                                      // 321
    }                                                                                                                  // 322
                                                                                                                       //
    // TODO(security):  It could arguably be a security problem that it's possible to probe the                        //
    //   server's local network (behind any firewalls) by presenting URLs here.                                        //
    var bytesExpected = undefined;                                                                                     // 326
    var bytesReceived = 0;                                                                                             // 327
    var hasher = Crypto.createHash("sha256");                                                                          // 328
    var done = false;                                                                                                  // 329
    var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                            // 330
      if (!done) {                                                                                                     // 331
        if (bytesExpected) {                                                                                           // 332
          _this3.updateProgress("download", bytesReceived / bytesExpected);                                            // 333
        } else {                                                                                                       // 334
          _this3.updateProgress("download", bytesReceived);                                                            // 335
        }                                                                                                              // 336
      }                                                                                                                // 337
    }), 500);                                                                                                          // 338
                                                                                                                       //
    var request = protocol.get(this.url);                                                                              // 340
                                                                                                                       //
    request.on("response", this.wrapCallback(function (response) {                                                     // 342
      if ("content-length" in response.headers) {                                                                      // 343
        bytesExpected = parseInt(response.headers["content-length"]);                                                  // 344
      }                                                                                                                // 345
    }));                                                                                                               // 346
                                                                                                                       //
    request.on("data", this.wrapCallback(function (chunk) {                                                            // 348
      hasher.update(chunk);                                                                                            // 349
      out.write(chunk);                                                                                                // 350
      bytesReceived += chunk.length;                                                                                   // 351
      updateDownloadProgress();                                                                                        // 352
    }));                                                                                                               // 353
                                                                                                                       //
    request.on("end", this.wrapCallback(function () {                                                                  // 355
      out.done();                                                                                                      // 356
                                                                                                                       //
      if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                    // 358
        throw new Error("Package hash did not match.");                                                                // 359
      }                                                                                                                // 360
                                                                                                                       //
      done = true;                                                                                                     // 362
      delete _this3.downloadRequest;                                                                                   // 363
                                                                                                                       //
      _this3.updateProgress("unpack");                                                                                 // 365
      out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                          // 366
        _this3.appId = info.appId;                                                                                     // 367
        _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                                 // 368
        _this3.done(info.manifest);                                                                                    // 369
      }), _this3.wrapCallback(function (err) {                                                                         // 370
        throw err;                                                                                                     // 371
      }));                                                                                                             // 372
    }));                                                                                                               // 373
                                                                                                                       //
    request.on("error", this.wrapCallback(function (err) {                                                             // 375
      throw err;                                                                                                       // 375
    }));                                                                                                               // 375
                                                                                                                       //
    this.downloadRequest = request;                                                                                    // 377
  };                                                                                                                   // 378
                                                                                                                       //
  AppInstaller.prototype.done = function done(manifest) {                                                              // 178
    console.log("App ready:", this.packageId);                                                                         // 381
    this.updateProgress("ready", 1, undefined, manifest);                                                              // 382
    var _this = this;                                                                                                  // 383
    _this.writeChain = _this.writeChain.then(function () {                                                             // 384
      return inMeteor(function () {                                                                                    // 385
        if (_this.isAutoUpdated) {                                                                                     // 386
          globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
        }                                                                                                              // 390
                                                                                                                       //
        if (globalDb.getPackageIdForPreinstalledApp(_this.appId) && globalDb.collections.appIndex.findOne({            // 392
          _id: _this.appId,                                                                                            // 394
          packageId: _this.packageId                                                                                   // 395
        })) {                                                                                                          // 393
          // Only mark app as preinstall ready if its appId is in the preinstalledApps setting                         //
          // and if it's the latest package version in the appIndex. The updateAppIndex function                       //
          // will always trigger updates of preinstalled apps, even if a concurrent download of                        //
          // an older package is going on.                                                                             //
          globalDb.setPreinstallAppAsReady(_this.appId, _this.packageId);                                              // 401
        }                                                                                                              // 402
      });                                                                                                              // 403
    }).then(function () {                                                                                              // 404
      delete installers[_this.packageId];                                                                              // 405
    });                                                                                                                // 406
  };                                                                                                                   // 407
                                                                                                                       //
  return AppInstaller;                                                                                                 // 178
}();                                                                                                                   // 178
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 410
  var metadata = manifest.metadata;                                                                                    // 411
  if (!metadata) return;                                                                                               // 412
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 414
  if (icons) {                                                                                                         // 415
    var handleIcon = function handleIcon(icon) {                                                                       // 416
      if (icon.svg) {                                                                                                  // 417
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 418
        icon.format = "svg";                                                                                           // 419
        delete icon.svg;                                                                                               // 420
        return true;                                                                                                   // 421
      } else if (icon.png) {                                                                                           // 422
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 424
        if (!normalDpi) return false;                                                                                  // 425
        icon.format = "png";                                                                                           // 426
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 427
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 429
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 431
        }                                                                                                              // 432
                                                                                                                       //
        delete icon.png;                                                                                               // 434
        return true;                                                                                                   // 435
      } else {                                                                                                         // 436
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 438
      }                                                                                                                // 439
    };                                                                                                                 // 440
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 442
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 443
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 446
    if (icons.marketBig) delete icons.marketBig;                                                                       // 447
  }                                                                                                                    // 448
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 450
    if (text.defaultText) {                                                                                            // 451
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 452
      delete text.defaultText;                                                                                         // 453
    }                                                                                                                  // 454
                                                                                                                       //
    if (text.localizations) {                                                                                          // 456
      text.localizations.forEach(function (localization) {                                                             // 457
        if (localization.text) {                                                                                       // 458
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 459
          delete localization.text;                                                                                    // 461
        }                                                                                                              // 462
      });                                                                                                              // 463
    }                                                                                                                  // 464
  };                                                                                                                   // 465
                                                                                                                       //
  var license = metadata.license;                                                                                      // 467
  if (license) {                                                                                                       // 468
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 469
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 470
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 471
  }                                                                                                                    // 472
                                                                                                                       //
  var author = metadata.author;                                                                                        // 474
  if (author) {                                                                                                        // 475
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 477
  }                                                                                                                    // 478
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 481
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 484
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 487
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 490
};                                                                                                                     // 491
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 493
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 496
  if (!metadata) return [];                                                                                            // 497
                                                                                                                       //
  var result = [];                                                                                                     // 499
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 501
  if (icons) {                                                                                                         // 502
    var handleIcon = function handleIcon(icon) {                                                                       // 503
      if (icon.assetId) {                                                                                              // 504
        result.push(icon.assetId);                                                                                     // 505
      }                                                                                                                // 506
    };                                                                                                                 // 507
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 509
    if (icons.grain) handleIcon(icons.grain);                                                                          // 510
  }                                                                                                                    // 511
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 513
    if (text.defaultTextAssetId) {                                                                                     // 514
      result.push(defaultTextAssetId);                                                                                 // 515
    }                                                                                                                  // 516
                                                                                                                       //
    if (text.localizations) {                                                                                          // 518
      text.localizations.forEach(function (localization) {                                                             // 519
        if (localization.assetId) {                                                                                    // 520
          result.push(localization.assetId);                                                                           // 521
        }                                                                                                              // 522
      });                                                                                                              // 523
    }                                                                                                                  // 524
  };                                                                                                                   // 525
                                                                                                                       //
  var license = metadata.license;                                                                                      // 527
  if (license) {                                                                                                       // 528
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 529
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 530
    if (license.notices) handleLocalizedText(license.notices);                                                         // 531
  }                                                                                                                    // 532
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 534
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 535
                                                                                                                       //
  return result;                                                                                                       // 537
};                                                                                                                     // 538
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"notifications-server.js":["/imports/server/async-helpers.js","/imports/server/desktop-notifications.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/notifications-server.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});var createAppActivityDesktopNotification;module.import("/imports/server/desktop-notifications.js",{"createAppActivityDesktopNotification":function(v){createAppActivityDesktopNotification=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 20
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 21
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 22
                                                                                                                       //
logActivity = function logActivity(grainId, identityIdOrAnonymous, event) {                                            // 24
  // identityIdOrAnonymous is the string "anonymous" for an anonymous user, or is null for a                           //
  // non-user-initiated ("background") activity.                                                                       //
                                                                                                                       //
  check(grainId, String);                                                                                              // 28
  check(identityIdOrAnonymous, Match.Maybe(String));                                                                   // 29
  // `event` is always an ActivityEvent parsed from Cap'n Proto but that's too complicated to check                    //
  // here.                                                                                                             //
                                                                                                                       //
  var identityId = identityIdOrAnonymous === "anonymous" ? null : identityIdOrAnonymous;                               // 33
                                                                                                                       //
  // TODO(perf): A cached copy of the grain from when the session opened would be fine to use                          //
  //   here, rather than looking it up every time.                                                                     //
  grain = Grains.findOne(grainId);                                                                                     // 37
  if (!grain) {                                                                                                        // 38
    // Shouldn't be possible since activity events come from the grain.                                                //
    throw new Error("no such grain");                                                                                  // 40
  }                                                                                                                    // 41
                                                                                                                       //
  // Look up the event typedef.                                                                                        //
  var eventType = ((grain.cachedViewInfo || {}).eventTypes || [])[event.type];                                         // 44
  if (!eventType) {                                                                                                    // 45
    throw new Error("No such event type in app's ViewInfo: " + event.type);                                            // 46
  }                                                                                                                    // 47
                                                                                                                       //
  if (!eventType.suppressUnread) {                                                                                     // 49
    // Clear the "seenAllActivity" bit for all users except the acting user.                                           //
    // TODO(perf): Consider throttling? Or should that be the app's responsibility?                                    //
    if (identityId != grain.identityId) {                                                                              // 52
      Grains.update(grainId, { $unset: { ownerSeenAllActivity: true } });                                              // 53
    }                                                                                                                  // 54
                                                                                                                       //
    // Also clear on ApiTokens.                                                                                        //
    ApiTokens.update({                                                                                                 // 57
      "grainId": grainId,                                                                                              // 58
      "owner.user.seenAllActivity": true,                                                                              // 59
      "owner.user.identityId": { $ne: identityId }                                                                     // 60
    }, { $unset: { "owner.user.seenAllActivity": true } }, { multi: true });                                           // 57
  }                                                                                                                    // 62
                                                                                                                       //
  if (identityId) {                                                                                                    // 64
    // Apply auto-subscriptions.                                                                                       //
    if (eventType.autoSubscribeToGrain) {                                                                              // 66
      globalDb.subscribeToActivity(identityId, grainId);                                                               // 67
    }                                                                                                                  // 68
                                                                                                                       //
    if (event.thread && eventType.autoSubscribeToThread) {                                                             // 70
      globalDb.subscribeToActivity(identityId, grainId, event.thread.path || "");                                      // 71
    }                                                                                                                  // 72
  }                                                                                                                    // 73
                                                                                                                       //
  // Figure out whom we need to notify.                                                                                //
  var notifyMap = {};                                                                                                  // 76
  var addRecipient = function addRecipient(recipient) {                                                                // 77
    // Mutes take priority over subscriptions.                                                                         //
    if (recipient.mute) {                                                                                              // 79
      notifyMap[recipient.identityId] = false;                                                                         // 80
    } else {                                                                                                           // 81
      if (!(recipient.identityId in notifyMap)) {                                                                      // 82
        notifyMap[recipient.identityId] = true;                                                                        // 83
      }                                                                                                                // 84
    }                                                                                                                  // 85
  };                                                                                                                   // 86
                                                                                                                       //
  if (identityId) {                                                                                                    // 88
    // Don't notify self.                                                                                              //
    addRecipient({ identityId: identityId, mute: true });                                                              // 90
  }                                                                                                                    // 91
                                                                                                                       //
  // Notify subscribers, if desired.                                                                                   //
  if (eventType.notifySubscribers) {                                                                                   // 94
    // The grain owner is implicitly subscribed.                                                                       //
    addRecipient({ identityId: grain.identityId });                                                                    // 96
                                                                                                                       //
    // Add everyone subscribed to the grain.                                                                           //
    globalDb.getActivitySubscriptions(grainId).forEach(addRecipient);                                                  // 99
                                                                                                                       //
    if (event.thread) {                                                                                                // 101
      // Add everyone subscribed to the thread.                                                                        //
      globalDb.getActivitySubscriptions(grainId, event.thread.path || "").forEach(addRecipient);                       // 103
    }                                                                                                                  // 104
  }                                                                                                                    // 105
                                                                                                                       //
  // Add everyone who is mentioned.                                                                                    //
  if (event.users && event.users.length > 0) {                                                                         // 108
    (function () {                                                                                                     // 108
      var promises = [];                                                                                               // 109
      event.users.forEach(function (user) {                                                                            // 110
        if (user.identity && (user.mentioned || user.subscribed)) {                                                    // 111
          promises.push(unwrapFrontendCap(user.identity, "identity", function (targetId) {                             // 112
            addRecipient({ identityId: targetId });                                                                    // 113
          }));                                                                                                         // 114
        }                                                                                                              // 115
      });                                                                                                              // 116
      waitPromise(Promise.all(promises).then(function (junk) {                                                         // 117
        return undefined;                                                                                              // 117
      }));                                                                                                             // 117
    })();                                                                                                              // 108
  }                                                                                                                    // 118
                                                                                                                       //
  // Make a list of everyone to notify.                                                                                //
  var notify = [];                                                                                                     // 121
  for (var _identityId in notifyMap) {                                                                                 // 122
    if (notifyMap[_identityId]) {                                                                                      // 123
      notify.push(_identityId);                                                                                        // 124
    }                                                                                                                  // 125
  }                                                                                                                    // 126
                                                                                                                       //
  if (notify.length > 0) {                                                                                             // 128
    (function () {                                                                                                     // 128
      var notification = {                                                                                             // 129
        grainId: grainId,                                                                                              // 130
        path: event.path || ""                                                                                         // 131
      };                                                                                                               // 129
                                                                                                                       //
      // Fields we'll update even if the notification already exists.                                                  //
      var update = {                                                                                                   // 135
        isUnread: true,                                                                                                // 136
        timestamp: new Date()                                                                                          // 137
      };                                                                                                               // 135
                                                                                                                       //
      if (event.thread) {                                                                                              // 140
        notification.threadPath = event.thread.path || "";                                                             // 141
      }                                                                                                                // 142
                                                                                                                       //
      if (identityId) {                                                                                                // 144
        notification.initiatingIdentity = identityId;                                                                  // 145
      } else if (identityIdOrAnonymous) {                                                                              // 146
        notification.initiatorAnonymous = true;                                                                        // 147
      }                                                                                                                // 148
                                                                                                                       //
      notification.eventType = event.type;                                                                             // 150
      update.text = eventType.verbPhrase;                                                                              // 151
                                                                                                                       //
      var body = event.notification && event.notification.caption || { defaultText: "" };                              // 153
                                                                                                                       //
      var appActivity = {                                                                                              // 155
        grainId: notification.grainId,                                                                                 // 156
        path: notification.path,                                                                                       // 157
        body: body,                                                                                                    // 158
        actionText: eventType.verbPhrase                                                                               // 159
      };                                                                                                               // 155
                                                                                                                       //
      if (identityId) {                                                                                                // 162
        // Look up icon urls for the responsible identity and the app                                                  //
        var identity = Meteor.users.findOne({ _id: identityId });                                                      // 164
        if (!identity) {                                                                                               // 165
          throw new Error("no such identity");                                                                         // 166
        }                                                                                                              // 167
                                                                                                                       //
        SandstormDb.fillInProfileDefaults(identity);                                                                   // 169
        SandstormDb.fillInPictureUrl(identity);                                                                        // 170
                                                                                                                       //
        appActivity.user = {                                                                                           // 172
          identityId: identity._id,                                                                                    // 173
          name: identity.profile.name,                                                                                 // 174
          avatarUrl: identity.profile.pictureUrl || ""                                                                 // 175
        };                                                                                                             // 172
      } else if (identityIdOrAnonymous) {                                                                              // 177
        appActivity.user = { anonymous: true };                                                                        // 178
      }                                                                                                                // 179
                                                                                                                       //
      notify.forEach(function (targetId) {                                                                             // 181
        // Notify all accounts connected with this identity.                                                           //
        Meteor.users.find({ $or: [{ "loginIdentities.id": targetId }, { "nonloginIdentities.id": targetId }] }).forEach(function (account) {
          // We need to know the ID of the inserted/updated document so we can embed it in the                         //
          // desktop notification to bind them.                                                                        //
          var idIfInserted = Random.id(17);                                                                            // 189
          var result = Notifications.findAndModify({                                                                   // 190
            query: _.extend({ userId: account._id }, notification),                                                    // 191
            update: {                                                                                                  // 192
              $set: update,                                                                                            // 193
              $inc: { count: 1 },                                                                                      // 194
              $setOnInsert: {                                                                                          // 195
                _id: idIfInserted                                                                                      // 196
              }                                                                                                        // 195
            },                                                                                                         // 192
            upsert: true                                                                                               // 199
          });                                                                                                          // 190
                                                                                                                       //
          if (!result.ok) {                                                                                            // 202
            console.error("Couldn't create notification!", result.lastErrorObject);                                    // 203
            return;                                                                                                    // 204
          }                                                                                                            // 205
                                                                                                                       //
          var notificationId = result.value._id || idIfInserted;                                                       // 207
                                                                                                                       //
          var desktopNotification = {                                                                                  // 209
            userId: account._id,                                                                                       // 210
            notificationId: notificationId,                                                                            // 211
            appActivity: appActivity                                                                                   // 212
          };                                                                                                           // 209
                                                                                                                       //
          createAppActivityDesktopNotification(desktopNotification);                                                   // 215
        });                                                                                                            // 216
      });                                                                                                              // 217
    })();                                                                                                              // 128
  }                                                                                                                    // 218
};                                                                                                                     // 219
                                                                                                                       //
Meteor.methods({                                                                                                       // 221
  testNotifications: function testNotifications() {                                                                    // 222
    // Deliver a test notification of each non-grain-initiated type to the user.                                       //
    if (!this.userId) return;                                                                                          // 224
                                                                                                                       //
    Notifications.insert({                                                                                             // 226
      admin: {                                                                                                         // 227
        action: "/admin/stats",                                                                                        // 228
        type: "reportStats"                                                                                            // 229
      },                                                                                                               // 227
      userId: this.userId,                                                                                             // 231
      timestamp: new Date(),                                                                                           // 232
      isUnread: true                                                                                                   // 233
    });                                                                                                                // 226
                                                                                                                       //
    Notifications.insert({                                                                                             // 236
      admin: {                                                                                                         // 237
        action: "/admin/feature-key",                                                                                  // 238
        type: "cantRenewFeatureKey"                                                                                    // 239
      },                                                                                                               // 237
      userId: this.userId,                                                                                             // 241
      timestamp: new Date(),                                                                                           // 242
      isUnread: true                                                                                                   // 243
    });                                                                                                                // 236
                                                                                                                       //
    Notifications.insert({                                                                                             // 246
      admin: {                                                                                                         // 247
        action: "/admin/feature-key",                                                                                  // 248
        type: "trialFeatureKeyExpired"                                                                                 // 249
      },                                                                                                               // 247
      userId: this.userId,                                                                                             // 251
      timestamp: new Date(),                                                                                           // 252
      isUnread: true                                                                                                   // 253
    });                                                                                                                // 246
                                                                                                                       //
    Notifications.insert({                                                                                             // 256
      userId: this.userId,                                                                                             // 257
      referral: true,                                                                                                  // 258
      timestamp: new Date(),                                                                                           // 259
      isUnread: true                                                                                                   // 260
    });                                                                                                                // 256
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 263
      Notifications.insert({                                                                                           // 264
        userId: this.userId,                                                                                           // 265
        mailingListBonus: true,                                                                                        // 266
        timestamp: new Date(),                                                                                         // 267
        isUnread: true                                                                                                 // 268
      });                                                                                                              // 264
    }                                                                                                                  // 270
  }                                                                                                                    // 271
});                                                                                                                    // 221
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 274
  return Notifications.find({ userId: this.userId });                                                                  // 275
});                                                                                                                    // 276
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 278
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 281
  var notifications = Notifications.find({                                                                             // 282
    _id: { $in: notificationIds },                                                                                     // 283
    userId: this.userId                                                                                                // 284
  }, {                                                                                                                 // 282
    fields: { grainId: 1, initiatingIdentity: 1 }                                                                      // 286
  });                                                                                                                  // 285
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 289
    return row.grainId;                                                                                                // 290
  }).filter(function (x) {                                                                                             // 291
    return x;                                                                                                          // 291
  });                                                                                                                  // 291
                                                                                                                       //
  var identities = notifications.map(function (row) {                                                                  // 293
    return row.initiatingIdentity;                                                                                     // 294
  }).filter(function (x) {                                                                                             // 295
    return x;                                                                                                          // 295
  });                                                                                                                  // 295
                                                                                                                       //
  return [Meteor.users.find({ _id: { $in: identities } }, { fields: { profile: 1 } })];                                // 297
});                                                                                                                    // 300
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
                                                                                                                       // 20
var Url = Npm.require("url");                                                                                          // 21
var Fs = Npm.require("fs");                                                                                            // 22
var Dns = Npm.require("dns");                                                                                          // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 27
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 29
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 32
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 33
                                                                                                                       //
var webPublishingHandlers = {};                                                                                        // 35
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
// TODO(perf): Implement a more general cache not just of web publishing handlers but of all sorts                     //
//   of hosts, in order to avoid database lookups to determine how to handle requests. Host types                      //
//   to distinguish between:                                                                                           //
//   - Grain hosts                                                                                                     //
//   - Web publishing hosts                                                                                            //
//   - Standalone grain hosts                                                                                          //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 46
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 52
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 55
}                                                                                                                      // 56
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 60
                                                                                                                       //
var mime = connect["static"].mime;                                                                                     // 62
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 64
  return function (request, response) {                                                                                // 65
    var path = request.url;                                                                                            // 66
                                                                                                                       //
    // If a directory, open "index.html".                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 69
      path = path + "index.html";                                                                                      // 70
    }                                                                                                                  // 71
                                                                                                                       //
    // Strip leading "/".                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 74
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 77
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 79
    var charset = mime.charsets.lookup(type);                                                                          // 80
    if (charset) {                                                                                                     // 81
      type = type + "; charset=" + charset;                                                                            // 82
    } else if (type === "application/json") {                                                                          // 83
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 85
    }                                                                                                                  // 86
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's "compress" middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 91
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 92
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 104
    }                                                                                                                  // 105
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 107
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         //
    // logic to happen if the response has no data.                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): This is pretty ugly.                                                                             //
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 113
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 115
      return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                       // 116
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 118
        if (status === "file") {                                                                                       // 119
          // Nothing to do.                                                                                            //
        } else if (status === "directory") {                                                                           // 121
            stream.sendingDirectResponse();                                                                            // 122
            response.writeHead(303, {                                                                                  // 123
              "Content-Type": "text/plain",                                                                            // 124
              "Location": "/" + path + "/",                                                                            // 125
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 126
            });                                                                                                        // 123
            response.end("redirect: /" + path + "/");                                                                  // 128
          } else if (status === "notFound") {                                                                          // 129
            stream.sendingDirectResponse();                                                                            // 130
            response.writeHead(404, {                                                                                  // 131
              "Content-Type": "text/plain"                                                                             // 132
            });                                                                                                        // 131
            response.end("404 not found: /" + path);                                                                   // 134
          } else {                                                                                                     // 135
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 136
            stream.sendingDirectResponse();                                                                            // 137
            response.writeHead(500, {                                                                                  // 138
              "Content-Type": "text/plain"                                                                             // 139
            });                                                                                                        // 138
            response.end("Internal server error");                                                                     // 141
          }                                                                                                            // 142
                                                                                                                       //
        streamCap.close();                                                                                             // 144
      });                                                                                                              // 145
    })["catch"](function (err) {                                                                                       // 146
      console.error(err.stack);                                                                                        // 147
      streamCap.close();                                                                                               // 148
    });                                                                                                                // 149
  };                                                                                                                   // 150
}                                                                                                                      // 151
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 153
  var status = 500;                                                                                                    // 154
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 155
    status = err.error;                                                                                                // 157
  } else if (err.httpErrorCode) {                                                                                      // 158
    status = err.httpErrorCode;                                                                                        // 159
  }                                                                                                                    // 160
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 163
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 165
  res.end(err.htmlMessage || err.message);                                                                             // 166
}                                                                                                                      // 167
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 169
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 170
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 172
  if (buf.length < magic.length) return false;                                                                         // 173
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 175
    if (buf[i] != magic[i]) return false;                                                                              // 176
  }                                                                                                                    // 177
                                                                                                                       //
  return true;                                                                                                         // 179
}                                                                                                                      // 180
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 182
  try {                                                                                                                // 183
    if (req.method === "GET" && req.url === "/") {                                                                     // 184
      var content = new Buffer("Self-test OK.");                                                                       // 186
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 189
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 190
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 191
      }                                                                                                                // 192
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 194
        "Content-Type": "text/plain",                                                                                  // 195
        "Content-Length": content.length,                                                                              // 196
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 197
      });                                                                                                              // 194
      res.end(content);                                                                                                // 199
    } else {                                                                                                           // 200
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 201
      res.end("Bad request to self-test subdomain.");                                                                  // 202
      return;                                                                                                          // 203
    }                                                                                                                  // 204
  } catch (err) {                                                                                                      // 205
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 206
  }                                                                                                                    // 207
}                                                                                                                      // 208
                                                                                                                       //
function serveStaticAsset(req, res, hostId) {                                                                          // 210
  inMeteor(function () {                                                                                               // 211
    if (req.method === "GET") {                                                                                        // 212
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 213
      if (req.headers["if-none-match"] === "permanent") {                                                              // 214
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 216
          "Cache-Control": "public, max-age=31536000",                                                                 // 217
          "ETag": "permanent",                                                                                         // 218
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          "Content-Security-Policy": assetCspHeader,                                                                   // 221
          "Access-Control-Allow-Origin": "*",                                                                          // 222
          "X-Content-Type-Options": "nosniff"                                                                          // 223
        });                                                                                                            // 216
        res.end();                                                                                                     // 225
        return;                                                                                                        // 226
      }                                                                                                                // 227
                                                                                                                       //
      var url = Url.parse(req.url, true);                                                                              // 229
      var pathname = url.pathname.slice(1);                                                                            // 230
      var asset = void 0;                                                                                              // 231
      if (pathname.startsWith("identicon/")) {                                                                         // 232
        var size = parseInt((url.query || {}).s);                                                                      // 233
        asset = new Identicon(pathname.slice("identicon/".length), size).asAsset();                                    // 234
      } else if (pathname.indexOf("/") == -1) {                                                                        // 235
        asset = globalDb.getStaticAsset(pathname);                                                                     // 236
      }                                                                                                                // 237
                                                                                                                       //
      if (asset) {                                                                                                     // 239
        var headers = {                                                                                                // 240
          "Content-Type": asset.mimeType,                                                                              // 241
          "Content-Length": asset.content.length,                                                                      // 242
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          "Cache-Control": "public, max-age=31536000",                                                                 // 245
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          "ETag": "permanent",                                                                                         // 248
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          "Content-Security-Policy": assetCspHeader,                                                                   // 255
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          "Access-Control-Allow-Origin": "*",                                                                          // 260
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          "X-Content-Type-Options": "nosniff"                                                                          // 263
        };                                                                                                             // 240
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 266
          headers["Content-Encoding"] = asset.encoding;                                                                // 267
        }                                                                                                              // 268
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 270
        res.end(asset.content);                                                                                        // 271
      } else {                                                                                                         // 272
        res.writeHead(404, { "Content-Type": "text/plain" });                                                          // 273
        res.end("not found");                                                                                          // 274
      }                                                                                                                // 275
    } else if (req.method === "POST") {                                                                                // 276
      var _ret = function () {                                                                                         // 276
        res.setHeader("Access-Control-Allow-Origin", "*");                                                             // 277
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 279
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 280
                                                                                                                       //
        // Sanity check the purpose of this upload token.                                                              //
        if (!purpose) {                                                                                                // 283
          res.writeHead(404, { "Content-Type": "text/plain" });                                                        // 284
          res.end("Upload token not found or expired.");                                                               // 285
          return {                                                                                                     // 286
            v: void 0                                                                                                  // 286
          };                                                                                                           // 286
        } else if (purpose.profilePicture) {                                                                           // 287
          var userId = purpose.profilePicture.userId;                                                                  // 288
          var identityId = purpose.profilePicture.identityId;                                                          // 289
          check(userId, String);                                                                                       // 290
          check(identityId, String);                                                                                   // 291
        } else if (purpose.loginLogo) {                                                                                // 292
          // no additional fields for loginLogo                                                                        //
        } else {                                                                                                       // 294
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 295
            res.end("Found invalid purpose for upload");                                                               // 296
            return {                                                                                                   // 297
              v: void 0                                                                                                // 297
            };                                                                                                         // 297
          }                                                                                                            // 298
                                                                                                                       //
        var buffers = [];                                                                                              // 300
        var totalSize = 0;                                                                                             // 301
        var done = new Future();                                                                                       // 302
        req.on("data", function (buf) {                                                                                // 303
          totalSize += buf.length;                                                                                     // 304
          if (totalSize <= 64 * 1024) {                                                                                // 305
            buffers.push(buf);                                                                                         // 306
          }                                                                                                            // 307
        });                                                                                                            // 308
        req.on("end", done["return"].bind(done));                                                                      // 309
        req.on("error", done["throw"].bind(done));                                                                     // 310
        done.wait();                                                                                                   // 311
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 313
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 315
          res.end("Picture too large; please use an image under 64 KiB.");                                             // 316
          return {                                                                                                     // 317
            v: void 0                                                                                                  // 317
          };                                                                                                           // 317
        }                                                                                                              // 318
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 320
        var type = void 0;                                                                                             // 321
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 322
          type = "image/png";                                                                                          // 323
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 324
          type = "image/jpeg";                                                                                         // 325
        } else {                                                                                                       // 326
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 327
          res.end("Image must be PNG or JPEG.");                                                                       // 328
          return {                                                                                                     // 329
            v: void 0                                                                                                  // 329
          };                                                                                                           // 329
        }                                                                                                              // 330
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 332
                                                                                                                       //
        if (purpose.profilePicture) {                                                                                  // 334
          var _identityId = purpose.profilePicture.identityId;                                                         // 335
          var result = Meteor.users.findAndModify({                                                                    // 336
            query: { _id: _identityId },                                                                               // 337
            update: { $set: { "profile.picture": assetId } },                                                          // 338
            fields: { "profile.picture": 1 }                                                                           // 339
          });                                                                                                          // 336
                                                                                                                       //
          if (result.ok) {                                                                                             // 342
            var old = result.value;                                                                                    // 343
            if (old && old.profile && old.profile.picture) {                                                           // 344
              globalDb.unrefStaticAsset(old.profile.picture);                                                          // 345
            }                                                                                                          // 346
          } else {                                                                                                     // 347
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 348
            res.end("Couldn't update profile picture.");                                                               // 349
            return {                                                                                                   // 350
              v: void 0                                                                                                // 350
            };                                                                                                         // 350
          }                                                                                                            // 351
        } else if (purpose.loginLogo) {                                                                                // 352
          var _result = globalDb.collections.settings.findAndModify({                                                  // 353
            query: { _id: "whitelabelCustomLogoAssetId" },                                                             // 354
            update: {                                                                                                  // 355
              $setOnInsert: { _id: "whitelabelCustomLogoAssetId" },                                                    // 356
              $set: { value: assetId }                                                                                 // 357
            },                                                                                                         // 355
            upsert: true,                                                                                              // 359
            fields: { value: 1 }                                                                                       // 360
          });                                                                                                          // 353
                                                                                                                       //
          if (_result.ok) {                                                                                            // 363
            var _old = _result.value;                                                                                  // 364
            if (_old && _old.value) {                                                                                  // 365
              globalDb.unrefStaticAsset(_old.value);                                                                   // 366
            }                                                                                                          // 367
          } else {                                                                                                     // 368
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 369
            res.end("Couldn't update login logo.");                                                                    // 370
            return {                                                                                                   // 371
              v: void 0                                                                                                // 371
            };                                                                                                         // 371
          }                                                                                                            // 372
        }                                                                                                              // 373
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 375
        res.end();                                                                                                     // 376
      }();                                                                                                             // 276
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 276
    } else if (req.method === "OPTIONS") {                                                                             // 377
      var requestedHeaders = req.headers["access-control-request-headers"];                                            // 378
      if (requestedHeaders) {                                                                                          // 379
        res.setHeader("Access-Control-Allow-Headers", requestedHeaders);                                               // 380
      }                                                                                                                // 381
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 383
        "Access-Control-Allow-Origin": "*",                                                                            // 384
        "Access-Control-Allow-Methods": "GET, HEAD, POST, OPTIONS",                                                    // 385
        "Access-Control-Max-Age": "3600"                                                                               // 386
      });                                                                                                              // 383
      res.end();                                                                                                       // 388
    } else {                                                                                                           // 389
      res.writeHead(405, "Method Not Allowed", {                                                                       // 390
        "Allow": "GET, POST, OPTIONS",                                                                                 // 391
        "Content-Type": "text/plain"                                                                                   // 392
      });                                                                                                              // 390
      res.end("405 Method Not Allowed: " + req.method);                                                                // 394
    }                                                                                                                  // 395
  })["catch"](function (err) {                                                                                         // 396
    writeErrorResponse(res, err);                                                                                      // 397
  });                                                                                                                  // 398
}                                                                                                                      // 399
                                                                                                                       //
var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                          // 401
  // Start with ROOT_URL, apply host & path from inbound URL, then                                                     //
  // redirect.                                                                                                         //
  var targetUrl = Url.parse(process.env.ROOT_URL);                                                                     // 404
                                                                                                                       //
  // Retain the protocol & port from ROOT_URL but use the inbound                                                      //
  // hostname.                                                                                                         //
  targetUrl.host = hostname + ":" + targetUrl.port;                                                                    // 408
                                                                                                                       //
  // The following allows to avoid decoding + re-encoding query                                                        //
  // string parameters, if provided.                                                                                   //
  targetUrl = Url.resolve(Url.format(targetUrl), url);                                                                 // 412
  return targetUrl;                                                                                                    // 413
};                                                                                                                     // 414
                                                                                                                       //
var handleNonMeteorRequest = function handleNonMeteorRequest(req, res, next, redirectIfInWildcard) {                   // 416
  // if redirectIfInWildcard is true, and if the host is part of the wildcard host, then we will                       //
  // prefer to redirect to the canonical url for that request.  If false, we will respond to the                       //
  // request directly.                                                                                                 //
                                                                                                                       //
  var hostname = req.headers.host.split(":")[0];                                                                       // 421
                                                                                                                       //
  var publicIdPromise = void 0;                                                                                        // 423
  // See if the request was for a host in the wildcard.                                                                //
  var id = matchWildcardHost(req.headers.host);                                                                        // 425
  if (id) {                                                                                                            // 426
    // Match!                                                                                                          //
    if (redirectIfInWildcard) {                                                                                        // 428
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 429
      res.end();                                                                                                       // 430
      return;                                                                                                          // 431
    }                                                                                                                  // 432
                                                                                                                       //
    if (id === "static") {                                                                                             // 434
      // Static assets domain.                                                                                         //
      serveStaticAsset(req, res);                                                                                      // 436
      return;                                                                                                          // 437
    }                                                                                                                  // 438
                                                                                                                       //
    if (id.match(/^selftest-/)) {                                                                                      // 440
      // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                       //
      // publishing wildcard hosts.                                                                                    //
      serveSelfTest(req, res);                                                                                         // 443
      return;                                                                                                          // 444
    }                                                                                                                  // 445
                                                                                                                       //
    // Try to route the request to a session.                                                                          //
    publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                          // 448
      if (handled) {                                                                                                   // 449
        return null;                                                                                                   // 450
      } else {                                                                                                         // 451
        return id;                                                                                                     // 452
      }                                                                                                                // 453
    });                                                                                                                // 454
  } else {                                                                                                             // 455
    // Not a wildcard host. Perhaps it is a custom host.                                                               //
    publicIdPromise = lookupPublicIdFromDns(hostname);                                                                 // 457
  }                                                                                                                    // 458
                                                                                                                       //
  publicIdPromise.then(function (publicId) {                                                                           // 460
    if (publicId) {                                                                                                    // 461
      return Promise.resolve(undefined).then(function () {                                                             // 462
        var handler = webPublishingHandlers[publicId];                                                                 // 463
        if (handler) {                                                                                                 // 464
          return handler;                                                                                              // 465
        } else {                                                                                                       // 466
          // We don't have a handler for this publicId, so look it up in the grain DB.                                 //
          return inMeteor(function () {                                                                                // 468
            var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                                // 469
            if (!grain) {                                                                                              // 470
              throw new Meteor.Error(404, "No such grain for public ID: " + publicId);                                 // 471
            }                                                                                                          // 472
                                                                                                                       //
            var grainId = grain._id;                                                                                   // 474
            return webPublishingHandlers[publicId] = wwwHandlerForGrain(grainId);                                      // 475
          });                                                                                                          // 476
        }                                                                                                              // 477
      }).then(function (handler) {                                                                                     // 478
        handler(req, res);                                                                                             // 479
      });                                                                                                              // 480
    } else {                                                                                                           // 481
      // Already handled by tryProxyRequest above, no further action needed.                                           //
      return Promise.resolve(undefined);                                                                               // 483
    }                                                                                                                  // 484
  })["catch"](function (err) {                                                                                         // 485
    writeErrorResponse(res, err);                                                                                      // 486
  });                                                                                                                  // 487
};                                                                                                                     // 488
                                                                                                                       //
// This function serves responses on Sandstorm's main HTTP/HTTPS                                                       //
// port.                                                                                                               //
var handleNonMeteorRequestDirectly = function handleNonMeteorRequestDirectly(req, res, next) {                         // 492
  handleNonMeteorRequest(req, res, next, false);                                                                       // 493
};                                                                                                                     // 494
                                                                                                                       //
// "Alternate ports" are ports other than the main HTTP or HTTPS port.                                                 //
// They are handled as follows:                                                                                        //
//                                                                                                                     //
// * Requests to the shell & grains, we redirect to the main port.                                                     //
// * For requests to static publishing on hosts within the wildcard, we redirect to the main port.                     //
// * For static publishing glued in via DNS TXT record, we serve the request as-is.                                    //
//                                                                                                                     //
// Alternate ports are bound to FD #5 and higher.                                                                      //
var getNumberOfAlternatePorts = function getNumberOfAlternatePorts() {                                                 // 504
  var numPorts = process.env.PORT.split(",").length;                                                                   // 505
  var numAlternatePorts = numPorts - 1;                                                                                // 506
  return numAlternatePorts;                                                                                            // 507
};                                                                                                                     // 508
                                                                                                                       //
var handleNonMainPortRequest = function handleNonMainPortRequest(req, res, next) {                                     // 510
  try {                                                                                                                // 511
    if (!req.headers.host) {                                                                                           // 512
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 513
      res.end("Missing Host header");                                                                                  // 514
      return;                                                                                                          // 515
    }                                                                                                                  // 516
                                                                                                                       //
    // If this request is intended for the shell, redirect to the canonical shell URL.                                 //
    var hostname = req.headers.host.split(":")[0];                                                                     // 519
    if (isSandstormShell(hostname)) {                                                                                  // 520
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 521
      res.end();                                                                                                       // 522
      return;                                                                                                          // 523
    }                                                                                                                  // 524
    // TODO(someday): check for standalone hosts and do something reasonable                                           //
                                                                                                                       //
    handleNonMeteorRequest(req, res, next, true);                                                                      // 527
  } catch (e) {                                                                                                        // 528
    // This should never be reached, because all the request handlers should be catching                               //
    // exceptions, but you can never be too careful in a top-level request handler.                                    //
    console.err("Unhandled exception in request handler:", e.stack);                                                   // 531
    res.writeHead(500, { "Content-Type": "text/plain" });                                                              // 532
    res.end("Unhandled exception: " + e.stack);                                                                        // 533
  }                                                                                                                    // 534
};                                                                                                                     // 535
                                                                                                                       //
var listenOnAlternatePorts = function listenOnAlternatePorts() {                                                       // 537
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 538
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(handleNonMainPortRequest);                                 // 540
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 541
  }                                                                                                                    // 542
};                                                                                                                     // 543
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 545
  var meteorRequestListeners = WebApp.httpServer.listeners("request");                                                 // 546
                                                                                                                       //
  // Construct the middleware chain for requests to non-DDP, non-shell hosts.                                          //
  var nonMeteorRequestHandler = connect();                                                                             // 549
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 551
    // Have to check with global, because it could be undefined.                                                       //
    nonMeteorRequestHandler.use(BlackrockPayments.makeConnectHandler(globalDb));                                       // 552
  }                                                                                                                    // 553
                                                                                                                       //
  nonMeteorRequestHandler.use(handleNonMeteorRequestDirectly);                                                         // 555
                                                                                                                       //
  WebApp.httpServer.removeAllListeners("request");                                                                     // 557
  WebApp.httpServer.on("request", function (req, res) {                                                                // 558
    Promise.resolve(undefined).then(function () {                                                                      // 559
      if (!req.headers.host) {                                                                                         // 560
        res.writeHead(400, { "Content-Type": "text/plain" });                                                          // 561
        res.end("Missing Host header");                                                                                // 562
        return;                                                                                                        // 563
      }                                                                                                                // 564
                                                                                                                       //
      var hostname = req.headers.host.split(":")[0]; // strip port if it exists                                        // 566
      if (isSandstormShell(hostname)) {                                                                                // 567
        if (req.url.startsWith("/_oauth/")) {                                                                          // 568
          // Intercept oauth callbacks on the main host to check if the user was actually logging                      //
          // into a standalone host, in which case we need to redirect to that host instead.                           //
          var parsedUrl = Url.parse(req.url, true);                                                                    // 571
          if (parsedUrl.query && parsedUrl.query.state) {                                                              // 572
            var _ret2 = function () {                                                                                  // 572
              var rawState = new Buffer(parsedUrl.query.state, "base64");                                              // 573
              var state = JSON.parse(rawState.toString());                                                             // 574
              if (state.redirectUrl) {                                                                                 // 575
                var _ret3 = function () {                                                                              // 575
                  var parsedRedirect = Url.parse(state.redirectUrl);                                                   // 576
                  var redirectHostname = parsedRedirect.hostname;                                                      // 577
                  if (redirectHostname !== HOSTNAME) {                                                                 // 578
                    return {                                                                                           // 579
                      v: {                                                                                             // 579
                        v: inMeteor(function () {                                                                      // 579
                          if (globalDb.hostIsStandalone(redirectHostname)) {                                           // 580
                            res.writeHead(302, { "Location": parsedRedirect.protocol + "//" + parsedRedirect.host + req.url });
                            res.end();                                                                                 // 583
                            return;                                                                                    // 584
                          } else {                                                                                     // 585
                            throw new Meteor.Error(400, "redirectUrl in OAuth was for an unknown host: " + state.redirectUrl);
                          }                                                                                            // 588
                        })                                                                                             // 589
                      }                                                                                                // 579
                    };                                                                                                 // 579
                  }                                                                                                    // 590
                }();                                                                                                   // 575
                                                                                                                       //
                if ((typeof _ret3 === "undefined" ? "undefined" : _typeof(_ret3)) === "object") return _ret3.v;        // 575
              }                                                                                                        // 591
            }();                                                                                                       // 572
                                                                                                                       //
            if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;            // 572
          }                                                                                                            // 592
        }                                                                                                              // 593
        // If destined for the DDP host or the main host, pass on to Meteor                                            //
        for (var i = 0; i < meteorRequestListeners.length; i++) {                                                      // 595
          meteorRequestListeners[i](req, res);                                                                         // 596
        }                                                                                                              // 597
      } else {                                                                                                         // 598
        return inMeteor(function () {                                                                                  // 599
          if (globalDb.hostIsStandalone(hostname)) {                                                                   // 600
            // If it's a standalone host, also pass on to meteor                                                       //
            for (var _i = 0; _i < meteorRequestListeners.length; _i++) {                                               // 602
              meteorRequestListeners[_i](req, res);                                                                    // 603
            }                                                                                                          // 604
          } else {                                                                                                     // 605
            // Otherwise, dispatch to our own middleware proxy chain.                                                  //
            nonMeteorRequestHandler(req, res);                                                                         // 607
            // Adjust timeouts on proxied requests to allow apps to long-poll if needed.                               //
            WebApp._timeoutAdjustmentRequestCallback(req, res);                                                        // 609
          }                                                                                                            // 610
        });                                                                                                            // 611
      }                                                                                                                // 612
    })["catch"](function (e) {                                                                                         // 613
      // This should never be reached, because all the request handlers should be catching                             //
      // exceptions, but you can never be too careful in a top-level request handler.                                  //
      console.error("Unhandled exception in request handler:", e.stack);                                               // 616
      res.writeHead(500, { "Content-Type": "text/plain" });                                                            // 617
      res.end("Unhandled exception: " + e.stack);                                                                      // 618
    });                                                                                                                // 619
  });                                                                                                                  // 620
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners("upgrade");                                                 // 622
  WebApp.httpServer.removeAllListeners("upgrade");                                                                     // 623
                                                                                                                       //
  WebApp.httpServer.on("upgrade", function (req, socket, head) {                                                       // 625
    Promise.resolve(undefined).then(function () {                                                                      // 626
      if (!req.headers.host) {                                                                                         // 627
        throw new Meteor.Error(400, "Missing Host header");                                                            // 628
      } else if (isSandstormShell(req.headers.host.split(":")[0])) {                                                   // 629
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 631
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 632
        }                                                                                                              // 633
                                                                                                                       //
        return true;                                                                                                   // 635
      } else {                                                                                                         // 636
        return inMeteor(function () {                                                                                  // 637
          // TODO(someday): This is slightly sad that some requests will now need a Meteor fiber                       //
          // If we disallow standalone domains from being in the wildcard host, then we can move                       //
          // this check to the bottom.                                                                                 //
          if (globalDb.hostIsStandalone(req.headers.host.split(":")[0])) {                                             // 641
            for (var _ii = 0; _ii < meteorUpgradeListeners.length; ++_ii) {                                            // 642
              meteorUpgradeListeners[_ii](req, socket, head);                                                          // 643
            }                                                                                                          // 644
                                                                                                                       //
            return true;                                                                                               // 646
          } else {                                                                                                     // 647
            var id = matchWildcardHost(req.headers.host);                                                              // 648
            if (id) {                                                                                                  // 649
              return tryProxyUpgrade(id, req, socket, head);                                                           // 650
            } else {                                                                                                   // 651
              return false;                                                                                            // 652
            }                                                                                                          // 653
          }                                                                                                            // 654
        });                                                                                                            // 655
      }                                                                                                                // 656
    }).then(function (handled) {                                                                                       // 657
      if (!handled) socket.destroy();                                                                                  // 658
    })["catch"](function (err) {                                                                                       // 659
      console.error("WebSocket event handler failed:", err.stack);                                                     // 660
      socket.destroy();                                                                                                // 661
    });                                                                                                                // 662
  });                                                                                                                  // 663
                                                                                                                       //
  listenOnAlternatePorts();                                                                                            // 665
});                                                                                                                    // 666
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 668
errorTxtMapping[Dns.NOTFOUND] = "<p>" + "If you were trying to configure static publishing for a blog or website, powered " + "by a Sandstorm app hosted at this server, you either have not added DNS TXT records " + "correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one " + "hour).</p>";
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 674
errorTxtMapping[Dns.TIMEOUT] = "<p>" + "The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>";
errorTxtMapping[Dns.CONNREFUSED] = "<p>" + "The DNS server refused the connection, which means either your DNS server is down/unreachable, " + "or the server has misconfigured their DNS.</p>";
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 681
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 695
  if (cache && Date.now() < cache.expiration) {                                                                        // 696
    return Promise.resolve(cache.value);                                                                               // 697
  }                                                                                                                    // 698
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 700
    Dns.resolveTxt("sandstorm-www." + hostname, function (err, records) {                                              // 701
      if (err) {                                                                                                       // 702
        var errorMsg = errorTxtMapping[err.code] || "";                                                                // 703
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 704
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + "<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>" + errorMsg + "<p>To visit this Sandstorm server's main interface, go to: <a href='" + process.env.ROOT_URL + "'>" + process.env.ROOT_URL + "</a></p>" + "<h3>DNS details</h3>" + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + "</p>" + "<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>" + "<p><tt>dig TXT sandstorm-www." + hostname + "</tt></p>" + "<h3>Changing the server URL, or troubleshooting OAuth login</h3>" + "<p>If you are the server admin and want to use this address as the main interface, " + "edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart " + "Sandstorm.</p>" + "<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), " + "the problem is probably that the OAuth callback URL was set wrong. You need to " + "update it through the respective login provider's management console. The " + "easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then " + "reconfigure the OAuth provider.</p>";
        error.httpErrorCode = _.contains(["ENOTFOUND", "ENODATA"], err.code) ? 404 : 500;                              // 725
        reject(error);                                                                                                 // 726
      } else if (records.length !== 1) {                                                                               // 727
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 728
      } else {                                                                                                         // 729
        // Under node 0.12+, `records` is an array-of-arrays. Each sub-array contains "chunks" of a                    //
        // record, which should be joined.                                                                             //
        var result = records[0].join("");                                                                              // 732
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 733
        resolve(result);                                                                                               // 734
      }                                                                                                                // 735
    });                                                                                                                // 736
  });                                                                                                                  // 737
}                                                                                                                      // 738
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum","/imports/server/constants.js","/imports/server/backend.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});var SandstormBackend,shouldRestartGrain;module.import("/imports/server/backend.js",{"SandstormBackend":function(v){SandstormBackend=v},"shouldRestartGrain":function(v){shouldRestartGrain=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
var Crypto = Npm.require("crypto");                                                                                    // 21
var ChildProcess = Npm.require("child_process");                                                                       // 22
var Fs = Npm.require("fs");                                                                                            // 23
var Path = Npm.require("path");                                                                                        // 24
var Http = Npm.require("http");                                                                                        // 25
var Url = Npm.require("url");                                                                                          // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
var Net = Npm.require("net");                                                                                          // 28
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 30
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 31
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 32
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 33
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 34
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 35
                                                                                                                       //
var PARSED_ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                 // 37
var PROTOCOL = PARSED_ROOT_URL.protocol;                                                                               // 38
var PORT = PARSED_ROOT_URL.port;                                                                                       // 39
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 44
  check(identityId, String);                                                                                           // 45
  check(apiTokenAccountId, String);                                                                                    // 46
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        //
  if (!db.isReferralEnabled()) {                                                                                       // 49
    return;                                                                                                            // 50
  }                                                                                                                    // 51
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 53
  var bobAccountId = accountId;                                                                                        // 54
  var bobIdentityId = identityId;                                                                                      // 55
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 57
    _id: bobAccountId,                                                                                                 // 58
    referredByComplete: { $exists: true }                                                                              // 59
  }).count() > 0) {                                                                                                    // 57
    return;                                                                                                            // 61
  }                                                                                                                    // 62
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 68
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 70
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        //
  if (!db.isReferralEnabled()) {                                                                                       // 86
    return;                                                                                                            // 87
  }                                                                                                                    // 88
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 91
    return;                                                                                                            // 92
  }                                                                                                                    // 93
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 96
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 97
    _id: { $in: bobIdentityIds },                                                                                      // 98
    referredBy: { $exists: true }                                                                                      // 99
  });                                                                                                                  // 97
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 102
    return;                                                                                                            // 103
  }                                                                                                                    // 104
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 106
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 109
  Meteor.users.update({                                                                                                // 110
    _id: bobAccountId,                                                                                                 // 111
    referredByComplete: { $exists: false }                                                                             // 112
  }, {                                                                                                                 // 110
    $set: {                                                                                                            // 114
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 115
      referredCompleteDate: now                                                                                        // 116
    }                                                                                                                  // 114
  });                                                                                                                  // 113
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 121
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 122
  });                                                                                                                  // 121
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 126
    $unset: { referredBy: true }                                                                                       // 127
  });                                                                                                                  // 126
}                                                                                                                      // 129
                                                                                                                       //
var HeaderWhitelist = function () {                                                                                    //
  function HeaderWhitelist(list) {                                                                                     // 132
    var _this2 = this;                                                                                                 // 132
                                                                                                                       //
    _classCallCheck(this, HeaderWhitelist);                                                                            // 132
                                                                                                                       //
    this._headers = {};                                                                                                // 133
    this._prefixes = [];                                                                                               // 134
                                                                                                                       //
    list.forEach(function (pattern) {                                                                                  // 136
      if (pattern.endsWith("*")) {                                                                                     // 137
        _this2._prefixes.push(pattern.slice(0, -1));                                                                   // 138
      } else {                                                                                                         // 139
        _this2._headers[pattern] = true;                                                                               // 140
      }                                                                                                                // 141
    });                                                                                                                // 142
  }                                                                                                                    // 143
                                                                                                                       //
  HeaderWhitelist.prototype.matches = function matches(header) {                                                       //
    header = header.toLowerCase();                                                                                     // 146
    if (this._headers[header]) return true;                                                                            // 147
                                                                                                                       //
    for (var i in this._prefixes) {                                                                                    // 149
      if (header.startsWith(this._prefixes[i])) {                                                                      // 150
        return true;                                                                                                   // 151
      }                                                                                                                // 152
    };                                                                                                                 // 153
                                                                                                                       //
    return false;                                                                                                      // 155
  };                                                                                                                   // 156
                                                                                                                       //
  return HeaderWhitelist;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var REQUEST_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Context.headerWhitelist);                                // 159
var RESPONSE_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Response.headerWhitelist);                              // 160
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 175
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 177
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory(globalDb);                                                         // 179
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 180
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 181
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 182
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 186
Meteor.onConnection(function (connection) {                                                                            // 187
  connection.sandstormBackend = globalBackend;                                                                         // 188
});                                                                                                                    // 189
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 198
var disconnectCount = 0;                                                                                               // 199
Meteor.setInterval(function () {                                                                                       // 200
  if (!backendHealthy) {                                                                                               // 201
    if (disconnectCount++ > 2) process.abort();                                                                        // 202
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 203
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 204
    sandstormBackendConnection.close();                                                                                // 205
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 206
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 207
    globalBackend._backendCap = sandstormBackend;                                                                      // 208
  }                                                                                                                    // 209
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 211
  backendHealthy = false;                                                                                              // 212
  var promise = sandstormBackend.ping().then(function () {                                                             // 213
    backendHealthy = true;                                                                                             // 214
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 215
  }, function (err) {                                                                                                  // 216
    console.error("error: Backend ping threw error!", err.stack);                                                      // 217
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 221
                                                                                                                       //
  if (debugLog) {                                                                                                      // 223
    console.log("capnp.js: outer promise:", promise);                                                                  // 224
  }                                                                                                                    // 225
}, 30000);                                                                                                             // 226
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 231
                                                                                                                       //
Meteor.methods({                                                                                                       // 233
  newGrain: function newGrain(packageId, command, title, identityId) {                                                 // 234
    // Create and start a new grain.                                                                                   //
                                                                                                                       //
    check(packageId, String);                                                                                          // 237
    check(command, Object); // Manifest.Command from package.capnp.                                                    // 238
    check(title, String);                                                                                              // 239
    check(identityId, String);                                                                                         // 240
                                                                                                                       //
    if (!this.userId) {                                                                                                // 242
      throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                              // 243
    }                                                                                                                  // 244
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 246
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 247
    }                                                                                                                  // 248
                                                                                                                       //
    if (!isSignedUpOrDemo()) {                                                                                         // 250
      throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");              // 251
    }                                                                                                                  // 253
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 255
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 256
    }                                                                                                                  // 258
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 260
    var isDev = false;                                                                                                 // 261
    var mountProc = false;                                                                                             // 262
    if (!pkg) {                                                                                                        // 263
      // Maybe they wanted a dev package.  Check there too.                                                            //
      pkg = DevPackages.findOne(packageId);                                                                            // 265
      isDev = true;                                                                                                    // 266
      mountProc = pkg.mountProc;                                                                                       // 267
    }                                                                                                                  // 268
                                                                                                                       //
    if (!pkg) {                                                                                                        // 270
      throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                       // 271
    }                                                                                                                  // 272
                                                                                                                       //
    var appId = pkg.appId;                                                                                             // 274
    var manifest = pkg.manifest;                                                                                       // 275
    var grainId = Random.id(22); // 128 bits of entropy                                                                // 276
    Grains.insert({                                                                                                    // 277
      _id: grainId,                                                                                                    // 278
      packageId: packageId,                                                                                            // 279
      appId: appId,                                                                                                    // 280
      appVersion: manifest.appVersion,                                                                                 // 281
      userId: this.userId,                                                                                             // 282
      identityId: identityId,                                                                                          // 283
      title: title,                                                                                                    // 284
      "private": true,                                                                                                 // 285
      size: 0                                                                                                          // 286
    });                                                                                                                // 277
                                                                                                                       //
    globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev, mountProc);                // 289
    globalBackend.updateLastActive(grainId, this.userId, identityId);                                                  // 291
    return grainId;                                                                                                    // 292
  },                                                                                                                   // 293
  openSession: function openSession(grainId, identityId, cachedSalt) {                                                 // 295
    // Open a new UI session on an existing grain.  Starts the grain if it is not already                              //
    // running.                                                                                                        //
                                                                                                                       //
    check(grainId, String);                                                                                            // 299
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 300
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 301
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 303
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 304
    }                                                                                                                  // 305
                                                                                                                       //
    var grain = Grains.findOne({ _id: grainId });                                                                      // 307
    if (!grain) {                                                                                                      // 308
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                          // 309
    } else if (grain.trashed) {                                                                                        // 310
      throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                        // 311
    } else if (grain.suspended) {                                                                                      // 312
      throw new Meteor.Error("grain-owner-suspended", "Grain's owner is suspended", "Grain ID: " + grainId);           // 313
    }                                                                                                                  // 315
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 317
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 318
    if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {                 // 319
      throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                       // 321
    }                                                                                                                  // 322
                                                                                                                       //
    var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);          // 324
    var result = opened.methodResult;                                                                                  // 326
    var proxy = new Proxy(grain, result.sessionId, result.hostId, result.tabId, identityId, false, null, opened.supervisor);
    proxiesByHostId[result.hostId] = proxy;                                                                            // 330
    return result;                                                                                                     // 331
  },                                                                                                                   // 332
  openSessionFromApiToken: function openSessionFromApiToken(params, identityId, cachedSalt, neverRedeem, parentOrigin) {
    // Given an API token, either opens a new WebSession to the underlying grain or returns a                          //
    // path to which the client should redirect in order to open such a session.                                       //
    //                                                                                                                 //
    // `parentOrigin` is the origin of the parent frame of the grain iframe. This may differ from                      //
    // ROOT_URL for standalone domains.                                                                                //
                                                                                                                       //
    neverRedeem = neverRedeem || false;                                                                                // 341
    parentOrigin = parentOrigin || process.env.ROOT_URL;                                                               // 342
                                                                                                                       //
    check(params, {                                                                                                    // 344
      token: String,                                                                                                   // 345
      incognito: Match.Optional(Boolean) });                                                                           // 346
    // obsolete, ignored                                                                                               //
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 348
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 349
    check(neverRedeem, Boolean);                                                                                       // 350
    check(parentOrigin, String);                                                                                       // 351
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 353
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 354
    }                                                                                                                  // 355
                                                                                                                       //
    if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                     // 357
      throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
    }                                                                                                                  // 360
                                                                                                                       //
    var token = params.token;                                                                                          // 362
    var incognito = !identityId;                                                                                       // 363
    var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                      // 364
    var apiToken = ApiTokens.findOne(hashedToken);                                                                     // 365
    validateWebkey(apiToken);                                                                                          // 366
    var grain = Grains.findOne({ _id: apiToken.grainId });                                                             // 367
    if (!grain) {                                                                                                      // 368
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                                 // 369
    }                                                                                                                  // 370
                                                                                                                       //
    if (apiToken.accountId) {                                                                                          // 372
      referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                                 // 373
    }                                                                                                                  // 374
                                                                                                                       //
    var title = void 0;                                                                                                // 376
    if (grain.userId === apiToken.accountId) {                                                                         // 377
      title = grain.title;                                                                                             // 378
    } else {                                                                                                           // 379
      var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                     // 380
        grainId: apiToken.grainId,                                                                                     // 382
        "owner.user.identityId": apiToken.identityId                                                                   // 383
      }, {                                                                                                             // 381
        sort: {                                                                                                        // 385
          lastUsed: -1                                                                                                 // 386
        }                                                                                                              // 385
      });                                                                                                              // 384
      if (sharerToken) {                                                                                               // 389
        title = sharerToken.owner.user.title;                                                                          // 390
      } else {                                                                                                         // 391
        title = "shared grain";                                                                                        // 392
      }                                                                                                                // 393
    }                                                                                                                  // 394
                                                                                                                       //
    if (this.userId && !incognito && !neverRedeem) {                                                                   // 396
      if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
        var owner = { user: { identityId: identityId, title: title } };                                                // 399
                                                                                                                       //
        // Create a new API token for the identity redeeming this token.                                               //
        var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname || "redeemed webkey", { allAccess: null }, owner);
        globalDb.addContact(apiToken.accountId, identityId);                                                           // 406
                                                                                                                       //
        // If the parent API token is forSharing and it has an accountId, then the logged-in user (call                //
        // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference                //
        // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                        //
        // share-by-identity, this happens immediately.)                                                               //
        if (result.parentApiToken) {                                                                                   // 412
          var parentApiToken = result.parentApiToken;                                                                  // 413
          if (parentApiToken.forSharing && parentApiToken.accountId) {                                                 // 414
            storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
          }                                                                                                            // 417
        }                                                                                                              // 418
      }                                                                                                                // 419
                                                                                                                       //
      return { redirectToGrain: apiToken.grainId };                                                                    // 421
    } else {                                                                                                           // 422
      if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                         // 423
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 424
      }                                                                                                                // 426
                                                                                                                       //
      // Even in incognito mode, we want to record the user ID on the session. The user ID is not                      //
      // leaked to the app in any way -- it is used to decide what options to show in a powerbox                       //
      // request. Even if the user is incognito, they should be able to offer their full range of                      //
      // capabilities.                                                                                                 //
      //                                                                                                               //
      // The identity ID passed here IS revealed to the app, but for incognito mode it is always                       //
      // null/undefined.                                                                                               //
      var opened = globalBackend.openSessionInternal(apiToken.grainId, this.userId, identityId, title, apiToken, cachedSalt);
                                                                                                                       //
      var _result = opened.methodResult;                                                                               // 438
      var proxy = new Proxy(grain, _result.sessionId, _result.hostId, _result.tabId, identityId, false, parentOrigin, opened.supervisor);
      proxy.apiToken = apiToken;                                                                                       // 442
      proxiesByHostId[_result.hostId] = proxy;                                                                         // 443
      return _result;                                                                                                  // 444
    }                                                                                                                  // 445
  },                                                                                                                   // 446
  keepSessionAlive: function keepSessionAlive(sessionId) {                                                             // 448
    // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                    //
    //   by them.                                                                                                      //
    check(sessionId, String);                                                                                          // 451
                                                                                                                       //
    var result = Sessions.findAndModify({                                                                              // 453
      query: { _id: sessionId },                                                                                       // 454
      update: { $set: { timestamp: new Date().getTime() } },                                                           // 455
      fields: { grainId: 1, identityId: 1, hostId: 1 }                                                                 // 456
    });                                                                                                                // 453
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 459
      return false;                                                                                                    // 460
    }                                                                                                                  // 461
                                                                                                                       //
    var session = result.value;                                                                                        // 463
    if (session) {                                                                                                     // 464
      // Session still present in database, so send keep-alive to backend.                                             //
      try {                                                                                                            // 466
        var grainId = session.grainId;                                                                                 // 467
        var hostId = session.hostId;                                                                                   // 468
        var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                                // 469
        if (!supervisor) {                                                                                             // 470
          supervisor = globalBackend.continueGrain(grainId).supervisor;                                                // 471
        }                                                                                                              // 472
                                                                                                                       //
        waitPromise(supervisor.keepAlive());                                                                           // 474
        globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                      // 475
      } catch (err) {                                                                                                  // 476
        // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                    //
        // the next request, so whatever.                                                                              //
        if (err.kjType !== "disconnected") {                                                                           // 479
          throw err;                                                                                                   // 480
        }                                                                                                              // 481
      }                                                                                                                // 482
                                                                                                                       //
      return true;                                                                                                     // 484
    } else {                                                                                                           // 485
      return false;                                                                                                    // 486
    }                                                                                                                  // 487
  },                                                                                                                   // 488
  shutdownGrain: function shutdownGrain(grainId) {                                                                     // 490
    check(grainId, String);                                                                                            // 491
    var grain = Grains.findOne(grainId);                                                                               // 492
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 493
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 494
    }                                                                                                                  // 495
                                                                                                                       //
    waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                             // 497
  }                                                                                                                    // 498
});                                                                                                                    // 233
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 501
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 506
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 507
  }                                                                                                                    // 508
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 510
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 511
  }                                                                                                                    // 512
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 514
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 515
  }                                                                                                                    // 516
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 518
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 519
  }                                                                                                                    // 520
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 522
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 523
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 524
    } else if (refreshedExpiration) {                                                                                  // 525
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 526
    } else {                                                                                                           // 527
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 529
    }                                                                                                                  // 530
  }                                                                                                                    // 531
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 533
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 534
  }                                                                                                                    // 535
};                                                                                                                     // 536
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 538
  var shutdownApp = function shutdownApp(appId) {                                                                      // 539
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 540
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 541
    });                                                                                                                // 542
  };                                                                                                                   // 543
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 545
    removed: function removed(devPackage) {                                                                            // 546
      shutdownApp(devPackage.appId);                                                                                   // 546
    },                                                                                                                 // 546
    changed: function changed(newDevPackage, oldDevPackage) {                                                          // 548
      shutdownApp(oldDevPackage.appId);                                                                                // 549
      if (oldDevPackage.appId !== newDevPackage.appId) {                                                               // 550
        shutdownApp(newDevPackage.appId);                                                                              // 551
      }                                                                                                                // 552
    },                                                                                                                 // 553
    added: function added(devPackage) {                                                                                // 555
      shutdownApp(devPackage.appId);                                                                                   // 555
    }                                                                                                                  // 555
  });                                                                                                                  // 545
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 558
    removed: function removed(session) {                                                                               // 559
      var proxy = proxiesByHostId[session.hostId];                                                                     // 560
      delete proxiesByHostId[session.hostId];                                                                          // 561
      if (proxy) {                                                                                                     // 562
        proxy.close();                                                                                                 // 563
      }                                                                                                                // 564
    }                                                                                                                  // 565
  });                                                                                                                  // 558
});                                                                                                                    // 567
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 570
var gcSessions = function gcSessions() {                                                                               // 571
  var now = new Date().getTime();                                                                                      // 572
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 573
};                                                                                                                     // 574
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 576
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 578
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 583
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 585
    var proxy = proxiesByHostId[hostId];                                                                               // 586
    if (proxy) {                                                                                                       // 587
      return proxy;                                                                                                    // 588
    } else {                                                                                                           // 589
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 591
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 593
        var session = Sessions.findOne({ hostId: hostId });                                                            // 594
        if (!session) {                                                                                                // 595
          if (isAlreadyOpened) {                                                                                       // 596
            var _ret = function () {                                                                                   // 596
              var observer = void 0;                                                                                   // 597
              return {                                                                                                 // 598
                v: new Promise(function (resolve, reject) {                                                            // 598
                  var task = Meteor.setTimeout(function () {                                                           // 599
                    reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
                  }, SESSION_PROXY_TIMEOUT);                                                                           // 605
                  observer = Sessions.find({ hostId: hostId }).observe({                                               // 606
                    added: function added() {                                                                          // 607
                      Meteor.clearTimeout(task);                                                                       // 608
                      resolve(getProxyForHostId(hostId, false));                                                       // 609
                    }                                                                                                  // 610
                  });                                                                                                  // 606
                }).then(function (v) {                                                                                 // 612
                  observer.stop();                                                                                     // 613
                  return v;                                                                                            // 614
                }, function (e) {                                                                                      // 615
                  observer.stop();                                                                                     // 616
                  throw e;                                                                                             // 617
                })                                                                                                     // 618
              };                                                                                                       // 598
            }();                                                                                                       // 596
                                                                                                                       //
            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;               // 596
          } else {                                                                                                     // 619
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 621
          }                                                                                                            // 622
        }                                                                                                              // 623
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 625
        if (session.hashedToken) {                                                                                     // 626
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 627
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 630
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 631
          }                                                                                                            // 632
        }                                                                                                              // 633
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 635
        if (!grain) {                                                                                                  // 636
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 638
        }                                                                                                              // 639
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain, session._id, hostId, session.tabId, session.identityId, false);                   // 644
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 646
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 650
          proxiesByHostId[hostId] = proxy;                                                                             // 651
        } else {                                                                                                       // 652
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 653
        }                                                                                                              // 654
                                                                                                                       //
        return proxy;                                                                                                  // 656
      });                                                                                                              // 657
    }                                                                                                                  // 658
  });                                                                                                                  // 659
};                                                                                                                     // 660
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 675
    var _this3 = this;                                                                                                 // 675
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 675
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 676
    this.newBucket = {};                                                                                               // 677
    this.oldBucket = {};                                                                                               // 678
    this.interval = Meteor.setInterval(function () {                                                                   // 679
      for (var oldHashedToken in _this3.oldBucket) {                                                                   // 680
        for (var oldHashedParams in _this3.oldBucket[oldHashedToken]) {                                                // 681
          var newProxy = _this3.newBucket[oldHashedToken] && _this3.newBucket[oldHashedToken][oldHashedParams];        // 682
          var oldProxy = _this3.oldBucket[oldHashedToken][oldHashedParams];                                            // 684
          if (oldProxy && !newProxy) {                                                                                 // 685
            if (Object.keys(oldProxy.websockets).length > 0 || Object.keys(oldProxy.streamingRequests).length > 0 || Object.keys(oldProxy.streamingResponses).length > 0) {
              // A client has an open stream. Keep the proxy around.                                                   //
              _this3.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 690
            } else {                                                                                                   // 691
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 693
            }                                                                                                          // 694
          }                                                                                                            // 695
        }                                                                                                              // 696
      }                                                                                                                // 697
                                                                                                                       //
      _this3.oldBucket = _this3.newBucket;                                                                             // 699
      _this3.newBucket = {};                                                                                           // 700
                                                                                                                       //
      var keepAlives = [];                                                                                             // 702
      for (var hashedToken in _this3.oldBucket) {                                                                      // 703
        for (var hashedParams in _this3.oldBucket[hashedToken]) {                                                      // 704
          var proxy = _this3.oldBucket[hashedToken][hashedParams];                                                     // 705
          keepAlives.push(proxy.supervisor.keepAlive()["catch"](function (e) {                                         // 706
            console.error("supervisor.keepAlive() failed.", e);                                                        // 707
          }));                                                                                                         // 708
        }                                                                                                              // 709
      }                                                                                                                // 710
                                                                                                                       //
      waitPromise(Promise.all(keepAlives));                                                                            // 712
    }, intervalMillis);                                                                                                // 713
  }                                                                                                                    // 714
                                                                                                                       //
  ApiSessionProxies.prototype.get = function get(hashedToken, hashedParams) {                                          //
    if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                    // 717
      return this.newBucket[hashedToken][hashedParams];                                                                // 718
    } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                             // 719
      var proxy = this.oldBucket[hashedToken][hashedParams];                                                           // 720
      delete this.oldBucket[hashedToken][hashedParams];                                                                // 721
      this.put(hashedToken, hashedParams, proxy);                                                                      // 722
      return proxy;                                                                                                    // 723
    } else {                                                                                                           // 724
      return null;                                                                                                     // 725
    }                                                                                                                  // 726
  };                                                                                                                   // 727
                                                                                                                       //
  ApiSessionProxies.prototype.put = function put(hashedToken, hashedParams, proxy) {                                   //
    if (!this.newBucket[hashedToken]) {                                                                                // 730
      this.newBucket[hashedToken] = {};                                                                                // 731
    }                                                                                                                  // 732
                                                                                                                       //
    this.newBucket[hashedToken][hashedParams] = proxy;                                                                 // 734
  };                                                                                                                   // 735
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function removeProxiesOfToken(hashedToken) {                      //
    if (hashedToken in this.oldBucket) {                                                                               // 738
      for (var hashedParams in this.oldBucket[hashedToken]) {                                                          // 739
        this.oldBucket[hashedToken][hashedParams].close();                                                             // 740
      }                                                                                                                // 741
                                                                                                                       //
      delete this.oldBucket[hashedToken];                                                                              // 743
    }                                                                                                                  // 744
                                                                                                                       //
    if (hashedToken in this.newBucket) {                                                                               // 746
      for (var _hashedParams in this.newBucket[hashedToken]) {                                                         // 747
        this.newBucket[hashedToken][_hashedParams].close();                                                            // 748
      }                                                                                                                // 749
                                                                                                                       //
      delete this.newBucket[hashedToken];                                                                              // 751
    }                                                                                                                  // 752
  };                                                                                                                   // 753
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
// The interval of 60 seconds here deliberately matches the `keepSessionAlive()` interval                              //
// in the case of non-API proxies.                                                                                     //
                                                                                                                       //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(60 * 1000);                                                              // 758
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 760
  Grains.find().observe({                                                                                              // 761
    changed: function changed(newGrain, oldGrain) {                                                                    // 762
      if (oldGrain["private"] != newGrain["private"]) {                                                                // 763
        Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                          // 764
        ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                        // 765
          apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                        // 766
        });                                                                                                            // 767
      }                                                                                                                // 768
    }                                                                                                                  // 769
  });                                                                                                                  // 761
});                                                                                                                    // 771
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 773
  var params = {};                                                                                                     // 774
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 775
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 776
      return s.trim();                                                                                                 // 778
    });                                                                                                                // 778
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 782
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 786
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 787
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 790
      }                                                                                                                // 791
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 793
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 798
          return parseInt(x, 10);                                                                                      // 799
        }).reduce(function (a, b) {                                                                                    // 799
          return 256 * a + b;                                                                                          // 800
        });                                                                                                            // 800
        params.remoteAddress = {                                                                                       // 801
          lower64: v4Int,                                                                                              // 802
          upper64: 0                                                                                                   // 803
        };                                                                                                             // 801
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 805
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 809
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 812
          groups.shift();                                                                                              // 813
        }                                                                                                              // 814
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 816
          groups.pop();                                                                                                // 817
        }                                                                                                              // 818
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 820
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 823
          groups.pop();                                                                                                // 824
          var quad = lastGroup.split(".").map(function (x) {                                                           // 825
            return parseInt(x, 10);                                                                                    // 825
          });                                                                                                          // 825
          groups.push((quad[0] * 256 + quad[1]).toString(16));                                                         // 826
          groups.push((quad[2] * 256 + quad[3]).toString(16));                                                         // 827
        }                                                                                                              // 828
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 830
        var emptyGroupIndex = groups.indexOf("");                                                                      // 831
        var cleanGroups = void 0;                                                                                      // 832
        if (emptyGroupIndex !== -1) {                                                                                  // 833
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 834
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 836
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 837
            mid[i] = "0";                                                                                              // 838
          }                                                                                                            // 839
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 841
          cleanGroups = [].concat(head, mid, tail);                                                                    // 842
        } else {                                                                                                       // 843
          cleanGroups = groups;                                                                                        // 844
        }                                                                                                              // 845
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 847
          return parseInt(x, 16);                                                                                      // 847
        });                                                                                                            // 847
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 850
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 851
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 852
        };                                                                                                             // 850
      }                                                                                                                // 854
    }                                                                                                                  // 855
  }                                                                                                                    // 856
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 858
}                                                                                                                      // 859
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 862
  check(token, String);                                                                                                // 863
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 864
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 865
  var serializedParams = getApiSessionParams(request);                                                                 // 867
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 868
  return Promise.resolve(undefined).then(function () {                                                                 // 869
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 870
    if (proxy) {                                                                                                       // 871
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 872
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 873
      }                                                                                                                // 874
                                                                                                                       //
      return proxy;                                                                                                    // 876
    } else {                                                                                                           // 877
      return inMeteor(function () {                                                                                    // 878
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 879
        validateWebkey(tokenInfo);                                                                                     // 880
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 882
        if (!grain) {                                                                                                  // 883
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 885
        }                                                                                                              // 886
                                                                                                                       //
        var proxy = void 0;                                                                                            // 888
        if (tokenInfo.userInfo) {                                                                                      // 889
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 890
        } else {                                                                                                       // 891
          var identityId = null;                                                                                       // 892
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 893
            identityId = tokenInfo.identityId;                                                                         // 894
          }                                                                                                            // 895
                                                                                                                       //
          proxy = new Proxy(grain, null, null, tabId, identityId, true);                                               // 897
          proxy.apiToken = tokenInfo;                                                                                  // 898
          proxy.apiSessionParams = serializedParams;                                                                   // 899
        }                                                                                                              // 900
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 902
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 904
        }                                                                                                              // 905
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 907
          proxy.expires = tokenInfo.expires;                                                                           // 908
        }                                                                                                              // 909
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 911
                                                                                                                       //
        return proxy;                                                                                                  // 913
      });                                                                                                              // 914
    }                                                                                                                  // 915
  });                                                                                                                  // 916
};                                                                                                                     // 917
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 919
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 927
    return true;                                                                                                       // 928
  }                                                                                                                    // 929
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 940
  return agent && agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                           // 941
};                                                                                                                     // 942
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 944
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 947
  var token = void 0;                                                                                                  // 948
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 949
    token = auth.slice(7).trim();                                                                                      // 950
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 951
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 953
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 954
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 957
    if (parts.length < 2) {                                                                                            // 958
      token = undefined;                                                                                               // 959
    } else {                                                                                                           // 960
      token = parts[1];                                                                                                // 961
      req.url = "/" + parts.slice(2).join("/");                                                                        // 962
      // remove .sandstorm-token/$TOKEN from path                                                                      //
    }                                                                                                                  // 964
  } else {                                                                                                             // 965
      token = undefined;                                                                                               // 966
    }                                                                                                                  // 967
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 969
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 971
      token = undefined;                                                                                               // 972
    }                                                                                                                  // 973
  }                                                                                                                    // 974
                                                                                                                       //
  return token;                                                                                                        // 976
};                                                                                                                     // 977
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 984
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 990
    var token = apiTokenForRequest(req, hostId);                                                                       // 991
    if (token) {                                                                                                       // 992
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 993
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 996
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 998
        return true;                                                                                                   // 999
      });                                                                                                              // 1000
    } else {                                                                                                           // 1001
      return Promise.resolve(false);                                                                                   // 1002
    }                                                                                                                  // 1003
  } else {                                                                                                             // 1004
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1005
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1006
      if (proxy) {                                                                                                     // 1007
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 1009
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 1010
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 1011
        }                                                                                                              // 1012
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 1016
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1018
        return true;                                                                                                   // 1019
      } else {                                                                                                         // 1020
        return false;                                                                                                  // 1021
      }                                                                                                                // 1022
    });                                                                                                                // 1023
  }                                                                                                                    // 1024
};                                                                                                                     // 1025
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 1028
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 1034
  if (hostIdHash) {                                                                                                    // 1035
    var _ret2 = function () {                                                                                          // 1035
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1038
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1040
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1057
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1058
          "Access-Control-Max-Age": "3600"                                                                             // 1059
        };                                                                                                             // 1057
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1063
        if (requestedHeaders) {                                                                                        // 1064
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1065
        }                                                                                                              // 1066
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1069
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1070
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1072
        }                                                                                                              // 1073
                                                                                                                       //
        for (header in accessControlHeaders) {                                                                         // 1075
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1076
        }                                                                                                              // 1077
      }                                                                                                                // 1078
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1080
        if (err instanceof Meteor.Error) {                                                                             // 1081
          console.log("error: " + err);                                                                                // 1082
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1083
        } else {                                                                                                       // 1084
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1085
        }                                                                                                              // 1086
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1088
      };                                                                                                               // 1089
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1091
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1092
        inMeteor(function () {                                                                                         // 1093
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1094
          check(keepaliveDuration, Match.Integer);                                                                     // 1095
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1096
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1097
        }).then(function () {                                                                                          // 1098
          res.writeHead(200, {});                                                                                      // 1099
          res.end();                                                                                                   // 1100
        }, errorHandler);                                                                                              // 1101
      } else if (token) {                                                                                              // 1102
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1103
          proxy.requestHandler(req, res);                                                                              // 1104
        }, errorHandler);                                                                                              // 1105
      } else {                                                                                                         // 1106
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1108
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1109
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1111
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1114
            if (dav.length > 0) {                                                                                      // 1115
              res.setHeader("DAV", dav.join(", "));                                                                    // 1116
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1117
            }                                                                                                          // 1118
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1120
            res.end();                                                                                                 // 1121
          } else {                                                                                                     // 1122
            var resources = (apiHost || {}).resources || {};                                                           // 1123
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1124
            if (path in resources) {                                                                                   // 1125
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1127
              console.log(path, resources, resource);                                                                  // 1128
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1129
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1130
              res.writeHead(200, {                                                                                     // 1131
                "Content-Type": resource.type                                                                          // 1132
              });                                                                                                      // 1131
              res.end(resource.body);                                                                                  // 1134
            } else {                                                                                                   // 1135
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1136
                res.writeHead(401, {                                                                                   // 1137
                  "Content-Type": "text/plain",                                                                        // 1138
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1139
                });                                                                                                    // 1137
              } else {                                                                                                 // 1141
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1143
              }                                                                                                        // 1144
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1150
          }                                                                                                            // 1151
        }).then(function () {}, errorHandler);                                                                         // 1152
      }                                                                                                                // 1153
                                                                                                                       //
      return {                                                                                                         // 1155
        v: Promise.resolve(true)                                                                                       // 1155
      };                                                                                                               // 1155
    }();                                                                                                               // 1035
                                                                                                                       //
    if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                    // 1035
  } else {                                                                                                             // 1156
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1157
                                                                                                                       //
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1160
      if (proxy) {                                                                                                     // 1161
        // Let's do some CSRF defense.                                                                                 //
        var expectedOrigin = PROTOCOL + "//" + req.headers.host;                                                       // 1163
        var mainUrl = proxy.parentOrigin;                                                                              // 1164
        var origin = req.headers.origin;                                                                               // 1165
        var referer = req.headers.referer;                                                                             // 1166
        if (origin) {                                                                                                  // 1167
          // If an origin header was provided, then it must be accurate. Note that Chrome and                          //
          // Safari always send an Origin header on non-GET requests (even same-origin), and                           //
          // therefore on those browsers this rule will block all CSRF attacks. Unfortunately,                         //
          // a patch to add this behavior to Firefox has stalled:                                                      //
          //     https://bugzilla.mozilla.org/show_bug.cgi?id=446344                                                   //
          // I haven't found any information on IE/Edge's behavior.                                                    //
          if (origin !== expectedOrigin) {                                                                             // 1174
            // TODO(security): Alas, it turns out we have apps that have:                                              //
            //   <meta name="referrer" content="no-referrer">                                                          //
            // as Chrome sends "Origin: null" in these cases. :( These apps need to switch to:                         //
            //   <meta name="referrer" content="same-origin">                                                          //
            // It's important that we don't break apps, so we will accept null origins for now,                        //
            // which of course completely defeats any CSRF protection. We should get the apps to                       //
            // update or apply a whitelist soon.                                                                       //
            if (origin === "null") {                                                                                   // 1182
              if (!proxy.wroteCsrfWarning) {                                                                           // 1183
                console.warn("Note: Observed null Origin header. App needs to be updated so that " + "we can apply automatic CSRF protection. grain ID:", proxy.grainId);
                proxy.wroteCsrfWarning = true;                                                                         // 1187
              }                                                                                                        // 1188
            } else {                                                                                                   // 1189
              throw new Meteor.Error(403, "Blocked illegal cross-origin request from: " + origin);                     // 1190
            }                                                                                                          // 1191
          }                                                                                                            // 1192
        } else if (referer) {                                                                                          // 1193
          // Mark that we've seed a Referer header on this host, which indicates that the user's                       //
          // browser is not suppressing them.                                                                          //
          proxy.seenReferer = true;                                                                                    // 1196
                                                                                                                       //
          // Deny requests coming from an external referer, since there is no legitimate use case                      //
          // for these. Note of course that an attacker can trivially suppress the referer header                      //
          // in practice, so this check alone does not give us any security benefit if we accept                       //
          // requests that lack a referer.                                                                             //
          if (referer != expectedOrigin && !referer.startsWith(expectedOrigin + "/") && referer != mainUrl && !referer.startsWith(mainUrl + "/")) {
            throw new Meteor.Error(403, "Blocked illegal cross-origin referral from: " + referer);                     // 1204
          }                                                                                                            // 1205
        } else {                                                                                                       // 1206
          // We saw neither an Origin nor a Referer header.                                                            //
          if (req.method !== "GET" && req.method !== "HEAD") {                                                         // 1208
            // This is possibly a side-effecting request, meaning we should worry about CSRF.                          //
            //                                                                                                         //
            // Note that we'll never get to this branch for Chrome or Safari since they would have                     //
            // sent an Origin header.                                                                                  //
                                                                                                                       //
            if (!proxy.wroteCsrfWarning) {                                                                             // 1214
              console.warn("Note: Observed session for which auto-CSRF-protection couldn't be applied.", "seenReferer:", !!proxy.seenReferer, "method:", req.method, "path:", req.url, "UA:", req.headers["user-agent"]);
              proxy.wroteCsrfWarning = true;                                                                           // 1219
            }                                                                                                          // 1220
          }                                                                                                            // 1221
        }                                                                                                              // 1222
                                                                                                                       //
        proxy.requestHandler(req, res);                                                                                // 1224
        return true;                                                                                                   // 1225
      } else {                                                                                                         // 1226
        return false;                                                                                                  // 1227
      }                                                                                                                // 1228
    });                                                                                                                // 1229
  }                                                                                                                    // 1230
};                                                                                                                     // 1231
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grain, sessionId, hostId, tabId, identityId, isApi, parentOrigin, supervisor) {                       // 1240
    var _this4 = this;                                                                                                 // 1240
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1240
                                                                                                                       //
    // `grain` is an entry in the `Grains` collection.                                                                 //
    this.grainId = grain._id;                                                                                          // 1242
    this.ownerId = grain.userId;                                                                                       // 1243
    this.identityId = identityId;                                                                                      // 1244
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1245
    this.sessionId = sessionId;                                                                                        // 1246
    this.tabId = tabId;                                                                                                // 1247
    this.isApi = isApi;                                                                                                // 1248
    this.hasLoaded = false;                                                                                            // 1249
    this.websockets = {};                                                                                              // 1250
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1251
    this.streamingRequests = {};                                                                                       // 1252
    this.streamingRequestCounter = 0; // Used for generating unique request IDs.                                       // 1253
    this.streamingResponses = {};                                                                                      // 1254
    this.streamingResponseCounter = 0; // Used for generating unique response IDs.                                     // 1255
    this.parentOrigin = parentOrigin || process.env.ROOT_URL;                                                          // 1256
                                                                                                                       //
    if (sessionId) {                                                                                                   // 1258
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1259
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1260
      this.hostId = hostId;                                                                                            // 1261
    } else {                                                                                                           // 1262
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1263
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1264
    }                                                                                                                  // 1265
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1267
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1268
      if (!identity) {                                                                                                 // 1269
        throw new Error("identity not found: " + this.identityId);                                                     // 1270
      }                                                                                                                // 1271
                                                                                                                       //
      // The identity cap becomes invalid if the user no longer has access to the grain.                               //
      var idCapRequirement = {                                                                                         // 1274
        permissionsHeld: { identityId: identity._id, grainId: this.grainId }                                           // 1275
      };                                                                                                               // 1274
                                                                                                                       //
      this.userInfo = {                                                                                                // 1278
        displayName: { defaultText: identity.profile.name },                                                           // 1279
        preferredHandle: identity.profile.handle,                                                                      // 1280
        identityId: new Buffer(identity._id, "hex"),                                                                   // 1281
        identity: makeIdentity(identity._id, [idCapRequirement])                                                       // 1282
      };                                                                                                               // 1278
      if (identity.profile.pictureUrl) {                                                                               // 1284
        this.userInfo.pictureUrl = identity.profile.pictureUrl;                                                        // 1285
      } else {                                                                                                         // 1286
        this.userInfo.pictureUrl = PROTOCOL + "//" + makeWildcardHost("static") + "/identicon/" + this.identityId.slice(0, 32) + "?s=128";
      }                                                                                                                // 1290
                                                                                                                       //
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1292
    } else {                                                                                                           // 1293
      this.userInfo = {                                                                                                // 1294
        displayName: { defaultText: "Anonymous User" },                                                                // 1295
        preferredHandle: "anonymous"                                                                                   // 1296
      };                                                                                                               // 1294
    }                                                                                                                  // 1298
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1300
      if (_this4.sessionId) {                                                                                          // 1301
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1303
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this4.sessionId) {                         // 1304
          _this4.doSessionInit(request, response, url.query.path);                                                     // 1305
          return;                                                                                                      // 1306
        }                                                                                                              // 1307
      }                                                                                                                // 1308
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1310
        var contentLength = request.headers["content-length"];                                                         // 1311
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this4.handleRequestStreaming(request, response, contentLength, 0);                                   // 1315
        } else {                                                                                                       // 1316
          return readAll(request).then(function (data) {                                                               // 1317
            return _this4.handleRequest(request, data, response, 0);                                                   // 1318
          });                                                                                                          // 1319
        }                                                                                                              // 1320
      })["catch"](function (err) {                                                                                     // 1321
        _this4.setHasLoaded();                                                                                         // 1322
                                                                                                                       //
        var body = err.stack;                                                                                          // 1324
        if (err.cppFile) {                                                                                             // 1325
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1326
        }                                                                                                              // 1327
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1329
          body += "\ntype: " + err.kjType;                                                                             // 1330
        }                                                                                                              // 1331
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1333
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1335
          response.end();                                                                                              // 1336
        } else {                                                                                                       // 1337
          if (err instanceof Meteor.Error) {                                                                           // 1338
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1339
          } else {                                                                                                     // 1340
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1341
          }                                                                                                            // 1342
                                                                                                                       //
          response.end(body);                                                                                          // 1344
        }                                                                                                              // 1345
      });                                                                                                              // 1346
    };                                                                                                                 // 1347
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1349
      _this4.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1350
        console.error("WebSocket setup failed:", err.stack);                                                           // 1351
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1353
      });                                                                                                              // 1354
    };                                                                                                                 // 1355
  }                                                                                                                    // 1356
                                                                                                                       //
  Proxy.prototype.close = function close() {                                                                           //
    for (var streamingResponseIdx in this.streamingResponses) {                                                        // 1359
      this.streamingResponses[streamingResponseIdx].abort();                                                           // 1360
    }                                                                                                                  // 1361
                                                                                                                       //
    this.streamingResponses = {};                                                                                      // 1363
                                                                                                                       //
    for (var streamingRequestIdx in this.streamingRequests) {                                                          // 1365
      this.streamingRequests[streamingRequestIdx].destroy();                                                           // 1366
    }                                                                                                                  // 1367
                                                                                                                       //
    this.streamingRequests = {};                                                                                       // 1369
                                                                                                                       //
    for (var socketIdx in this.websockets) {                                                                           // 1371
      this.websockets[socketIdx].destroy();                                                                            // 1372
    };                                                                                                                 // 1373
                                                                                                                       //
    this.websockets = {};                                                                                              // 1375
                                                                                                                       //
    if (this.session) {                                                                                                // 1377
      this.session.close();                                                                                            // 1378
      delete this.session;                                                                                             // 1379
    }                                                                                                                  // 1380
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1382
      this.uiView.close();                                                                                             // 1383
      delete this.uiView;                                                                                              // 1384
    }                                                                                                                  // 1385
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1387
      this.supervisor.close();                                                                                         // 1388
      delete this.supervisor;                                                                                          // 1389
    }                                                                                                                  // 1390
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1392
      this.permissionsObserver.stop();                                                                                 // 1393
      delete this.permissionsObserver;                                                                                 // 1394
    }                                                                                                                  // 1395
  };                                                                                                                   // 1396
                                                                                                                       //
  Proxy.prototype.getConnection = function getConnection() {                                                           //
    if (!this.supervisor) {                                                                                            // 1399
      this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                           // 1400
      this.uiView = null;                                                                                              // 1401
    }                                                                                                                  // 1402
                                                                                                                       //
    if (!this.uiView) {                                                                                                // 1404
      this.uiView = this.supervisor.getMainView().view;                                                                // 1405
    }                                                                                                                  // 1406
  };                                                                                                                   // 1407
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function _callNewWebSession(request, userInfo) {                                //
    var params = Capnp.serialize(WebSession.Params, {                                                                  // 1410
      basePath: PROTOCOL + "//" + request.headers.host,                                                                // 1411
      userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",                 // 1412
      acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
        return s.trim();                                                                                               // 1416
      }) : ["en-US", "en"]                                                                                             // 1416
    });                                                                                                                // 1410
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
  };                                                                                                                   // 1422
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function _callNewApiSession(request, userInfo) {                                //
    var _this5 = this;                                                                                                 // 1424
                                                                                                                       //
    var serializedParams = this.apiSessionParams;                                                                      // 1425
    if (!serializedParams) {                                                                                           // 1426
      throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                   // 1427
    }                                                                                                                  // 1428
                                                                                                                       //
    // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                     //
    // calling newSession with an ApiSession._id.                                                                      //
    // Eventually we'll remove this logic once we're sure apps have updated.                                           //
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
      return session.session;                                                                                          // 1437
    }, function (err) {                                                                                                // 1438
      return _this5._callNewWebSession(request, userInfo);                                                             // 1439
    });                                                                                                                // 1440
  };                                                                                                                   // 1441
                                                                                                                       //
  Proxy.prototype._callNewSession = function _callNewSession(request, viewInfo) {                                      //
    var _this6 = this;                                                                                                 // 1443
                                                                                                                       //
    var userInfo = _.clone(this.userInfo);                                                                             // 1444
    var promise = inMeteor(function () {                                                                               // 1445
      var vertex = void 0;                                                                                             // 1446
      if (_this6.apiToken) {                                                                                           // 1447
        vertex = { token: _this6.apiToken };                                                                           // 1448
      } else {                                                                                                         // 1449
        // (this.identityId might be null; this is fine)                                                               //
        vertex = { grain: { _id: _this6.grainId, identityId: _this6.identityId } };                                    // 1451
      }                                                                                                                // 1452
                                                                                                                       //
      var onInvalidated = function onInvalidated() {                                                                   // 1454
        Sessions.remove({ _id: _this6.sessionId });                                                                    // 1455
      };                                                                                                               // 1456
                                                                                                                       //
      if (!_this6.sessionId) {                                                                                         // 1458
        onInvalidated = function onInvalidated() {                                                                     // 1459
          apiSessionProxies.removeProxiesOfToken(_this6.apiToken._id);                                                 // 1460
        };                                                                                                             // 1461
      }                                                                                                                // 1462
                                                                                                                       //
      var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);              // 1464
                                                                                                                       //
      if (_this6.permissionsObserver) _this6.permissionsObserver.stop();                                               // 1467
      _this6.permissionsObserver = permissions.observeHandle;                                                          // 1468
                                                                                                                       //
      if (!permissions.permissions) {                                                                                  // 1470
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 1471
      }                                                                                                                // 1472
                                                                                                                       //
      Sessions.update({                                                                                                // 1474
        _id: _this6.sessionId                                                                                          // 1475
      }, {                                                                                                             // 1474
        $set: {                                                                                                        // 1477
          viewInfo: viewInfo,                                                                                          // 1478
          permissions: permissions.permissions                                                                         // 1479
        }                                                                                                              // 1477
      });                                                                                                              // 1476
                                                                                                                       //
      return permissions.permissions;                                                                                  // 1483
    });                                                                                                                // 1484
                                                                                                                       //
    return promise.then(function (permissions) {                                                                       // 1486
      userInfo.permissions = permissions;                                                                              // 1487
                                                                                                                       //
      var numBytes = Math.ceil(permissions.length / 8);                                                                // 1489
      var buf = new Buffer(numBytes);                                                                                  // 1490
      for (var ii = 0; ii < numBytes; ++ii) {                                                                          // 1491
        buf[ii] = 0;                                                                                                   // 1492
      }                                                                                                                // 1493
                                                                                                                       //
      for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                             // 1495
        var byteNum = Math.floor(_ii / 8);                                                                             // 1496
        var bitNum = _ii % 8;                                                                                          // 1497
        if (permissions[_ii]) {                                                                                        // 1498
          buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                   // 1499
        }                                                                                                              // 1500
      }                                                                                                                // 1501
                                                                                                                       //
      userInfo.deprecatedPermissionsBlob = buf;                                                                        // 1503
                                                                                                                       //
      if (_this6.isApi) {                                                                                              // 1505
        return _this6._callNewApiSession(request, userInfo);                                                           // 1506
      } else {                                                                                                         // 1507
        return _this6._callNewWebSession(request, userInfo);                                                           // 1508
      }                                                                                                                // 1509
    });                                                                                                                // 1510
  };                                                                                                                   // 1511
                                                                                                                       //
  Proxy.prototype.getSession = function getSession(request) {                                                          //
    var _this7 = this;                                                                                                 // 1513
                                                                                                                       //
    if (!this.session) {                                                                                               // 1514
      this.getConnection(); // make sure we're connected                                                               // 1515
      var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                               // 1516
        return inMeteor(function () {                                                                                  // 1517
          // For now, we don't allow grains to set `appTitle` or `grainIcon`.                                          //
          var cachedViewInfo = _.omit(viewInfo, "appTitle", "grainIcon");                                              // 1519
          Grains.update(_this7.grainId, { $set: { cachedViewInfo: cachedViewInfo } });                                 // 1520
        }).then(function () {                                                                                          // 1521
          return _this7._callNewSession(request, viewInfo);                                                            // 1522
        });                                                                                                            // 1523
      }, function (error) {                                                                                            // 1524
        if (error.kjType === "failed" || error.kjType === "unimplemented") {                                           // 1525
          // Method not implemented.                                                                                   //
          // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                     //
          //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                     //
          //   to accept 'failed' here at least until the next API bump.                                               //
          return _this7._callNewSession(request, {});                                                                  // 1530
        } else {                                                                                                       // 1531
          return Promise.reject(error);                                                                                // 1532
        }                                                                                                              // 1533
      });                                                                                                              // 1534
      this.session = new Capnp.Capability(promise, WebSession);                                                        // 1535
    }                                                                                                                  // 1536
                                                                                                                       //
    return this.session;                                                                                               // 1538
  };                                                                                                                   // 1539
                                                                                                                       //
  Proxy.prototype.keepAlive = function keepAlive() {                                                                   //
    this.getConnection();                                                                                              // 1542
    return this.supervisor.keepAlive();                                                                                // 1543
  };                                                                                                                   // 1544
                                                                                                                       //
  Proxy.prototype.resetConnection = function resetConnection() {                                                       //
    if (this.session) {                                                                                                // 1547
      this.session.close();                                                                                            // 1548
      delete this.session;                                                                                             // 1549
    }                                                                                                                  // 1550
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1552
      this.uiView.close();                                                                                             // 1553
      delete this.uiView;                                                                                              // 1554
    }                                                                                                                  // 1555
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1557
      this.supervisor.close();                                                                                         // 1558
      delete this.supervisor;                                                                                          // 1559
    }                                                                                                                  // 1560
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1562
      this.permissionsObserver.stop();                                                                                 // 1563
      delete this.permissionsObserver;                                                                                 // 1564
    }                                                                                                                  // 1565
  };                                                                                                                   // 1566
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function maybeRetryAfterError(error, retryCount) {                            //
    var _this8 = this;                                                                                                 // 1568
                                                                                                                       //
    // If the error may be caused by the grain dying or a network failure, try to restart it,                          //
    // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                            //
    // `retryCount` should be incremented for every successful retry as part of the same request;                      //
    // we only want to retry once.                                                                                     //
    if (shouldRestartGrain(error, retryCount)) {                                                                       // 1573
      this.resetConnection();                                                                                          // 1574
      return inMeteor(function () {                                                                                    // 1575
        _this8.supervisor = globalBackend.continueGrain(_this8.grainId).supervisor;                                    // 1576
      });                                                                                                              // 1577
    } else {                                                                                                           // 1578
      throw error;                                                                                                     // 1579
    }                                                                                                                  // 1580
  };                                                                                                                   // 1581
                                                                                                                       //
  Proxy.prototype.doSessionInit = function doSessionInit(request, response, requestPath) {                             //
    // jscs:disable disallowQuotedKeysInObjects                                                                        //
    var path = requestPath || "/";                                                                                     // 1585
                                                                                                                       //
    // Check that the path is relative (ie. starts with a /).                                                          //
    // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                         //
    if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                           // 1589
      response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                              // 1590
      response.end("Invalid path supplied.");                                                                          // 1591
      return;                                                                                                          // 1592
    }                                                                                                                  // 1593
                                                                                                                       //
    // Set the session ID.                                                                                             //
    response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));     // 1596
                                                                                                                       //
    response.setHeader("Cache-Control", "no-cache, private");                                                          // 1598
                                                                                                                       //
    // Redirect to the app's root URL.                                                                                 //
    // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                  //
    //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                       //
    response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                             // 1603
    response.end();                                                                                                    // 1604
  };                                                                                                                   // 1605
                                                                                                                       //
  Proxy.prototype.makeContext = function makeContext(request, response, callback) {                                    //
    // Parses the cookies from the request, checks that the session ID is present and valid, then                      //
    // synchronously calls callback() passing it the request context object which contains the                         //
    // other cookies. Throws an exception if the session ID is missing or invalid. The callback                        //
    // must immediately use the context in an RPC. Once the callback returns, the context object                       //
    // will be torn down.                                                                                              //
    //                                                                                                                 //
    // `makeContext()` returns the result of `callback()`.                                                             //
                                                                                                                       //
    var context = {};                                                                                                  // 1616
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1618
      var parseResult = parseCookies(request);                                                                         // 1619
      if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                        // 1620
        throw new Meteor.Error(403, "Unauthorized");                                                                   // 1621
      }                                                                                                                // 1622
                                                                                                                       //
      if (parseResult.cookies.length > 0) {                                                                            // 1624
        context.cookies = parseResult.cookies;                                                                         // 1625
      }                                                                                                                // 1626
    } else {                                                                                                           // 1627
      // jscs:disable disallowEmptyBlocks                                                                              //
      // This is an API request. Cookies are not supported.                                                            //
    }                                                                                                                  // 1630
                                                                                                                       //
    context.accept = parseAcceptHeader(request);                                                                       // 1632
                                                                                                                       //
    context.acceptEncoding = parseAcceptEncodingHeader(request);                                                       // 1634
                                                                                                                       //
    context.eTagPrecondition = parsePreconditionHeader(request);                                                       // 1636
                                                                                                                       //
    context.additionalHeaders = [];                                                                                    // 1638
    for (var headerName in request.headers) {                                                                          // 1639
      if (REQUEST_HEADER_WHITELIST.matches(headerName)) {                                                              // 1640
        context.additionalHeaders.push({                                                                               // 1641
          name: headerName,                                                                                            // 1642
          value: request.headers[headerName]                                                                           // 1643
        });                                                                                                            // 1641
      }                                                                                                                // 1645
    }                                                                                                                  // 1646
                                                                                                                       //
    if (response) {                                                                                                    // 1648
      var promise = new Promise(function (resolve, reject) {                                                           // 1649
        response.resolveResponseStream = resolve;                                                                      // 1650
        response.rejectResponseStream = reject;                                                                        // 1651
      });                                                                                                              // 1652
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1654
                                                                                                                       //
      try {                                                                                                            // 1656
        return callback(context);                                                                                      // 1657
      } finally {                                                                                                      // 1658
        context.responseStream.close();                                                                                // 1659
      }                                                                                                                // 1660
    } else {                                                                                                           // 1661
      // WebSocket -- no response object.                                                                              //
      return callback(context);                                                                                        // 1663
    }                                                                                                                  // 1664
  };                                                                                                                   // 1665
                                                                                                                       //
  Proxy.prototype.translateResponse = function translateResponse(rpcResponse, response, request) {                     //
    var _this9 = this;                                                                                                 // 1667
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1668
      if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                               // 1669
        response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                             // 1670
      }                                                                                                                // 1671
                                                                                                                       //
      var mainUrl = this.parentOrigin;                                                                                 // 1673
      var grainHost = PROTOCOL + "//" + request.headers.host;                                                          // 1674
      response.setHeader("Content-Security-Policy", "frame-ancestors " + mainUrl + " " + grainHost);                   // 1675
      response.setHeader("X-Frame-Options", "ALLOW-FROM " + mainUrl);                                                  // 1676
                                                                                                                       //
      // TODO(security): Add a Content-Security-Policy header which:                                                   //
      // (1) Prevents the app from initiating HTTP requests to third parties.                                          //
      // (2) Prevents the app from navigating the parent frame.                                                        //
      // (3) Prevents the app from opening popups.                                                                     //
      // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                         //
      //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                        //
    } else {                                                                                                           // 1684
        // This is an API request. Cookies are not supported.                                                          //
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                //
        response.setHeader("Vary", "Authorization");                                                                   // 1688
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                //
        response.setHeader("Access-Control-Allow-Origin", "*");                                                        // 1691
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 //
        // in a browser context. This policy should thoroughly neuter it.                                              //
        response.setHeader("Content-Security-Policy", "default-src 'none'; sandbox");                                  // 1695
      }                                                                                                                // 1696
                                                                                                                       //
    if (rpcResponse.additionalHeaders && rpcResponse.additionalHeaders.length > 0) {                                   // 1698
      // Add any additional prefixed/whitelisted headers to the response.                                              //
      // We cannot trust that the headers in the RPC response are actually                                             //
      // allowed, so we check if they are prefixed or whitelisted.                                                     //
      rpcResponse.additionalHeaders.forEach(function (header) {                                                        // 1702
        if (RESPONSE_HEADER_WHITELIST.matches(header.name)) {                                                          // 1703
          // If header is prefixed with appHeaderPrefix,                                                               //
          // or if the header name is in whitelist, set it.                                                            //
          response.setHeader(header.name, header.value);                                                               // 1706
        }                                                                                                              // 1707
      });                                                                                                              // 1708
    }                                                                                                                  // 1709
                                                                                                                       //
    // On first response, update the session to have hasLoaded=true                                                    //
    this.setHasLoaded();                                                                                               // 1712
                                                                                                                       //
    // TODO(security): Set X-Content-Type-Options: nosniff?                                                            //
                                                                                                                       //
    if ("content" in rpcResponse) {                                                                                    // 1716
      var content = rpcResponse.content;                                                                               // 1717
      var code = successCodes[content.statusCode];                                                                     // 1718
      if (!code) {                                                                                                     // 1719
        throw new Error("Unknown status code: ", content.statusCode);                                                  // 1720
      }                                                                                                                // 1721
                                                                                                                       //
      if (content.mimeType) {                                                                                          // 1723
        response.setHeader("Content-Type", content.mimeType);                                                          // 1724
      }                                                                                                                // 1725
                                                                                                                       //
      if (content.encoding) {                                                                                          // 1727
        response.setHeader("Content-Encoding", content.encoding);                                                      // 1728
      }                                                                                                                // 1729
                                                                                                                       //
      if (content.language) {                                                                                          // 1731
        response.setHeader("Content-Language", content.language);                                                      // 1732
      }                                                                                                                // 1733
                                                                                                                       //
      if (content.eTag) {                                                                                              // 1735
        response.setHeader("ETag", composeETag(content.eTag));                                                         // 1736
      }                                                                                                                // 1737
                                                                                                                       //
      if ("disposition" in content && "download" in content.disposition) {                                             // 1739
        response.setHeader("Content-Disposition", 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
      }                                                                                                                // 1742
                                                                                                                       //
      if ("stream" in content.body) {                                                                                  // 1744
        if (request.method === "HEAD") {                                                                               // 1745
          content.body.stream.close();                                                                                 // 1746
          response.rejectResponseStream(new Error("HEAD request; content doesn't matter."));                           // 1747
        } else if (response.socket.destroyed) {                                                                        // 1748
          // The client has already closed the stream. No additional "close" event will be                             //
          // emitted. Annoyingly, we cannot rely on `response.write()` throwing an exception                           //
          // in this case, so if we don't handle it specially we could end up with a                                   //
          // `ResponseStream` that gets stuck waiting for a "drain" event that never arrives.                          //
          content.body.stream.close();                                                                                 // 1753
          response.rejectResponseStream(new Error("client disconnected"));                                             // 1754
        } else {                                                                                                       // 1755
          var _ret3 = function () {                                                                                    // 1755
            var idx = _this9.streamingResponseCounter;                                                                 // 1756
            _this9.streamingResponseCounter += 1;                                                                      // 1757
            var streamHandle = content.body.stream;                                                                    // 1758
            var rawResponseStream = new ResponseStream(response, code.id, code.title, streamHandle, function () {      // 1759
              delete _this9.streamingResponses[idx];                                                                   // 1761
            });                                                                                                        // 1761
            _this9.streamingResponses[idx] = rawResponseStream;                                                        // 1762
            var responseStream = new Capnp.Capability(rawResponseStream, ByteStream);                                  // 1763
            response.resolveResponseStream(responseStream);                                                            // 1764
            return {                                                                                                   // 1765
              v: { streamHandle: responseStream }                                                                      // 1765
            };                                                                                                         // 1765
          }();                                                                                                         // 1755
                                                                                                                       //
          if ((typeof _ret3 === "undefined" ? "undefined" : _typeof(_ret3)) === "object") return _ret3.v;              // 1755
        }                                                                                                              // 1766
      } else {                                                                                                         // 1767
        response.rejectResponseStream(new Error("Response content body was not a stream."));                           // 1768
                                                                                                                       //
        if ("bytes" in content.body) {                                                                                 // 1771
          response.setHeader("Content-Length", content.body.bytes.length);                                             // 1772
        } else {                                                                                                       // 1773
          throw new Error("Unknown content body type.");                                                               // 1774
        }                                                                                                              // 1775
      }                                                                                                                // 1776
                                                                                                                       //
      response.writeHead(code.id, code.title);                                                                         // 1778
                                                                                                                       //
      if ("bytes" in content.body && request.method !== "HEAD") {                                                      // 1780
        response.write(content.body.bytes);                                                                            // 1781
      }                                                                                                                // 1782
                                                                                                                       //
      response.end();                                                                                                  // 1784
    } else if ("noContent" in rpcResponse) {                                                                           // 1785
      var noContent = rpcResponse.noContent;                                                                           // 1786
      var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                        // 1787
      if (noContent.eTag) {                                                                                            // 1788
        response.setHeader("ETag", composeETag(noContent.eTag));                                                       // 1789
      }                                                                                                                // 1790
                                                                                                                       //
      response.writeHead(noContentCode.id, noContentCode.title);                                                       // 1792
      response.end();                                                                                                  // 1793
    } else if ("preconditionFailed" in rpcResponse) {                                                                  // 1794
      var preconditionFailed = rpcResponse.preconditionFailed;                                                         // 1795
      if (request.method === "GET" && "if-none-match" in request.headers) {                                            // 1796
        if (preconditionFailed.matchingETag) {                                                                         // 1797
          response.setHeader("ETag", composeETag(preconditionFailed.matchingETag));                                    // 1798
        }                                                                                                              // 1799
                                                                                                                       //
        response.writeHead(304, "Not Modified");                                                                       // 1801
      } else {                                                                                                         // 1802
        response.writeHead(412, "Precondition Failed");                                                                // 1803
      }                                                                                                                // 1804
                                                                                                                       //
      response.end();                                                                                                  // 1806
    } else if ("redirect" in rpcResponse) {                                                                            // 1807
      var redirect = rpcResponse.redirect;                                                                             // 1808
      var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                               // 1809
      response.writeHead(redirectCode.id, redirectCode.title, {                                                        // 1810
        "Location": redirect.location                                                                                  // 1811
      });                                                                                                              // 1810
      response.end();                                                                                                  // 1813
    } else if ("clientError" in rpcResponse) {                                                                         // 1814
      var clientError = rpcResponse.clientError;                                                                       // 1815
      var errorCode = errorCodes[clientError.statusCode];                                                              // 1816
      if (!errorCode) {                                                                                                // 1817
        throw new Error("Unknown status code: ", clientError.statusCode);                                              // 1818
      }                                                                                                                // 1819
                                                                                                                       //
      response.writeHead(errorCode.id, errorCode.title, {                                                              // 1821
        "Content-Type": "text/html"                                                                                    // 1822
      });                                                                                                              // 1821
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1825
        if (clientError.descriptionHtml) {                                                                             // 1826
          response.write(clientError.descriptionHtml);                                                                 // 1827
        } else {                                                                                                       // 1828
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>" + errorCode.id + ": " + errorCode.title + "</h1></body></html>");          // 1830
        }                                                                                                              // 1832
      }                                                                                                                // 1833
                                                                                                                       //
      response.end();                                                                                                  // 1835
    } else if ("serverError" in rpcResponse) {                                                                         // 1836
      response.writeHead(500, "Internal Server Error", {                                                               // 1837
        "Content-Type": "text/html"                                                                                    // 1838
      });                                                                                                              // 1837
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1841
        if (rpcResponse.serverError.descriptionHtml) {                                                                 // 1842
          response.write(rpcResponse.serverError.descriptionHtml);                                                     // 1843
        } else {                                                                                                       // 1844
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>500: Internal Server Error</h1></body></html>");                             // 1846
        }                                                                                                              // 1847
      }                                                                                                                // 1848
                                                                                                                       //
      response.end();                                                                                                  // 1850
    } else {                                                                                                           // 1851
      throw new Error("Unknown HTTP response type:\n" + JSON.stringify(rpcResponse));                                  // 1852
    }                                                                                                                  // 1853
                                                                                                                       //
    return {};                                                                                                         // 1855
  };                                                                                                                   // 1856
                                                                                                                       //
  Proxy.prototype.handleRequest = function handleRequest(request, data, response, retryCount) {                        //
    var _this10 = this;                                                                                                // 1858
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1859
      return _this10.makeContext(request, response, function (context) {                                               // 1860
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1863
        var session = _this10.getSession(request);                                                                     // 1864
                                                                                                                       //
        var requestContent = function requestContent() {                                                               // 1866
          return {                                                                                                     // 1867
            content: data,                                                                                             // 1868
            encoding: request.headers["content-encoding"],                                                             // 1869
            mimeType: request.headers["content-type"]                                                                  // 1870
          };                                                                                                           // 1867
        };                                                                                                             // 1872
                                                                                                                       //
        var xmlContent = function xmlContent() {                                                                       // 1874
          var type = request.headers["content-type"] || "application/xml;charset=utf-8";                               // 1875
          var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                              // 1876
          if (!match) {                                                                                                // 1877
            response.writeHead(415, "Unsupported media type.", {                                                       // 1878
              "Content-Type": "text/plain"                                                                             // 1879
            });                                                                                                        // 1878
            response.end("expected XML request body");                                                                 // 1881
            throw new Error("expected XML request body");                                                              // 1882
          }                                                                                                            // 1883
                                                                                                                       //
          var charset = match[2] || "ISO-8859-1";                                                                      // 1885
                                                                                                                       //
          var encoding = request.headers["content-encoding"];                                                          // 1887
          if (encoding && encoding !== "identity") {                                                                   // 1888
            if (encoding !== "gzip") throw new Error("unknown Content-Encoding: " + encoding);                         // 1889
            data = gunzipSync(data);                                                                                   // 1890
          }                                                                                                            // 1891
                                                                                                                       //
          return data.toString(charset.toLowerCase() === "utf-8" ? "utf8" : "binary");                                 // 1893
        };                                                                                                             // 1894
                                                                                                                       //
        var propfindDepth = function propfindDepth() {                                                                 // 1896
          var depth = request.headers["depth"];                                                                        // 1897
          return depth === "0" ? "zero" : depth === "1" ? "one" : "infinity";                                          // 1898
        };                                                                                                             // 1901
                                                                                                                       //
        var shallow = function shallow() {                                                                             // 1903
          return request.headers["depth"] === "0";                                                                     // 1904
        };                                                                                                             // 1905
                                                                                                                       //
        var noOverwrite = function noOverwrite() {                                                                     // 1907
          return (request.headers["overwrite"] || "").toLowerCase() === "f";                                           // 1908
        };                                                                                                             // 1909
                                                                                                                       //
        var destination = function destination() {                                                                     // 1911
          var result = request.headers["destination"];                                                                 // 1912
          if (!result) throw new Error("missing destination");                                                         // 1913
          return Url.parse(result).path.slice(1); // remove leading '/'                                                // 1914
        };                                                                                                             // 1915
                                                                                                                       //
        if (request.method === "GET" || request.method === "HEAD") {                                                   // 1917
          return session.get(path, context, request.method === "HEAD");                                                // 1918
        } else if (request.method === "POST") {                                                                        // 1919
          return session.post(path, requestContent(), context);                                                        // 1920
        } else if (request.method === "PUT") {                                                                         // 1921
          return session.put(path, requestContent(), context);                                                         // 1922
        } else if (request.method === "PATCH") {                                                                       // 1923
          return session.patch(path, requestContent(), context);                                                       // 1924
        } else if (request.method === "DELETE") {                                                                      // 1925
          return session["delete"](path, context);                                                                     // 1926
        } else if (request.method === "PROPFIND") {                                                                    // 1927
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1928
        } else if (request.method === "PROPPATCH") {                                                                   // 1929
          return session.proppatch(path, xmlContent(), context);                                                       // 1930
        } else if (request.method === "MKCOL") {                                                                       // 1931
          return session.mkcol(path, requestContent(), context);                                                       // 1932
        } else if (request.method === "COPY") {                                                                        // 1933
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1934
        } else if (request.method === "MOVE") {                                                                        // 1935
          return session.move(path, destination(), noOverwrite(), context);                                            // 1936
        } else if (request.method === "LOCK") {                                                                        // 1937
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1938
        } else if (request.method === "UNLOCK") {                                                                      // 1939
          return session.unlock(path, request.headers["lock-token"], context);                                         // 1940
        } else if (request.method === "ACL") {                                                                         // 1941
          return session.acl(path, xmlContent(), context);                                                             // 1942
        } else if (request.method === "REPORT") {                                                                      // 1943
          return session.report(path, requestContent(), context);                                                      // 1944
        } else if (request.method === "OPTIONS") {                                                                     // 1945
          return session.options(path, context).then(function (options) {                                              // 1946
            var dav = [];                                                                                              // 1947
            if (options.davClass1) dav.push("1");                                                                      // 1948
            if (options.davClass2) dav.push("2");                                                                      // 1949
            if (options.davClass3) dav.push("3");                                                                      // 1950
            if (options.davExtensions) {                                                                               // 1951
              options.davExtensions.forEach(function (token) {                                                         // 1952
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1953
                  dav.push(token);                                                                                     // 1954
                }                                                                                                      // 1955
              });                                                                                                      // 1956
            }                                                                                                          // 1957
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1959
              response.setHeader("DAV", dav.join(", "));                                                               // 1960
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1961
            }                                                                                                          // 1962
                                                                                                                       //
            response.end();                                                                                            // 1964
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1966
            if (err.kjType !== "unimplemented") throw err;                                                             // 1967
            response.end();                                                                                            // 1968
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1970
        } else {                                                                                                       // 1971
            throw new Error("Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.");
          }                                                                                                            // 1973
      });                                                                                                              // 1974
    }).then(function (rpcResponse) {                                                                                   // 1975
      if (rpcResponse !== undefined) {                                                                                 // 1976
        // Will be undefined for OPTIONS request.                                                                      //
        return _this10.translateResponse(rpcResponse, response, request);                                              // 1977
      }                                                                                                                // 1978
    })["catch"](function (error) {                                                                                     // 1979
      return _this10.maybeRetryAfterError(error, retryCount).then(function () {                                        // 1980
        return _this10.handleRequest(request, data, response, retryCount + 1);                                         // 1981
      });                                                                                                              // 1982
    });                                                                                                                // 1983
  };                                                                                                                   // 1984
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function handleRequestStreaming(request, response, contentLength, retryCount) {
    var _this11 = this;                                                                                                // 1986
                                                                                                                       //
    return this.makeContext(request, response, function (context) {                                                    // 1987
      var path = request.url.slice(1); // remove leading '/'                                                           // 1988
      var session = _this11.getSession(request);                                                                       // 1989
                                                                                                                       //
      var mimeType = request.headers["content-type"] || "application/octet-stream";                                    // 1991
      var encoding = request.headers["content-encoding"];                                                              // 1992
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1994
      if (request.method === "POST") {                                                                                 // 1995
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1996
      } else if (request.method === "PUT") {                                                                           // 1997
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1998
      } else {                                                                                                         // 1999
        throw new Error("Sandstorm only supports streaming POST and PUT requests.");                                   // 2000
      }                                                                                                                // 2001
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 2007
        var requestStream = requestStreamResult.stream;                                                                // 2008
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 2011
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 2014
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even                      //
        // while data is still being streamed up. This theoretically allows apps to perform                            //
        // bidirectional streaming, though probably very few actually do that.                                         //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that                      //
        // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                           //
        // variable.                                                                                                   //
        var responsePromise = requestStream.getResponse();                                                             // 2023
                                                                                                                       //
        var reportUploadStreamError = function reportUploadStreamError(err) {                                          // 2025
          // Called when an upload-stream method throws.                                                               //
                                                                                                                       //
          if (!uploadStreamError) {                                                                                    // 2028
            uploadStreamError = err;                                                                                   // 2029
                                                                                                                       //
            // If we're still waiting on any response stuff, cancel it.                                                //
            responsePromise.cancel();                                                                                  // 2032
            requestStream.close();                                                                                     // 2033
            if (downloadStreamHandle) {                                                                                // 2034
              downloadStreamHandle.close();                                                                            // 2035
            }                                                                                                          // 2036
          }                                                                                                            // 2037
        };                                                                                                             // 2038
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 2041
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 2042
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== "unimplemented") {                                                                      // 2044
              reportUploadStreamError(err);                                                                            // 2045
            }                                                                                                          // 2046
          });                                                                                                          // 2047
        }                                                                                                              // 2048
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        var writesInFlight = 0;                                                                                        // 2051
        var readingPaused = false;                                                                                     // 2052
        request.on("data", function (buf) {                                                                            // 2053
          // TODO(someday): Coalesce small writes.                                                                     //
          if (!uploadStreamError) {                                                                                    // 2055
            requestStream.write(buf).then(function () {                                                                // 2056
              writesInFlight--;                                                                                        // 2057
              if (readingPaused) {                                                                                     // 2058
                request.resume();                                                                                      // 2059
                readingPaused = false;                                                                                 // 2060
              }                                                                                                        // 2061
            })["catch"](reportUploadStreamError);                                                                      // 2062
                                                                                                                       //
            if (writesInFlight++ > 16) {                                                                               // 2064
              request.pause();                                                                                         // 2065
              readingPaused = true;                                                                                    // 2066
            }                                                                                                          // 2067
          }                                                                                                            // 2068
        });                                                                                                            // 2069
                                                                                                                       //
        var idx = _this11.streamingRequestCounter;                                                                     // 2071
        _this11.streamingRequestCounter += 1;                                                                          // 2072
        _this11.streamingRequests[idx] = request;                                                                      // 2073
        destructor = function destructor() {                                                                           // 2074
          delete _this11.streamingRequests[idx];                                                                       // 2074
        };                                                                                                             // 2074
                                                                                                                       //
        request.on("end", function () {                                                                                // 2076
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 2077
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 2080
          destructor();                                                                                                // 2081
        });                                                                                                            // 2082
                                                                                                                       //
        request.on("close", function () {                                                                              // 2084
          reportUploadStreamError(new Error("HTTP connection unexpectedly closed during request."));                   // 2085
          destructor();                                                                                                // 2086
        });                                                                                                            // 2087
                                                                                                                       //
        request.on("error", function (err) {                                                                           // 2089
          reportUploadStreamError(err);                                                                                // 2090
          destructor();                                                                                                // 2091
        });                                                                                                            // 2092
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 2094
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 2096
          downloadStreamHandle = _this11.translateResponse(rpcResponse, response, request).streamHandle;               // 2097
        });                                                                                                            // 2098
      }, function (err) {                                                                                              // 2099
        if (err.kjType === "failed" && err.message.indexOf("not implemented") !== -1) {                                // 2100
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = "unimplemented";                                                                                // 2105
        }                                                                                                              // 2106
                                                                                                                       //
        if (shouldRestartGrain(err, 0)) {                                                                              // 2108
          // This is the kind of error that indicates we should retry. Note that we passed 0 for                       //
          // the retry count above because we were just checking if this is a retriable error (vs.                     //
          // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                    //
          // the proper retry count.                                                                                   //
          return _this11.maybeRetryAfterError(err, retryCount).then(function () {                                      // 2113
            return _this11.handleRequestStreaming(request, response, contentLength, retryCount + 1);                   // 2114
          });                                                                                                          // 2115
        } else if (err.kjType === "unimplemented") {                                                                   // 2116
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 2118
            return _this11.handleRequest(request, data, response, 0);                                                  // 2119
          });                                                                                                          // 2120
        } else {                                                                                                       // 2121
          throw err;                                                                                                   // 2122
        }                                                                                                              // 2123
      });                                                                                                              // 2124
    });                                                                                                                // 2125
  };                                                                                                                   // 2126
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function handleWebSocket(request, socket, head, retryCount) {                      //
    var _this12 = this;                                                                                                // 2128
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 2129
      return _this12.makeContext(request, undefined, function (context) {                                              // 2130
        var path = request.url.slice(1); // remove leading '/'                                                         // 2131
        var session = _this12.getSession(request);                                                                     // 2132
                                                                                                                       //
        if (!("sec-websocket-key" in request.headers)) {                                                               // 2134
          throw new Error("Missing Sec-WebSocket-Accept header.");                                                     // 2135
        }                                                                                                              // 2136
                                                                                                                       //
        var magic = request.headers["sec-websocket-key"] + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";                     // 2138
        var acceptKey = Crypto.createHash("sha1").update(magic).digest("base64");                                      // 2139
                                                                                                                       //
        var protocols = [];                                                                                            // 2141
        if ("sec-websocket-protocol" in request.headers) {                                                             // 2142
          protocols = request.headers["sec-websocket-protocol"].split(",").map(function (s) {                          // 2143
            return s.trim();                                                                                           // 2144
          });                                                                                                          // 2144
        }                                                                                                              // 2145
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 2147
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 2149
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 2151
          promise.serverStream.sendBytes(head);                                                                        // 2152
        }                                                                                                              // 2153
                                                                                                                       //
        var socketIdx = _this12.websocketCounter;                                                                      // 2155
        _this12.websockets[socketIdx] = socket;                                                                        // 2156
        _this12.websocketCounter += 1;                                                                                 // 2157
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 2158
          delete _this12.websockets[socketIdx];                                                                        // 2158
        });                                                                                                            // 2158
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 2160
          var headers = ["HTTP/1.1 101 Switching Protocols", "Upgrade: websocket", "Connection: Upgrade", "Sec-WebSocket-Accept: " + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2167
            headers.push("Sec-WebSocket-Protocol: " + response.protocol.join(", "));                                   // 2168
          }                                                                                                            // 2169
                                                                                                                       //
          headers.push("");                                                                                            // 2171
          headers.push("");                                                                                            // 2172
                                                                                                                       //
          socket.write(headers.join("\r\n"));                                                                          // 2174
          receiver.go();                                                                                               // 2175
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 2178
      });                                                                                                              // 2179
    })["catch"](function (error) {                                                                                     // 2180
      return _this12.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2181
        return _this12.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2182
      });                                                                                                              // 2183
    });                                                                                                                // 2184
  };                                                                                                                   // 2185
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function setHasLoaded() {                                                             //
    var _this13 = this;                                                                                                // 2187
                                                                                                                       //
    if (!this.hasLoaded) {                                                                                             // 2188
      (function () {                                                                                                   // 2188
        _this13.hasLoaded = true;                                                                                      // 2189
        var sessionId = _this13.sessionId;                                                                             // 2190
        inMeteor(function () {                                                                                         // 2191
          Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                          // 2192
        });                                                                                                            // 2193
      })();                                                                                                            // 2188
    }                                                                                                                  // 2194
  };                                                                                                                   // 2195
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2198
  if (Net.isIPv4(address)) {                                                                                           // 2199
    var quad = address.split(".").map(function (x) {                                                                   // 2200
      return parseInt(x, 10);                                                                                          // 2200
    });                                                                                                                // 2200
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2204
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === "::1" || address.lastIndexOf("fd", 0) === 0;                                                    // 2206
  } else {                                                                                                             // 2207
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2209
  }                                                                                                                    // 2210
};                                                                                                                     // 2211
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2213
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2214
  return num.toString();                                                                                               // 2218
};                                                                                                                     // 2219
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2224
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["cookie"];                                                                              // 2226
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2228
  if (header) {                                                                                                        // 2229
    var reqCookies = header.split(";");                                                                                // 2230
    for (var i in reqCookies) {                                                                                        // 2231
      var reqCookie = reqCookies[i];                                                                                   // 2232
      var equalsPos = reqCookie.indexOf("=");                                                                          // 2233
      var cookie = void 0;                                                                                             // 2234
      if (equalsPos === -1) {                                                                                          // 2235
        cookie = { key: reqCookie.trim(), value: "" };                                                                 // 2236
      } else {                                                                                                         // 2237
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2238
      }                                                                                                                // 2239
                                                                                                                       //
      if (cookie.key === "sandstorm-sid") {                                                                            // 2241
        if (result.sessionId) {                                                                                        // 2242
          throw new Error("Multiple sandstorm session IDs?");                                                          // 2243
        }                                                                                                              // 2244
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2246
      } else {                                                                                                         // 2247
        result.cookies.push(cookie);                                                                                   // 2248
      }                                                                                                                // 2249
    }                                                                                                                  // 2250
  }                                                                                                                    // 2251
                                                                                                                       //
  return result;                                                                                                       // 2253
};                                                                                                                     // 2254
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2256
  if (request.headers["if-match"]) {                                                                                   // 2257
    if (request.headers["if-match"].trim() === "*") {                                                                  // 2258
      return { exists: null };                                                                                         // 2259
    }                                                                                                                  // 2260
                                                                                                                       //
    var matches = parseETagList(request.headers["if-match"]);                                                          // 2262
    if (matches.length > 0) {                                                                                          // 2263
      return { matchesOneOf: matches };                                                                                // 2264
    }                                                                                                                  // 2265
  }                                                                                                                    // 2266
                                                                                                                       //
  if (request.headers["if-none-match"]) {                                                                              // 2268
    if (request.headers["if-none-match"].trim() === "*") {                                                             // 2269
      return { doesntExist: null };                                                                                    // 2270
    }                                                                                                                  // 2271
                                                                                                                       //
    var noneMatches = parseETagList(request.headers["if-none-match"]);                                                 // 2273
    if (noneMatches.length > 0) {                                                                                      // 2274
      return { matchesNoneOf: noneMatches };                                                                           // 2275
    }                                                                                                                  // 2276
  }                                                                                                                    // 2277
                                                                                                                       //
  return { none: null };                                                                                               // 2279
};                                                                                                                     // 2280
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2282
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2286
  var results = [];                                                                                                    // 2287
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2289
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2290
    if (!match) throw new Meteor.Error(400, "invalid etag");                                                           // 2291
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2293
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, "$1") });                                       // 2294
  }                                                                                                                    // 2295
                                                                                                                       //
  return results;                                                                                                      // 2297
};                                                                                                                     // 2298
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2300
  var result = '"' + (tag.value || "").replace(/([\\"])/g, "\\$1") + '"';                                              // 2301
  if (tag.weak) result = "W/" + result;                                                                                // 2302
  return result;                                                                                                       // 2303
};                                                                                                                     // 2304
                                                                                                                       //
var parseAcceptHeaderString = function parseAcceptHeaderString(header, field) {                                        // 2306
  var result = [];                                                                                                     // 2307
  if (header) {                                                                                                        // 2308
    var acceptList = header.split(",");                                                                                // 2309
    for (var i in acceptList) {                                                                                        // 2310
      var acceptStr = acceptList[i];                                                                                   // 2311
      var tokensList = acceptStr.split(";");                                                                           // 2312
                                                                                                                       //
      var temp = {};                                                                                                   // 2314
      temp[field] = tokensList[0].trim();                                                                              // 2315
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2317
      for (var j in tokensListRest) {                                                                                  // 2318
        var token = tokensListRest[j];                                                                                 // 2319
        var equalsPos = token.indexOf("=");                                                                            // 2320
        if (equalsPos) {                                                                                               // 2321
          var key = token.slice(0, equalsPos).trim();                                                                  // 2322
          var value = token.slice(equalsPos + 1).trim();                                                               // 2323
                                                                                                                       //
          if (key === "q") {                                                                                           // 2325
            temp.qValue = +value;                                                                                      // 2326
          }                                                                                                            // 2327
        }                                                                                                              // 2328
      }                                                                                                                // 2329
                                                                                                                       //
      result.push(temp);                                                                                               // 2331
    }                                                                                                                  // 2332
  }                                                                                                                    // 2333
                                                                                                                       //
  return result;                                                                                                       // 2335
};                                                                                                                     // 2336
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2338
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["accept"];                                                                              // 2340
  return parseAcceptHeaderString(header, "mimeType");                                                                  // 2341
};                                                                                                                     // 2342
                                                                                                                       //
var parseAcceptEncodingHeader = function parseAcceptEncodingHeader(request) {                                          // 2344
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["accept-encoding"];                                                                     // 2346
  return parseAcceptHeaderString(header, "contentCoding");                                                             // 2347
};                                                                                                                     // 2348
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2353
  return new Promise(function (resolve, reject) {                                                                      // 2354
    var buffers = [];                                                                                                  // 2355
    stream.on("data", function (buf) {                                                                                 // 2356
      buffers.push(buf);                                                                                               // 2357
    });                                                                                                                // 2358
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 2360
      resolve(Buffer.concat(buffers));                                                                                 // 2361
    });                                                                                                                // 2362
                                                                                                                       //
    stream.on("error", reject);                                                                                        // 2364
  });                                                                                                                  // 2365
};                                                                                                                     // 2366
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2368
  var result = [cookie.name, "=", cookie.value];                                                                       // 2369
                                                                                                                       //
  if ("absolute" in cookie.expires) {                                                                                  // 2371
    result.push("; Expires=");                                                                                         // 2372
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2373
  } else if ("relative" in cookie.expires) {                                                                           // 2374
    result.push("; Max-Age=" + cookie.expires.relative);                                                               // 2375
  }                                                                                                                    // 2376
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2378
    result.push("; Path=" + cookie.path);                                                                              // 2379
  }                                                                                                                    // 2380
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2382
    result.push("; HttpOnly");                                                                                         // 2383
  }                                                                                                                    // 2384
                                                                                                                       //
  return result.join("");                                                                                              // 2386
};                                                                                                                     // 2387
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2390
  ok: { id: 200, title: "OK" },                                                                                        // 2391
  created: { id: 201, title: "Created" },                                                                              // 2392
  accepted: { id: 202, title: "Accepted" },                                                                            // 2393
  multiStatus: { id: 207, title: "Multi-Status" }                                                                      // 2394
};                                                                                                                     // 2390
var noContentSuccessCodes = [                                                                                          // 2396
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: "No Content" }, { id: 205, title: "Reset Content" }];                                                // 2398
var redirectCodes = [                                                                                                  // 2401
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: "Temporary Redirect" }, { id: 308, title: "Permanent Redirect" }, { id: 303, title: "See Other" }, { id: 301, title: "Moved Permanently" }];
var errorCodes = {                                                                                                     // 2408
  badRequest: { id: 400, title: "Bad Request" },                                                                       // 2409
  forbidden: { id: 403, title: "Forbidden" },                                                                          // 2410
  notFound: { id: 404, title: "Not Found" },                                                                           // 2411
  methodNotAllowed: { id: 405, title: "Method Not Allowed" },                                                          // 2412
  notAcceptable: { id: 406, title: "Not Acceptable" },                                                                 // 2413
  conflict: { id: 409, title: "Conflict" },                                                                            // 2414
  gone: { id: 410, title: "Gone" },                                                                                    // 2415
  requestEntityTooLarge: { id: 413, title: "Request Entity Too Large" },                                               // 2416
  requestUriTooLong: { id: 414, title: "Request-URI Too Long" },                                                       // 2417
  unsupportedMediaType: { id: 415, title: "Unsupported Media Type" },                                                  // 2418
  imATeapot: { id: 418, title: "I'm a teapot" },                                                                       // 2419
  unprocessableEntity: { id: 422, title: "Unprocessable Entity" }                                                      // 2420
};                                                                                                                     // 2408
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2423
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle, idempotentCleanup) {                         // 2426
    var _this14 = this;                                                                                                // 2426
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2426
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2444
    this.httpCode = httpCode;                                                                                          // 2445
    this.httpStatus = httpStatus;                                                                                      // 2446
    this.upstreamHandle = upstreamHandle;                                                                              // 2447
    this.idempotentCleanup = idempotentCleanup;                                                                        // 2448
                                                                                                                       //
    this.started = false;                                                                                              // 2450
    this.ended = false; // Invariant: if `ended` is true, then `started` is also true.                                 // 2451
    this.waiting = [];                                                                                                 // 2452
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2454
      _this14.waiting.forEach(function (f) {                                                                           // 2455
        return f();                                                                                                    // 2455
      });                                                                                                              // 2455
      _this14.waiting = [];                                                                                            // 2456
    });                                                                                                                // 2457
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2459
      _this14.abort();                                                                                                 // 2459
    });                                                                                                                // 2459
  }                                                                                                                    // 2460
                                                                                                                       //
  ResponseStream.prototype.abort = function abort() {                                                                  // 2423
    this.aborted = true;                                                                                               // 2463
                                                                                                                       //
    // Resolve all outstanding writes. This is OK even if they didn't actually go through because                      //
    // an incomplete download is the client's problem, not the server's. The important thing is                        //
    // to cancel the stream if it is still being generated; to that end, the next new write() call                     //
    // after this point will throw.                                                                                    //
    this.waiting.forEach(function (f) {                                                                                // 2469
      return f();                                                                                                      // 2469
    });                                                                                                                // 2469
    this.waiting = [];                                                                                                 // 2470
                                                                                                                       //
    this.close();                                                                                                      // 2472
  };                                                                                                                   // 2473
                                                                                                                       //
  ResponseStream.prototype.expectSize = function expectSize(size) {                                                    // 2423
    if (!this.started) {                                                                                               // 2476
      this.started = true;                                                                                             // 2477
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                             // 2478
    }                                                                                                                  // 2479
  };                                                                                                                   // 2480
                                                                                                                       //
  ResponseStream.prototype.write = function write(data) {                                                              // 2423
    var _this15 = this;                                                                                                // 2482
                                                                                                                       //
    if (!this.started) {                                                                                               // 2483
      this.started = true;                                                                                             // 2484
      this.response.writeHead(this.httpCode, this.httpStatus);                                                         // 2485
    }                                                                                                                  // 2486
                                                                                                                       //
    if (this.aborted) {                                                                                                // 2488
      // Connection has been aborted.                                                                                  //
      if (this.alreadyThrew) {                                                                                         // 2490
        // We already threw an error from a previous write(). Do not throw more errors, because                        //
        // older versions of sandstorm-http-bridge do not stop on the first error and will print                       //
        // every error to the log, wasting space. Newer versions stop on the first failure.                            //
        return;                                                                                                        // 2494
      } else {                                                                                                         // 2495
        this.alreadyThrew = true;                                                                                      // 2496
        throw new Error("client disconnected");                                                                        // 2497
      }                                                                                                                // 2498
    } else {                                                                                                           // 2499
      if (this.response.write(data)) {                                                                                 // 2500
        // All written.                                                                                                //
        return;                                                                                                        // 2502
      } else {                                                                                                         // 2503
        // Write buffer is full. Don't complete until it has more space.                                               //
        return new Promise(function (resolve, reject) {                                                                // 2505
          _this15.waiting.push(resolve);                                                                               // 2506
        });                                                                                                            // 2507
      }                                                                                                                // 2508
    }                                                                                                                  // 2509
  };                                                                                                                   // 2510
                                                                                                                       //
  ResponseStream.prototype.done = function done() {                                                                    // 2423
    if (!this.started) {                                                                                               // 2513
      this.started = true;                                                                                             // 2514
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                                // 2515
    }                                                                                                                  // 2516
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2518
      this.ended = true;                                                                                               // 2519
      this.response.end();                                                                                             // 2520
    }                                                                                                                  // 2521
                                                                                                                       //
    this.close();                                                                                                      // 2523
  };                                                                                                                   // 2524
                                                                                                                       //
  ResponseStream.prototype.close = function close() {                                                                  // 2423
    if (this.upstreamHandle) {                                                                                         // 2527
      this.upstreamHandle.close();                                                                                     // 2528
    }                                                                                                                  // 2529
                                                                                                                       //
    if (this.idempotentCleanup) {                                                                                      // 2531
      this.idempotentCleanup();                                                                                        // 2532
    }                                                                                                                  // 2533
                                                                                                                       //
    // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                   //
    // the only case in which we can actually report the error is when we haven't done any writes                      //
    // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                           //
    // implies `!this.ended`.                                                                                          //
    if (!this.started) {                                                                                               // 2539
      this.started = true;                                                                                             // 2540
      this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });        // 2541
    }                                                                                                                  // 2543
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2545
      this.ended = true;                                                                                               // 2546
      this.response.end();                                                                                             // 2547
    }                                                                                                                  // 2548
  };                                                                                                                   // 2549
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function sendingDirectResponse() {                                  // 2423
    // For internal front-end use: Indicates that the caller is going to fill in the response                          //
    // instead. If a response has already been started, this throws an exception.                                      //
    //                                                                                                                 //
    // This is used in particular in pre-meteor.js, when dealing with static web publishing.                           //
                                                                                                                       //
    if (this.started) {                                                                                                // 2557
      throw new Error("can't sendDirectResponse() because response already started");                                  // 2558
      this.response.end();                                                                                             // 2559
    } else if (this.ended) {                                                                                           // 2560
      throw new Error("can't sendDirectResponse() because response already sent");                                     // 2561
    } else {                                                                                                           // 2562
      this.started = true;                                                                                             // 2563
      this.ended = true;                                                                                               // 2564
    }                                                                                                                  // 2565
  };                                                                                                                   // 2566
                                                                                                                       //
  return ResponseStream;                                                                                               // 2423
}();                                                                                                                   // 2423
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require("zlib");                                                                                        // 2570
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2571
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2576
  function WebSocketReceiver(socket) {                                                                                 // 2577
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2577
                                                                                                                       //
    this.socket = socket;                                                                                              // 2578
    this.queue = [];                                                                                                   // 2579
  }                                                                                                                    // 2580
                                                                                                                       //
  WebSocketReceiver.prototype.go = function go() {                                                                     // 2576
    for (var i in this.queue) {                                                                                        // 2583
      this.socket.write(this.queue[i]);                                                                                // 2584
    }                                                                                                                  // 2585
                                                                                                                       //
    this.queue = null;                                                                                                 // 2587
  };                                                                                                                   // 2588
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function sendBytes(message) {                                                // 2576
    // TODO(someday):  Flow control of some sort?                                                                      //
    if (this.queue === null) {                                                                                         // 2592
      this.socket.write(message);                                                                                      // 2593
    } else {                                                                                                           // 2594
      this.queue.push(message);                                                                                        // 2595
    }                                                                                                                  // 2596
  };                                                                                                                   // 2597
                                                                                                                       //
  WebSocketReceiver.prototype.close = function close() {                                                               // 2576
    this.socket.end();                                                                                                 // 2600
  };                                                                                                                   // 2601
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2576
}();                                                                                                                   // 2576
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2604
  var writesInFlight = 0;                                                                                              // 2605
  var readingPaused = false;                                                                                           // 2606
  socket.on("data", function (chunk) {                                                                                 // 2607
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2608
      writesInFlight--;                                                                                                // 2609
      if (readingPaused) {                                                                                             // 2610
        socket.resume();                                                                                               // 2611
        readingPaused = false;                                                                                         // 2612
      }                                                                                                                // 2613
    })["catch"](function (err) {                                                                                       // 2614
      if (err.kjType !== "disconnected") {                                                                             // 2615
        console.error("WebSocket sendBytes failed: " + err.stack);                                                     // 2616
      }                                                                                                                // 2617
                                                                                                                       //
      socket.destroy();                                                                                                // 2619
    });                                                                                                                // 2620
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2622
      socket.pause();                                                                                                  // 2623
      readingPaused = true;                                                                                            // 2624
    }                                                                                                                  // 2625
  });                                                                                                                  // 2626
                                                                                                                       //
  socket.on("end", function (chunk) {                                                                                  // 2628
    rpcStream.close();                                                                                                 // 2629
  });                                                                                                                  // 2630
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2632
    destructor();                                                                                                      // 2633
  });                                                                                                                  // 2634
};                                                                                                                     // 2635
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish("grainLog", function (grainId) {                                                                        // 2640
  var _this16 = this;                                                                                                  // 2640
                                                                                                                       //
  check(grainId, String);                                                                                              // 2641
  var id = 0;                                                                                                          // 2642
  var grain = Grains.findOne(grainId);                                                                                 // 2643
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2644
    this.added("grainLog", id++, { text: "Only the grain owner can view the debug log." });                            // 2645
    this.ready();                                                                                                      // 2646
    return;                                                                                                            // 2647
  }                                                                                                                    // 2648
                                                                                                                       //
  var connected = false;                                                                                               // 2650
  var _this = this;                                                                                                    // 2651
                                                                                                                       //
  var receiver = {                                                                                                     // 2653
    write: function write(data) {                                                                                      // 2654
      connected = true;                                                                                                // 2655
      _this.added("grainLog", id++, { text: data.toString("utf8") });                                                  // 2656
    },                                                                                                                 // 2657
    close: function close() {                                                                                          // 2659
      if (connected) {                                                                                                 // 2660
        _this.added("grainLog", id++, {                                                                                // 2661
          text: "*** lost connection to grain (probably because it shut down) ***"                                     // 2662
        });                                                                                                            // 2661
      }                                                                                                                // 2664
    }                                                                                                                  // 2665
  };                                                                                                                   // 2653
                                                                                                                       //
  try {                                                                                                                // 2668
    (function () {                                                                                                     // 2668
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2669
        return supervisor.watchLog(8192, receiver);                                                                    // 2670
      })).handle;                                                                                                      // 2671
      connected = true;                                                                                                // 2672
      _this16.onStop(function () {                                                                                     // 2673
        handle.close();                                                                                                // 2674
      });                                                                                                              // 2675
    })();                                                                                                              // 2668
  } catch (err) {                                                                                                      // 2676
    if (!connected) {                                                                                                  // 2677
      this.added("grainLog", id++, {                                                                                   // 2678
        text: "*** couldn't connect to grain (" + err + ") ***"                                                        // 2679
      });                                                                                                              // 2678
    }                                                                                                                  // 2681
  }                                                                                                                    // 2682
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2685
});                                                                                                                    // 2686
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 28
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 34
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 36
  var responseCallback = function responseCallback(res) {                                                              // 37
    if (res.statusCode === 200) {                                                                                      // 38
      console.log("Successfully updated sandcats IP");                                                                 // 39
    } else {                                                                                                           // 40
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 41
    }                                                                                                                  // 42
  };                                                                                                                   // 43
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 45
    console.error("Couldn't send update sandcats hostname", err);                                                      // 46
  };                                                                                                                   // 47
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 51
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 53
  var socket = dgram.createSocket("udp4");                                                                             // 54
  var secret = Random.secret(16);                                                                                      // 55
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 57
  socket.on("message", function (buf) {                                                                                // 58
    if (buf.toString() === secret) {                                                                                   // 59
      updateSandcatsIp();                                                                                              // 60
    } else {                                                                                                           // 61
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 62
    }                                                                                                                  // 63
  });                                                                                                                  // 64
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 66
    if (err) {                                                                                                         // 67
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 68
    }                                                                                                                  // 69
  });                                                                                                                  // 70
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 72
    socket.close();                                                                                                    // 73
  }, 10 * 1000);                                                                                                       // 74
};                                                                                                                     // 75
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 78
    hostname: hostname,                                                                                                // 79
    path: path,                                                                                                        // 80
    method: "POST",                                                                                                    // 81
    agent: false,                                                                                                      // 82
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 83
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 84
    headers: {                                                                                                         // 85
      "X-Sand": "cats",                                                                                                // 86
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 87
    }                                                                                                                  // 85
  };                                                                                                                   // 78
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 91
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 95
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 97
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 98
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 103
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 105
  req.write(newPostData);                                                                                              // 106
  req.end();                                                                                                           // 107
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 109
    req.on("error", errorCallback);                                                                                    // 110
  }                                                                                                                    // 111
                                                                                                                       //
  return req;                                                                                                          // 113
};                                                                                                                     // 114
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 116
  check(commonName, String);                                                                                           // 117
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 122
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 126
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = pki.createCertificationRequest();                                                                          // 129
  csr.publicKey = keys.publicKey;                                                                                      // 130
  csr.setSubject([{                                                                                                    // 131
    name: "commonName",                                                                                                // 133
    value: commonName,                                                                                                 // 134
    valueTagClass: asn1.Type.UTF8                                                                                      // 135
  }]);                                                                                                                 // 132
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 141
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 142
  return {                                                                                                             // 143
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 144
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 145
  };                                                                                                                   // 143
};                                                                                                                     // 147
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 149
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 156
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 157
  var csrFilename = keyFilename + ".csr";                                                                              // 158
  var responseFilename = keyFilename + ".response-json";                                                               // 159
  var withWildcard = "*." + hostname;                                                                                  // 160
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 161
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 162
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 164
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 169
    csrFilename: csrFilename,                                                                                          // 170
    keyFilename: keyFilename,                                                                                          // 171
    responseFilename: responseFilename                                                                                 // 172
  };                                                                                                                   // 169
};                                                                                                                     // 174
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 176
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 177
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 178
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 179
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 180
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 182
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 183
    };                                                                                                                 // 184
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 186
      if (res.statusCode == 200) {                                                                                     // 187
        (function () {                                                                                                 // 187
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 190
          res.on("data", function (chunk) {                                                                            // 191
            responseBody += chunk;                                                                                     // 192
          });                                                                                                          // 193
                                                                                                                       //
          res.on("end", function () {                                                                                  // 195
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 198
              JSON.parse(responseBody);                                                                                // 199
            } catch (e) {                                                                                              // 200
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 207
            }                                                                                                          // 208
                                                                                                                       //
            try {                                                                                                      // 210
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 211
            } catch (err) {                                                                                            // 212
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 217
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 221
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 223
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 225
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 227
            }                                                                                                          // 229
          });                                                                                                          // 230
        })();                                                                                                          // 187
      } else {                                                                                                         // 231
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 232
        res.on("data", function (chunk) {                                                                              // 234
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 235
        });                                                                                                            // 236
      }                                                                                                                // 237
    };                                                                                                                 // 238
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 240
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 242
      rawHostname: SANDCATS_NAME,                                                                                      // 243
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 244
    }, errorCallback, responseCallback);                                                                               // 242
  };                                                                                                                   // 246
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 248
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 249
    return renewHttpsCertificate();                                                                                    // 250
  }                                                                                                                    // 251
};                                                                                                                     // 252
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 254
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 255
  if (i < 0) {                                                                                                         // 256
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 259
    var oneMinute = 60 * 1000;                                                                                         // 260
    var oneHour = 60 * oneMinute;                                                                                      // 261
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 262
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 264
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 265
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 267
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 269
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 273
    }                                                                                                                  // 275
  }                                                                                                                    // 276
};                                                                                                                     // 277
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 279
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 280
};                                                                                                                     // 281
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":["/imports/server/async-helpers.js","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});var staticAssetHost;module.import("/imports/server/constants.js",{"staticAssetHost":function(v){staticAssetHost=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
                                                                                                                       // 36
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 38
Meteor.startup(function () {                                                                                           // 39
  var frameSetter = function frameSetter() {                                                                           // 40
    BrowserPolicy.content.disallowFrame(); // This clears all the old rules                                            // 41
    BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                       // 42
    var billingPromptUrl = globalDb.getBillingPromptUrl();                                                             // 43
    if (billingPromptUrl) {                                                                                            // 44
      BrowserPolicy.content.allowFrameOrigin(billingPromptUrl);                                                        // 45
    }                                                                                                                  // 46
  };                                                                                                                   // 47
                                                                                                                       //
  frameSetter(); // Call once on startup                                                                               // 49
  globalDb.collections.settings.find({ _id: "billingPromptUrl" }).observe({                                            // 50
    added: frameSetter,                                                                                                // 51
    changed: frameSetter,                                                                                              // 52
    removed: frameSetter                                                                                               // 53
  });                                                                                                                  // 50
});                                                                                                                    // 55
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
                                                                                                                       // 58
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 59
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 60
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 61
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 62
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 64
  var _this = this;                                                                                                    // 64
                                                                                                                       //
  if (this.userId) {                                                                                                   // 65
    if (globalDb.isQuotaEnabled()) {                                                                                   // 66
      (function () {                                                                                                   // 66
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 71
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 72
          inMeteor(function () {                                                                                       // 73
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 74
          });                                                                                                          // 75
        })["catch"](function (err) {                                                                                   // 76
          if (err.kjType === "unimplemented") {                                                                        // 77
            // Compute based on sum of grain sizes instead.                                                            //
            var total = 0;                                                                                             // 79
            Grains.find({ userId: userId }, { fields: { size: 1 } }).forEach(function (grain) {                        // 80
              return total += grain.size || 0;                                                                         // 81
            });                                                                                                        // 81
            Meteor.users.update(userId, { $set: { storageUsage: total } });                                            // 82
          } else {                                                                                                     // 83
            console.error(err.stack);                                                                                  // 84
          }                                                                                                            // 85
        });                                                                                                            // 86
      })();                                                                                                            // 66
    }                                                                                                                  // 87
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 89
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 95
    return [];                                                                                                         // 96
  }                                                                                                                    // 97
});                                                                                                                    // 98
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 100
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 104
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 105
});                                                                                                                    // 106
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 108
  return DevPackages.find();                                                                                           // 109
});                                                                                                                    // 110
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 112
  var _this2 = this;                                                                                                   // 112
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 116
  if (cursor.count() > 0) {                                                                                            // 117
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 118
  } else {                                                                                                             // 119
    (function () {                                                                                                     // 119
      var handle = cursor.observeChanges({                                                                             // 120
        added: function added(id) {                                                                                    // 121
          _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                    // 122
          handle.stop();                                                                                               // 123
          handle = null;                                                                                               // 124
        }                                                                                                              // 125
      });                                                                                                              // 120
      _this2.onStop(function () {                                                                                      // 127
        if (handle) handle.stop();                                                                                     // 128
      });                                                                                                              // 129
    })();                                                                                                              // 119
  }                                                                                                                    // 130
                                                                                                                       //
  this.ready();                                                                                                        // 132
});                                                                                                                    // 133
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 135
  var _this3 = this;                                                                                                   // 135
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 144
    return [];                                                                                                         // 145
  }                                                                                                                    // 146
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 154
    referredBy: this.userId,                                                                                           // 155
    "profile.name": { $exists: true }                                                                                  // 156
  }, {                                                                                                                 // 154
    fields: {                                                                                                          // 158
      _id: 1,                                                                                                          // 159
      referredBy: 1,                                                                                                   // 160
      "profile.name": 1                                                                                                // 161
    }                                                                                                                  // 158
  });                                                                                                                  // 157
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 164
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function added(id, fields) {                                                                                // 166
      _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                               // 167
    },                                                                                                                 // 168
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function removed(id) {                                                                                    // 171
      _this3.removed("referralInfo", id);                                                                              // 172
    },                                                                                                                 // 173
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function modified(id, fields) {                                                                          // 175
      _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                            // 176
    }                                                                                                                  // 177
  });                                                                                                                  // 164
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 188
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 189
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 190
      stopWatchingIdentity(identityId);                                                                                // 191
    });                                                                                                                // 192
  };                                                                                                                   // 193
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 195
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 196
    if (handleForProfileName) {                                                                                        // 197
      _this3.removed("referralInfo", identityId);                                                                      // 198
      handleForProfileName.stop();                                                                                     // 199
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 201
    }                                                                                                                  // 202
  };                                                                                                                   // 203
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 205
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 206
    if (handleForProfileName) {                                                                                        // 207
      return;                                                                                                          // 208
    }                                                                                                                  // 209
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 211
      _id: identityId                                                                                                  // 212
    }, {                                                                                                               // 211
      fields: {                                                                                                        // 214
        "profile.name": 1                                                                                              // 215
      }                                                                                                                // 214
    }).observeChanges({                                                                                                // 213
      added: function added(id, fields) {                                                                              // 218
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                              // 219
      },                                                                                                               // 220
                                                                                                                       //
      changed: function changed(id, fields) {                                                                          // 222
        _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                            // 223
      },                                                                                                               // 224
                                                                                                                       //
      removed: function removed(id) {                                                                                  // 226
        stopWatchingIdentity(id);                                                                                      // 227
      }                                                                                                                // 228
    });                                                                                                                // 217
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 231
  };                                                                                                                   // 232
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 234
    _id: this.userId,                                                                                                  // 235
    referredIdentityIds: { $exists: true }                                                                             // 236
  }, {                                                                                                                 // 234
    fields: {                                                                                                          // 238
      referredIdentityIds: true                                                                                        // 239
    }                                                                                                                  // 238
  }).observeChanges({                                                                                                  // 237
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function added(id, fields) {                                                                                // 243
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 244
        // Unconditionally mark these as successful referrals and start watching.                                      //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 246
      }                                                                                                                // 248
    },                                                                                                                 // 249
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function changed(id, fields) {                                                                            // 252
      // Two major tasks.                                                                                              //
      //                                                                                                               //
      // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                             //
      //                                                                                                               //
      // 2. Look for identityIds to subscribe to.                                                                      //
                                                                                                                       //
      // Task 1. Unsubscribe where needed.                                                                             //
      var referredIdentityIdsAsObject = {};                                                                            // 260
      fields.referredIdentityIds.forEach(function (i) {                                                                // 261
        referredIdentityIdsAsObject[i] = true;                                                                         // 261
      });                                                                                                              // 261
                                                                                                                       //
      Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                    // 263
        // If the handle doesn't show up in the new list of referredIdentityIds, then remove                           //
        // info from the client & stop it on the server & make it null.                                                //
        var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                       // 266
        if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                  // 267
          stopWatchingIdentity(identityId);                                                                            // 268
        }                                                                                                              // 269
      });                                                                                                              // 270
                                                                                                                       //
      // Task 2. Subscribe where needed.                                                                               //
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 273
        // The watch... function will avoid double-creating subscriptions, so this is safe.                            //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 275
      }                                                                                                                // 276
    },                                                                                                                 // 277
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function removed() {                                                                                      // 279
      // Remove all data from client; stop all handles.                                                                //
      stopWatchingAllIdentities();                                                                                     // 281
    }                                                                                                                  // 282
  });                                                                                                                  // 241
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 286
    stopWatchingAllIdentities();                                                                                       // 287
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 288
    completedIdentityIdsHandle.stop();                                                                                 // 289
  });                                                                                                                  // 290
                                                                                                                       //
  this.ready();                                                                                                        // 292
});                                                                                                                    // 293
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 295
  var _this4 = this;                                                                                                   // 295
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 296
  var anonCount = 0;                                                                                                   // 297
  var counter = 0;                                                                                                     // 298
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 300
    name = name.trim();                                                                                                // 301
    if (name === "") {                                                                                                 // 302
      ++anonCount;                                                                                                     // 303
    } else {                                                                                                           // 304
      _this4.added("backers", counter++, { name: name });                                                              // 305
    }                                                                                                                  // 306
  });                                                                                                                  // 307
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 310
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 312
                                                                                                                       //
  this.ready();                                                                                                        // 314
});                                                                                                                    // 315
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function useSignupKey(key) {                                                                           // 26
    check(key, String);                                                                                                // 27
                                                                                                                       //
    if (!this.userId) {                                                                                                // 29
      throw new Meteor.Error(403, "Must be signed in.");                                                               // 30
    }                                                                                                                  // 31
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 33
    if (user.signupKey) {                                                                                              // 34
      // Don't waste it.                                                                                               //
      return;                                                                                                          // 36
    }                                                                                                                  // 37
                                                                                                                       //
    if (isDemoUser()) {                                                                                                // 39
      throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");             // 40
    }                                                                                                                  // 42
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 44
      // Don't consume signup key as identity user.                                                                    //
      return;                                                                                                          // 46
    }                                                                                                                  // 47
                                                                                                                       //
    var keyInfo = SignupKeys.findOne(key);                                                                             // 49
    if (!keyInfo || keyInfo.used) {                                                                                    // 50
      throw new Meteor.Error(403, "Invalid key or already used.");                                                     // 51
    }                                                                                                                  // 52
                                                                                                                       //
    if (isSignedUp() && user.payments && user.payments.id) {                                                           // 54
      // This user is already signed up with a payment account. Possibly, they signed up before                        //
      // using their invite, and then went back and clicked on the invite. As a result they                            //
      // probably now have two payment accounts. Mark this invite as used but also add a special                       //
      // flag so we can find it later and cancel the dupe payment account. Record who tried to                         //
      // use it so that we can transfer credits over if needed.                                                        //
      SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                       // 60
      return;                                                                                                          // 61
    }                                                                                                                  // 62
                                                                                                                       //
    var userFields = {                                                                                                 // 64
      signupKey: key,                                                                                                  // 65
      signupNote: keyInfo.note                                                                                         // 66
    };                                                                                                                 // 64
    if (keyInfo.email) {                                                                                               // 68
      userFields.signupEmail = keyInfo.email;                                                                          // 69
    }                                                                                                                  // 70
                                                                                                                       //
    if ("quota" in keyInfo) {                                                                                          // 72
      userFields.quota = keyInfo.quota;                                                                                // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (keyInfo.plan) {                                                                                                // 76
      userFields.plan = keyInfo.plan;                                                                                  // 77
    }                                                                                                                  // 78
                                                                                                                       //
    if (keyInfo.payments) {                                                                                            // 80
      userFields["payments.id"] = keyInfo.payments.id;                                                                 // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Meteor.users.update(this.userId, { $set: userFields });                                                            // 84
    SignupKeys.update(key, { $set: { used: true } });                                                                  // 85
  }                                                                                                                    // 86
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"standalone-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/standalone-server.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.publish("standaloneDomain", function (domain) {                                                                 // 17
  check(domain, String);                                                                                               // 18
                                                                                                                       //
  return globalDb.collections.standaloneDomains.find({ _id: domain });                                                 // 20
});                                                                                                                    // 21
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    // If the only thing that happened is some trailing slashes got removed, then don't reset OAuth                    //
    // providers.                                                                                                      //
    var resetOAuth = true;                                                                                             // 31
    if (baseUrlRow.value.replace(/[/]*$/, "") === ROOT_URL) {                                                          // 32
      console.log("Not resetting OAuth because old ROOT_URL and new ROOT_URL differ only by trailing slashes.");       // 33
      resetOAuth = false;                                                                                              // 34
    }                                                                                                                  // 35
                                                                                                                       //
    if (resetOAuth) {                                                                                                  // 37
      console.log("resetting oauth");                                                                                  // 38
      Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                               // 39
        if (!!setting.value) {                                                                                         // 40
          Settings.update({ _id: setting._id }, { $set: { value: false,                                                // 41
              automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                       // 43
        }                                                                                                              // 44
      });                                                                                                              // 45
    }                                                                                                                  // 46
                                                                                                                       //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 48
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 49
  }                                                                                                                    // 50
});                                                                                                                    // 51
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 19
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 21
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 24
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 26
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 28
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 29
};                                                                                                                     // 30
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 32
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 34
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 38
    expires: { $exists: false },                                                                                       // 39
    loginIdentities: { $exists: true },                                                                                // 40
    lastActive: timeConstraint                                                                                         // 41
  }).count();                                                                                                          // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 46
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 52
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 54
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 59
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 62
    $group: {                                                                                                          // 65
      _id: "$appId",                                                                                                   // 66
      grains: { $sum: 1 },                                                                                             // 67
      userIds: { $addToSet: "$userId" }                                                                                // 68
    }                                                                                                                  // 65
  }, {                                                                                                                 // 64
    $project: {                                                                                                        // 72
      grains: 1,                                                                                                       // 73
      owners: { $size: "$userIds" }                                                                                    // 74
    }                                                                                                                  // 72
  }]);                                                                                                                 // 71
  apps = _.indexBy(apps, "_id");                                                                                       // 78
                                                                                                                       //
  for (var appId in apps) {                                                                                            // 80
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 90
    delete app._id;                                                                                                    // 91
    var grains = Grains.find({                                                                                         // 92
      lastUsed: timeConstraint,                                                                                        // 93
      appId: appId                                                                                                     // 94
    }, {                                                                                                               // 92
      fields: { _id: 1 }                                                                                               // 96
    }).fetch();                                                                                                        // 95
    var grainIds = _.pluck(grains, "_id");                                                                             // 98
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 100
      $match: {                                                                                                        // 102
        "owner.user": { $exists: true },                                                                               // 103
        lastUsed: timeConstraint,                                                                                      // 104
        grainId: { $in: grainIds }                                                                                     // 105
      }                                                                                                                // 102
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 101
      $group: {                                                                                                        // 110
        _id: "count",                                                                                                  // 111
        count: { $sum: 1 }                                                                                             // 112
      }                                                                                                                // 110
    }]);                                                                                                               // 109
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 117
      if (counts.length !== 1) {                                                                                       // 118
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 119
      }                                                                                                                // 120
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 122
    }                                                                                                                  // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 127
    $match: {                                                                                                          // 129
      lastActive: timeConstraint,                                                                                      // 130
      appId: { $exists: true }                                                                                         // 131
    }                                                                                                                  // 129
  }, {                                                                                                                 // 128
    $group: {                                                                                                          // 135
      _id: {                                                                                                           // 136
        appId: "$appId",                                                                                               // 137
        type: "$type"                                                                                                  // 138
      },                                                                                                               // 136
      count: { $sum: 1 }                                                                                               // 140
    }                                                                                                                  // 135
  }]).forEach(function (deletion) {                                                                                    // 134
    var app = apps[deletion._id.appId];                                                                                // 144
    if (!app) {                                                                                                        // 145
      app = apps[deletion.appId] = {};                                                                                 // 146
    }                                                                                                                  // 147
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 149
      app.appDemoUsers = deletion.count;                                                                               // 150
    } else if (deletion._id.type === "grain") {                                                                        // 151
      app.deleted = deletion.count;                                                                                    // 152
    } else if (deletion._id.type === "demoGrain") {                                                                    // 153
      app.demoed = deletion.count;                                                                                     // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 156
                                                                                                                       //
  return {                                                                                                             // 158
    activeUsers: currentlyActiveUsersCount,                                                                            // 159
    demoUsers: deletedDemoUsersCount,                                                                                  // 160
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 161
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 162
    apps: apps                                                                                                         // 163
  };                                                                                                                   // 158
};                                                                                                                     // 165
                                                                                                                       //
function recordStats() {                                                                                               // 167
  var postStats = function postStats(record) {                                                                         // 168
    HTTP.post("https://alpha-api.sandstorm.io/data", {                                                                 // 169
      data: record,                                                                                                    // 170
      headers: {                                                                                                       // 171
        Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                           // 172
        "Content-Type": "application/json"                                                                             // 173
      }                                                                                                                // 171
    });                                                                                                                // 169
  };                                                                                                                   // 176
                                                                                                                       //
  var now = new Date();                                                                                                // 178
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 186
    timestamp: now,                                                                                                    // 187
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 188
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 189
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 190
    forever: computeStats(new Date(0)),                                                                                // 191
    plans: planStats                                                                                                   // 192
  };                                                                                                                   // 186
  record.computeTime = Date.now() - now;                                                                               // 194
  if (global.BlackrockPayments && global.BlackrockPayments.getTotalCharges) {                                          // 195
    // This only exists under Blackrock                                                                                //
    record.totalCharges = global.BlackrockPayments.getTotalCharges();                                                  // 197
  }                                                                                                                    // 198
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 200
  var age = ActivityStats.find().count();                                                                              // 201
  // The stats page which the user agreed we can send actually displays the whole history                              //
  // of the server, but we're only sending stats from the last day. Let's also throw in the                            //
  // length of said history. This is still strictly less information than what the user said                           //
  // we're allowed to send.                                                                                            //
  record.serverAge = age;                                                                                              // 206
                                                                                                                       //
  if (globalDb.isFeatureKeyOptedIntoStats()) {                                                                         // 208
    record.customerId = globalDb.currentFeatureKey().customer.id;                                                      // 209
    postStats(record);                                                                                                 // 210
  } else if (age > 3) {                                                                                                // 211
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 212
                                                                                                                       //
    if (!reportSetting) {                                                                                              // 214
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("reportStats", "/admin/stats");                                                   // 216
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 217
    } else if (reportSetting.value === true) {                                                                         // 218
      postStats(record);                                                                                               // 219
    }                                                                                                                  // 220
  }                                                                                                                    // 221
}                                                                                                                      // 222
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 224
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 227
    Meteor.setInterval(function () {                                                                                   // 228
      recordStats();                                                                                                   // 229
    }, DAY_MS);                                                                                                        // 230
                                                                                                                       //
    recordStats();                                                                                                     // 232
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 233
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 235
    if (StatsTokens.find().count() === 0) {                                                                            // 236
      StatsTokens.remove({});                                                                                          // 237
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 238
    }                                                                                                                  // 239
  });                                                                                                                  // 240
}                                                                                                                      // 241
                                                                                                                       //
Meteor.methods({                                                                                                       // 243
  regenerateStatsToken: function regenerateStatsToken() {                                                              // 244
    if (!isAdmin()) {                                                                                                  // 245
      throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                               // 246
    }                                                                                                                  // 247
                                                                                                                       //
    StatsTokens.remove({});                                                                                            // 249
    var token = StatsTokens.insert({ _id: Random.id(22) });                                                            // 250
    return token._id;                                                                                                  // 251
  }                                                                                                                    // 252
});                                                                                                                    // 243
                                                                                                                       //
Router.map(function () {                                                                                               // 255
  this.route("fetchStats", {                                                                                           // 256
    where: "server",                                                                                                   // 257
    path: "/fetchStats/:tokenId",                                                                                      // 258
    action: function action() {                                                                                        // 259
      var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                   // 260
                                                                                                                       //
      if (!token) {                                                                                                    // 262
        this.response.writeHead(404, {                                                                                 // 263
          "Content-Type": "text/plain"                                                                                 // 264
        });                                                                                                            // 263
        this.response.write("Token not found");                                                                        // 266
        return this.response.end();                                                                                    // 267
      }                                                                                                                // 268
                                                                                                                       //
      try {                                                                                                            // 270
        var stats = ActivityStats.find().fetch();                                                                      // 271
        var statsString = JSON.stringify(stats);                                                                       // 272
                                                                                                                       //
        this.response.writeHead(200, {                                                                                 // 274
          "Content-Type": "application/json"                                                                           // 275
        });                                                                                                            // 274
        this.response.write(statsString);                                                                              // 277
      } catch (error) {                                                                                                // 278
        console.error(error.stack);                                                                                    // 279
        this.response.writeHead(500, {                                                                                 // 280
          "Content-Type": "text/plain"                                                                                 // 281
        });                                                                                                            // 280
        this.response.write(error.stack);                                                                              // 283
      }                                                                                                                // 284
                                                                                                                       //
      return this.response.end();                                                                                      // 286
    }                                                                                                                  // 287
  });                                                                                                                  // 256
});                                                                                                                    // 289
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// TODO(someday): split out fields by locus                                                                            //
// isEnabled is available on both client and server                                                                    //
// getLoginId is only used on server                                                                                   //
// initiateLogin and loginTemplate are only used on client                                                             //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 22
  var setting = Settings.findOne({ _id: name });                                                                       // 23
  return setting && !!setting.value;                                                                                   // 24
}                                                                                                                      // 25
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 27
  isEnabled: function isEnabled() {                                                                                    // 28
    return serviceEnabled("github");                                                                                   // 29
  },                                                                                                                   // 30
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 32
    return identity.services.github.username;                                                                          // 33
  },                                                                                                                   // 34
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 36
    Meteor.loginWithGithub();                                                                                          // 37
    return { oneClick: true };                                                                                         // 38
  },                                                                                                                   // 39
                                                                                                                       //
  loginTemplate: {                                                                                                     // 41
    name: "oauthLoginButton",                                                                                          // 42
    priority: 1,                                                                                                       // 43
    data: {                                                                                                            // 44
      method: "loginWithGithub",                                                                                       // 45
      name: "github",                                                                                                  // 46
      displayName: "GitHub",                                                                                           // 47
      linkingNewIdentity: false                                                                                        // 48
    }                                                                                                                  // 44
  }                                                                                                                    // 41
};                                                                                                                     // 27
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 53
  isEnabled: function isEnabled() {                                                                                    // 54
    return serviceEnabled("google");                                                                                   // 55
  },                                                                                                                   // 56
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 58
    return identity.services.google.email;                                                                             // 59
  },                                                                                                                   // 60
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 62
    Meteor.loginWithGoogle({ loginHint: loginId });                                                                    // 63
    return { oneClick: true };                                                                                         // 64
  },                                                                                                                   // 65
                                                                                                                       //
  loginTemplate: {                                                                                                     // 67
    name: "oauthLoginButton",                                                                                          // 68
    priority: 2,                                                                                                       // 69
    data: {                                                                                                            // 70
      method: "loginWithGoogle",                                                                                       // 71
      name: "google",                                                                                                  // 72
      displayName: "Google",                                                                                           // 73
      linkingNewIdentity: false                                                                                        // 74
    }                                                                                                                  // 70
  }                                                                                                                    // 67
};                                                                                                                     // 53
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 79
  isEnabled: function isEnabled() {                                                                                    // 80
    return serviceEnabled("emailToken");                                                                               // 81
  },                                                                                                                   // 82
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 84
    return identity.services.email.email;                                                                              // 85
  },                                                                                                                   // 86
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 88
    return { form: true };                                                                                             // 89
  },                                                                                                                   // 90
                                                                                                                       //
  loginTemplate: {                                                                                                     // 92
    name: "emailLoginForm",                                                                                            // 93
    priority: 10                                                                                                       // 94
  }                                                                                                                    // 92
};                                                                                                                     // 79
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 98
  isEnabled: function isEnabled() {                                                                                    // 99
    return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                     // 100
  },                                                                                                                   // 101
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 103
    return identity.services.ldap.username;                                                                            // 104
  },                                                                                                                   // 105
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 107
    return { form: true };                                                                                             // 108
  },                                                                                                                   // 109
                                                                                                                       //
  loginTemplate: {                                                                                                     // 111
    name: "ldapLoginForm",                                                                                             // 112
    priority: 21 }                                                                                                     // 113
};                                                                                                                     // 98
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 117
  isEnabled: function isEnabled() {                                                                                    // 118
    return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                     // 119
  },                                                                                                                   // 120
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 122
    return identity.services.saml.id;                                                                                  // 123
  },                                                                                                                   // 124
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 126
    Meteor.loginWithSaml();                                                                                            // 127
    return { oneClick: true };                                                                                         // 128
  },                                                                                                                   // 129
                                                                                                                       //
  loginTemplate: {                                                                                                     // 131
    name: "samlLoginForm",                                                                                             // 132
    priority: 20 }                                                                                                     // 133
};                                                                                                                     // 117
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 137
  isEnabled: function isEnabled() {                                                                                    // 138
    return false; // You can never authenticate as a demo user.                                                        // 139
  },                                                                                                                   // 140
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 142
    return identity._id;                                                                                               // 143
  },                                                                                                                   // 144
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 146
    return { demoCannotLogin: true };                                                                                  // 147
  },                                                                                                                   // 148
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 150
};                                                                                                                     // 137
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function isEnabled() {                                                                                    // 18
    return globalDb.allowDevAccounts();                                                                                // 19
  },                                                                                                                   // 20
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 22
    return identity.services.dev.name;                                                                                 // 23
  },                                                                                                                   // 24
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 26
    loginDevAccount(loginId);                                                                                          // 27
    return { oneClick: true };                                                                                         // 28
  },                                                                                                                   // 29
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-shared.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/grain-shared.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 17
  // Methods defined in this file have meaningful latency compensation (client-side prediction)                        //
  // potential.                                                                                                        //
  //                                                                                                                   //
  // Methods for which latency compensation makes no sense are defined in grain-server.js.                             //
                                                                                                                       //
  markActivityReadByOwner: function markActivityReadByOwner(grainId) {                                                 // 23
    check(grainId, String);                                                                                            // 24
    check(this.userId, String);                                                                                        // 25
                                                                                                                       //
    Grains.update({ _id: grainId, userId: this.userId }, { $set: { "ownerSeenAllActivity": true } });                  // 27
  },                                                                                                                   // 29
                                                                                                                       //
  markActivityRead: function markActivityRead(grainId, identityId) {                                                   // 31
    check(grainId, String);                                                                                            // 32
    check(identityId, String);                                                                                         // 33
                                                                                                                       //
    if (!this.userId || !globalDb.userHasIdentity(this.userId, identityId)) {                                          // 35
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 36
    }                                                                                                                  // 37
                                                                                                                       //
    ApiTokens.update({ "grainId": grainId, "owner.user.identityId": identityId }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
  },                                                                                                                   // 41
                                                                                                                       //
  moveGrainsToTrash: function moveGrainsToTrash(grainIds) {                                                            // 43
    var _this = this;                                                                                                  // 43
                                                                                                                       //
    check(grainIds, [String]);                                                                                         // 44
                                                                                                                       //
    if (this.userId) {                                                                                                 // 46
      Grains.update({ userId: { $eq: this.userId },                                                                    // 47
        _id: { $in: grainIds },                                                                                        // 48
        trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                            // 49
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 53
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 55
        "owner.user.identityId": { $in: identityIds },                                                                 // 56
        trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                          // 57
                                                                                                                       //
      if (!this.isSimulation) {                                                                                        // 61
        var grainsOwned = Grains.find({                                                                                // 62
          userId: { $eq: this.userId },                                                                                // 63
          _id: { $in: grainIds }                                                                                       // 64
        }, { fields: { _id: 1 } });                                                                                    // 62
                                                                                                                       //
        grainsOwned.forEach(function (grain) {                                                                         // 67
          Sessions.remove({ grainId: grain._id });                                                                     // 68
          try {                                                                                                        // 69
            _this.connection.sandstormBackend.shutdownGrain(grain._id, _this.userId).await();                          // 70
          } catch (err) {                                                                                              // 71
            console.error("Failed to shutdown trashed grain", grain._id, err);                                         // 72
          }                                                                                                            // 73
        });                                                                                                            // 74
      }                                                                                                                // 75
    }                                                                                                                  // 76
  },                                                                                                                   // 77
                                                                                                                       //
  moveGrainsOutOfTrash: function moveGrainsOutOfTrash(grainIds) {                                                      // 79
    check(grainIds, [String]);                                                                                         // 80
                                                                                                                       //
    if (this.userId) {                                                                                                 // 82
      Grains.update({ userId: { $eq: this.userId },                                                                    // 83
        _id: { $in: grainIds },                                                                                        // 84
        trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                    // 85
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 89
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 91
        "owner.user.identityId": { $in: identityIds },                                                                 // 92
        "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                                // 93
    }                                                                                                                  // 96
  },                                                                                                                   // 97
                                                                                                                       //
  deleteGrain: function deleteGrain(grainId) {                                                                         // 99
    check(grainId, String);                                                                                            // 100
                                                                                                                       //
    if (this.userId) {                                                                                                 // 102
      var grainsQuery = {                                                                                              // 103
        _id: grainId,                                                                                                  // 104
        userId: this.userId,                                                                                           // 105
        trashed: { $exists: true }                                                                                     // 106
      };                                                                                                               // 103
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 109
      if (this.isSimulation) {                                                                                         // 110
        numDeleted = Grains.remove(grainsQuery);                                                                       // 111
      } else {                                                                                                         // 112
        numDeleted = globalDb.deleteGrains(grainsQuery, globalBackend, isDemoUser() ? "demoGrain" : "grain");          // 113
      }                                                                                                                // 115
                                                                                                                       //
      // Usually we don't automatically remove user-owned tokens that have become invalid,                             //
      // because if we did their owner might become confused as to why they have mysteriously                          //
      // disappeared. In this particular case, however, for tokens held by the grain owner,                            //
      // there should be no confusion. Indeed, it would be more confusing *not* to remove these                        //
      // tokens, because then the grain could still show up in the trash bin as a "shared with me"                     //
      // grain after the owner clicks "delete permanently".                                                            //
      //                                                                                                               //
      // Note that these tokens may be visible to other accounts if there are identities shared                        //
      // between the accounts; by only removing 'trashed' tokens, we minimize confusion in that                        //
      // case too.                                                                                                     //
      var apiTokensQuery = {                                                                                           // 127
        grainId: grainId,                                                                                              // 128
        "owner.user.identityId": { $in: SandstormDb.getUserIdentityIds(Meteor.user()) },                               // 129
        "trashed": { $exists: true }                                                                                   // 130
      };                                                                                                               // 127
                                                                                                                       //
      if (numDeleted > 0) {                                                                                            // 133
        if (this.isSimulation) {                                                                                       // 134
          ApiTokens.remove(apiTokensQuery);                                                                            // 135
        } else {                                                                                                       // 136
          globalDb.removeApiTokens(apiTokensQuery);                                                                    // 137
        }                                                                                                              // 138
      }                                                                                                                // 139
    }                                                                                                                  // 140
  },                                                                                                                   // 141
                                                                                                                       //
  forgetGrain: function forgetGrain(grainId, identityId) {                                                             // 143
    check(grainId, String);                                                                                            // 144
    check(identityId, String);                                                                                         // 145
                                                                                                                       //
    if (!this.userId) {                                                                                                // 147
      throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                             // 148
    }                                                                                                                  // 149
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 151
      throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                            // 152
    }                                                                                                                  // 153
                                                                                                                       //
    var query = {                                                                                                      // 155
      grainId: grainId,                                                                                                // 156
      "owner.user.identityId": identityId,                                                                             // 157
      "trashed": { $exists: true }                                                                                     // 158
    };                                                                                                                 // 155
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 161
      ApiTokens.remove(query);                                                                                         // 162
    } else {                                                                                                           // 163
      globalDb.removeApiTokens(query);                                                                                 // 164
    }                                                                                                                  // 165
  }                                                                                                                    // 166
});                                                                                                                    // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function isSafeDemoAppUrl(url) {                                                                    // 17
    // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)                   //
    // and we allow specifying a sandstorm.io URL.                                                                     //
    return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
};                                                                                                                     // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function createMockGithubUser() {                                                        // 35
          Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 39
                                                                                                                       //
        clearMockGithubUser: function clearMockGithubUser() {                                                          // 41
          clearUser("Py8fwsaryQNGBuiXb");                                                                              // 42
        },                                                                                                             // 43
                                                                                                                       //
        createMockGoogleUser: function createMockGoogleUser() {                                                        // 45
          Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 49
                                                                                                                       //
        clearMockGoogleUser: function clearMockGoogleUser() {                                                          // 51
          clearUser("6WJcRo2gg2Ysuxsok");                                                                              // 52
        },                                                                                                             // 53
                                                                                                                       //
        fetchAppIndexTest: function fetchAppIndexTest() {                                                              // 55
          globalDb.collections.appIndex.remove({});                                                                    // 56
          SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                                         // 57
        }                                                                                                              // 58
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 60
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 62
    Meteor.call("createMockGithubUser", function (err) {                                                               // 63
      if (err) {                                                                                                       // 64
        console.log(err);                                                                                              // 65
      }                                                                                                                // 66
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 68
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 69
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 70
      window.location.reload();                                                                                        // 71
    });                                                                                                                // 72
  };                                                                                                                   // 73
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 75
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 76
      if (err) {                                                                                                       // 77
        console.log(err);                                                                                              // 78
      }                                                                                                                // 79
    });                                                                                                                // 80
  };                                                                                                                   // 81
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 83
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 84
      if (err) {                                                                                                       // 85
        console.log(err);                                                                                              // 86
      }                                                                                                                // 87
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 89
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 90
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 91
      window.location.reload();                                                                                        // 92
    });                                                                                                                // 93
  };                                                                                                                   // 94
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 96
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 97
      if (err) {                                                                                                       // 98
        console.log(err);                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 101
  };                                                                                                                   // 102
}                                                                                                                      // 103
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/accounts/email-token/token-server.js");
require("./server/accounts/identity/identity-server.js");
require("./server/accounts/ldap/ldap-server.js");
require("./server/accounts/saml/saml-server.js");
require("./server/accounts/accounts-server.js");
require("./server/accounts/accounts-ui-methods.js");
require("./server/accounts/accounts-ui-server.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/00-startup.js");
require("./server/account-suspension.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/contacts-server.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/desktop-notifications-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/identity.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/notifications-server.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/standalone-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/grain-shared.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
