(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
var collectionOptions = { defineMutationMethods: Meteor.isClient };                                                    // 38
// Set to `true` on the client so that method simulation works. Set to `false` on the server                           //
// so that we can be extra certain that all mutations must go through methods.                                         //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       //
//              can be suspended. After some amount of time, the user will be completely deleted                       //
//              and removed from the DB.                                                                               //
//              It is an object with fields:                                                                           //
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        //
//                  chance to still login and reverse the suspension/deletion.                                         //
//                admin: The userId of the admin who suspended the account.                                            //
//                timestamp: Date object. When the suspension occurred.                                                //
//                willDelete: Boolean. If true, this account will be deleted after some time.                          //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 139
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 140
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 141
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 142
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 143
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 144
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 145
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 146
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 149
                                                                                                                       //
Packages = new Mongo.Collection("packages", collectionOptions);                                                        // 151
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions);                                                  // 173
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
//   mountProc: True if the supervisor should mount /proc.                                                             //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions);                                                  // 195
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions);                                                            // 214
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        //
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    //
//              of querying.                                                                                           //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions);                                          // 248
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions);                                                        // 253
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions);                                                        // 270
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions);                                                    // 300
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions);                                              // 309
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions);                                                  // 333
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions);                                                    // 342
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions);                                                      // 353
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        //
//              so treat this token the same as "trashed". It is denormalized out of Users for                         //
//              ease of querying.                                                                                      //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 492
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 493
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 494
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions);                                                        // 496
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions);                                              // 521
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               //
//                 initiatingIdentity is present, the notification is not from a user.                                 //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification -- can be "reportStats", "cantRenewFeatureKey", or                         //
//                 "trialFeatureKeyExpired".                                                                           //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions);                              // 560
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 577
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 578
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions);                                                  // 580
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions);                                                                // 589
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions);                                                        // 599
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions);                                                    // 619
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions);                                                // 625
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions);                                      // 639
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions);                                                              // 651
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions);                                                        // 665
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions);                                          // 672
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions);                                                    // 692
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//   renewalProblem: If we tried to renew this feature key and failed, an object describing that                       //
//       failure. Includes exactly one of the following fields:                                                        //
//     noPaymentSource: True, indicating that the key could not be renewed because there was no                        //
//         payment source set for this key.                                                                            //
//     paymentFailed: String error message returned by our payment processor describing why they                       //
//         declined the charge.                                                                                        //
//     noSuchKey: True, indicating the key doesn't exist.                                                              //
//     revoked: True, indicating the key has been revoked.                                                             //
//     unknownResponse: String response text from the renewal API which wasn't recognized. Should                      //
//         be reported to Sandstorm.                                                                                   //
//     exception: String error message from an exception thrown by the renewal code. This usually                      //
//         indicates some sort of connectivity problem, so could be reported to the user as:                           //
//         "There was a problem reaching the feature key renewal server."                                              //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions);                                                // 715
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions);                            // 723
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          //
//           present, it will have one of the following shapes:                                                        //
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      //
//       {                                                                                                             //
//         identityId: String  The user's identity ID.                                                                 //
//         name: String        The user's display name.                                                                //
//         avatarUrl: String   The URL for the user's profile picture.                                                 //
//       },                                                                                                            //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
var StandaloneDomains = new Mongo.Collection("standaloneDomains", collectionOptions);                                  // 750
// A standalone domain that points to a single share link. These domains act a little different                        //
// than a normal shared Sandstorm grain. They completely drop any Sandstorm topbar/sidebar, and at                     //
// first glance look completely like a non-Sandstorm hosted webserver. The apps instead act in                         //
// concert with Sandstorm through the postMessage API, which allows it to do things like prompt for                    //
// login.                                                                                                              //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String. The domain name to use.                                                                              //
//   token: String. _id of a sharing token (it must be a webkey).                                                      //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 761
  Meteor.publish("credentials", function () {                                                                          // 762
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 765
      var db = this.connection.sandstormDb;                                                                            // 766
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 770
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), db.collections.plans.find()];              // 771
    } else {                                                                                                           // 774
      return [];                                                                                                       // 775
    }                                                                                                                  // 776
  });                                                                                                                  // 777
}                                                                                                                      // 778
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 780
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 781
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 782
};                                                                                                                     // 783
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 785
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 797
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 799
  if (isPaid) {                                                                                                        // 800
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 801
    return { grains: 0,                                                                                                // 802
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 803
  } else {                                                                                                             // 806
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 807
    var bonus = {                                                                                                      // 808
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 809
    };                                                                                                                 // 808
    if (successfulReferralsCount > 0) {                                                                                // 813
      bonus.grains = Infinity;                                                                                         // 814
    } else {                                                                                                           // 815
      bonus.grains = 0;                                                                                                // 816
    }                                                                                                                  // 817
                                                                                                                       //
    return bonus;                                                                                                      // 819
  }                                                                                                                    // 820
};                                                                                                                     // 821
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 823
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 826
  if (user && user.isAdmin) {                                                                                          // 827
    return true;                                                                                                       // 828
  } else {                                                                                                             // 829
    return false;                                                                                                      // 830
  }                                                                                                                    // 831
};                                                                                                                     // 832
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 834
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 837
  if (user && user.isAdmin) {                                                                                          // 838
    return true;                                                                                                       // 839
  } else {                                                                                                             // 840
    return false;                                                                                                      // 841
  }                                                                                                                    // 842
};                                                                                                                     // 843
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 845
  if (!token.requirements) {                                                                                           // 846
    return;                                                                                                            // 847
  }                                                                                                                    // 848
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 850
    return "userIsAdmin" in requirement;                                                                               // 851
  });                                                                                                                  // 852
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 854
    return;                                                                                                            // 855
  }                                                                                                                    // 856
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 858
    return;                                                                                                            // 859
  }                                                                                                                    // 860
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 862
};                                                                                                                     // 863
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 865
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 867
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 868
}                                                                                                                      // 869
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 871
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 876
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 877
  var hostSansPort = host.split(":")[0];                                                                               // 878
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 883
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 884
      return id;                                                                                                       // 885
    }                                                                                                                  // 886
  }                                                                                                                    // 887
                                                                                                                       //
  return null;                                                                                                         // 889
};                                                                                                                     // 890
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 892
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 893
};                                                                                                                     // 894
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 896
  if (hostId) {                                                                                                        // 897
    var split = hostId.split("-");                                                                                     // 898
    if (split[0] === "api") return split[1] || "*";                                                                    // 899
  }                                                                                                                    // 900
                                                                                                                       //
  return false;                                                                                                        // 902
};                                                                                                                     // 903
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 905
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 906
};                                                                                                                     // 907
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 909
if (Meteor.isServer) {                                                                                                 // 910
  (function () {                                                                                                       // 910
    var Crypto = Npm.require("crypto");                                                                                // 911
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 912
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 919
    };                                                                                                                 // 920
  })();                                                                                                                // 910
} else {                                                                                                               // 921
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 922
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 929
  };                                                                                                                   // 930
}                                                                                                                      // 931
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 933
  return "api-" + apiHostIdHashForToken(token);                                                                        // 934
};                                                                                                                     // 935
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 937
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 938
};                                                                                                                     // 939
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 941
  (function () {                                                                                                       // 941
    var Url = Npm.require("url");                                                                                      // 942
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 943
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 951
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 953
      if (dotPos < 0) {                                                                                                // 954
        return protocol + "//*";                                                                                       // 955
      } else {                                                                                                         // 956
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 957
      }                                                                                                                // 958
    };                                                                                                                 // 959
  })();                                                                                                                // 941
}                                                                                                                      // 960
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 962
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 972
  this.collections = {                                                                                                 // 973
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    //
    // collection globals directly.                                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
    users: Meteor.users,                                                                                               // 979
                                                                                                                       //
    packages: Packages,                                                                                                // 981
    devPackages: DevPackages,                                                                                          // 982
    userActions: UserActions,                                                                                          // 983
    grains: Grains,                                                                                                    // 984
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 985
    contacts: Contacts,                                                                                                // 986
    sessions: Sessions,                                                                                                // 987
    signupKeys: SignupKeys,                                                                                            // 988
    activityStats: ActivityStats,                                                                                      // 989
    deleteStats: DeleteStats,                                                                                          // 990
    fileTokens: FileTokens,                                                                                            // 991
    apiTokens: ApiTokens,                                                                                              // 992
    apiHosts: ApiHosts,                                                                                                // 993
    notifications: Notifications,                                                                                      // 994
    activitySubscriptions: ActivitySubscriptions,                                                                      // 995
    statsTokens: StatsTokens,                                                                                          // 996
    misc: Misc,                                                                                                        // 997
    settings: Settings,                                                                                                // 998
    migrations: Migrations,                                                                                            // 999
    staticAssets: StaticAssets,                                                                                        // 1000
    assetUploadTokens: AssetUploadTokens,                                                                              // 1001
    plans: Plans,                                                                                                      // 1002
    appIndex: AppIndex,                                                                                                // 1003
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1004
    featureKey: FeatureKey,                                                                                            // 1005
    setupSession: SetupSession,                                                                                        // 1006
    desktopNotifications: DesktopNotifications,                                                                        // 1007
    standaloneDomains: StandaloneDomains                                                                               // 1008
  };                                                                                                                   // 973
};                                                                                                                     // 1010
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1015
  isAdmin: isAdmin,                                                                                                    // 1016
  isAdminById: isAdminById,                                                                                            // 1017
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1018
  matchWildcardHost: matchWildcardHost,                                                                                // 1019
  makeWildcardHost: makeWildcardHost,                                                                                  // 1020
  isApiHostId: isApiHostId,                                                                                            // 1021
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1022
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1023
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1024
  makeApiHost: makeApiHost,                                                                                            // 1025
  allowDevAccounts: function allowDevAccounts() {                                                                      // 1026
    var setting = this.collections.settings.findOne({ _id: "devAccounts" });                                           // 1027
    if (setting) {                                                                                                     // 1028
      return setting.value;                                                                                            // 1029
    } else {                                                                                                           // 1030
      return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;               // 1031
    }                                                                                                                  // 1033
  },                                                                                                                   // 1034
                                                                                                                       //
                                                                                                                       //
  roleAssignmentPattern: {                                                                                             // 1036
    none: Match.Optional(null),                                                                                        // 1037
    allAccess: Match.Optional(null),                                                                                   // 1038
    roleId: Match.Optional(Match.Integer),                                                                             // 1039
    addPermissions: Match.Optional([Boolean]),                                                                         // 1040
    removePermissions: Match.Optional([Boolean])                                                                       // 1041
  },                                                                                                                   // 1036
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1044
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1047
    if (user && user.expires) {                                                                                        // 1048
      return true;                                                                                                     // 1049
    } else {                                                                                                           // 1050
      return false;                                                                                                    // 1051
    }                                                                                                                  // 1052
  },                                                                                                                   // 1053
  isSignedUp: function isSignedUp() {                                                                                  // 1055
    var user = Meteor.user();                                                                                          // 1056
    return this.isAccountSignedUp(user);                                                                               // 1057
  },                                                                                                                   // 1058
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1060
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1063
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1065
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1067
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1069
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1071
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1073
                                                                                                                       //
    return false;                                                                                                      // 1075
  },                                                                                                                   // 1076
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1078
    var user = Meteor.user();                                                                                          // 1079
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1080
  },                                                                                                                   // 1081
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1083
    if (!user) return false; // not signed in                                                                          // 1084
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1086
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1088
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1090
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1092
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1094
                                                                                                                       //
    return false;                                                                                                      // 1096
  },                                                                                                                   // 1097
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1099
    if (!identity || !identity.services) {                                                                             // 1100
      return false;                                                                                                    // 1101
    }                                                                                                                  // 1102
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1104
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1105
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1106
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1107
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1108
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1109
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1110
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1111
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1112
        return true;                                                                                                   // 1113
      }                                                                                                                // 1114
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1115
      return true;                                                                                                     // 1116
    } else if (samlEnabled && identity.services.saml) {                                                                // 1117
      return true;                                                                                                     // 1118
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1119
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1120
        return true;                                                                                                   // 1121
      }                                                                                                                // 1122
    }                                                                                                                  // 1123
                                                                                                                       //
    return false;                                                                                                      // 1125
  },                                                                                                                   // 1126
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1128
    if (!this.isFeatureKeyValid()) {                                                                                   // 1129
      return false;                                                                                                    // 1130
    }                                                                                                                  // 1131
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1133
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1134
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1135
        return true;                                                                                                   // 1136
      }                                                                                                                // 1137
    }                                                                                                                  // 1138
                                                                                                                       //
    return false;                                                                                                      // 1140
  }                                                                                                                    // 1141
});                                                                                                                    // 1015
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1144
  (function () {                                                                                                       // 1144
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1145
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1147
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1148
      var _this2 = this;                                                                                               // 1148
                                                                                                                       //
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1151
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1153
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1154
          _this2.collections.apiHosts.remove({ hash2: hash2 });                                                        // 1155
        }                                                                                                              // 1156
      });                                                                                                              // 1157
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1159
    };                                                                                                                 // 1160
  })();                                                                                                                // 1144
}                                                                                                                      // 1161
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1165
if (Meteor.isServer) {                                                                                                 // 1166
  var _Url = Npm.require("url");                                                                                       // 1167
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1168
} else {                                                                                                               // 1169
  httpProtocol = window.location.protocol;                                                                             // 1170
}                                                                                                                      // 1171
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1176
  getUser: function getUser(userId) {                                                                                  // 1177
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1178
    if (userId) {                                                                                                      // 1179
      return Meteor.users.findOne(userId);                                                                             // 1180
    }                                                                                                                  // 1181
  },                                                                                                                   // 1182
  getIdentity: function getIdentity(identityId) {                                                                      // 1184
    check(identityId, String);                                                                                         // 1185
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1186
    if (identity) {                                                                                                    // 1187
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1188
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1189
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1190
      return identity;                                                                                                 // 1191
    }                                                                                                                  // 1192
  },                                                                                                                   // 1193
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1195
    check(userId, String);                                                                                             // 1196
    check(identityId, String);                                                                                         // 1197
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1199
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1201
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1202
  },                                                                                                                   // 1203
  userGrains: function userGrains(userId, options) {                                                                   // 1205
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1206
    check(options, Match.OneOf(undefined, null, { includeTrashOnly: Match.Optional(Boolean), includeTrash: Match.Optional(Boolean) }));
                                                                                                                       //
    var query = { userId: userId };                                                                                    // 1210
    if (options && options.includeTrashOnly) {                                                                         // 1211
      query.trashed = { $exists: true };                                                                               // 1212
    } else if (options && options.includeTrash) {                                                                      // 1213
      // Keep query as-is.                                                                                             //
    } else {                                                                                                           // 1215
        query.trashed = { $exists: false };                                                                            // 1216
      }                                                                                                                // 1217
                                                                                                                       //
    return this.collections.grains.find(query);                                                                        // 1219
  },                                                                                                                   // 1220
  currentUserGrains: function currentUserGrains(options) {                                                             // 1222
    return this.userGrains(Meteor.userId(), options);                                                                  // 1223
  },                                                                                                                   // 1224
  getGrain: function getGrain(grainId) {                                                                               // 1226
    check(grainId, String);                                                                                            // 1227
    return this.collections.grains.findOne(grainId);                                                                   // 1228
  },                                                                                                                   // 1229
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1231
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1232
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1233
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1234
    return this.collections.apiTokens.find({                                                                           // 1235
      "owner.user.identityId": { $in: identityIds },                                                                   // 1236
      trashed: { $exists: !!trashed }                                                                                  // 1237
    });                                                                                                                // 1235
  },                                                                                                                   // 1239
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1241
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1242
  },                                                                                                                   // 1243
  userActions: function userActions(user) {                                                                            // 1245
    return this.collections.userActions.find({ userId: user });                                                        // 1246
  },                                                                                                                   // 1247
  currentUserActions: function currentUserActions() {                                                                  // 1249
    return this.userActions(Meteor.userId());                                                                          // 1250
  },                                                                                                                   // 1251
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1253
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1254
  },                                                                                                                   // 1255
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1257
    var grain = this.getGrain(grainId);                                                                                // 1258
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1259
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1261
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1262
    }                                                                                                                  // 1263
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1265
    var grainInfo = { appTitle: appTitle };                                                                            // 1266
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1268
      var icons = pkg.manifest.metadata.icons;                                                                         // 1269
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1270
    }                                                                                                                  // 1271
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1274
      grainInfo.appId = pkg.appId;                                                                                     // 1275
    }                                                                                                                  // 1276
                                                                                                                       //
    return grainInfo;                                                                                                  // 1278
  },                                                                                                                   // 1279
  getPlan: function getPlan(id) {                                                                                      // 1281
    check(id, String);                                                                                                 // 1282
    var plan = this.collections.plans.findOne(id);                                                                     // 1283
    if (!plan) {                                                                                                       // 1284
      throw new Error("no such plan: " + id);                                                                          // 1285
    }                                                                                                                  // 1286
                                                                                                                       //
    return plan;                                                                                                       // 1288
  },                                                                                                                   // 1289
  listPlans: function listPlans() {                                                                                    // 1291
    return this.collections.plans.find({}, { sort: { price: 1 } });                                                    // 1292
  },                                                                                                                   // 1293
  getMyPlan: function getMyPlan() {                                                                                    // 1295
    var user = Meteor.user();                                                                                          // 1296
    return user && this.collections.plans.findOne(user.plan || "free");                                                // 1297
  },                                                                                                                   // 1298
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1300
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1305
  },                                                                                                                   // 1306
  getMyUsage: function getMyUsage(user) {                                                                              // 1308
    user = user || Meteor.user();                                                                                      // 1309
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1310
      if (Meteor.isClient) {                                                                                           // 1311
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1314
      } else {                                                                                                         // 1315
        return {                                                                                                       // 1316
          grains: this.collections.grains.find({ userId: user._id }).count(),                                          // 1317
          storage: user.storageUsage || 0,                                                                             // 1318
          compute: 0 };                                                                                                // 1319
      }                                                                                                                // 1321
    } else // not tracked yet                                                                                          // 1322
      {                                                                                                                // 1322
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1323
      }                                                                                                                // 1324
  },                                                                                                                   // 1325
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1327
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1328
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1330
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1331
  },                                                                                                                   // 1332
  getSetting: function getSetting(name) {                                                                              // 1334
    var setting = this.collections.settings.findOne(name);                                                             // 1335
    return setting && setting.value;                                                                                   // 1336
  },                                                                                                                   // 1337
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1339
    var value = this.getSetting(name);                                                                                 // 1340
    if (value === undefined) {                                                                                         // 1341
      return fallbackValue;                                                                                            // 1342
    }                                                                                                                  // 1343
                                                                                                                       //
    return value;                                                                                                      // 1345
  },                                                                                                                   // 1346
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1348
    check(userId, String);                                                                                             // 1349
    check(packageId, String);                                                                                          // 1350
                                                                                                                       //
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1352
    if (pack) {                                                                                                        // 1353
      // Remove old versions.                                                                                          //
      var numRemoved = this.collections.userActions.remove({ userId: userId, appId: pack.appId });                     // 1355
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1358
      for (var i in actions) {                                                                                         // 1359
        var action = actions[i];                                                                                       // 1360
        if ("none" in action.input) {                                                                                  // 1361
          var userAction = {                                                                                           // 1362
            userId: userId,                                                                                            // 1363
            packageId: pack._id,                                                                                       // 1364
            appId: pack.appId,                                                                                         // 1365
            appTitle: pack.manifest.appTitle,                                                                          // 1366
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1367
            appVersion: pack.manifest.appVersion,                                                                      // 1368
            title: action.title,                                                                                       // 1369
            nounPhrase: action.nounPhrase,                                                                             // 1370
            command: action.command                                                                                    // 1371
          };                                                                                                           // 1362
          this.collections.userActions.insert(userAction);                                                             // 1373
        } else {                                                                                                       // 1374
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1376
      }                                                                                                                // 1377
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1379
        this.deleteUnusedPackages(pack.appId);                                                                         // 1380
      }                                                                                                                // 1381
    }                                                                                                                  // 1382
  },                                                                                                                   // 1383
  sendAdminNotification: function sendAdminNotification(type, action) {                                                // 1385
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1386
      Notifications.insert({                                                                                           // 1387
        admin: { action: action, type: type },                                                                         // 1388
        userId: user._id,                                                                                              // 1389
        timestamp: new Date(),                                                                                         // 1390
        isUnread: true                                                                                                 // 1391
      });                                                                                                              // 1387
    });                                                                                                                // 1393
  },                                                                                                                   // 1394
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1396
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1397
  },                                                                                                                   // 1398
  getServerTitle: function getServerTitle() {                                                                          // 1400
    var setting = this.collections.settings.findOne({ _id: "serverTitle" });                                           // 1401
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1402
  },                                                                                                                   // 1403
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1405
    var setting = this.collections.settings.findOne({ _id: "smtpConfig" });                                            // 1406
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1407
  },                                                                                                                   // 1408
  getReturnAddress: function getReturnAddress() {                                                                      // 1410
    var config = this.getSmtpConfig();                                                                                 // 1411
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1412
  },                                                                                                                   // 1413
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1415
    check(identityId, String);                                                                                         // 1416
    var identity = this.getIdentity(identityId);                                                                       // 1417
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1418
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1422
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1424
  },                                                                                                                   // 1425
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1427
    check(accountId, String);                                                                                          // 1428
    check(identityId, String);                                                                                         // 1429
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1431
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1432
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1433
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1434
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1435
      return accountPrimaryEmailAddress;                                                                               // 1436
    } else if (senderPrimaryEmail) {                                                                                   // 1437
      return senderPrimaryEmail.email;                                                                                 // 1438
    } else {                                                                                                           // 1439
      return null;                                                                                                     // 1440
    }                                                                                                                  // 1441
  },                                                                                                                   // 1442
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1444
    check(accountId, String);                                                                                          // 1445
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1447
    var result = Meteor.users.findAndModify({                                                                          // 1448
      query: { _id: accountId },                                                                                       // 1449
      update: {                                                                                                        // 1450
        $inc: {                                                                                                        // 1451
          dailySentMailCount: 1                                                                                        // 1452
        }                                                                                                              // 1451
      },                                                                                                               // 1450
      fields: { dailySentMailCount: 1 }                                                                                // 1455
    });                                                                                                                // 1448
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1458
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1459
    }                                                                                                                  // 1460
                                                                                                                       //
    var user = result.value;                                                                                           // 1462
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1463
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1468
  },                                                                                                                   // 1469
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1471
    var featureKey = this.currentFeatureKey();                                                                         // 1472
    return !!featureKey;                                                                                               // 1473
  },                                                                                                                   // 1474
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1476
    var featureKey = this.currentFeatureKey();                                                                         // 1477
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1478
  },                                                                                                                   // 1479
  isFeatureKeyOptedIntoStats: function isFeatureKeyOptedIntoStats() {                                                  // 1481
    var featureKey = this.currentFeatureKey();                                                                         // 1482
    return featureKey && featureKey.isTrial && parseInt(featureKey.issued) > 1472601600;                               // 1483
    // 1472601600 is 2016 Aug 31 in seconds since the epoch                                                            //
  },                                                                                                                   // 1485
  getLdapUrl: function getLdapUrl() {                                                                                  // 1487
    var setting = this.collections.settings.findOne({ _id: "ldapUrl" });                                               // 1488
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1489
  },                                                                                                                   // 1490
  getLdapBase: function getLdapBase() {                                                                                // 1492
    var setting = this.collections.settings.findOne({ _id: "ldapBase" });                                              // 1493
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1494
  },                                                                                                                   // 1495
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1497
    var setting = this.collections.settings.findOne({ _id: "ldapDnPattern" });                                         // 1498
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1499
  },                                                                                                                   // 1500
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1502
    var setting = this.collections.settings.findOne({ _id: "ldapSearchUsername" });                                    // 1503
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1504
  },                                                                                                                   // 1505
  getLdapNameField: function getLdapNameField() {                                                                      // 1507
    var setting = this.collections.settings.findOne({ _id: "ldapNameField" });                                         // 1508
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1509
  },                                                                                                                   // 1510
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1512
    var setting = this.collections.settings.findOne({ _id: "ldapEmailField" });                                        // 1513
    return setting ? setting.value : "mail";                                                                           // 1514
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1516
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1518
    var setting = this.collections.settings.findOne({ _id: "ldapExplicitDnSelected" });                                // 1519
    return setting && setting.value;                                                                                   // 1520
  },                                                                                                                   // 1521
  getLdapFilter: function getLdapFilter() {                                                                            // 1523
    var setting = this.collections.settings.findOne({ _id: "ldapFilter" });                                            // 1524
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1525
  },                                                                                                                   // 1526
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1528
    var setting = this.collections.settings.findOne({ _id: "ldapSearchBindDn" });                                      // 1529
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1530
  },                                                                                                                   // 1531
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1533
    var setting = this.collections.settings.findOne({ _id: "ldapSearchBindPassword" });                                // 1534
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1535
  },                                                                                                                   // 1536
  getLdapCaCert: function getLdapCaCert() {                                                                            // 1538
    var setting = this.collections.settings.findOne({ _id: "ldapCaCert" });                                            // 1539
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1540
  },                                                                                                                   // 1541
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1543
    var setting = this.collections.settings.findOne({ _id: "organizationMembership" });                                // 1544
    return setting && setting.value;                                                                                   // 1545
  },                                                                                                                   // 1546
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1548
    var membership = this.getOrganizationMembership();                                                                 // 1549
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1550
  },                                                                                                                   // 1551
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1553
    var membership = this.getOrganizationMembership();                                                                 // 1554
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1555
  },                                                                                                                   // 1556
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1558
    var membership = this.getOrganizationMembership();                                                                 // 1559
    return membership && membership.google && membership.google.enabled;                                               // 1560
  },                                                                                                                   // 1561
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1563
    var membership = this.getOrganizationMembership();                                                                 // 1564
    return membership && membership.google && membership.google.domain;                                                // 1565
  },                                                                                                                   // 1566
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1568
    var membership = this.getOrganizationMembership();                                                                 // 1569
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1570
  },                                                                                                                   // 1571
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1573
    var membership = this.getOrganizationMembership();                                                                 // 1574
    return membership && membership.saml && membership.saml.enabled;                                                   // 1575
  },                                                                                                                   // 1576
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1578
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1579
  },                                                                                                                   // 1580
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1582
    var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                  // 1583
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1584
  },                                                                                                                   // 1585
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1587
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1588
  },                                                                                                                   // 1589
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1591
    var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                  // 1592
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1593
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1595
    } else {                                                                                                           // 1596
      return setting.value.shareContacts;                                                                              // 1597
    }                                                                                                                  // 1598
  },                                                                                                                   // 1599
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1601
    var setting = this.collections.settings.findOne({ _id: "samlEntryPoint" });                                        // 1602
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1603
  },                                                                                                                   // 1604
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1606
    var setting = this.collections.settings.findOne({ _id: "samlPublicCert" });                                        // 1607
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1608
  },                                                                                                                   // 1609
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1611
    var setting = this.collections.settings.findOne({ _id: "samlEntityId" });                                          // 1612
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1613
  },                                                                                                                   // 1614
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1616
    return this.collections.activitySubscriptions.find({                                                               // 1617
      grainId: grainId,                                                                                                // 1618
      threadPath: threadPath || { $exists: false }                                                                     // 1619
    }, {                                                                                                               // 1617
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1621
    }).fetch();                                                                                                        // 1620
  },                                                                                                                   // 1623
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1625
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1630
    if (threadPath) {                                                                                                  // 1631
      record.threadPath = threadPath;                                                                                  // 1632
    }                                                                                                                  // 1633
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    this.collections.activitySubscriptions.upsert(record, { $set: record });                                           // 1639
  },                                                                                                                   // 1640
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1642
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1646
    if (threadPath) {                                                                                                  // 1647
      record.threadPath = threadPath;                                                                                  // 1648
    }                                                                                                                  // 1649
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, { $set: { mute: true } });                                   // 1651
  },                                                                                                                   // 1652
  updateAppIndex: function updateAppIndex() {                                                                          // 1654
    var _this3 = this;                                                                                                 // 1654
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1655
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1656
    if (!appUpdatesEnabled) {                                                                                          // 1657
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1660
    }                                                                                                                  // 1661
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1663
    var appIndex = this.collections.appIndex;                                                                          // 1664
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1665
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1666
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1669
      app._id = app.appId;                                                                                             // 1670
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1672
      app.hasSentNotifications = false;                                                                                // 1673
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1674
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1675
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this3.collections.packages.findOne({ _id: app.packageId });                                        // 1679
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1680
        if (pack) {                                                                                                    // 1681
          if (pack.status === "ready") {                                                                               // 1682
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1683
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1684
            } else {                                                                                                   // 1686
              _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1687
              if (isAppPreinstalled) {                                                                                 // 1689
                _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                              // 1690
              }                                                                                                        // 1691
            }                                                                                                          // 1692
          } else {                                                                                                     // 1693
            var result = _this3.collections.packages.findAndModify({                                                   // 1694
              query: { _id: app.packageId },                                                                           // 1695
              update: { $set: { isAutoUpdated: true } }                                                                // 1696
            });                                                                                                        // 1694
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1699
              return;                                                                                                  // 1700
            }                                                                                                          // 1701
                                                                                                                       //
            var newPack = result.value;                                                                                // 1703
            if (newPack.status === "ready") {                                                                          // 1704
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1708
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1709
              } else {                                                                                                 // 1711
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                if (isAppPreinstalled) {                                                                               // 1714
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1715
                }                                                                                                      // 1716
              }                                                                                                        // 1717
            } else if (newPack.status === "failed") {                                                                  // 1718
              // If the package has failed, retry it                                                                   //
              _this3.startInstall(app.packageId, url, true, true);                                                     // 1720
            }                                                                                                          // 1721
          }                                                                                                            // 1722
        } else {                                                                                                       // 1723
          _this3.startInstall(app.packageId, url, false, true);                                                        // 1724
        }                                                                                                              // 1725
      }                                                                                                                // 1726
    });                                                                                                                // 1727
  },                                                                                                                   // 1728
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1730
    return this.collections.settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;    // 1731
  },                                                                                                                   // 1732
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1734
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1739
  },                                                                                                                   // 1740
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1742
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1747
  },                                                                                                                   // 1748
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1750
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1751
    var ret = setting && setting.value || [];                                                                          // 1752
    return _.chain(ret).filter(function (app) {                                                                        // 1753
      return app.status === "ready";                                                                                   // 1754
    }).map(function (app) {                                                                                            // 1754
      return app.appId;                                                                                                // 1755
    }).value();                                                                                                        // 1755
  },                                                                                                                   // 1757
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1759
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1760
    var ret = setting && setting.value || [];                                                                          // 1761
    return _.map(ret, function (app) {                                                                                 // 1762
      return app.appId;                                                                                                // 1762
    });                                                                                                                // 1762
  },                                                                                                                   // 1763
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1765
    var _this4 = this;                                                                                                 // 1765
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1766
    appIds.forEach(function (appId) {                                                                                  // 1767
      try {                                                                                                            // 1768
        _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                   // 1769
      } catch (e) {                                                                                                    // 1770
        console.error("failed to install app for user:", e);                                                           // 1771
      }                                                                                                                // 1772
    });                                                                                                                // 1773
  },                                                                                                                   // 1774
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1776
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1780
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1782
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1789
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1791
    check(appId, String);                                                                                              // 1792
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1793
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1794
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1795
    if (pack && pack.status === "ready") {                                                                             // 1796
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1797
    } else if (pack && pack.status === "failed") {                                                                     // 1798
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1799
      this.startInstall(packageId, url, true, false);                                                                  // 1800
    } else {                                                                                                           // 1801
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1802
      this.startInstall(packageId, url, false, false);                                                                 // 1803
    }                                                                                                                  // 1804
  },                                                                                                                   // 1805
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1807
    var _this5 = this;                                                                                                 // 1807
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1811
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1814
        value: appAndPackageIds.map(function (data) {                                                                  // 1815
          return {                                                                                                     // 1816
            appId: data.appId,                                                                                         // 1817
            status: "notReady",                                                                                        // 1818
            packageId: data.packageId                                                                                  // 1819
          };                                                                                                           // 1816
        })                                                                                                             // 1821
      } });                                                                                                            // 1814
    appAndPackageIds.forEach(function (data) {                                                                         // 1823
      _this5.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1824
    });                                                                                                                // 1825
  },                                                                                                                   // 1826
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1828
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1829
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1831
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1832
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1833
  },                                                                                                                   // 1835
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1837
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1838
  },                                                                                                                   // 1841
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1843
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1844
    if (!setting || !setting.value) {                                                                                  // 1845
      return true;                                                                                                     // 1846
    }                                                                                                                  // 1847
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1849
    var readyApps = this.collections.packages.find({                                                                   // 1850
      _id: {                                                                                                           // 1851
        $in: packageIds                                                                                                // 1852
      },                                                                                                               // 1851
      status: "ready"                                                                                                  // 1854
    });                                                                                                                // 1850
    return readyApps.count() === packageIds.length;                                                                    // 1856
  },                                                                                                                   // 1857
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1859
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1860
    return setting && setting.value;                                                                                   // 1861
  },                                                                                                                   // 1862
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1864
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1868
  },                                                                                                                   // 1869
  isHideAboutEnabled: function isHideAboutEnabled() {                                                                  // 1871
    var setting = this.collections.settings.findOne({ _id: "whiteLabelHideAbout" });                                   // 1872
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1873
  },                                                                                                                   // 1874
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1876
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1877
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1879
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1880
  },                                                                                                                   // 1881
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1883
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1884
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1885
  },                                                                                                                   // 1886
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1888
    if (this.quotaManager) {                                                                                           // 1889
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1890
    }                                                                                                                  // 1891
  },                                                                                                                   // 1892
  getUserQuota: function getUserQuota(user) {                                                                          // 1894
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1895
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1896
    } else {                                                                                                           // 1897
      var plan = this.collections.plans.findOne(user.plan || "free");                                                  // 1898
      var referralBonus = calculateReferralBonus(user);                                                                // 1899
      var bonus = user.planBonus || {};                                                                                // 1900
      var userQuota = {                                                                                                // 1901
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1902
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1903
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1904
      };                                                                                                               // 1901
      return userQuota;                                                                                                // 1906
    }                                                                                                                  // 1907
  },                                                                                                                   // 1908
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1910
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1917
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1919
    if (plan.grains < Infinity) {                                                                                      // 1920
      var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: plan.grains }).count();
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1923
    }                                                                                                                  // 1924
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1926
  },                                                                                                                   // 1927
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1929
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1935
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1937
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1940
      var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1943
    }                                                                                                                  // 1944
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1946
  },                                                                                                                   // 1947
  suspendIdentity: function suspendIdentity(userId, suspension) {                                                      // 1949
    check(userId, String);                                                                                             // 1950
    check(suspension, {                                                                                                // 1951
      timestamp: Date,                                                                                                 // 1952
      admin: Match.Optional(String),                                                                                   // 1953
      voluntary: Match.Optional(Boolean)                                                                               // 1954
    });                                                                                                                // 1951
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1957
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1960
  unsuspendIdentity: function unsuspendIdentity(userId) {                                                              // 1962
    check(userId, String);                                                                                             // 1963
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1965
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1968
  suspendAccount: function suspendAccount(userId, byAdminUserId, willDelete) {                                         // 1970
    var _this6 = this;                                                                                                 // 1970
                                                                                                                       //
    check(userId, String);                                                                                             // 1971
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 1972
    check(willDelete, Boolean);                                                                                        // 1973
                                                                                                                       //
    var user = this.collections.users.findOne({ _id: userId });                                                        // 1975
    var suspension = {                                                                                                 // 1976
      timestamp: new Date(),                                                                                           // 1977
      willDelete: willDelete || false                                                                                  // 1978
    };                                                                                                                 // 1976
    if (byAdminUserId) {                                                                                               // 1980
      suspension.admin = byAdminUserId;                                                                                // 1981
    } else {                                                                                                           // 1982
      suspension.voluntary = true;                                                                                     // 1983
    }                                                                                                                  // 1984
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1986
    this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });                // 1987
                                                                                                                       //
    delete suspension.willDelete;                                                                                      // 1989
    // Only mark the parent account for deletion. This makes the query simpler later.                                  //
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 1992
      _this6.suspendIdentity(identity.id, suspension);                                                                 // 1993
    });                                                                                                                // 1994
    user.nonloginIdentities.forEach(function (identity) {                                                              // 1995
      if (_this6.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // Only suspend non-login identities that are unique to this account.                                          //
        _this6.suspendIdentity(identity.id, suspension);                                                               // 2001
      }                                                                                                                // 2002
    });                                                                                                                // 2003
                                                                                                                       //
    // Force logout this user                                                                                          //
    this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                  // 2006
    if (user && user.loginIdentities) {                                                                                // 2008
      user.loginIdentities.forEach(function (identity) {                                                               // 2009
        Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                   // 2010
      });                                                                                                              // 2011
    }                                                                                                                  // 2012
  },                                                                                                                   // 2013
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 2015
    var _this7 = this;                                                                                                 // 2015
                                                                                                                       //
    check(userId, String);                                                                                             // 2016
                                                                                                                       //
    var user = this.collections.users.findOne({ _id: userId });                                                        // 2018
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 2019
    this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });                 // 2020
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 2022
      _this7.unsuspendIdentity(identity.id);                                                                           // 2023
    });                                                                                                                // 2024
                                                                                                                       //
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2026
      _this7.unsuspendIdentity(identity.id);                                                                           // 2027
    });                                                                                                                // 2028
  },                                                                                                                   // 2029
  deletePendingAccounts: function deletePendingAccounts(deletionCoolingOffTime, backend, cb) {                         // 2031
    var _this8 = this;                                                                                                 // 2031
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 2032
                                                                                                                       //
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 2034
    this.collections.users.find({                                                                                      // 2035
      "suspended.willDelete": true,                                                                                    // 2036
      "suspended.timestamp": { $lt: queryDate }                                                                        // 2037
    }).forEach(function (user) {                                                                                       // 2035
      if (cb) cb(_this8, user);                                                                                        // 2039
      _this8.deleteAccount(user._id, backend);                                                                         // 2040
    });                                                                                                                // 2041
  },                                                                                                                   // 2042
                                                                                                                       //
                                                                                                                       //
  hostIsStandalone: function hostIsStandalone(hostname) {                                                              // 2044
    check(hostname, String);                                                                                           // 2045
                                                                                                                       //
    return !!this.collections.standaloneDomains.findOne({ _id: hostname });                                            // 2047
  }                                                                                                                    // 2048
});                                                                                                                    // 1176
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2051
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 2056
};                                                                                                                     // 2057
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2059
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 2062
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2063
  var action = manifest.actions[0];                                                                                    // 2064
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2065
  return appName;                                                                                                      // 2067
};                                                                                                                     // 2068
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2070
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 2075
    return "(unnamed)";                                                                                                // 2076
  }                                                                                                                    // 2077
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2079
    name = name.slice(4);                                                                                              // 2080
  }                                                                                                                    // 2081
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2083
    name = "Hacker CMS";                                                                                               // 2084
  } else {                                                                                                             // 2085
    var space = name.indexOf(" ");                                                                                     // 2086
    if (space > 0) {                                                                                                   // 2087
      name = name.slice(0, space);                                                                                     // 2088
    }                                                                                                                  // 2089
  }                                                                                                                    // 2090
                                                                                                                       //
  return name;                                                                                                         // 2092
};                                                                                                                     // 2093
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2095
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2099
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2101
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2106
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 2108
    var text = action.title.defaultText;                                                                               // 2109
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2111
      var candidate = text.slice(4);                                                                                   // 2112
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2114
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2115
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 2117
          return newCandidate.toLowerCase();                                                                           // 2118
        } else {                                                                                                       // 2119
          return "grain";                                                                                              // 2120
        }                                                                                                              // 2121
      }                                                                                                                // 2122
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2124
    }                                                                                                                  // 2125
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 2128
  } else {                                                                                                             // 2129
    return "grain";                                                                                                    // 2130
  }                                                                                                                    // 2131
};                                                                                                                     // 2132
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 2136
  appNameFromActionName: appNameFromActionName,                                                                        // 2137
  appNameFromPackage: appNameFromPackage,                                                                              // 2138
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2139
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2140
});                                                                                                                    // 2136
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2143
  (function () {                                                                                                       // 2143
    var Crypto = Npm.require("crypto");                                                                                // 2144
    var ContentType = Npm.require("content-type");                                                                     // 2145
    var Zlib = Npm.require("zlib");                                                                                    // 2146
    var Url = Npm.require("url");                                                                                      // 2147
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2149
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2151
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 2161
      while (denom <= n) {                                                                                             // 2162
        denom <<= 1;                                                                                                   // 2162
      }var num = n * 2 - denom + 1;                                                                                    // 2162
      return num / denom;                                                                                              // 2164
    };                                                                                                                 // 2165
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2167
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2169
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2177
      check(callback, Function);                                                                                       // 2178
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2180
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2181
      }                                                                                                                // 2183
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2187
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2191
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2194
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2196
        callback();                                                                                                    // 2197
        Meteor.setInterval(callback, intervalMs);                                                                      // 2198
      }, first);                                                                                                       // 2199
    };                                                                                                                 // 2200
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2203
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2205
      return Match.Where(function (buf) {                                                                              // 2206
        check(buf, Buffer);                                                                                            // 2207
        return buf.length < limit;                                                                                     // 2208
      });                                                                                                              // 2209
    };                                                                                                                 // 2210
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2212
      check(s, String);                                                                                                // 2213
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2214
    });                                                                                                                // 2215
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                              // 2217
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2221
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2222
        metadata.encoding = "gzip";                                                                                    // 2223
      }                                                                                                                // 2224
                                                                                                                       //
      check(metadata, {                                                                                                // 2226
        mimeType: String,                                                                                              // 2227
        encoding: Match.Optional("gzip")                                                                               // 2228
      });                                                                                                              // 2226
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2230
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2233
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2235
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2236
      hasher.update(content);                                                                                          // 2237
      var hash = hasher.digest("base64");                                                                              // 2238
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2240
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2241
        update: { $inc: { refcount: 1 } },                                                                             // 2242
        fields: { _id: 1, refcount: 1 }                                                                                // 2243
      });                                                                                                              // 2240
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2246
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2247
      }                                                                                                                // 2248
                                                                                                                       //
      var existing = result.value;                                                                                     // 2250
      if (existing) {                                                                                                  // 2251
        return existing._id;                                                                                           // 2252
      }                                                                                                                // 2253
                                                                                                                       //
      return this.collections.staticAssets.insert(_.extend({                                                           // 2255
        hash: hash,                                                                                                    // 2256
        content: content,                                                                                              // 2257
        refcount: 1                                                                                                    // 2258
      }, metadata));                                                                                                   // 2255
    };                                                                                                                 // 2260
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2262
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2270
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2272
        query: { hash: hash },                                                                                         // 2273
        update: { $inc: { refcount: 1 } },                                                                             // 2274
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2275
      });                                                                                                              // 2272
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2278
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2279
      }                                                                                                                // 2280
                                                                                                                       //
      var existing = result.value;                                                                                     // 2282
      return existing;                                                                                                 // 2283
    };                                                                                                                 // 2284
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2286
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2293
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2295
        query: { _id: id },                                                                                            // 2296
        update: { $inc: { refcount: -1 } },                                                                            // 2297
        fields: { _id: 1, refcount: 1 },                                                                               // 2298
        "new": true                                                                                                    // 2299
      });                                                                                                              // 2295
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2302
        throw new Error("Couldn't unref static asset " + id);                                                          // 2303
      }                                                                                                                // 2304
                                                                                                                       //
      var existing = result.value;                                                                                     // 2306
      if (!existing) {                                                                                                 // 2307
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2308
      } else if (existing.refcount <= 0) {                                                                             // 2309
        this.collections.staticAssets.remove({ _id: existing._id });                                                   // 2310
      }                                                                                                                // 2311
    };                                                                                                                 // 2312
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2314
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2317
                                                                                                                       //
      var asset = this.collections.staticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });
      if (asset) {                                                                                                     // 2320
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2323
      }                                                                                                                // 2324
                                                                                                                       //
      return asset;                                                                                                    // 2326
    };                                                                                                                 // 2327
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2329
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return this.collections.assetUploadTokens.insert({                                                               // 2335
        purpose: purpose,                                                                                              // 2336
        expires: new Date(Date.now() + 300000) });                                                                     // 2337
    };                                                                                                                 // 2339
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2341
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2345
                                                                                                                       //
      var result = this.collections.assetUploadTokens.findAndModify({                                                  // 2347
        query: { _id: id },                                                                                            // 2348
        remove: true                                                                                                   // 2349
      });                                                                                                              // 2347
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2352
        throw new Error("Failed to remove asset upload token");                                                        // 2353
      }                                                                                                                // 2354
                                                                                                                       //
      var upload = result.value;                                                                                       // 2356
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2358
        return undefined; // already expired                                                                           // 2359
      } else {                                                                                                         // 2360
          return upload.purpose;                                                                                       // 2361
        }                                                                                                              // 2362
    };                                                                                                                 // 2363
                                                                                                                       //
    SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                   // 2365
      this.collections.assetUploadTokens.remove({ expires: { $lt: Date.now() } });                                     // 2366
    };                                                                                                                 // 2367
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   //
    var Future = Npm.require("fibers/future");                                                                         // 2370
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2371
      var result = new Future();                                                                                       // 2372
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2373
      return result;                                                                                                   // 2374
    };                                                                                                                 // 2375
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2377
      return promiseToFuture(promise).wait();                                                                          // 2378
    };                                                                                                                 // 2379
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2381
      var _this9 = this;                                                                                               // 2381
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2384
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2386
      this.collections.grains.find(query).forEach(function (grain) {                                                   // 2387
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2388
        numDeleted += _this9.collections.grains.remove({ _id: grain._id });                                            // 2389
        _this9.removeApiTokens({                                                                                       // 2390
          grainId: grain._id,                                                                                          // 2391
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2392
        });                                                                                                            // 2390
                                                                                                                       //
        _this9.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2398
                                                                                                                       //
        _this9.collections.activitySubscriptions.remove({ grainId: grain._id });                                       // 2400
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2402
          _this9.collections.deleteStats.insert({                                                                      // 2403
            type: "grain", // Demo grains can never get here!                                                          // 2404
            lastActive: grain.lastUsed,                                                                                // 2405
            appId: grain.appId                                                                                         // 2406
          });                                                                                                          // 2403
        }                                                                                                              // 2408
                                                                                                                       //
        _this9.deleteUnusedPackages(grain.appId);                                                                      // 2410
                                                                                                                       //
        if (grain.size) {                                                                                              // 2412
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2413
        }                                                                                                              // 2414
      });                                                                                                              // 2415
      return numDeleted;                                                                                               // 2416
    };                                                                                                                 // 2417
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2419
      check(grainId, String);                                                                                          // 2420
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2421
      check(identityId, String);                                                                                       // 2422
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2424
      if (!grain) {                                                                                                    // 2425
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2426
      }                                                                                                                // 2427
                                                                                                                       //
      var title = grain.title;                                                                                         // 2429
      if (grain.userId !== accountId) {                                                                                // 2430
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2431
          grainId: grainId,                                                                                            // 2432
          "owner.user.identityId": identityId                                                                          // 2433
        }, {                                                                                                           // 2431
          sort: {                                                                                                      // 2435
            lastUsed: -1                                                                                               // 2436
          }                                                                                                            // 2435
        });                                                                                                            // 2434
        if (sharerToken) {                                                                                             // 2439
          title = sharerToken.owner.user.title;                                                                        // 2440
        } else {                                                                                                       // 2441
          title = "shared grain";                                                                                      // 2442
        }                                                                                                              // 2443
      }                                                                                                                // 2444
                                                                                                                       //
      return title;                                                                                                    // 2446
    };                                                                                                                 // 2447
                                                                                                                       //
    var packageCache = {};                                                                                             // 2449
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2452
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2457
        return packageCache[packageId];                                                                                // 2458
      }                                                                                                                // 2459
                                                                                                                       //
      var pkg = this.collections.packages.findOne(packageId);                                                          // 2461
      if (pkg && pkg.status === "ready") {                                                                             // 2462
        packageCache[packageId] = pkg;                                                                                 // 2463
      }                                                                                                                // 2464
                                                                                                                       //
      return pkg;                                                                                                      // 2466
    };                                                                                                                 // 2467
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2469
      var _this10 = this;                                                                                              // 2469
                                                                                                                       //
      check(appId, String);                                                                                            // 2470
      this.collections.packages.find({ appId: appId }).forEach(function (pkg) {                                        // 2471
        // Mark package for possible deletion;                                                                         //
        _this10.collections.packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });     // 2473
      });                                                                                                              // 2474
    };                                                                                                                 // 2475
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this11 = this;                                                                                              // 2478
                                                                                                                       //
      var actions = this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2481
        var userId = action.userId;                                                                                    // 2482
        var updater = {                                                                                                // 2483
          timestamp: new Date(),                                                                                       // 2484
          isUnread: true                                                                                               // 2485
        };                                                                                                             // 2483
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2487
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2491
          marketingVersion: marketingVersion,                                                                          // 2492
          packageId: packageId,                                                                                        // 2493
          name: name,                                                                                                  // 2494
          version: versionNumber                                                                                       // 2495
        };                                                                                                             // 2491
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this11.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this11.collections.notifications.insert(inserter);                                                          // 2504
        }                                                                                                              // 2505
      });                                                                                                              // 2506
                                                                                                                       //
      this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                      // 2508
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2512
    };                                                                                                                 // 2513
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                        // 2515
      this.collections.notifications.upsert({                                                                          // 2516
        userId: userId,                                                                                                // 2517
        referral: true                                                                                                 // 2518
      }, {                                                                                                             // 2516
        userId: userId,                                                                                                // 2520
        referral: true,                                                                                                // 2521
        timestamp: new Date(),                                                                                         // 2522
        isUnread: true                                                                                                 // 2523
      });                                                                                                              // 2519
    };                                                                                                                 // 2525
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2527
      check(appId, String);                                                                                            // 2528
      check(version, Match.Integer);                                                                                   // 2529
      check(packageId, String);                                                                                        // 2530
                                                                                                                       //
      var selector = {                                                                                                 // 2532
        userId: Meteor.userId(),                                                                                       // 2533
        appId: appId,                                                                                                  // 2534
        appVersion: { $lte: version },                                                                                 // 2535
        packageId: { $ne: packageId }                                                                                  // 2536
      };                                                                                                               // 2532
                                                                                                                       //
      this.collections.grains.find(selector).forEach(function (grain) {                                                // 2539
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2540
      });                                                                                                              // 2541
                                                                                                                       //
      this.collections.grains.update(selector, {                                                                       // 2543
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2544
      }, { multi: true });                                                                                             // 2543
    };                                                                                                                 // 2546
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2548
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2551
        status: "download",                                                                                            // 2552
        progress: 0,                                                                                                   // 2553
        url: url,                                                                                                      // 2554
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2555
      };                                                                                                               // 2551
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2558
        this.collections.packages.update({ _id: packageId, status: "failed" }, { $set: fields });                      // 2559
      } else {                                                                                                         // 2560
        try {                                                                                                          // 2561
          fields._id = packageId;                                                                                      // 2562
          this.collections.packages.insert(fields);                                                                    // 2563
        } catch (err) {                                                                                                // 2564
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2565
        }                                                                                                              // 2566
      }                                                                                                                // 2567
    };                                                                                                                 // 2568
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2570
      check(keyFingerprint, String);                                                                                   // 2571
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2572
    });                                                                                                                // 2573
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2575
      var _this12 = this;                                                                                              // 2575
                                                                                                                       //
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2578
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2580
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2585
      }, function (err, keybaseResponse) {                                                                             // 2584
        if (err) {                                                                                                     // 2587
          console.log("keybase lookup error:", err.stack);                                                             // 2588
          return;                                                                                                      // 2589
        }                                                                                                              // 2590
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2592
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2593
          return;                                                                                                      // 2594
        }                                                                                                              // 2595
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2597
                                                                                                                       //
        if (profile) {                                                                                                 // 2599
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2601
            displayName: (profile.profile || {}).full_name,                                                            // 2602
            handle: (profile.basics || {}).username,                                                                   // 2603
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2604
          };                                                                                                           // 2601
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2608
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2611
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2615
                delete proof[field];                                                                                   // 2616
              }                                                                                                        // 2617
            }                                                                                                          // 2618
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2623
          });                                                                                                          // 2624
                                                                                                                       //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });              // 2626
        } else {                                                                                                       // 2627
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2636
      });                                                                                                              // 2637
    };                                                                                                                 // 2638
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2640
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2643
      var account = this.collections.users.findOne({ "loginIdentities.id": identityId });                              // 2644
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({ userId: account._id }) && !this.collections.apiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({ ownerId: account._id })) {
        this.collections.users.remove({ _id: account._id });                                                           // 2653
        backend.deleteUser(account._id);                                                                               // 2654
      }                                                                                                                // 2655
    };                                                                                                                 // 2656
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2658
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2659
      var db = this.connection.sandstormDb;                                                                            // 2660
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2662
      if (cursor.count() === 0) {                                                                                      // 2663
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2665
      }                                                                                                                // 2666
                                                                                                                       //
      return cursor;                                                                                                   // 2668
    });                                                                                                                // 2669
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2671
      check(appId, String);                                                                                            // 2672
      var db = this.connection.sandstormDb;                                                                            // 2673
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2674
      return cursor;                                                                                                   // 2675
    });                                                                                                                // 2676
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2678
      var _this13 = this;                                                                                              // 2678
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2682
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2694
      var refPackage = function refPackage(packageId) {                                                                // 2695
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2697
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2699
          hasPackage[packageId] = true;                                                                                // 2700
          var pkg = db.getPackage(packageId);                                                                          // 2701
          if (pkg) {                                                                                                   // 2702
            _this13.added("packages", packageId, pkg);                                                                 // 2703
          } else {                                                                                                     // 2704
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2705
          }                                                                                                            // 2707
        }                                                                                                              // 2708
      };                                                                                                               // 2709
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2712
      var actionsHandle = actions.observe({                                                                            // 2713
        added: function added(newAction) {                                                                             // 2714
          refPackage(newAction.packageId);                                                                             // 2715
        },                                                                                                             // 2716
        changed: function changed(newAction, oldAction) {                                                              // 2718
          refPackage(newAction.packageId);                                                                             // 2719
        }                                                                                                              // 2720
      });                                                                                                              // 2713
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId, { includeTrash: true });                                                 // 2724
      var grainsHandle = grains.observe({                                                                              // 2725
        added: function added(newGrain) {                                                                              // 2726
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2728
            refPackage(newGrain.packageId);                                                                            // 2729
          }                                                                                                            // 2730
        },                                                                                                             // 2731
        changed: function changed(newGrain, oldGrain) {                                                                // 2733
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2735
            refPackage(newGrain.packageId);                                                                            // 2736
          }                                                                                                            // 2737
        }                                                                                                              // 2738
      });                                                                                                              // 2725
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2741
        actionsHandle.stop();                                                                                          // 2742
        grainsHandle.stop();                                                                                           // 2743
      });                                                                                                              // 2744
                                                                                                                       //
      this.ready();                                                                                                    // 2746
    });                                                                                                                // 2747
  })();                                                                                                                // 2143
}                                                                                                                      // 2748
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey, renewalProblem) {                                 // 2750
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2753
                                                                                                                       //
  if (renewalProblem) {                                                                                                // 2755
    processedFeatureKey.renewalProblem = renewalProblem;                                                               // 2756
  }                                                                                                                    // 2757
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2760
};                                                                                                                     // 2761
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2763
  (function () {                                                                                                       // 2763
    var processFeatureKeyDoc = function processFeatureKeyDoc(doc) {                                                    // 2764
      if (!doc) return null;                                                                                           // 2765
      var buf = new Buffer(doc.value);                                                                                 // 2766
      // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                  //
      // once we can use ES6 modules.                                                                                  //
      var rawFeatureKey = loadSignedFeatureKey(buf);                                                                   // 2769
      return processRawFeatureKey(rawFeatureKey, doc.renewalProblem);                                                  // 2770
    };                                                                                                                 // 2771
                                                                                                                       //
    SandstormDb.prototype.currentFeatureKey = function () {                                                            // 2773
      // Returns an object with all of the current signed feature key properties,                                      //
      // or null, if the feature key is missing or not correctly signed.                                               //
      var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                     // 2776
      return processFeatureKeyDoc(doc);                                                                                // 2777
    };                                                                                                                 // 2778
                                                                                                                       //
    SandstormDb.prototype.observeFeatureKey = function (callback) {                                                    // 2780
      // Calls `callback(currentFeatureKey())` whenever the feature key changes. Returns an observe                    //
      // handle (use .stop() to stop observing).                                                                       //
                                                                                                                       //
      return this.collections.featureKey.find({ _id: "currentFeatureKey" }).observe({                                  // 2784
        added: function added(doc) {                                                                                   // 2785
          callback(processFeatureKeyDoc(doc));                                                                         // 2786
        },                                                                                                             // 2787
        changed: function changed(newDoc, oldDoc) {                                                                    // 2789
          if (newDoc.value !== oldDoc.value) {                                                                         // 2790
            callback(processFeatureKeyDoc(newDoc));                                                                    // 2791
          }                                                                                                            // 2792
        },                                                                                                             // 2793
        removed: function removed() {                                                                                  // 2795
          callback(null);                                                                                              // 2796
        }                                                                                                              // 2797
      });                                                                                                              // 2784
    };                                                                                                                 // 2799
  })();                                                                                                                // 2763
} else {                                                                                                               // 2800
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2801
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2802
    return processRawFeatureKey(featureKey);                                                                           // 2803
  };                                                                                                                   // 2804
}                                                                                                                      // 2805
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2807
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2808
    check(identityId, String);                                                                                         // 2809
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2811
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2812
    Meteor.users.remove({ _id: identityId });                                                                          // 2813
  };                                                                                                                   // 2814
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2816
    check(userId, String);                                                                                             // 2817
                                                                                                                       //
    var _this = this;                                                                                                  // 2819
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2820
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2821
    this.collections.userActions.remove({ userId: userId });                                                           // 2822
    this.collections.notifications.remove({ userId: userId });                                                         // 2823
    user.loginIdentities.forEach(function (identity) {                                                                 // 2824
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2830
      }                                                                                                                // 2831
    });                                                                                                                // 2832
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2833
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2839
      }                                                                                                                // 2840
    });                                                                                                                // 2841
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2842
    backend.deleteUser(userId);                                                                                        // 2843
    Meteor.users.remove({ _id: userId });                                                                              // 2844
  };                                                                                                                   // 2845
}                                                                                                                      // 2846
                                                                                                                       //
Meteor.methods({                                                                                                       // 2848
  addUserActions: function addUserActions(packageId) {                                                                 // 2849
    check(packageId, String);                                                                                          // 2850
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2851
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2852
    }                                                                                                                  // 2853
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2855
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2858
    } else {                                                                                                           // 2859
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2860
    }                                                                                                                  // 2861
  },                                                                                                                   // 2862
  removeUserAction: function removeUserAction(actionId) {                                                              // 2864
    check(actionId, String);                                                                                           // 2865
    if (this.isSimulation) {                                                                                           // 2866
      UserActions.remove({ _id: actionId });                                                                           // 2867
    } else {                                                                                                           // 2868
      if (this.userId) {                                                                                               // 2869
        var result = this.connection.sandstormDb.collections.userActions.findAndModify({                               // 2870
          query: { _id: actionId, userId: this.userId },                                                               // 2871
          remove: true                                                                                                 // 2872
        });                                                                                                            // 2870
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2875
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2876
        }                                                                                                              // 2877
                                                                                                                       //
        var action = result.value;                                                                                     // 2879
        if (action) {                                                                                                  // 2880
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2881
        }                                                                                                              // 2882
      }                                                                                                                // 2883
    }                                                                                                                  // 2884
  }                                                                                                                    // 2885
});                                                                                                                    // 2848
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        //
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
    if (email) {                                                                                                       // 268
      return [{ email: email, primary: true }];                                                                        // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 282
                                                                                                                       //
  // For LDAP, the field containing the e-mail address is configurable...                                              //
  var ldapQuery = {};                                                                                                  // 285
  ldapQuery["services.ldap.rawAttrs." + this.getLdapEmailField()] = email;                                             // 286
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, ldapQuery, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_.findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                   // 296
  });                                                                                                                  // 297
};                                                                                                                     // 298
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 300
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 301
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 308
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 309
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 310
};                                                                                                                     // 312
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 314
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 317
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 318
  } else {                                                                                                             // 319
    return [];                                                                                                         // 320
  }                                                                                                                    // 321
};                                                                                                                     // 322
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 324
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 335
  var verifiedEmails = {};                                                                                             // 336
  var unverifiedEmails = {};                                                                                           // 337
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 339
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 340
    if (identity && identity.services) {                                                                               // 341
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 342
        if (verifiedEmail) {                                                                                           // 343
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 344
        }                                                                                                              // 345
      });                                                                                                              // 346
    }                                                                                                                  // 347
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 349
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 350
    }                                                                                                                  // 351
  });                                                                                                                  // 352
                                                                                                                       //
  var result = [];                                                                                                     // 354
  _.keys(verifiedEmails).map(function (email) {                                                                        // 355
    result.push({ email: email,                                                                                        // 356
      verified: true,                                                                                                  // 357
      primary: email === user.primaryEmail });                                                                         // 358
  });                                                                                                                  // 359
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 361
    if (!(email in verifiedEmails)) {                                                                                  // 362
      result.push({ email: email, verified: false });                                                                  // 362
    }                                                                                                                  // 362
  });                                                                                                                  // 363
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 366
    result[0].primary = true;                                                                                          // 367
  }                                                                                                                    // 368
                                                                                                                       //
  return result;                                                                                                       // 370
};                                                                                                                     // 371
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 373
  check(ownerId, String);                                                                                              // 374
  check(identityId, String);                                                                                           // 375
  var profile = this.getIdentity(identityId).profile;                                                                  // 376
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 377
    ownerId: ownerId,                                                                                                  // 378
    petname: profile && profile.name,                                                                                  // 379
    created: new Date(),                                                                                               // 380
    identityId: identityId                                                                                             // 381
  });                                                                                                                  // 377
};                                                                                                                     // 383
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
